<?php
// $Id$

class Campaign {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete': $this->delete(globalize('id')); break;
            case 'add':
				$this->add(	globalize('campaignStartYear'),
							globalize('campaignStartMonth'),
							globalize('campaignStartDay'),
							globalize('campaignEndYear'),
							globalize('campaignEndMonth'),
							globalize('campaignEndDay'),
							globalize('campaignCreatedDateTime'),
							globalize('campaignName'),
							globalize('audioAllotted'),
							globalize('spotsAllotted'),
							globalize('contractID'),
							globalize('campaignAssignIDList'),
							globalize('samActorID'),
							globalize('salesRepActorID')
							);
				break;
            case 'save':
				$this->save(globalize('campaignID'),
							globalize('campaignStartYear'),
							globalize('campaignStartMonth'),
							globalize('campaignStartDay'),
							globalize('campaignEndYear'),
							globalize('campaignEndMonth'),
							globalize('campaignEndDay'),
							globalize('campaignName'),
							globalize('audioAllotted'),
							globalize('spotsAllotted'),
							globalize('campaignAssignIDList'),
							globalize('samActorID'),
							globalize('salesRepActorID')
							);
				break;
            case 'select':
				$this->select(globalize('contractID'));
				break;
            case 'remove':
				$this->remove(globalize('id'));
				break;
            case 'cancel':
				$this->cancel(globalize('id'));
				break;
            case 'annotate':
				Notes::add(
					globalize('notesActorID'),
					globalize('notesType'),
					globalize('notesId'),
					globalize('notesAction'),
					globalize('notesDetails')
					);
				break;
        }
    }

    public function headers($doc) {
        switch(globalize('action')) {
            case 'schedule':
                return(Schedule::headers($doc));
                break;
			default:
				$moduleID = globalize('moduleID');
				$item = globalize('item', get_class($this));
				$script = $doc->createElement('script');
				$script->setAttribute('language', 'javascript');
				$script->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=".$item.".js");
				$script->appendChild($doc->createTextNode(''));

				return(array($script));
        }
    }

    public function schedule($doc,$campaignID) {
        return(Schedule::displayGridInputboxes($doc,$campaignID));
    }

    public function form($doc, $id='') {

		global $module_parameter;
		$contractID = globalize('contractID');
		$item = globalize('item', get_class($this));

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Campaign';
        else
            $headerText = 'Edit Campaign';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		if ($id != '') {
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'remove','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Campaign",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

        $campaignID = $doc->createElement('input');
        $campaignID->setAttribute('type','hidden');
        $campaignID->setAttribute('name','campaignID');
        $campaignID->setAttribute('value',$id);
        $container->appendChild($campaignID);

		$input = $doc->createElement('input');
        $input->setAttribute('type','hidden');
        $input->setAttribute('name','contractID');
        $input->setAttribute('value',$contractID);
        $container->appendChild($input);

		$datetime = date("Y-m-d H:i:s");

		$date = $doc->createElement('input');
        $date->setAttribute('type','hidden');
        $date->setAttribute('name','campaignCreatedDateTime');
        $date->setAttribute('value',$datetime);
        $container->appendChild($date);

        if ($id != '') {
			$query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.audioPurchased, A.spotsPurchased, I.* ";
			$query .= "FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A) ";
			$query .= "WHERE I.campaignID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

			$clientID = $line['clientID'];
			$contractID = $line['contractID'];
            $campaignID = $line['campaignID'];
            $startDateArray = explode('-',$line['startDate']);
            $endDateArray = explode('-',$line['endDate']);
            $createdDateTime = $line['createdDateTime'];
            $name = $line['name'];
			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$audioAllotted = $line['audioAllotted'];
			$spotsAllotted = $line['spotsAllotted'];

			// Decode UTF-8 character encoding.
			$values = array(&$name,
							&$clientName,
							&$contractName
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$query = "SELECT * FROM {$this->store->table_traffic_campaignassign} WHERE campaignID = '$id'";
			$result = sysdb::query($query);
			$assignIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($assignIDList, $line['id']);
			}

        } else {

			$query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.audioPurchased, A.spotsPurchased, A.startDate as contractStartDate, A.endDate as contractEndDate ";
			$query .= "FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A) ";
			$query .= "WHERE A.contractID = '$contractID' AND C.clientID = A.clientID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$clientID = $line['clientID'];

            $campaignID = '';
			$startDateArray = explode('-',$line['contractStartDate']);
			$endDateArray = explode('-',$line['contractEndDate']);
            $createdDateTime = '';
            $name = '';
			$audioAllotted = '';
			$spotsAllotted = '';
		}

		$contractData = $this->getContractDetails($contractID);

		$totalActualAudio = $contractData['totalActualAudio'];
		$totalActualSpots = $contractData['totalActualSpots'];
		$contractAudioRemaining = $contractData['audioRemaining'];
		$contractSpotsRemaining = $contractData['spotsRemaining'];

        if ($id == '') {
			// Change the default allotted values to the remaining values when adding new campaigns.
			$audioAllotted = $contractAudioRemaining;
			$spotsAllotted = $contractSpotsRemaining;
		}

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign Name *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

		$contractAudioRemainingtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Remaining purchased contract audio');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractAudioRemaining);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractAudioRemainingtr->appendChild($labeltd);
        $contractAudioRemainingtr->appendChild($inputtd);

		$contractSpotsRemainingtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Remaining purchased contract spots');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractSpotsRemaining);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractSpotsRemainingtr->appendChild($labeltd);
        $contractSpotsRemainingtr->appendChild($inputtd);

		$totalActualAudiotr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Total actual contract audio');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($totalActualAudio);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $totalActualAudiotr->appendChild($labeltd);
        $totalActualAudiotr->appendChild($inputtd);

		$audioAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Audio allotted to campaign');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','audioAllotted');
        $input->setAttribute('value',$audioAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $audioAllottedtr->appendChild($labeltd);
        $audioAllottedtr->appendChild($inputtd);

		$spotsAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Spots allotted to campaign');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','spotsAllotted');
        $input->setAttribute('value',$spotsAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $spotsAllottedtr->appendChild($labeltd);
        $spotsAllottedtr->appendChild($inputtd);

		$totalActualSpotstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Total actual contract spots');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($totalActualSpots);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $totalActualSpotstr->appendChild($labeltd);
        $totalActualSpotstr->appendChild($inputtd);

		$AssignIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');

 		// Check to see if disabling of SAM role is set as a module parameter.
		if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == 1) {
			$class_title = new SalesRep;
			// $class_title = 'SalesRep';
			$display_title = 'Sales Rep';
			$table_assign = $this->store->table_traffic_salesrep;
			$field_assign = $this->store->field_salesrep_salesRepID;
			$field_actor = $this->store->field_salesrep_actorID;
		} else {
			$class_title = new SAM;
			$display_title = 'SAM';
			$table_assign = $this->store->table_traffic_sam;
			$field_assign = $this->store->field_sam_samID;
			$field_actor = $this->store->field_sam_actorID;
		}

		$labeltd->appendChild($label = $doc->createTextNode('Assign '.$display_title));
		$AssignIDtr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','campaignAssignIDList[]');
		$input->setAttribute('id','campaignAssignIDList');

		$query = "SELECT I.{$field_assign} as id, D.{$this->store->field_detail_firstName}, D.{$this->store->field_detail_lastName} FROM ({$table_assign} I, {$this->store->table_detail} D) WHERE I.{$field_actor} = D.{$this->store->field_detail_actorID}";
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($assignIDList)) {
				if ( in_array($line['id'],$assignIDList) )
					$inputOption->setAttribute('selected','selected');
			} elseif ($id == '' && isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == 1) {
				// Check to see if disabling of SAM role is set as a module parameter.
				// Try select the sales rep assigned to the parent contract as the default assignee.
				$query = <<<EOQ
					SELECT {$this->store->field_contractsalesrep_salesRepID}
					FROM {$this->store->table_traffic_contractsalesrep}
					WHERE {$this->store->field_contractsalesrep_contractID} = '$contractID'
EOQ;
				$contractSalesRepID = sysdb::queryOne($query);
				if ($line['id'] == $contractSalesRepID)
					$inputOption->setAttribute('selected','selected');
			} else {
				// Try select the currently authenticated user by default.
				// $myActorID = user::userActorID($login='');
				$user = new user();
				$myActorID = $user->getActorID();
				if ($myActorID != '') {
					$query = <<<EOQ
						SELECT {$field_assign}
						FROM {$table_assign}
						WHERE {$field_actor} = '$myActorID'
EOQ;
					$myAssignID = sysdb::queryOne($query);
					if ($line['id'] == $myAssignID)
						$inputOption->setAttribute('selected','selected');
				}
			}
			$inputOption->setAttribute('value',$line['id']);
			$inputOption->appendChild($doc->createTextNode($line['firstName'].' '.$line['lastName']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleAssignForm.
		$inputtd->appendChild($divShowAssign = $doc->createElement('div'));
		$divShowAssign->setAttribute('id','show_assign');
		$divShowAssign->appendChild($divButtonShowAssign = $doc->createElement('div'));
		$divButtonShowAssign->appendChild($spanButtonShowAssign = $doc->createElement('span'));
		$spanButtonShowAssign->setAttribute('class', 'link_button');
		$spanButtonShowAssign->setAttribute("onclick", "toggleAssignForm('$display_title','hide_assign','show_assign');");
		$spanButtonShowAssign->appendChild($aShowAssign = $doc->createElement('a'));
		$aShowAssign->setAttribute('title', 'Add New '.$display_title);
		$aShowAssign->setAttribute('class', 'link_button');
		$aShowAssign->appendChild($spanShowAssign = $doc->createElement('span'));
		$spanShowAssign->setAttribute('class', 'link_add');
		$spanShowAssign->appendChild($textShowAssign = $doc->createTextNode('Add New '.$display_title));

		$divShowAssign->appendChild($input);
		// End of show toggleAssignForm.

		// Start of hide toggleAssignForm.
		$inputtd->appendChild($divHideAssign = $doc->createElement('div'));
		$divHideAssign->setAttribute('id','hide_assign');
		$divHideAssign->appendChild($divButtonHideAssign = $doc->createElement('div'));
		$divButtonHideAssign->appendChild($spanButtonHideAssign = $doc->createElement('span'));
		$spanButtonHideAssign->setAttribute('class', 'link_button');
		$spanButtonHideAssign->setAttribute("onclick", "toggleAssignForm('$display_title','hide_assign','show_assign');");
		$spanButtonHideAssign->appendChild($aHideAssign = $doc->createElement('a'));
		$aHideAssign->setAttribute('title', 'Select Existing '.$display_title);
		$aHideAssign->setAttribute('class', 'link_button');
		$aHideAssign->appendChild($spanHideAssign = $doc->createElement('span'));
		$spanHideAssign->setAttribute('class', 'link_add');
		$spanHideAssign->appendChild($textHideAssign = $doc->createTextNode('Select Existing '.$display_title));

		$divHideAssign->appendChild(call_user_func_array(array($class_title, "inline_form"), array($doc,'',true)));
		// End of hide toggleAssignForm.

		$AssignIDtr->appendChild($inputtd);

        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($nametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($audioAllottedtr);
        $table->appendChild($totalActualAudiotr);
        $table->appendChild($contractAudioRemainingtr);
		$table->appendChild($spotsAllottedtr);
        $table->appendChild($totalActualSpotstr);
        $table->appendChild($contractSpotsRemainingtr);
		$table->appendChild($AssignIDtr);


        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);

        return($container);
    }

    public function view($doc, $id) {
		global $module_parameter;
        $container = $doc->createElement('div');
		$container->setAttribute('class','module');
		switch(globalize('extras','CampaignAudio')) {
			case 'CampaignAudio':
				$campaignAudio = new CampaignAudio();
				$container->appendChild($campaignAudio->inline_list($doc,'',true));
				break;
			case 'CampaignMaterial':
				$campaignMaterial = new CampaignMaterial();
				$container->appendChild($campaignMaterial->inline_list($doc,'',true));
				break;
			case 'CampaignPromotion':
				$campaignPromotion = new CampaignPromotion();
				$container->appendChild($campaignPromotion->inline_list($doc,'',true));
				break;
			case 'Log':
				$log = new Log();
				$container->appendChild($log->inline_list($doc,'',true));
				break;
		}
		$containerLeft = $doc->createElement('div');
		$containerLeft->setAttribute('class','module_left');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Campaign'));
		$containerLeft->appendChild($header);

		// Disabling add single audio until further notice.
		// $spanbutton = $doc->createElement('span');
		// $spanbutton->setAttribute('class', 'link_button');
		// $a = module::link_to_script_dom_unappended($doc,'Add Audio','',array('item'=>"CampaignAudio",'action'=>'edit','campaignID'=>$id),'Add Audio','link_button');
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $label = $doc->createTextNode('Add Audio');
		// $span->appendChild($label);
		// $a->appendChild($span);
		// $spanbutton->appendChild($a);
		// $containerLeft->appendChild($spanbutton);

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Audio','',array('item'=>"CampaignAudio",'action'=>'multi_add','campaignID'=>$id),'Add Audio','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Audio');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$containerLeft->appendChild($spanbutton);

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Material','',array('item'=>"CampaignMaterial",'action'=>'edit','campaignID'=>$id),'Add Material','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Material');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$containerLeft->appendChild($spanbutton);

		// $spanbutton = $doc->createElement('span');
		// $spanbutton->setAttribute('class', 'link_button');
		// $a = module::link_to_script_dom_unappended($doc,'Add Promotion','',array('item'=>"CampaignPromotion",'action'=>'edit','campaignID'=>$id),'Add Promotion','link_button');
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $label = $doc->createTextNode('Add Promotion');
		// $span->appendChild($label);
		// $a->appendChild($span);
		// $spanbutton->appendChild($a);
		// $containerLeft->appendChild($spanbutton);

//		$containerLeft->appendChild($doc->createElement('br'));
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $containerLeft->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$containerLeft->appendChild($spanbutton);

		$containerLeft->appendChild($spanbutton = $doc->createElement('span'));
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc,'Schedule','',array('item'=>get_class($this),'action'=>'schedule','id'=>$id),'Schedule','link_button'));
		$spanbutton->setAttribute('class', 'link_button');
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_edit');
		$span->appendChild($label = $doc->createTextNode('Schedule'));

 		$containerLeft->appendChild($spanbutton = Defer::defer_schedule_button_ui($doc, $id));

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $campaignID = $doc->createElement('input');
        $campaignID->setAttribute('type','hidden');
        $campaignID->setAttribute('name','campaignID');
        $campaignID->setAttribute('value',$id);
        $containerLeft->appendChild($campaignID);

        $query = "SELECT C.name as clientName, A.name as contractName, I.* FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A) WHERE I.campaignID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $campaignID = $line['campaignID'];
        $startDate = date("d-M-Y", strtotime($line['startDate']));
        $endDate = date("d-M-Y", strtotime($line['endDate']));
        $createdDateTime = date("d-M-Y H:i:s", strtotime($line['createdDateTime']));
        $name = $line['name'];
		$clientName = $line['clientName'];
		$clientID = $line['clientID'];
		$contractName = $line['contractName'];
		$contractID = $line['contractID'];
		$audioAllotted = $line['audioAllotted'];
		$spotsAllotted = $line['spotsAllotted'];

		// Decode UTF-8 character encoding.
		$values = array(&$name,
						&$clientName,
						&$contractName
						);
		foreach ($values as &$value) {
			$value = utf8_decode($value);
		}
		unset($value);

 		// Check to see if disabling of SAM role is set as a module parameter.
		if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == 1) {
			$table_assign = $this->store->table_traffic_salesrep;
			$field_assign = $this->store->field_salesrep_salesRepID;
			$field_actor = $this->store->field_salesrep_actorID;
		} else {
			$table_assign = $this->store->table_traffic_sam;
			$field_assign = $this->store->field_sam_samID;
			$field_actor = $this->store->field_sam_actorID;
		}

		$queryassign = "SELECT D.{$this->store->field_detail_firstName}, D.{$this->store->field_detail_lastName} FROM ({$this->store->table_traffic_campaignassign} C, {$table_assign} P, {$this->store->table_detail} D) WHERE C.{$this->store->field_campaignassign_campaignID} = '$id' AND C.{$this->store->field_campaignassign_id} = P.{$field_assign} AND P.{$field_actor} = D.{$this->store->field_detail_actorID}";
        $resultassign = sysdb::query($queryassign);

		$assignNames = array();
		while ($linename = sysdb::fetch_assoc($resultassign)) {
			array_push($assignNames, $linename['firstName'].' '.$linename['lastName']);
		}

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($startDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($endDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

        $createdDateTimetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Created');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($createdDateTime);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $createdDateTimetr->appendChild($labeltd);
        $createdDateTimetr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name');
        $inputtd = $doc->createElement('td');
        $inputtd->setAttribute('class','name');
        $inputtd->appendChild($input = $doc->createTextNode($name));
        $labeltd->appendChild($label);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $campaignnumtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign No.');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($campaignID);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $campaignnumtr->appendChild($labeltd);
        $campaignnumtr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractName);
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$audioAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Audio Allotted');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($audioAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $audioAllottedtr->appendChild($labeltd);
        $audioAllottedtr->appendChild($inputtd);

		$spotsAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Spots Allotted');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($spotsAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $spotsAllottedtr->appendChild($labeltd);
        $spotsAllottedtr->appendChild($inputtd);

		$campaignAssigntr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');

		// Check to see if disabling of SAM role is set as a module parameter.
		if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM']) {
			$label = $doc->createTextNode('Sales Representative');
		} else {
			$label = $doc->createTextNode('Sponsor Account Manager');
		}

		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($assignNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $campaignAssigntr->appendChild($labeltd);
        $campaignAssigntr->appendChild($inputtd);

        $table->appendChild($nametr);
        $table->appendChild($campaignnumtr);
        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($audioAllottedtr);
		$table->appendChild($spotsAllottedtr);
        $table->appendChild($createdDateTimetr);
        $table->appendChild($campaignAssigntr);

		$containerLeft->appendChild($table);

		$containerLeft->appendChild(Notes::form($doc,$id));

		$container->appendChild($containerLeft);

		$moduleFooter = $doc->createElement('div');
		$moduleFooter->setAttribute('class','clear_both');
		$container->appendChild($moduleFooter);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
		$item = get_class($this);
		$query = <<<EOQ
            SELECT C.name as clientName, I.clientID, I.campaignID, I.name, I.startDate, I.endDate, I.createdDateTime
            FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C)
            WHERE C.clientID = I.clientID
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
			$query .= " AND I.campaignID IN (".implode(',',$ids).") ";
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

		$col1 = $doc->createElement('col');
        $table->appendChild($col1);

		$col2 = $doc->createElement('col');
        $table->appendChild($col2);

		$col3 = $doc->createElement('col');
        $table->appendChild($col3);

		$col4 = $doc->createElement('col');
        $table->appendChild($col4);

		$colactions = $doc->createElement('col');
		//$colactions->setAttribute('width', '56px');
        $table->appendChild($colactions);

        $tr = $doc->createElement('tr');
        $nametd = $doc->createElement('th');
        $clientNametd = $doc->createElement('th');
        $startDatetd = $doc->createElement('th');
        $endDatetd = $doc->createElement('th');

        $nametd->appendChild($doc->createTextNode('Name'));
        $clientNametd->appendChild($doc->createTextNode('Client'));
        $startDatetd->appendChild($doc->createTextNode('Start'));
        $endDatetd->appendChild($doc->createTextNode('End'));


        $tr->appendChild($nametd);
        $tr->appendChild($clientNametd);
        $tr->appendChild($startDatetd);
        $tr->appendChild($endDatetd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No campaigns entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $nametd = $doc->createElement('td');
            $clientNametd = $doc->createElement('td');
            $startDatetd = $doc->createElement('td');
            $endDatetd = $doc->createElement('td');
            $emailtd = $doc->createElement('td');

            $nametd->appendChild(module::link_to_script_dom($doc,$line['name'],'',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['campaignID']),'View'));
            $clientNametd->appendChild(module::link_to_script_dom($doc,$line['clientName'],'',array('item'=>'Client','action'=>'view','id'=>$line['clientID']),'View'));
            $startDatetd->appendChild($doc->createTextNode(date("d-M-Y", strtotime($line['startDate']))));
            $endDatetd->appendChild($doc->createTextNode(date("d-M-Y", strtotime($line['endDate']))));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['campaignID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['campaignID']),'Edit'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
            $actiontd->appendChild($span = $doc->createElement('span'));
            $span->setAttribute('class','link_traffic_small');
            $span->appendChild(module::link_to_script_dom_unappended($doc,'View Traffic','',
                            array('item'=>'Traffic',
                                  'mode'=>'Campaign',
                                  'campaignID'=>$line['campaignID'],
                                    ),'View Traffic','link_traffic_small'));
            $table->appendChild($tr);
            $tr->appendChild($nametd);
            $tr->appendChild($clientNametd);
            $tr->appendChild($startDatetd);
            $tr->appendChild($endDatetd);
            $tr->appendChild($actiontd);
			$i++;
        }
        $tr = $doc->createElement('tr');
        $actiontd = $doc->createElement('td');
        $actiontd->setAttribute('colspan','5');
        $actiontd->setAttribute('style','text-align: right;');
        $actiontd->appendChild(module::link_to_script_dom($doc,'add','',array('item'=>globalize('item', get_class($this)),'action'=>'edit'),'Add'));

        //$table->appendChild($tr);
        $tr->appendChild($actiontd);

        return($table);
    }

    public function overview($doc,$ids='',$isInclude=false) {
		$startsWith = globalize('startswith');

		$container = $doc->createElement('div');
		if ( $isInclude ) {
			$item = get_class($this);
			$parentID = globalize('id');
			$parentIDType = globalize('item', get_class($this));
			switch ($parentIDType) {
				case 'Client':
					$parentFieldName = 'clientID';
					break;
				case 'Contract':
					$parentFieldName = 'contractID';
					break;
				default:
					$isInclude = false;
					$warning_message = "Not a valid parent.";
					break;
			}
			$container->setAttribute('class','module_right');
			$container->appendChild($this->include_header($doc,$parentID));
		} else {
			$item = globalize('item', get_class($this));
			$container->setAttribute('class','module');
		}

		$query = <<<EOQ
            SELECT C.name as clientName, I.campaignID, I.name, I.startDate, I.endDate, I.createdDateTime
            FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C)
            WHERE C.clientID = I.clientID
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND I.campaignID IN (".implode(',',$ids).") ";

		if ( $startsWith != '' ) {
			$query .= " AND I.name LIKE '".$startsWith."%'";
		}
		if ( $isInclude )
			$query .= " AND I.$parentFieldName = '$parentID'";

        $query .= " ORDER BY endDate, startDate ";

        $ids = sysdb::query2vector($query,'campaignID');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Campaigns'));
		$container->appendChild($header);
		//$container->appendChild(module::link_to_script_dom($doc,'Add Campaign','',array('item'=>$item,'action'=>'edit')));

		$searchLetters = $doc->createElement('div');
		$searchLetters->setAttribute('class','search_letters');
		$searchLetters->appendChild($doc->createTextNode('Browse: '));
		foreach ( range('A','Z') as $c ) {
			$searchLetters->appendChild(module::link_to_script_dom($doc,$c,'',array('item'=>$item,'action'=>'search','startswith'=>$c),'Starts with '.$c));
			$searchLetters->appendChild($doc->createTextNode(' '));
		}
		$container->appendChild($searchLetters);

		if ($startsWith != '') $container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT {$this->store->field_campaign_campaignID} as campaignID,
			{$this->store->field_campaign_name} as name ";
        $query .= "FROM {$this->store->table_traffic_campaign} ";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' WHERE 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= "WHERE {$this->store->field_campaign_campaignID} IN (".implode(',',$ids).") ";
        $query .= "ORDER BY {$this->store->field_campaign_endDate}, {$this->store->field_campaign_startDate}";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','campaignID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No campaigns available');
            $option->appendChild($text);
            $select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('Please select a campaign...');
            $option->appendChild($text);
            $select->appendChild($option);
            while ($line = sysdb::fetch_assoc($result)) {
                $option = $doc->createElement('option');
                $option->setAttribute('value',$line['campaignID']);
                $text = $doc->createTextNode(utf8_decode($line['name']));
                $option->appendChild($text);
                if ($default == $line['campaignID']) $option->setAttribute('selected','selected');
                $select->appendChild($option);
            }
        }

        return($select);
    }

    public function add($startYear,$startMonth,$startDay,
						$endYear,$endMonth,$endDay,$createdDateTime,
						$name,$audioAllotted,$spotsAllotted,$contractID,$assignIDList,
						$samActorID,$salesRepActorID) {
		// Escape values.
		$values = array(&$name
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Format integers to strip thousand-separators.
		$values = array(&$audioAllotted,
						&$spotsAllotted
						);
 		foreach ($values as &$value) {
			$value = number_format(str_replace(',', '', $value), 0, '', '');
		}
		unset($value);

		global $module_parameter;
		$errors = false;
		$item = globalize('item', get_class($this));

		if (!checkdate($startMonth,$startDay,$startYear)) {
			state::setMessage('warning', 'Invalid start date.');
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			state::setMessage('warning', 'Invalid end date.');
			$errors = true;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ( !$errors ) {
			$query = "SELECT clientID FROM {$this->store->table_traffic_contract} WHERE contractID = '$contractID'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$query = "INSERT INTO {$this->store->table_traffic_campaign} (startDate,endDate,createdDateTime,name,audioAllotted,spotsAllotted,contractID,clientID) VALUES ('$startDate','$endDate','$createdDateTime','$name','$audioAllotted','$spotsAllotted','$contractID','".$line['clientID']."')";
			$result = sysdb::query($query);

			$contractData = self::getContractDetails($contractID);
			$audio = ($contractData['audioRemaining'] < 0);
			$spots = ($contractData['spotsRemaining'] < 0);
			if ( $audio || $spots ) {

				$msg = 'This campaign\'s contract is now exceeding its purchased amounts for ';

				if ( $audio && $spots )
					$msg .= 'audio and spots.';
				elseif ( $audio )
					$msg .= 'audio.';
				elseif ( $spots )
					$msg .= 'spots.';

				state::setMessage('warning', $msg );
			}

			state::setMessage('notify', 'Successfully added new campaign: '.utf8_decode($name));
			$campaignID = sysdb::insert_id();

			// Check to see if disabling of SAM role is set as a module parameter.
			if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == 1) {
				$assign_type = 'salesRepID';
				$class_title = new SalesRep;
				$assignID = $salesRepActorID;
				$table_assign = $this->store->table_traffic_salesrep;
				$field_assign = $this->store->field_salesrep_salesRepID;
				$field_actor = $this->store->field_salesrep_actorID;
			} else {
				$assign_type = 'samID';
				$class_title = new SAM;
				$assignID = $samActorID;
				$table_assign = $this->store->table_traffic_sam;
				$field_assign = $this->store->field_sam_samID;
				$field_actor = $this->store->field_sam_actorID;
			}

			// If details for a new role was added on the inline form, add it.
			if ($assignID != '') {
				call_user_func_array(array($class_title, "add"), array($assignID));

				// Fetch the newly inserted assignID and add it into the table_assign table.
				$query = <<<EOQ
					INSERT INTO {$this->store->table_traffic_campaignassign} (
						{$this->store->field_campaignassign_id},
						{$this->store->field_campaignassign_campaignID},
						{$this->store->field_campaignassign_type}
					)
					SELECT {$field_assign} AS {$this->store->field_campaignassign_id},
						'$campaignID' AS {$this->store->field_campaignassign_campaignID},
						'$assign_type' AS {$this->store->field_campaignassign_type}
					FROM {$table_assign}
					WHERE {$field_actor} = '$assignID'
EOQ;
				sysdb::query($query);
/*
			}
			if (!empty($assignIDList)) {
*/
			// The above two lines of code are replaced by the following elseif statement because currently
			// only one salesrep/sam may be assigned to each campaign. So $assignID overrides $assignIDList.
			// If you want to be able to assign multiple salesreps/sams, replace the elseif and change the input box
			// to a multi-select box instead of a combo box.
			} elseif (!empty($assignIDList)) {
				foreach($assignIDList as $assignID ) {
					if ($assignID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_campaignassign} ({$this->store->field_campaignassign_campaignID},{$this->store->field_campaignassign_id},{$this->store->field_campaignassign_type}) VALUES ('$campaignID','$assignID','$assign_type')";
						$result = sysdb::query($query);
					}
				}
			}

            // Forward user to new Audio if not using function from foreign class.
			if ($item == 'Campaign') {
				module::forward_to_script('',array('item'=>'CampaignAudio','action'=>'multi_add','campaignID'=>$campaignID));
			}
			//module::forward_to_script('',array('item'=>'Campaign','action'=>'view','id'=>$campaignID));
		}
    }

    public function save($id,$startYear,$startMonth,$startDay,$endYear,$endMonth,
						$endDay,$name,$audioAllotted,$spotsAllotted,$assignIDList,
						$samActorID,$salesRepActorID) {
		// Escape values.
		$values = array(&$name
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Format integers to strip thousand-separators.
		$values = array(&$audioAllotted,
						&$spotsAllotted
						);
 		foreach ($values as &$value) {
			$value = number_format(str_replace(',', '', $value), 0, '', '');
		}
		unset($value);

 		global $module_parameter;
		$errors = false;

		if (!checkdate($startMonth,$startDay,$startYear)) {
			state::setMessage('warning', 'Invalid start date.');
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			state::setMessage('warning', 'Invalid end date.');
			$errors = true;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ( !$errors ) {
			$query = "UPDATE {$this->store->table_traffic_campaign} SET startDate = '$startDate', endDate = '$endDate', name = '$name', audioAllotted = '$audioAllotted', spotsAllotted = '$spotsAllotted' WHERE campaignID = '$id'";
			$result = sysdb::query($query);

			$query = "SELECT contractID FROM {$this->store->table_traffic_campaign} WHERE campaignID = '$id'";
			$line = sysdb::fetch_assoc(sysdb::query($query));
			$contractID = $line['contractID'];

			$contractData = $this->getContractDetails($contractID);
			$audio = ($contractData['audioRemaining'] < 0);
			$spots = ($contractData['spotsRemaining'] < 0);
			if ( $audio || $spots ) {

				$msg = 'This campaign\'s contract is now exceeding its purchased amounts for ';

				if ( $audio && $spots )
					$msg .= 'audio and spots.';
				elseif ( $audio )
					$msg .= 'audio.';
				elseif ( $spots )
					$msg .= 'spots.';

				state::setMessage('warning', $msg );
			}

			state::setMessage('notify', 'Successfully updated campaign: '.utf8_decode($name));

			// Check to see if disabling of SAM role is set as a module parameter.
			if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == 1) {
				$assign_type = 'salesRepID';
				$class_title = new SalesRep;
				$assignID = $salesRepActorID;
				$table_assign = $this->store->table_traffic_salesrep;
				$field_assign = $this->store->field_salesrep_salesRepID;
				$field_actor = $this->store->field_salesrep_actorID;
			} else {
				$assign_type = 'samID';
				$class_title = new SAM;
				$assignID = $samActorID;
				$table_assign = $this->store->table_traffic_sam;
				$field_assign = $this->store->field_sam_samID;
				$field_actor = $this->store->field_sam_actorID;
			}

			// Purge existing assignments for campaign.
			$query = "DELETE FROM {$this->store->table_traffic_campaignassign} WHERE {$this->store->field_campaignassign_campaignID} = '$id'";
			sysdb::query($query);

			// If details for a new role was added on the inline form, add it.
			if ($assignID != '') {
				call_user_func_array(array($class_title, "add"), array($assignID));

				// Fetch the newly inserted assignID and add it into the table_assign table.
				$query = <<<EOQ
					INSERT INTO {$this->store->table_traffic_campaignassign} (
						{$this->store->field_campaignassign_id},
						{$this->store->field_campaignassign_campaignID},
						{$this->store->field_campaignassign_type}
					)
					SELECT {$field_assign} AS {$this->store->field_campaignassign_id},
					'$id' AS {$this->store->field_campaignassign_campaignID},
					'$assign_type' AS {$this->store->field_campaignassign_type}
					FROM {$table_assign}
					WHERE {$field_actor} = '$assignID'
EOQ;
				sysdb::query($query);
/*
			}
			if (!empty($assignIDList)) {
*/
			// The above two lines of code are replaced by the following elseif statement because currently
			// only one salesrep/sam may be assigned to each campaign. So $assignID overrides $assignIDList.
			// If you want to be able to assign multiple salesreps/sams, replace the elseif and change the input box
			// to a multi-select box instead of a combo box.
			} elseif (!empty($assignIDList)) {
				foreach($assignIDList as $assignID) {
					if ($assignID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_campaignassign} ({$this->store->field_campaignassign_campaignID},{$this->store->field_campaignassign_id},{$this->store->field_campaignassign_type}) VALUES ('$id','$assignID','$assign_type')";
						$result = sysdb::query($query);
					}
				}
			}

			module::forward_to_script('',array('item'=>'Campaign','action'=>'view','id'=>$id));
		}
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this Campaign item?</p>';
		$message .= '<p>The item and all its daughter campaign materials, audio and spots will be permanently deleted if you proceed.</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);
		return;
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','id'=>$id));
		return;
    }

    public function delete($id) {
		$success = false;

        $query = <<<EOQ
            SELECT {$this->store->field_campaign_name}
			FROM {$this->store->table_traffic_campaign}
			WHERE campaignID = '$id'
EOQ;
		$campaignName = sysdb::queryOne($query);

		// Delete daughter campaign audio.
        $query = <<<EOQ
            SELECT {$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID
			FROM {$this->store->table_traffic_campaignaudio}
			WHERE {$this->store->field_campaignaudio_campaignID} = '$id'
EOQ;
		$result = sysdb::query($query);
		if (sysdb::num_rows($result) > 0) {
			while ($line = sysdb::fetch_assoc($result)) {
				$status = CampaignAudio::delete($line['campaignAudioID']);
				if ($status) {
					$success = true;
				} else {
					state::setMessage('warning', 'Could not delete campaign audio.');
					$success = false;
				}
			}
		}

		// Delete daughter campaign materials.
        $query = <<<EOQ
            SELECT {$this->store->field_campaignmaterial_campaignMaterialID} AS campaignMaterialID
			FROM {$this->store->table_traffic_campaignmaterial}
			WHERE {$this->store->field_campaignmaterial_campaignID} = '$id'
EOQ;
		$result = sysdb::query($query);
		if (sysdb::num_rows($result) > 0) {
			while ($line = sysdb::fetch_assoc($result)) {
				$status = CampaignMaterial::delete($line['campaignMaterialID']);
				if ($status) {
					$success = true;
				} else {
					state::setMessage('warning', 'Could not delete campaign materials.');
					$success = false;
				}
			}
		}

		// Delete daughter campaign promotions.
        $query = <<<EOQ
            SELECT {$this->store->field_campaignpromotion_campaignPromotionID} AS campaignPromotionID
			FROM {$this->store->table_traffic_campaignpromotion}
			WHERE {$this->store->field_campaignpromotion_campaignID} = '$id'
EOQ;
		$result = sysdb::query($query);
		if (sysdb::num_rows($result) > 0) {
			while ($line = sysdb::fetch_assoc($result)) {
				$status = CampaignPromotion::delete($line['campaignPromotionID']);
				if ($status) {
					$success = true;
				} else {
					state::setMessage('warning', 'Could not delete campaign promotions.');
					$success = false;
				}
			}
		}

		// Proceed if all daughter objects successfully removed.
		if ($success) {
			// Remove assignments for campaign.
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_campaignassign}
				WHERE {$this->store->field_campaignassign_campaignID} = '$id'
EOQ;
			sysdb::query($query);

			// Remove campaign.
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_campaign}
				WHERE {$this->store->field_campaign_campaignID} = '$id'
EOQ;
			sysdb::query($query);
			state::setMessage('notify', 'Successfully deleted campaign: '.utf8_decode($campaignName));
		}
		return $success;
    }

    public function search($doc,$string) {
        $string = strtolower($string);
        $query = "SELECT campaignID FROM {$this->store->table_traffic_campaign} WHERE LCASE(name) LIKE '%$string%' OR startDate LIKE '%$string%' OR endDate LIKE '%$string%' OR createdDateTime LIKE '%$string%' ";
        $result = sysdb::query($query);
        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'campaignID')));
        }
    }

	public function include_header($doc,$parentIDType) {

		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		$item = globalize('item', get_class($this));
		$id = globalize('id');
		$extras = globalize('extras');
		$includeHeader = $doc->createElement('div');
		$includeHeader->setAttribute('id', 'inline_menu');

		$link = module::link_to_script_dom($doc,'Contracts','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Contract'),'Contracts');
		$contractsLink = $doc->createElement('span');
		$contractsLink->setAttribute('id', 'link_contracts');
		$contractsLink->setAttribute('class', 'inline_link');
		$contractsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Campaigns','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Campaign'),'Campaigns');
		$campaignsLink = $doc->createElement('span');
		if ($extras == 'Campaign' || $extras == '')
			$campaignsLink->setAttribute('id', 'link_campaigns_selected');
		else
			$campaignsLink->setAttribute('id', 'link_campaigns');
		$campaignsLink->setAttribute('class', 'inline_link');
		$campaignsLink->appendChild($link);

		// $link = module::link_to_script_dom($doc,'Promotions','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignPromotion'),'Promotions');
		// $campaignPromotionsLink = $doc->createElement('span');
		// $campaignPromotionsLink->setAttribute('id', 'link_campaign_promotions');
		// $campaignPromotionsLink->setAttribute('class', 'inline_link');
		// $campaignPromotionsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Materials','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignMaterial'),'Materials');
		$campaignMaterialsLink = $doc->createElement('span');
		$campaignMaterialsLink->setAttribute('id', 'link_campaign_materials');
		$campaignMaterialsLink->setAttribute('class', 'inline_link');
		$campaignMaterialsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Audio','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignAudio'),'Audio');
		$campaignAudioLink = $doc->createElement('span');
		$campaignAudioLink->setAttribute('id', 'link_campaign_audio');
		$campaignAudioLink->setAttribute('class', 'inline_link');
		$campaignAudioLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Traffic','',array('item'=>'Traffic','mode'=>$item,$parentFieldName=>$id),'Traffic');
		$trafficLink = $doc->createElement('span');
		$trafficLink->setAttribute('id', 'link_traffic');
		$trafficLink->setAttribute('class', 'inline_link');
		$trafficLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Log','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Log'),'Log');
		$logLink = $doc->createElement('span');
		$logLink->setAttribute('id', 'link_traffic');
		$logLink->setAttribute('class', 'inline_link');
		$logLink->appendChild($link);

		/* 	This switch is specifically designed *without* break statements.
			This is because once we hit our current item, all those below it are required as well.
			-CH
		*/
		switch ($item) {
			case 'Client':
				$includeHeader->appendChild($contractsLink);
			case 'Contract':
				$includeHeader->appendChild($campaignsLink);
			case 'Campaign':
				$includeHeader->appendChild($campaignAudioLink);
				$includeHeader->appendChild($logLink);
				$includeHeader->appendChild($trafficLink);
				break;
		}

		return $includeHeader;

	}

    public function inline_list($doc,$ids='',$isInclude=false) {
		$item = get_class($this);
		$parentID = globalize('id');
		$parentIDType = globalize('item', get_class($this));
		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		if ($parentIDType == 'Client')
			$x = 'C';
		if ($parentIDType == 'Contract')
			$x = 'T';
		if ($parentIDType == 'Campaign')
			$x = 'G';
		$query = "SELECT $x.name FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} T, {$this->store->table_traffic_campaign} G) WHERE $x.$parentFieldName = '$parentID' AND C.clientID = $x.clientID";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$caption_name = utf8_decode($line['name']);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module_right');
		$container->appendChild($this->include_header($doc,$parentIDType));

		$sortby = globalize('sortby');
		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
							break;
				case 'contractname':
							$sortby = 'contractName';
							break;
				case 'startdate':
							$sortby = 'startDate, name';
							break;
				case 'enddate':
							$sortby = 'endDate, name';
							break;
				default:
							$sortby = 'name';
							break;
			}
		}

		function inline_list_actions($doc,$id) {
			$item = 'Campaign';
			$div = $doc->createElement('div');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
			/* I had to substitute the $item variable for the hardcoded 'Contract' because using the variable would require modification of the db.php callback */
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$id),'View'));
            $div->appendChild($span);
			$div->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$id),'Edit'));
            $div->appendChild($span);

			return $div;
		}

		function inline_list_header($doc) {
			$item = 'Campaign';
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			$th1 = $doc->createElement('th');
			if ($parentIDType == 'Client')
				$th2 = $doc->createElement('th');
			$th3 = $doc->createElement('th');
			$th4 = $doc->createElement('th');
			$actiontd = $doc->createElement('th');
			$actiontd->setAttribute('class', 'action');
			$th1->appendChild(module::link_to_script_dom($doc,'Name','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'name'),'Name'));
			if ($parentIDType == 'Client')
				$th2->appendChild(module::link_to_script_dom($doc,'Contract #','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'contractname'),'Contract #'));
			$th3->appendChild(module::link_to_script_dom($doc,'Start Date','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'startdate'),'Start Date'));
			$th4->appendChild(module::link_to_script_dom($doc,'End Date','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'enddate'),'End Date'));

			if ($parentIDType == 'Client') {
				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Campaign','',array('item'=>$item,'action'=>'inline_add','clientID'=>$parentID),'Add New Campaign'));
				$actiontd->appendChild($span);
			}

			if ($parentIDType == 'Contract') {
				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Campaign','',array('item'=>$item,'action'=>'edit','contractID'=>$parentID),'Add New Campaign'));
				$actiontd->appendChild($span);
			}

			$tr->appendChild($th1);
			if ($parentIDType == 'Client')
				$tr->appendChild($th2);
			$tr->appendChild($th3);
			$tr->appendChild($th4);
			$tr->appendChild($actiontd);

			return $tr;
		}

		function inline_list_footer($doc) {
			$item = 'Campaign';
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
//			if ($parentIDType == 'Contract') {
				$td1 = $doc->createElement('td');
				if ($parentIDType == 'Client')
					$td2 = $doc->createElement('td');
				$td3 = $doc->createElement('td');
				$td4 = $doc->createElement('td');
				$actiontd = $doc->createElement('td');
				$actiontd->setAttribute('class', 'number');

				if ($parentIDType == 'Client') {
					$span = $doc->createElement('span');
					$span->setAttribute('class', 'link_add_small');
					$span->appendChild(module::link_to_script_dom($doc,'Add New Campaign','',array('item'=>$item,'action'=>'inline_add','clientID'=>$parentID),'Add New Campaign'));
					$actiontd->appendChild($span);
				}

				if ($parentIDType == 'Contract') {
					$span = $doc->createElement('span');
					$span->setAttribute('class', 'link_add_small');
					$span->appendChild(module::link_to_script_dom($doc,'Add New Campaign','',array('item'=>$item,'action'=>'edit','contractID'=>$parentID),'Add New Campaign'));
					$actiontd->appendChild($span);
				}

				$tr->appendChild($td1);
				if ($parentIDType == 'Client')
					$tr->appendChild($td2);
				$tr->appendChild($td3);
				$tr->appendChild($td4);
				$tr->appendChild($actiontd);
//			}
			return $tr;
		}

		function inline_list_colgroups($doc) {
			$parentIDType = globalize('item');
			$col1 = $doc->createElement('col');

			$col2 = $doc->createElement('col');
			$col2->setAttribute('width', '110px');

			$col3 = $doc->createElement('col');
			$col4 = $doc->createElement('col');
			$colactions = $doc->createElement('col');
			//$colactions->setAttribute('width', '56px');

			if ($parentIDType == 'Client') {
				$colgroup = array($col1,$col2,$col3,$col4,$colactions);
			}
			if ($parentIDType == 'Contract' || $parentIDType == 'Campaign') {
				$colgroup = array($col1,$col3,$col4,$colactions);
			}
			return $colgroup;
		}

		/* All the functions need to be loaded up as variables, to avoid undefined variable errors from call_user_func_array() */
		$action_func = 'inline_list_actions';
		$footer_func = 'inline_list_footer';
		$header_func = 'inline_list_header';
		$col_func = 'inline_list_colgroups';
		$colgroup = call_user_func_array($col_func,array($doc));
		$caption = "Campaigns for $caption_name";
		if ($parentIDType == 'Contract') {
			$ignore = array('0','2','3');
		} else {
			$ignore = array('0','2');
		}

		$query = "SELECT I.campaignID, I.name, ";
		$query .= "I.contractID, T.name as contractName, ";
		$query .= "I.startDate, I.endDate FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_contract} T)";
		$query .= " WHERE I.$parentFieldName = '$parentID'";
		$query .= " AND T.contractID = I.contractID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " I.campaignID IN (".implode(',',$ids).") ";
        if(isset($sortby))
			$query .= " ORDER BY ".$sortby;
        // $result = sysdb::query($query);

		// Turn result query into a matrix.
		$matrix = sysdb::query2matrix($query,false);

		// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
		$vectors = sysdb::rotatematrix($matrix);

		// Perform data transformation on any column (vector), row by row (key by key).
        $campaignNames = array();
        $contractNames = array();
        $startDates = array();
        $endDates = array();
        $actions = array();
		if (!empty($vectors[0])) {
			foreach ($vectors[0] as $key=>$value) {
				$campaignNames[$key] = module::link_to_script_dom($doc,utf8_decode($vectors[1][$key]),'',array('item'=>'Campaign','action'=>'view','id'=>$vectors[0][$key]),'');
				$contractNames[$key] = module::link_to_script_dom($doc,utf8_decode($vectors[3][$key]),'',array('item'=>'Contract','action'=>'view','id'=>$vectors[2][$key]),'');
				$startDates[$key] = date("d-M-Y", strtotime($vectors[4][$key]));
				$endDates[$key] = date("d-M-Y", strtotime($vectors[5][$key]));
				$actions[$key] = inline_list_actions($doc,$value);
			}
		}

		// Replace the original matrix column(s) with the new the vector(s).
		$vectors[1] = $campaignNames;
		$vectors[3] = $contractNames;
		$vectors[4] = $startDates;
		$vectors[5] = $endDates;
		$vectors[6] = $actions;

		// Rotate the new matrix 270 degrees to put it back the right way.
		$matrix_rotated_180 = sysdb::rotatematrix($vectors);
		$matrix_rotated_270 = sysdb::rotatematrix($matrix_rotated_180);
		$matrix_upright = sysdb::rotatematrix($matrix_rotated_270);

		$containertable = $doc->createElement('div');
		$containertable->setAttribute('id', 'inline_table');

		$table = sysdb::dom_matrix2table
		(
			$doc,
			$matrix_upright,
			false,
			'',
			'',
			$ignore,
			$footer_func,
			$header_func,
			array('table'=>'list','tr'=>'even','td'=>''),
			$caption,
			$colgroup,
			''
		);

		$containertable->appendChild($table);
 		$container->appendChild($containertable);

        return($container);
    }

    public function inline_add($doc,$ids='') {
		$item = get_class($this);
		if (globalize('clientID') != '') {
			$parentID = globalize('clientID');
			$parentIDType = 'Client';
			$parentFieldName = 'clientID';

			$query = "SELECT contractID FROM ({$this->store->table_traffic_contract}) WHERE $parentFieldName = '$parentID'";
			$ids = sysdb::query2vector($query,'contractID');

			if (is_array($ids) && sizeof($ids) == 1) { $default = $ids[0]; }
			else if (is_array($ids) && sizeof($ids) != 1) { $default = ''; }

			$container = $doc->createElement('div');
			$container->setAttribute('class','module_left');

			$header = $doc->createElement('h1');
			$header->appendChild($doc->createTextNode('Add Campaign'));
			$container->appendChild($header);

			$subheader = $doc->createElement('h2');
			$subheader->appendChild($doc->createTextNode('Specify the parent contract for the new campaign.'));
			$container->appendChild($subheader);

			$contract = new Contract();
			$container->appendChild($contract->display_select($doc, $ids, $default));

			$container->appendChild($select = $doc->createElement('input'));
			$select->setAttribute('type','submit');
			$select->setAttribute('name','action');
			$select->setAttribute('value','select');

			$container->appendChild($br = $doc->createElement('br'));
			$container->appendChild($br = $doc->createElement('br'));
			$container->appendChild($br = $doc->createElement('br'));

			$altsubheader = $doc->createElement('h2');
			$altsubheader->appendChild($doc->createTextNode('Alternatively, add a new contract.'));
			$container->appendChild($altsubheader);

			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Add Contract','',array('item'=>"Contract",'action'=>'edit','clientID'=>$parentID),'Add Contract','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_add');
			$label = $doc->createTextNode('Add Contract');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			return($container);
		} else {
			state::setMessage('warning', 'Not a valid parent.');
			break;
		}
    }

    public function select($contractID) {
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','contractID'=>$contractID));
    }

	public function getContractDetails($contractID) {
		$query = "SELECT audioPurchased, spotsPurchased FROM {$this->store->table_traffic_contract} WHERE contractID = '$contractID'";
		$result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$audioPurchased = $line['audioPurchased'];
		$spotsPurchased = $line['spotsPurchased'];

		$query = "SELECT audioAllotted, spotsAllotted FROM {$this->store->table_traffic_campaign} WHERE contractID = '$contractID'";
		$result = sysdb::query($query);
		$totalCampaignAudio = 0;
		$totalCampaignSpots = 0;
		while ($line = sysdb::fetch_assoc($result)) {
			$totalCampaignAudio += $line['audioAllotted'];
			$totalCampaignSpots += $line['spotsAllotted'];
		}

		$query = "SELECT contractID FROM {$this->store->table_traffic_campaignaudio} WHERE contractID = '$contractID'";
		$result = sysdb::query($query);
		$totalActualAudio = sysdb::num_rows($result);

		$query = "SELECT S.spotID FROM ({$this->store->table_traffic_spot} S, {$this->store->table_traffic_campaignaudio} A) WHERE A.contractID = '$contractID' AND A.mediaID = S.mediaID";
		$result = sysdb::query($query);
		$totalActualSpots = sysdb::num_rows($result);

		$contractAudioRemaining = $audioPurchased - $totalCampaignAudio;
		$contractSpotsRemaining = $spotsPurchased - $totalCampaignSpots;

		return array( 'audioRemaining'=>$contractAudioRemaining,
					  'spotsRemaining'=>$contractSpotsRemaining,
					  'totalActualSpots'=>$totalActualSpots,
					  'totalActualAudio'=>$totalActualAudio );
	}

}
?>
