<?php
// $Id$

/** @file
* Handles functionality related to CampaignAudio objects.
*/

include_once('sendemails.php');

class CampaignAudio {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function headers($doc) {
        switch(globalize('action')) {
            case 'schedule':
                return(Schedule::headers($doc));
                break;
			default:
				$moduleID = globalize('moduleID');
				$item = globalize('item', get_class($this));
				$script = $doc->createElement('script');
				$script->setAttribute('language', 'javascript');
				$script->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=".$item.".js");
				$script->appendChild($doc->createTextNode(''));
				return(array($script));
        }
    }

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('campaignAudioName'),
							globalize('campaignAudioProductionStatus'),
							globalize('campaignAudioDescription'),
							globalize('campaignAudioDuration'),
							globalize('campaignAudioTalentGender'),
							globalize('campaignAudioStartYear'),
							globalize('campaignAudioStartMonth'),
							globalize('campaignAudioStartDay'),
							globalize('campaignAudioEndYear'),
							globalize('campaignAudioEndMonth'),
							globalize('campaignAudioEndDay'),
							globalize('campaignAudioDeadlineYear'),
							globalize('campaignAudioDeadlineMonth'),
							globalize('campaignAudioDeadlineDay'),
							globalize('campaignAudioCreatedDateTime'),
							globalize('campaignAudioProducerID'),
							globalize('producerActorID'),
							globalize('campaignID'),
							'campaignAudioFilename',
							globalize('MAX_FILE_SIZE'),
							globalize('campaignAudioProductTypeIDList'),
							globalize('productTypeName'),
							globalize('productTypeStartYear'),
							globalize('productTypeStartMonth'),
							globalize('productTypeStartDay'),
							globalize('productTypeEndYear'),
							globalize('productTypeEndMonth'),
							globalize('productTypeEndDay'),
							globalize('campaignAudioTalentIDList'),
							globalize('talentTitle'),
							globalize('talentFirstName'),
							globalize('talentLastName'),
							globalize('talentAddress'),
							globalize('talentCity'),
							globalize('talentPostcode'),
							globalize('talentWork'),
							globalize('talentMobile'),
							globalize('talentFax'),
							globalize('talentEmail')
							);
				break;
            case 'add all':
				$this->add_many(globalize('campaignAudioName'),
							globalize('campaignAudioProductionStatus'),
							globalize('campaignAudioDescription'),
							globalize('campaignAudioDuration'),
							globalize('campaignAudioTalentGender'),
							globalize('campaignAudioStartYear'),
							globalize('campaignAudioStartMonth'),
							globalize('campaignAudioStartDay'),
							globalize('campaignAudioEndYear'),
							globalize('campaignAudioEndMonth'),
							globalize('campaignAudioEndDay'),
							globalize('campaignAudioDeadlineYear'),
							globalize('campaignAudioDeadlineMonth'),
							globalize('campaignAudioDeadlineDay'),
							globalize('campaignAudioCreatedDateTime'),
							globalize('campaignAudioProducerID'),
							globalize('producerActorID'),
							globalize('campaignID'),
							globalize('campaignAudioProductTypeIDList'),
							globalize('productTypeName'),
							globalize('productTypeStartYear'),
							globalize('productTypeStartMonth'),
							globalize('productTypeStartDay'),
							globalize('productTypeEndYear'),
							globalize('productTypeEndMonth'),
							globalize('productTypeEndDay'),
							globalize('campaignAudioTalentIDList'),
							globalize('talentTitle'),
							globalize('talentFirstName'),
							globalize('talentLastName'),
							globalize('talentAddress'),
							globalize('talentCity'),
							globalize('talentPostcode'),
							globalize('talentWork'),
							globalize('talentMobile'),
							globalize('talentFax'),
							globalize('talentEmail'),
							globalize('campaignAudioQuantity')
							);
				break;
            case 'save':
				$this->save(globalize('campaignAudioID'),
							globalize('campaignAudioName'),
							globalize('campaignAudioProductionStatus'),
							globalize('campaignAudioDescription'),
							globalize('campaignAudioDuration'),
							globalize('campaignAudioTalentGender'),
							globalize('campaignAudioStartYear'),
							globalize('campaignAudioStartMonth'),
							globalize('campaignAudioStartDay'),
							globalize('campaignAudioEndYear'),
							globalize('campaignAudioEndMonth'),
							globalize('campaignAudioEndDay'),
							globalize('campaignAudioDeadlineYear'),
							globalize('campaignAudioDeadlineMonth'),
							globalize('campaignAudioDeadlineDay'),
							globalize('campaignAudioCreatedDateTime'),
							globalize('campaignAudioProducerID'),
							globalize('producerActorID'),
							'campaignAudioFilename',
							globalize('MAX_FILE_SIZE'),
							globalize('campaignAudioMediaID'),
							globalize('campaignAudioProductTypeIDList'),
							globalize('productTypeName'),
							globalize('productTypeStartYear'),
							globalize('productTypeStartMonth'),
							globalize('productTypeStartDay'),
							globalize('productTypeEndYear'),
							globalize('productTypeEndMonth'),
							globalize('productTypeEndDay'),
							globalize('campaignAudioTalentIDList'),
							globalize('talentTitle'),
							globalize('talentFirstName'),
							globalize('talentLastName'),
							globalize('talentAddress'),
							globalize('talentCity'),
							globalize('talentPostcode'),
							globalize('talentWork'),
							globalize('talentMobile'),
							globalize('talentFax'),
							globalize('talentEmail')
							);
				break;
            case 'download':
				$this->download(globalize('campaignAudioID'),
							globalize('id'));
				break;
            case 'select':
				$this->select(globalize('campaignID'));
				break;
            case "remove":
				$this->remove(globalize('id'));
				break;
            case "cancel":
				$this->cancel(globalize('id'));
				break;
            case 'annotate':
				Notes::add(
					globalize('notesActorID'),
					globalize('notesType'),
					globalize('notesId'),
					globalize('notesAction'),
					globalize('notesDetails')
					);
				break;
        }
    }

    public function form($doc, $id='') {

		$campaignID = globalize('campaignID');

		$form = module::form_dom($doc);
		$form->setAttribute('enctype','multipart/form-data');

		$item = globalize('item', get_class($this));

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','item');
		$iteminput->setAttribute('value',$item);
		$form->appendChild($iteminput);

		$maxFileSize = $doc->createElement('input');
		$maxFileSize->setAttribute('type','hidden');
		$maxFileSize->setAttribute('name','MAX_FILE_SIZE');
		$maxFileSize->setAttribute('value','150000000');
		$form->appendChild($maxFileSize);


		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$form->appendChild($terminate);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Campaign Audio';
        else
            $headerText = 'Edit Campaign Audio';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

        $campaignAudioID = $doc->createElement('input');
        $campaignAudioID->setAttribute('type','hidden');
        $campaignAudioID->setAttribute('name','campaignAudioID');
        $campaignAudioID->setAttribute('value',$id);
        $container->appendChild($campaignAudioID);

		$input = $doc->createElement('input');
        $input->setAttribute('type','hidden');
        $input->setAttribute('name','campaignID');
        $input->setAttribute('value',$campaignID);
        $container->appendChild($input);

		$datetime = date("Y-m-d H:i:s");

		$date = $doc->createElement('input');
        $date->setAttribute('type', 'hidden');
        $date->setAttribute('name', 'campaignAudioCreatedDateTime');
        $date->setAttribute('value', $datetime);
        $container->appendChild($date);

        if ($id != '') {
			$query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.contractID as contractID, B.name as campaignName, B.campaignID as campaignID, I.* ";
			$query.= "FROM {$this->store->table_traffic_campaignaudio} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A, {$this->store->table_traffic_campaign} B ";
			$query .= "WHERE I.campaignAudioID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID AND B.campaignID = I.campaignID";

			$result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $campaignAudioID = $line['campaignAudioID'];
			$mediaID = $line['mediaID'];
            $name = $line['name'];
			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$campaignName = $line['campaignName'];
			$clientID = $line['clientID'];
			$contractID = $line['contractID'];
			$campaignID = $line['campaignID'];
            $createdDateTime = $line['createdDateTime'];
            $productionStatus = $line['productionStatus'];
            $description = $line['description'];
            $filename = $line['filename'];
            $duration = $line['duration'];
            $talentGender = $line['talentGender'];
			$startDateArray = explode('-',$line['startDate']);
			$endDateArray = explode('-',$line['endDate']);
			$deadlineDateArray = explode('-',$line['deadlineDate']);
            $producerID = $line['producerID'];

			// Decode UTF-8 character encoding.
			$values = array(&$name,
							&$description,
							&$clientName,
							&$contractName,
							&$campaignName
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$query = "SELECT * FROM {$this->store->table_traffic_campaignaudioproducttype} WHERE campaignAudioID = '$id'";
			$result = sysdb::query($query);
			$productTypeIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($productTypeIDList, $line['productTypeID']);
			}

			$query = "SELECT * FROM {$this->store->table_traffic_campaignaudiotalent} WHERE campaignAudioID = '$id'";
			$result = sysdb::query($query);
			$talentIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($talentIDList, $line['talentID']);
			}

			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>"CampaignAudio",'action'=>'remove','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"CampaignAudio",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);

			if ($mediaID == 0)
				$mediaID = '';

			$campaignAudioMediaID = $doc->createElement('input');
			$campaignAudioMediaID->setAttribute('type','hidden');
			$campaignAudioMediaID->setAttribute('name','campaignAudioMediaID');
			$campaignAudioMediaID->setAttribute('value',$mediaID);
			$container->appendChild($campaignAudioMediaID);

        } else {
			// Check to see if a deadline date buffer is set as a module parameter.
			global $module_parameter;
			if (isset($module_parameter['deadlineDateBuffer'])) {
				$deadlineDateBuffer = $module_parameter['deadlineDateBuffer'];
			} else {
				$deadlineDateBuffer = 0;
			}
			$query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.contractID as contractID, B.name as campaignName, B.startDate as campaignStartDate, B.endDate as campaignEndDate, (B.startDate + INTERVAL $deadlineDateBuffer DAY) as campaignDeadlineDate ";
			$query .= "FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A, {$this->store->table_traffic_campaign} B) ";
			$query .= "WHERE B.campaignID = '$campaignID' AND A.contractID = B.contractID AND C.clientID = B.clientID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);

			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$campaignName = $line['campaignName'];
			$contractID = $line['contractID'];
			$clientID = $line['clientID'];
            $campaignAudioID = '';
            $createdDateTime = '';
            $name = $line['campaignName'];
            $productionStatus = '';
            $description = '';
            $filename = '';

			// Check to see if a default duration is set as a module parameter.
			if (isset($module_parameter['durationDefault'])) {
				$duration = $module_parameter['durationDefault'];
			} else {
				$duration = '';
			}

            $talentGender = '';
			$startDateArray = explode('-',$line['campaignStartDate']);
			$endDateArray = explode('-',$line['campaignEndDate']);
			$deadlineDateArray = explode('-',$line['campaignDeadlineDate']);
            $producerID = '';

			// If default statuses to Approved is enabled as a module parameter.
			if (isset($module_parameter['defaultStatusApproved']) && $module_parameter['defaultStatusApproved'] == '1') {
				$productionStatus = 'Approved';
			}
		}

        $queryproducer = "SELECT S.campaignAudioID, S.description, S.filename, S.name FROM {$this->store->table_traffic_campaignaudio} S ORDER BY filename, description";
        $resultproducer = sysdb::query($queryproducer);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$campaignNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$campaignName,'',array('item'=>'Campaign','action'=>'view','id'=>$campaignID),'View'));
        $campaignNametr->appendChild($labeltd);
        $campaignNametr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign Audio Name *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignAudioName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $productionStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Production Status *');
        $inputtd = $doc->createElement('td');
		$data = array( 'Pending Draft Approval'=>'Pending Draft Approval', 'In Production'=>'In Production', 'Pending Internal Approval'=>'Pending Internal Approval', 'Pending Client Approval'=>'Pending Client Approval', 'Approved'=>'Approved' );
        $input = dom::createDropdown( $doc, 'campaignAudioProductionStatus', $data, $productionStatus );
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $productionStatustr->appendChild($labeltd);
        $productionStatustr->appendChild($inputtd);

        $descriptiontr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Description');
        $inputtd = $doc->createElement('td');
        $textarea = $doc->createElement('textarea');
        $textarea->setAttribute('name','campaignAudioDescription');
        $input = $doc->createTextNode($description);
        $labeltd->appendChild($label);
        $inputtd->appendChild($textarea);
        $textarea->appendChild($input);
        $descriptiontr->appendChild($labeltd);
        $descriptiontr->appendChild($inputtd);

		$currentFilenametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Current Filename');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($filename);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $currentFilenametr->appendChild($labeltd);
        $currentFilenametr->appendChild($inputtd);

        $filenametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Upload New File');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','file');
        $input->setAttribute('name','campaignAudioFilename');
        $input->setAttribute('id','campaignAudioFilename');
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $filenametr->appendChild($labeltd);
        $filenametr->appendChild($inputtd);
		// Start of show toggleSalesRepForm.
		$inputtd->appendChild($divShowRemoveIcon = $doc->createElement('div'));
		$divShowRemoveIcon->setAttribute('id','hide_audio_remove');
		$divShowRemoveIcon->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_cancel_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'removeAudioPath();');
		$span->appendChild($doc->createTextNode(' '));

        $durationtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Duration (seconds) *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignAudioDuration');
        $input->setAttribute('value',$duration);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $durationtr->appendChild($labeltd);
        $durationtr->appendChild($inputtd);

        $talentGendertr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Talent Gender');
        $inputtd = $doc->createElement('td');
        $inputtd = $doc->createElement('td');
		$dataGender = array( 'Unspecified'=>'Unspecified', 'Female'=>'Female', 'Male'=>'Male', 'Mixed'=>'Mixed' );
        $inputGender = dom::createDropdown( $doc, 'campaignAudioTalentGender', $dataGender, $talentGender );
        $labeltd->appendChild($label);
        $inputtd->appendChild($inputGender);
        $talentGendertr->appendChild($labeltd);
        $talentGendertr->appendChild($inputtd);

		$startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignAudioStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

		$endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignAudioEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

		$deadlineDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Deadline Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignAudioDeadline',date('Y') - 3,date('Y') + 2,'',$deadlineDateArray[0],$deadlineDateArray[1],$deadlineDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $deadlineDatetr->appendChild($labeltd);
        $deadlineDatetr->appendChild($inputtd);

		$currentProducerIDtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Current Producer');
        $inputtd = $doc->createElement('td');
		$producerName = $this->resolve_producer_name($producerID);
        $input = $doc->createTextNode($producerName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $currentProducerIDtr->appendChild($labeltd);
        $currentProducerIDtr->appendChild($inputtd);

        $producerIDtr = $doc->createElement('tr');
        $producerIDtr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('Select Producer'));
        $inputtd = $doc->createElement('td');
		$input = $this->display_select_producer($doc, '', $producerID);
//        $inputtd->appendChild($input);

		// Start of show toggleProducerForm.
		$inputtd->appendChild($divShowProducer = $doc->createElement('div'));
		$divShowProducer->setAttribute('id','show_producer');
		$divShowProducer->appendChild($divButtonShowProducer = $doc->createElement('div'));
		$divButtonShowProducer->appendChild($spanButtonShowProducer = $doc->createElement('span'));
		$spanButtonShowProducer->setAttribute('class', 'link_button');
		$spanButtonShowProducer->setAttribute("onclick", "toggleProducerForm('hide_producer','show_producer');");
		$spanButtonShowProducer->appendChild($aShowProducer = $doc->createElement('a'));
		$aShowProducer->setAttribute('title', 'Add New Producer');
		$aShowProducer->setAttribute('class', 'link_button');
		$aShowProducer->appendChild($spanShowProducer = $doc->createElement('span'));
		$spanShowProducer->setAttribute('class', 'link_add');
		$spanShowProducer->appendChild($textShowProducer = $doc->createTextNode('Add New Producer'));

		$divShowProducer->appendChild($input);
		// End of show toggleProducerForm.

		// Start of hide toggleProducerForm.
		$inputtd->appendChild($divHideProducer = $doc->createElement('div'));
		$divHideProducer->setAttribute('id','hide_producer');
		$divHideProducer->appendChild($divButtonHideProducer = $doc->createElement('div'));
		$divButtonHideProducer->appendChild($spanButtonHideProducer = $doc->createElement('span'));
		$spanButtonHideProducer->setAttribute('class', 'link_button');
		$spanButtonHideProducer->setAttribute("onclick", "toggleProducerForm('hide_producer','show_producer');");
		$spanButtonHideProducer->appendChild($aHideProducer = $doc->createElement('a'));
		$aHideProducer->setAttribute('title', 'Select Existing Producer');
		$aHideProducer->setAttribute('class', 'link_button');
		$aHideProducer->appendChild($spanHideProducer = $doc->createElement('span'));
		$spanHideProducer->setAttribute('class', 'link_add');
		$spanHideProducer->appendChild($textHideProducer = $doc->createTextNode('Select Existing Producer'));

		$divHideProducer->appendChild(Producer::inline_form($doc,'',true));
		// End of hide toggleProducerForm.

		$producerIDtr->appendChild($inputtd);

		$ProductTypeIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
		$labeltd->appendChild($label = $doc->createTextNode('Product Type'));
		$ProductTypeIDtr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','campaignAudioProductTypeIDList[]');
		$input->setAttribute('id','campaignAudioProductTypeIDList');

		$query = "SELECT I.productTypeID, I.name FROM ({$this->store->table_traffic_producttype} I)";
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($productTypeIDList)) {
				if ( in_array($line['productTypeID'],$productTypeIDList) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['productTypeID']);
			$inputOption->appendChild($doc->createTextNode($line['name']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleProductTypeForm.
		$inputtd->appendChild($divShowProductType = $doc->createElement('div'));
		$divShowProductType->setAttribute('id','show_producttype');
		$divShowProductType->appendChild($divButtonShowProductType = $doc->createElement('div'));
		$divButtonShowProductType->appendChild($spanButtonShowProductType = $doc->createElement('span'));
		$spanButtonShowProductType->setAttribute('class', 'link_button');
		$spanButtonShowProductType->setAttribute("onclick", "toggleProductTypeForm('hide_producttype','show_producttype');");
		$spanButtonShowProductType->appendChild($aShowProductType = $doc->createElement('a'));
		$aShowProductType->setAttribute('title', 'Add New Product Type');
		$aShowProductType->setAttribute('class', 'link_button');
		$aShowProductType->appendChild($spanShowProductType = $doc->createElement('span'));
		$spanShowProductType->setAttribute('class', 'link_add');
		$spanShowProductType->appendChild($textShowProductType = $doc->createTextNode('Add New Product Type'));

		$divShowProductType->appendChild($input);
		// End of show toggleProductTypeForm.

		// Start of hide toggleProductTypeForm.
		$inputtd->appendChild($divHideProductType = $doc->createElement('div'));
		$divHideProductType->setAttribute('id','hide_producttype');
		$divHideProductType->appendChild($divButtonHideProductType = $doc->createElement('div'));
		$divButtonHideProductType->appendChild($spanButtonHideProductType = $doc->createElement('span'));
		$spanButtonHideProductType->setAttribute('class', 'link_button');
		$spanButtonHideProductType->setAttribute("onclick", "toggleProductTypeForm('hide_producttype','show_producttype');");
		$spanButtonHideProductType->appendChild($aHideProductType = $doc->createElement('a'));
		$aHideProductType->setAttribute('title', 'Select Existing Product Type');
		$aHideProductType->setAttribute('class', 'link_button');
		$aHideProductType->appendChild($spanHideProductType = $doc->createElement('span'));
		$spanHideProductType->setAttribute('class', 'link_add');
		$spanHideProductType->appendChild($textHideProductType = $doc->createTextNode('Select Existing Product Type'));

		$divHideProductType->appendChild(ProductType::inline_form($doc,'',true));
		// End of hide toggleProductTypeForm.

		$ProductTypeIDtr->appendChild($inputtd);

		$TalentIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
		$labeltd->appendChild($label = $doc->createTextNode('Assign Talent'));
		$TalentIDtr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','campaignAudioTalentIDList[]');
		$input->setAttribute('id','campaignAudioTalentIDList');

		$query = "SELECT I.talentID, D.firstName, D.lastName FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID";
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($talentIDList)) {
				if ( in_array($line['talentID'],$talentIDList) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['talentID']);
			$inputOption->appendChild($doc->createTextNode($line['firstName'].' '.$line['lastName']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleTalentForm.
		$inputtd->appendChild($divShowTalent = $doc->createElement('div'));
		$divShowTalent->setAttribute('id','show_talent');
		$divShowTalent->appendChild($divButtonShowTalent = $doc->createElement('div'));
		$divButtonShowTalent->appendChild($spanButtonShowTalent = $doc->createElement('span'));
		$spanButtonShowTalent->setAttribute('class', 'link_button');
		$spanButtonShowTalent->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		$spanButtonShowTalent->appendChild($aShowTalent = $doc->createElement('a'));
		$aShowTalent->setAttribute('title', 'Add New Talent');
		$aShowTalent->setAttribute('class', 'link_button');
		$aShowTalent->appendChild($spanShowTalent = $doc->createElement('span'));
		$spanShowTalent->setAttribute('class', 'link_add');
		$spanShowTalent->appendChild($textShowTalent = $doc->createTextNode('Add New Talent'));

		$divShowTalent->appendChild($input);
		// End of show toggleTalentForm.

		// Start of hide toggleTalentForm.
		$inputtd->appendChild($divHideTalent = $doc->createElement('div'));
		$divHideTalent->setAttribute('id','hide_talent');
		$divHideTalent->appendChild($divButtonHideTalent = $doc->createElement('div'));
		$divButtonHideTalent->appendChild($spanButtonHideTalent = $doc->createElement('span'));
		$spanButtonHideTalent->setAttribute('class', 'link_button');
		$spanButtonHideTalent->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		$spanButtonHideTalent->appendChild($aHideTalent = $doc->createElement('a'));
		$aHideTalent->setAttribute('title', 'Select Existing Talent');
		$aHideTalent->setAttribute('class', 'link_button');
		$aHideTalent->appendChild($spanHideTalent = $doc->createElement('span'));
		$spanHideTalent->setAttribute('class', 'link_add');
		$spanHideTalent->appendChild($textHideTalent = $doc->createTextNode('Select Existing Talent'));

		$divHideTalent->appendChild(Talent::inline_form($doc,''));
		// End of hide toggleTalentForm.

		$TalentIDtr->appendChild($inputtd);

        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($campaignNametr);
        $table->appendChild($nametr);
        $table->appendChild($productionStatustr);
        $table->appendChild($descriptiontr);
		if ($filename != '')
			$table->appendChild($currentFilenametr);
        $table->appendChild($filenametr);
        $table->appendChild($durationtr);
        $table->appendChild($talentGendertr);
		if ($producerID != '')
			$table->appendChild($currentProducerIDtr);
		$table->appendChild($producerIDtr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($deadlineDatetr);
		$table->appendChild($ProductTypeIDtr);
		$table->appendChild($TalentIDtr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);
		$form->appendChild($container);

        return($form);
    }

    public function form_multi($doc, $id='') {

		$campaignID = globalize('campaignID');

		$form = module::form_dom($doc);
		$form->setAttribute('enctype','multipart/form-data');

		$item = globalize('item', get_class($this));

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','item');
		$iteminput->setAttribute('value',$item);
		$form->appendChild($iteminput);

		$maxFileSize = $doc->createElement('input');
		$maxFileSize->setAttribute('type','hidden');
		$maxFileSize->setAttribute('name','MAX_FILE_SIZE');
		$maxFileSize->setAttribute('value','28000000');
		$form->appendChild($maxFileSize);


		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$form->appendChild($terminate);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Multiple Campaign Audio';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

        $campaignAudioID = $doc->createElement('input');
        $campaignAudioID->setAttribute('type','hidden');
        $campaignAudioID->setAttribute('name','campaignAudioID');
        $campaignAudioID->setAttribute('value',$id);
        $container->appendChild($campaignAudioID);

		$input = $doc->createElement('input');
        $input->setAttribute('type','hidden');
        $input->setAttribute('name','campaignID');
        $input->setAttribute('value',$campaignID);
        $container->appendChild($input);

		$datetime = date("Y-m-d H:i:s");

		$date = $doc->createElement('input');
        $date->setAttribute('type', 'hidden');
        $date->setAttribute('name', 'campaignAudioCreatedDateTime');
        $date->setAttribute('value', $datetime);
        $container->appendChild($date);

		global $module_parameter;
		if (isset($module_parameter['deadlineDateBuffer'])) {
			$deadlineDateBuffer = $module_parameter['deadlineDateBuffer'];
		} else {
			$deadlineDateBuffer = 0;
		}
		$query = <<<EOQ
			SELECT C.{$this->store->field_client_name} AS clientName,
				C.{$this->store->field_client_clientID} AS clientID,
				A.{$this->store->field_contract_name} AS contractName,
				A.{$this->store->field_contract_contractID} AS contractID,
				B.{$this->store->field_campaign_name} AS campaignName,
				B.{$this->store->field_campaign_startDate} AS campaignStartDate,
				B.{$this->store->field_campaign_endDate} AS campaignEndDate,
				(B.{$this->store->field_campaign_startDate} + INTERVAL $deadlineDateBuffer DAY) AS campaignDeadlineDate,
				B.{$this->store->field_campaign_audioAllotted} - (SELECT COUNT({$this->store->field_campaignaudio_campaignAudioID})
					FROM {$this->store->table_traffic_campaignaudio}
					WHERE {$this->store->field_campaignaudio_campaignID} = '$campaignID'
				) AS campaignAudioRemaining
			FROM ({$this->store->table_traffic_client} C,
				{$this->store->table_traffic_contract} A,
				{$this->store->table_traffic_campaign} B
			)
			WHERE B.{$this->store->field_campaign_campaignID} = '$campaignID'
			AND A.{$this->store->field_contract_contractID} = B.{$this->store->field_campaign_contractID}
			AND C.{$this->store->field_client_clientID} = B.{$this->store->field_campaign_clientID}
EOQ;
		$result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);

		$clientName = $line['clientName'];
		$contractName = $line['contractName'];
		$campaignName = $line['campaignName'];
		$contractID = $line['contractID'];
		$clientID = $line['clientID'];
		$campaignAudioID = '';
		$qty = $line['campaignAudioRemaining'];
		$name = $line['campaignName'];
		$productionStatus = '';
		$description = '';
		$filename = '';

		// Check to see if a default duration is set as a module parameter.
		if (isset($module_parameter['durationDefault'])) {
			$duration = $module_parameter['durationDefault'];
		} else {
			$duration = '';
		}

		// If default statuses to Approved is enabled as a module parameter.
		if (isset($module_parameter['defaultStatusApproved']) && $module_parameter['defaultStatusApproved'] == '1') {
			$productionStatus = 'Approved';
		}

		$talentGender = '';
		$startDateArray = explode('-',$line['campaignStartDate']);
		$endDateArray = explode('-',$line['campaignEndDate']);
		$deadlineDateArray = explode('-',$line['campaignDeadlineDate']);
		$producerID = '';

        $queryproducer = "SELECT S.campaignAudioID, S.description, S.filename, S.name FROM {$this->store->table_traffic_campaignaudio} S ORDER BY filename, description";
        $resultproducer = sysdb::query($queryproducer);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$campaignNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$campaignName,'',array('item'=>'Campaign','action'=>'view','id'=>$campaignID),'View'));
        $campaignNametr->appendChild($labeltd);
        $campaignNametr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign Audio Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignAudioName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $qtytr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Quantity of audio to create *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignAudioQuantity');
        $input->setAttribute('value',$qty);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $qtytr->appendChild($labeltd);
        $qtytr->appendChild($inputtd);

        $productionStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Production Status *');
        $inputtd = $doc->createElement('td');
		$data = array( 'Pending Draft Approval'=>'Pending Draft Approval', 'In Production'=>'In Production', 'Pending Internal Approval'=>'Pending Internal Approval', 'Pending Client Approval'=>'Pending Client Approval', 'Approved'=>'Approved' );
        $input = dom::createDropdown( $doc, 'campaignAudioProductionStatus', $data, $productionStatus );
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $productionStatustr->appendChild($labeltd);
        $productionStatustr->appendChild($inputtd);

        $descriptiontr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Description');
        $inputtd = $doc->createElement('td');
        $textarea = $doc->createElement('textarea');
        $textarea->setAttribute('name','campaignAudioDescription');
        $input = $doc->createTextNode($description);
        $labeltd->appendChild($label);
        $inputtd->appendChild($textarea);
        $textarea->appendChild($input);
        $descriptiontr->appendChild($labeltd);
        $descriptiontr->appendChild($inputtd);

		// $currentFilenametr = $doc->createElement('tr');
        // $labeltd = $doc->createElement('th');
        // $label = $doc->createTextNode('Current Filename');
        // $inputtd = $doc->createElement('td');
        // $input = $doc->createTextNode($filename);
        // $labeltd->appendChild($label);
        // $inputtd->appendChild($input);
        // $currentFilenametr->appendChild($labeltd);
        // $currentFilenametr->appendChild($inputtd);

        // $filenametr = $doc->createElement('tr');
        // $labeltd = $doc->createElement('th');
        // $label = $doc->createTextNode('Upload New File');
        // $inputtd = $doc->createElement('td');
        // $input = $doc->createElement('input');
        // $input->setAttribute('type','file');
        // $input->setAttribute('name','campaignAudioFilename');
        // $input->setAttribute('id','campaignAudioFilename');
        // $labeltd->appendChild($label);
        // $inputtd->appendChild($input);
        // $filenametr->appendChild($labeltd);
        // $filenametr->appendChild($inputtd);
		// // Start of show toggleSalesRepForm.
		// $inputtd->appendChild($divShowRemoveIcon = $doc->createElement('div'));
		// $divShowRemoveIcon->setAttribute('id','hide_audio_remove');
		// $divShowRemoveIcon->appendChild($span = $doc->createElement('span'));
		// $span->setAttribute('class', 'link_cancel_small');
		// $span->setAttribute('style', 'float: right;');
		// $span->setAttribute('onclick', 'removeAudioPath();');
		// $span->appendChild($doc->createTextNode(' '));

        $durationtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Duration (seconds) *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignAudioDuration');
        $input->setAttribute('value',$duration);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $durationtr->appendChild($labeltd);
        $durationtr->appendChild($inputtd);

        $talentGendertr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Talent Gender');
        $inputtd = $doc->createElement('td');
        $inputtd = $doc->createElement('td');
		$dataGender = array( 'Unspecified'=>'Unspecified', 'Female'=>'Female', 'Male'=>'Male', 'Mixed'=>'Mixed' );
        $inputGender = dom::createDropdown( $doc, 'campaignAudioTalentGender', $dataGender, $talentGender );
        $labeltd->appendChild($label);
        $inputtd->appendChild($inputGender);
        $talentGendertr->appendChild($labeltd);
        $talentGendertr->appendChild($inputtd);

		$startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignAudioStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

		$endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignAudioEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

		$deadlineDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Deadline Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignAudioDeadline',date('Y') - 3,date('Y') + 2,'',$deadlineDateArray[0],$deadlineDateArray[1],$deadlineDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $deadlineDatetr->appendChild($labeltd);
        $deadlineDatetr->appendChild($inputtd);

		$currentProducerIDtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Current Producer');
        $inputtd = $doc->createElement('td');
		$producerName = $this->resolve_producer_name($producerID);
        $input = $doc->createTextNode($producerName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $currentProducerIDtr->appendChild($labeltd);
        $currentProducerIDtr->appendChild($inputtd);

        $producerIDtr = $doc->createElement('tr');
        $producerIDtr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('Select Producer'));
        $inputtd = $doc->createElement('td');
		$input = $this->display_select_producer($doc, '', $producerID);
//        $inputtd->appendChild($input);

		// Start of show toggleProducerForm.
		$inputtd->appendChild($divShowProducer = $doc->createElement('div'));
		$divShowProducer->setAttribute('id','show_producer');
		$divShowProducer->appendChild($divButtonShowProducer = $doc->createElement('div'));
		$divButtonShowProducer->appendChild($spanButtonShowProducer = $doc->createElement('span'));
		$spanButtonShowProducer->setAttribute('class', 'link_button');
		$spanButtonShowProducer->setAttribute("onclick", "toggleProducerForm('hide_producer','show_producer');");
		$spanButtonShowProducer->appendChild($aShowProducer = $doc->createElement('a'));
		$aShowProducer->setAttribute('title', 'Add New Producer');
		$aShowProducer->setAttribute('class', 'link_button');
		$aShowProducer->appendChild($spanShowProducer = $doc->createElement('span'));
		$spanShowProducer->setAttribute('class', 'link_add');
		$spanShowProducer->appendChild($textShowProducer = $doc->createTextNode('Add New Producer'));

		$divShowProducer->appendChild($input);
		// End of show toggleProducerForm.

		// Start of hide toggleProducerForm.
		$inputtd->appendChild($divHideProducer = $doc->createElement('div'));
		$divHideProducer->setAttribute('id','hide_producer');
		$divHideProducer->appendChild($divButtonHideProducer = $doc->createElement('div'));
		$divButtonHideProducer->appendChild($spanButtonHideProducer = $doc->createElement('span'));
		$spanButtonHideProducer->setAttribute('class', 'link_button');
		$spanButtonHideProducer->setAttribute("onclick", "toggleProducerForm('hide_producer','show_producer');");
		$spanButtonHideProducer->appendChild($aHideProducer = $doc->createElement('a'));
		$aHideProducer->setAttribute('title', 'Select Existing Producer');
		$aHideProducer->setAttribute('class', 'link_button');
		$aHideProducer->appendChild($spanHideProducer = $doc->createElement('span'));
		$spanHideProducer->setAttribute('class', 'link_add');
		$spanHideProducer->appendChild($textHideProducer = $doc->createTextNode('Select Existing Producer'));

		$divHideProducer->appendChild(Producer::inline_form($doc,'',true));
		// End of hide toggleProducerForm.

		$producerIDtr->appendChild($inputtd);

		$ProductTypeIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
		$labeltd->appendChild($label = $doc->createTextNode('Product Type'));
		$ProductTypeIDtr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','campaignAudioProductTypeIDList[]');
		$input->setAttribute('id','campaignAudioProductTypeIDList');

		$query = "SELECT I.productTypeID, I.name FROM ({$this->store->table_traffic_producttype} I)";
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($productTypeIDList)) {
				if ( in_array($line['productTypeID'],$productTypeIDList) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['productTypeID']);
			$inputOption->appendChild($doc->createTextNode($line['name']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleProductTypeForm.
		$inputtd->appendChild($divShowProductType = $doc->createElement('div'));
		$divShowProductType->setAttribute('id','show_producttype');
		$divShowProductType->appendChild($divButtonShowProductType = $doc->createElement('div'));
		$divButtonShowProductType->appendChild($spanButtonShowProductType = $doc->createElement('span'));
		$spanButtonShowProductType->setAttribute('class', 'link_button');
		$spanButtonShowProductType->setAttribute("onclick", "toggleProductTypeForm('hide_producttype','show_producttype');");
		$spanButtonShowProductType->appendChild($aShowProductType = $doc->createElement('a'));
		$aShowProductType->setAttribute('title', 'Add New Product Type');
		$aShowProductType->setAttribute('class', 'link_button');
		$aShowProductType->appendChild($spanShowProductType = $doc->createElement('span'));
		$spanShowProductType->setAttribute('class', 'link_add');
		$spanShowProductType->appendChild($textShowProductType = $doc->createTextNode('Add New Product Type'));

		$divShowProductType->appendChild($input);
		// End of show toggleProductTypeForm.

		// Start of hide toggleProductTypeForm.
		$inputtd->appendChild($divHideProductType = $doc->createElement('div'));
		$divHideProductType->setAttribute('id','hide_producttype');
		$divHideProductType->appendChild($divButtonHideProductType = $doc->createElement('div'));
		$divButtonHideProductType->appendChild($spanButtonHideProductType = $doc->createElement('span'));
		$spanButtonHideProductType->setAttribute('class', 'link_button');
		$spanButtonHideProductType->setAttribute("onclick", "toggleProductTypeForm('hide_producttype','show_producttype');");
		$spanButtonHideProductType->appendChild($aHideProductType = $doc->createElement('a'));
		$aHideProductType->setAttribute('title', 'Select Existing Product Type');
		$aHideProductType->setAttribute('class', 'link_button');
		$aHideProductType->appendChild($spanHideProductType = $doc->createElement('span'));
		$spanHideProductType->setAttribute('class', 'link_add');
		$spanHideProductType->appendChild($textHideProductType = $doc->createTextNode('Select Existing Product Type'));

		$divHideProductType->appendChild(ProductType::inline_form($doc,'',true));
		// End of hide toggleProductTypeForm.

		$ProductTypeIDtr->appendChild($inputtd);

		$TalentIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
		$labeltd->appendChild($label = $doc->createTextNode('Assign Talent'));
		$TalentIDtr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','campaignAudioTalentIDList[]');
		$input->setAttribute('id','campaignAudioTalentIDList');

		$query = "SELECT I.talentID, D.firstName, D.lastName FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID";
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($talentIDList)) {
				if ( in_array($line['talentID'],$talentIDList) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['talentID']);
			$inputOption->appendChild($doc->createTextNode($line['firstName'].' '.$line['lastName']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleTalentForm.
		$inputtd->appendChild($divShowTalent = $doc->createElement('div'));
		$divShowTalent->setAttribute('id','show_talent');
		$divShowTalent->appendChild($divButtonShowTalent = $doc->createElement('div'));
		$divButtonShowTalent->appendChild($spanButtonShowTalent = $doc->createElement('span'));
		$spanButtonShowTalent->setAttribute('class', 'link_button');
		$spanButtonShowTalent->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		$spanButtonShowTalent->appendChild($aShowTalent = $doc->createElement('a'));
		$aShowTalent->setAttribute('title', 'Add New Talent');
		$aShowTalent->setAttribute('class', 'link_button');
		$aShowTalent->appendChild($spanShowTalent = $doc->createElement('span'));
		$spanShowTalent->setAttribute('class', 'link_add');
		$spanShowTalent->appendChild($textShowTalent = $doc->createTextNode('Add New Talent'));

		$divShowTalent->appendChild($input);
		// End of show toggleTalentForm.

		// Start of hide toggleTalentForm.
		$inputtd->appendChild($divHideTalent = $doc->createElement('div'));
		$divHideTalent->setAttribute('id','hide_talent');
		$divHideTalent->appendChild($divButtonHideTalent = $doc->createElement('div'));
		$divButtonHideTalent->appendChild($spanButtonHideTalent = $doc->createElement('span'));
		$spanButtonHideTalent->setAttribute('class', 'link_button');
		$spanButtonHideTalent->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		$spanButtonHideTalent->appendChild($aHideTalent = $doc->createElement('a'));
		$aHideTalent->setAttribute('title', 'Select Existing Talent');
		$aHideTalent->setAttribute('class', 'link_button');
		$aHideTalent->appendChild($spanHideTalent = $doc->createElement('span'));
		$spanHideTalent->setAttribute('class', 'link_add');
		$spanHideTalent->appendChild($textHideTalent = $doc->createTextNode('Select Existing Talent'));

		$divHideTalent->appendChild(Talent::inline_form($doc,''));
		// End of hide toggleTalentForm.

		$TalentIDtr->appendChild($inputtd);

        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($campaignNametr);
        $table->appendChild($nametr);
        $table->appendChild($qtytr);
        $table->appendChild($productionStatustr);
        $table->appendChild($descriptiontr);
		// if ( $filename != '' )
			// $table->appendChild($currentFilenametr);
        //$table->appendChild($filenametr); // Can't add the same file to multiple campaign audios.
        $table->appendChild($durationtr);
        $table->appendChild($talentGendertr);
		if ( $producerID != '' )
			$table->appendChild($currentProducerIDtr);
		$table->appendChild($producerIDtr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($deadlineDatetr);
		$table->appendChild($ProductTypeIDtr);
		$table->appendChild($TalentIDtr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        $save->setAttribute('value','add all');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);
		$form->appendChild($container);

        return($form);
    }

    public function view($doc, $id) {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');
		switch(globalize('extras','Log')) {
			case 'Log':
				$log = new Log();
				$container->appendChild($log->inline_list($doc,'',true));
				break;
		}
		$containerLeft = $doc->createElement('div');
		$containerLeft->setAttribute('class','module_left');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Campaign Audio'));
		$containerLeft->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $containerLeft->appendChild($span);
		$containerLeft->appendChild($spanbutton = $doc->createElement('span'));
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button'));
		$spanbutton->setAttribute('class', 'link_button');
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_edit');
		$span->appendChild($label = $doc->createTextNode('Edit'));

		$containerLeft->appendChild($spanbutton = $doc->createElement('span'));
		$spanbutton->appendChild($a = module::link_to_script_dom_unappended($doc,'Schedule','',array('item'=>get_class($this),'action'=>'schedule','id'=>$id),'Schedule','link_button'));
		$spanbutton->setAttribute('class', 'link_button');
		$a->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_edit');
		$span->appendChild($label = $doc->createTextNode('Schedule'));

		$containerLeft->appendChild($spanbutton = Defer::defer_schedule_button_ui($doc, $id));

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $campaignAudioID = $doc->createElement('input');
        $campaignAudioID->setAttribute('type','hidden');
        $campaignAudioID->setAttribute('name','campaignAudioID');
        $campaignAudioID->setAttribute('value',$id);
        $containerLeft->appendChild($campaignAudioID);

        $query = "SELECT C.name as clientName, A.name as contractName, B.name as campaignName, I.* ";
		$query.= "FROM {$this->store->table_traffic_campaignaudio} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A, {$this->store->table_traffic_campaign} B ";
		$query .= "WHERE I.campaignAudioID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID AND B.campaignID = I.campaignID";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $campaignAudioID = $line['campaignAudioID'];
        $mediaID = $line['mediaID'];
        $name = $line['name'];
		$clientName = $line['clientName'];
		$clientID = $line['clientID'];
		$contractName = $line['contractName'];
		$contractID = $line['contractID'];
		$campaignName = $line['campaignName'];
		$campaignID = $line['campaignID'];
        $createdDateTime = date("d-M-Y H:i:s", strtotime($line['createdDateTime']));
        $productionStatus = $line['productionStatus'];
        $description = $line['description'];
        $filename = $line['filename'];
        $mimetype = $line['mimetype'];
        $duration = $line['duration'];
        $talentGender = $line['talentGender'];
        $startDate = date("d-M-Y", strtotime($line['startDate']));
        $endDate = date("d-M-Y", strtotime($line['endDate']));
		$deadlineDate = date("d-M-Y", strtotime($line['deadlineDate']));
        $producerID = $line['producerID'];

		// Decode UTF-8 character encoding.
		$values = array(&$name,
						&$description,
						&$clientName,
						&$contractName,
						&$campaignName
						);
		foreach ($values as &$value) {
			$value = utf8_decode($value);
		}
		unset($value);

		$queryname = "SELECT P.name FROM ({$this->store->table_traffic_campaignaudioproducttype} C, {$this->store->table_traffic_producttype} P) WHERE C.campaignAudioID = '$id' AND C.productTypeID = P.productTypeID";
        $resultname = sysdb::query($queryname);

		$productTypeNames = array();
		while ($linename = sysdb::fetch_assoc($resultname)) {
			array_push($productTypeNames, $linename['name']);
		}

		$querytalent = "SELECT D.firstName, D.lastName FROM ({$this->store->table_traffic_campaignaudiotalent} C, {$this->store->table_traffic_talent} P, {$this->store->table_detail} D) WHERE C.campaignAudioID = '$id' AND C.talentID = P.talentID AND P.actorID = D.actorID";
        $resulttalent = sysdb::query($querytalent);

		$talentNames = array();
		while ($linename = sysdb::fetch_assoc($resulttalent)) {
			array_push($talentNames, $linename['firstName'].' '.$linename['lastName']);
		}

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name');
        $inputtd = $doc->createElement('td');
        $inputtd->setAttribute('class','name');
        $input = $doc->createTextNode($name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$campaignNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($campaignName);
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$campaignName,'',array('item'=>'Campaign','action'=>'view','id'=>$campaignID),'View'));
        $campaignNametr->appendChild($labeltd);
        $campaignNametr->appendChild($inputtd);

        $productionStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Production Status');
        $inputtd = $doc->createElement('td');
		$class = $this->production_status($productionStatus);
        $inputtd->setAttribute('class',$class);
        $input = $doc->createTextNode($productionStatus);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $productionStatustr->appendChild($labeltd);
        $productionStatustr->appendChild($inputtd);

        $descriptiontr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Description');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($description);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $descriptiontr->appendChild($labeltd);
        $descriptiontr->appendChild($inputtd);

		if ($line['filename'] != '') {
			$filenametr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('File Name');
			$inputtd = $doc->createElement('td');
			$labeltd->appendChild($label);
			$inputtd->appendChild(module::link_to_script_dom($doc,$filename,'',array('item'=>get_class($this),'action'=>'download','id'=>$line['mediaID'],'campaignAudioID'=>$line['campaignAudioID']),'Download'));
			$inputtd->appendChild($labeltd);
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_download_small');
			$span->appendChild(module::link_to_script_dom($doc,'download','',array('item'=>get_class($this),'action'=>'download','id'=>$line['mediaID'],'campaignAudioID'=>$line['campaignAudioID']),'Download'));
			$inputtd->appendChild($span);
			$filenametr->appendChild($labeltd);
			$filenametr->appendChild($inputtd);

			$mimetypetr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('File Type');
			$inputtd = $doc->createElement('td');
			$input = $doc->createTextNode($mimetype);
			$labeltd->appendChild($label);
			$inputtd->appendChild($input);
			$mimetypetr->appendChild($labeltd);
			$mimetypetr->appendChild($inputtd);
		}
        $durationtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Duration (sec)');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($duration);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $durationtr->appendChild($labeltd);
        $durationtr->appendChild($inputtd);

        $talentGendertr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Talent Gender');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($talentGender);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $talentGendertr->appendChild($labeltd);
        $talentGendertr->appendChild($inputtd);

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($startDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($endDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

		$deadlineDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Deadline Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($deadlineDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $deadlineDatetr->appendChild($labeltd);
        $deadlineDatetr->appendChild($inputtd);

        $createdDateTimetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Created');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($createdDateTime);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $createdDateTimetr->appendChild($labeltd);
        $createdDateTimetr->appendChild($inputtd);

        $producerIDtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Producer');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
		$producerName = $this->resolve_producer_name($producerID);
        $inputtd->appendChild(module::link_to_script_dom($doc,$producerName,'',array('item'=>'Producer','action'=>'view','id'=>$line['producerID']),'View'));
        $producerIDtr->appendChild($labeltd);
        $producerIDtr->appendChild($inputtd);

		$campaignAudioProductTypetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Product Type');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

//		$productTypeName = $this->resolve_product_type($productTypeNames);
		foreach ($productTypeNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}


        $campaignAudioProductTypetr->appendChild($labeltd);
        $campaignAudioProductTypetr->appendChild($inputtd);

		$campaignAudioTalenttr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Talent');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($talentNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $campaignAudioTalenttr->appendChild($labeltd);
        $campaignAudioTalenttr->appendChild($inputtd);

        $table->appendChild($nametr);
        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($campaignNametr);
        $table->appendChild($productionStatustr);
        $table->appendChild($descriptiontr);
		if ($line['filename'] != '') {
			$table->appendChild($filenametr);
			$table->appendChild($mimetypetr);
		}
        $table->appendChild($durationtr);
        $table->appendChild($talentGendertr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($deadlineDatetr);
		$table->appendChild($createdDateTimetr);
        $table->appendChild($producerIDtr);
        $table->appendChild($campaignAudioProductTypetr);
        $table->appendChild($campaignAudioTalenttr);

		$containerLeft->appendChild($table);

		$containerLeft->appendChild(Notes::form($doc,$id));

		$container->appendChild($containerLeft);

		$moduleFooter = $doc->createElement('div');
		$moduleFooter->setAttribute('class','clear_both');
		$container->appendChild($moduleFooter);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $query = <<<EOQ
            SELECT I.campaignAudioID, I.name, I.productionStatus, I.description, I.filename, I.producerID
            FROM {$this->store->table_traffic_campaignaudio} I
            WHERE 1
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND I.campaignAudioID IN (".implode(',',$ids).") ";
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

		$col1 = $doc->createElement('col');
        $table->appendChild($col1);

		$col2 = $doc->createElement('col');
        $table->appendChild($col2);

		$col3 = $doc->createElement('col');
		$col3->setAttribute('width', '200px');
        $table->appendChild($col3);

		$col4 = $doc->createElement('col');
        $table->appendChild($col4);

		// $col5 = $doc->createElement('col');
        // $table->appendChild($col5);

		$colactions = $doc->createElement('col');
		$colactions->setAttribute('width', '76px');
        $table->appendChild($colactions);

        $tr = $doc->createElement('tr');
		$nametd = $doc->createElement('th');
		$productionStatustd = $doc->createElement('th');
        $descriptiontd = $doc->createElement('th');
        $filenametd = $doc->createElement('th');
        $producerIDtd = $doc->createElement('th');

		$nametd->appendChild($doc->createTextNode('Name'));
        $productionStatustd->appendChild($doc->createTextNode('Status'));
        $descriptiontd->appendChild($doc->createTextNode('Description'));
        $filenametd->appendChild($doc->createTextNode('Filename'));
        $producerIDtd->appendChild($doc->createTextNode('Producer'));

		$tr->appendChild($nametd);
		$tr->appendChild($productionStatustd);
        $tr->appendChild($descriptiontd);
        $tr->appendChild($filenametd);
//        $tr->appendChild($producerIDtd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No Campaign Audio');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
			$nametd = $doc->createElement('td');
            $productionStatustd = $doc->createElement('td');
 			$class = $this->production_status($line['productionStatus']);
			$productionStatustd->setAttribute('class',$class);
            $descriptiontd = $doc->createElement('td');
            $filenametd = $doc->createElement('td');
            $producerIDtd = $doc->createElement('td');

			$nametd->appendChild(module::link_to_script_dom($doc,$line['name'],'',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['campaignAudioID']),'View'));
            $productionStatustd->appendChild($doc->createTextNode($line['productionStatus']));
            $descriptiontd->appendChild($doc->createTextNode($line['description']));
            $filenametd->appendChild($doc->createTextNode($line['filename']));
			$producerName = $this->resolve_producer_name($line['producerID']);
			$producerIDtd->appendChild(module::link_to_script_dom($doc,$producerName,'',array('item'=>'Producer','action'=>'view','id'=>$line['producerID']),'View'));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['campaignAudioID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
            $span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
			$span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['campaignAudioID']),'Edit'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
            $actiontd->appendChild($span = $doc->createElement('span'));
            $span->setAttribute('class','link_traffic_small');
            $span->appendChild($a = module::link_to_script_dom_unappended($doc,'View Traffic','',
                            array('item'=>'Traffic',
                                  'mode'=>'CampaignAudio',
                                  'campaignAudioID'=>$line['campaignAudioID'],
                                    ),'View Traffic','link_traffic_small'));
            $a->appendChild($doc->createTextNode(' '));

			$actiontd->appendChild($doc->createTextNode(' '));
            $actiontd->appendChild($span = $doc->createElement('span'));
            $span->setAttribute('class','link_schedule_small');
            $span->appendChild($a = module::link_to_script_dom_unappended($doc,'Schedule','',
                            array('item'=>globalize('item', get_class($this)),
                                  'action'=>'schedule',
                                  'id'=>$line['campaignAudioID']),'Schedule','link_schedule_small'));
            $a->appendChild($doc->createTextNode(' '));

            $table->appendChild($tr);
			$tr->appendChild($nametd);
            $tr->appendChild($productionStatustd);
            $tr->appendChild($descriptiontd);
            $tr->appendChild($filenametd);
//            $tr->appendChild($producerIDtd);
            $tr->appendChild($actiontd);
			$i++;
        }

        return($table);
    }

    public function overview($doc,$ids='',$isInclude=false) {

		$startsWith = globalize('startswith');
		$campaignAudioSearchColumn = globalize('campaignAudioSearchColumn');
		$campaignAudioSearchAction = globalize('campaignAudioSearchAction');
		$campaignAudioSearchText = globalize('campaignAudioSearchText');

		$container = $doc->createElement('div');
		if ( $isInclude ) {
			$item = get_class($this);
			$parentID = globalize('id');
			$parentIDType = globalize('item', get_class($this));
			switch ($parentIDType) {
				case 'Client':
					$parentFieldName = 'clientID';
					break;
				case 'Contract':
					$parentFieldName = 'contractID';
					break;
				case 'Campaign':
					$parentFieldName = 'campaignID';
					break;
				default:
					$isInclude = false;
					$warning_message = "Not a valid parent.";
					break;
			}
			$container->setAttribute('class','module_right');
			$container->appendChild($this->include_header($doc,$parentID));
		} else {
			$item = globalize('item', get_class($this));
			$container->setAttribute('class','module');
		}

        $query = "SELECT I.campaignAudioID, I.name, I.productionStatus, I.description, I.filename, I.producerID FROM {$this->store->table_traffic_campaignaudio} I WHERE 1 ";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND I.campaignAudioID IN (".implode(',',$ids).") ";

		if ( $startsWith != '' ) {
			$query .= " AND I.name LIKE '".$startsWith."%'";
		} elseif ($campaignAudioSearchText != '') {

			// Which column does the user want to search in?
			// Default searches the contract name column
			switch ($campaignAudioSearchColumn) {
				case 'name':
					$column = "I.name";
					break;
				case 'status':
					$column = "I.productionStatus";
					break;
				case 'description':
					$column = "I.description";
					break;
				case 'filename':
					$column = "I.filename";
					break;
				case 'producerID':
					$column = "I.producerID";
					break;
				default:
					$column = "I.name";
					break;
			}

			// What type of search: contains or ends with?
			// Default is contains
			switch ($campaignAudioSearchAction) {
				case 'contains':
					$campaignAudioSearchText = '%'.$campaignAudioSearchText.'%';
					break;
				case 'endswith':
					$campaignAudioSearchText = '%'.$campaignAudioSearchText;
					break;
				default:
					$campaignAudioSearchText = '%'.$campaignAudioSearchText.'%';
					break;
			}

			$query .= " WHERE ".$column." LIKE '$campaignAudioSearchText'";
		}

		if ( $isInclude )
			$query .= " WHERE I.$parentFieldName = '$parentID'";
        $query .= " ORDER BY filename, description, name ";
        $ids = sysdb::query2vector($query,'campaignAudioID');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Campaign Audio'));
		$container->appendChild($header);
		//$container->appendChild(module::link_to_script_dom($doc,'Add Audio','',array('item'=>$item,'action'=>'edit')));

		$searchLetters = $doc->createElement('div');
		$searchLetters->setAttribute('class','search_letters');
		$searchLetters->appendChild($doc->createTextNode('Browse: '));
		foreach ( range('A','Z') as $c ) {
			$searchLetters->appendChild(module::link_to_script_dom($doc,$c,'',array('item'=>$item,'action'=>'search','startswith'=>$c),'Starts with '.$c));
			$searchLetters->appendChild($doc->createTextNode(' '));
		}
		$container->appendChild($searchLetters);

		if ($startsWith != '') $container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT campaignAudioID as campaignAudioID, name as name, duration as duration ";
		$query .= "FROM {$this->store->table_traffic_campaignaudio} ";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= 'WHERE 0=1 '; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= "WHERE campaignAudioID IN (".implode(',',$ids).") ";
		$query .= "ORDER BY filename";
        $result = sysdb::query($query);
        $select = $doc->createElement('select');
        $select->setAttribute('name','campaignAudioID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No audio available');
            $option->appendChild($text);
			$select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
			$option->setAttribute('value','');
			$text = $doc->createTextNode('Please select an audio piece.');
			$option->appendChild($text);
			$select->appendChild($option);
			while ($line = sysdb::fetch_assoc($result)) {
				$option = $doc->createElement('option');
				$option->setAttribute('value',$line['campaignAudioID']);
				if ($line['campaignAudioID'] == $default)
					$option->setAttribute('selected','selected');
				$text = $doc->createTextNode(utf8_decode($line['name']).' ('.$line['duration'].')');
				$option->appendChild($text);
				$select->appendChild($option);
			}
		}
        return($select);
    }

    public function display_select_producer($doc, $ids='', $producerID) {
        $query = "SELECT P.actorID, P.producerID, U.name, U.login ";
		$query .= "FROM ({$this->store->table_traffic_producer} P, {$this->store->table_user} U) ";
		$query .= "WHERE U.actorID = P.actorID ";
		$query .= "ORDER BY name";
        $result = sysdb::query($query);
        $select = $doc->createElement('select');
        $select->setAttribute('name','campaignAudioProducerID');
        $select->setAttribute('id','campaignAudioProducerID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No producers available');
            $option->appendChild($text);
			$select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
			$option->setAttribute('value','');
			$text = $doc->createTextNode('');
			$option->appendChild($text);
			$select->appendChild($option);
			while ($line = sysdb::fetch_assoc($result)) {
				$option = $doc->createElement('option');
				$option->setAttribute('value',$line['producerID']);
				if ($producerID != '') {
					if ($line['producerID'] == $producerID)
						$option->setAttribute('selected','selected');
				} else {
					// Try select the currently authenticated user by default.
					$user = new user();
					$myActorID = $user->getActorID();
					// $myActorID = user::userActorID($login='');
					if ($myActorID != '') {
						$query = <<<EOQ
							SELECT {$this->store->field_producer_producerID}
							FROM {$this->store->table_traffic_producer}
							WHERE {$this->store->field_producer_actorID} = '$myActorID'
EOQ;
						$myProducerID = sysdb::queryOne($query);
						if ($line['producerID'] == $myProducerID)
							$option->setAttribute('selected','selected');
					}
				}
				$text = $doc->createTextNode($line['name'].' ('.$line['login'].')');
				$option->appendChild($text);
				$select->appendChild($option);
			}
		}
        return($select);
    }

    public function display_select_producttype($doc, $ids='', $productTypeIDList) {
        $query = "SELECT P.name, P.productTypeID ";
		$query .= "FROM ({$this->store->table_traffic_producttype} P) ";
		$query .= "ORDER BY name";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
		$select->setAttribute('name','campaignAudioProductTypeIDList[]');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No product types available');
            $option->appendChild($text);
			$select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
			$option->setAttribute('value','');
			$text = $doc->createTextNode('');
			$option->appendChild($text);
			$select->appendChild($option);
			while ($line = sysdb::fetch_assoc($result)) {
				$option = $doc->createElement('option');
				$option->setAttribute('value',$line['productTypeID']);
				if ( isset($productTypeIDList)) {
					if ( in_array($line['productTypeID'],$productTypeIDList) )
						$option->setAttribute('selected','selected');
				}
				$text = $doc->createTextNode($line['name']);
				$option->appendChild($text);
				$select->appendChild($option);
			}
		}
        return($select);
    }

    public function add_many($name,$productionStatus,$description,$duration,$talentGender,
						$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,
						$deadlineYear,$deadlineMonth,$deadlineDay,$createdDateTime,$producerID,$producerActorID,$campaignID,
						$productTypeIDList,$productTypeName,$productTypeStartYear,
						$productTypeStartMonth,$productTypeStartDay,$productTypeEndYear,$productTypeEndMonth,
						$productTypeEndDay,$talentIDList,$talentTitle,$talentFirstName,
						$talentLastName,$talentAddress,$talentCity,$talentPostcode,$talentWork,
						$talentMobile,$talentFax,$talentEmail, $qty) {

		// Escape value for name.
		$name = sysdb::escape_string($name);

		$query = <<<EOQ
			SELECT COUNT({$this->store->field_campaignaudio_campaignAudioID})
			FROM {$this->store->table_traffic_campaignaudio}
			WHERE {$this->store->field_campaignaudio_campaignID} = '$campaignID'
EOQ;
		$count = sysdb::queryOne($query);
		$charOriginal = toAlphabet(++$count);
		$charOrgPlus = toAlphabet(++$count);

		// Assume that the next alphabetical character corresponds to the count. Valid if none were deleted.
		$char = $charOriginal;

		for ($i = 0; $i < $qty; $i++) {
			if ($name != '') {
				$rename = $name.' '.$char;
			} else {
				$rename = $char;
			}

			if ($char == $charOriginal) {
				// For the first audio, add all parameters.
				$this->add($rename,$productionStatus,$description,$duration,$talentGender,
							$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,
							$deadlineYear,$deadlineMonth,$deadlineDay,$createdDateTime,$producerID,$producerActorID,$campaignID,$filename,
							$maxfilesize,$productTypeIDList,$productTypeName,$productTypeStartYear,
							$productTypeStartMonth,$productTypeStartDay,$productTypeEndYear,$productTypeEndMonth,
							$productTypeEndDay,$talentIDList,$talentTitle,$talentFirstName,
							$talentLastName,$talentAddress,$talentCity,$talentPostcode,$talentWork,
							$talentMobile,$talentFax,$talentEmail);
				$char++;
			} else {
				// For further campaign audio, reuse previously added producer, product type and talent.

				if ($producerActorID != '' && $char == $charOrgPlus) {
					// Fetch the newly inserted producerID.
					$query = <<<EOQ
						SELECT {$this->store->field_campaignaudio_producerID}
						FROM {$this->store->table_traffic_campaignaudio}
						WHERE {$this->store->field_campaignaudio_name} = '$name $charOriginal'
EOQ;
					$producerID = sysdb::queryOne($query);
				}
				if (empty($productTypeIDList) && $char == $charOrgPlus) {
					// Fetch the newly inserted productTypeID.
					$query = <<<EOQ
						SELECT P.{$this->store->field_campaignaudioproducttype_productTypeID}
						FROM ({$this->store->table_traffic_campaignaudioproducttype} P,
							{$this->store->table_traffic_campaignaudio} A
						)
						WHERE A.{$this->store->field_campaignaudio_name} = '$name $charOriginal'
						AND A.{$this->store->field_campaignaudio_campaignAudioID} = P.{$this->store->field_campaignaudioproducttype_campaignAudioID}
EOQ;
					// This is valid so long as only one product type is added on the inline form.
					$productTypeIDList = array(sysdb::queryOne($query));
				}
				if (empty($talentIDList) && $char == $charOrgPlus) {
					// Fetch the newly inserted talentID.
					$query = <<<EOQ
						SELECT T.{$this->store->field_campaignaudiotalent_talentID}
						FROM ({$this->store->table_traffic_campaignaudiotalent} T,
							{$this->store->table_traffic_campaignaudio} A
						)
						WHERE A.{$this->store->field_campaignaudio_name} = '$name $charOriginal'
						AND A.{$this->store->field_campaignaudio_campaignAudioID} = T.{$this->store->field_campaignaudiotalent_campaignAudioID}
EOQ;
					// This is valid so long as only one talent is added on the inline form.
					$talentIDList = array(sysdb::queryOne($query));
				}

				$this->add($rename,$productionStatus,$description,$duration,$talentGender,
							$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,
							$deadlineYear,$deadlineMonth,$deadlineDay,$createdDateTime,$producerID,'',$campaignID,'',
							'',$productTypeIDList,'','',
							'','','','',
							'',$talentIDList,'','',
							'','','','','',
							'','','');
				$char++;
			}
		}
		module::forward_to_script('',array('item'=>'Campaign','action'=>'schedule','id'=>$campaignID));
	}

    public function add($name,$productionStatus,$description,$duration,$talentGender,
						$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,
						$deadlineYear,$deadlineMonth,$deadlineDay,$createdDateTime,$producerID,$producerActorID,$campaignID,$filename,
						$maxfilesize,$productTypeIDList,$productTypeName,$productTypeStartYear,
						$productTypeStartMonth,$productTypeStartDay,$productTypeEndYear,$productTypeEndMonth,
						$productTypeEndDay,$talentIDList,$talentTitle,$talentFirstName,
						$talentLastName,$talentAddress,$talentCity,$talentPostcode,$talentWork,
						$talentMobile,$talentFax,$talentEmail) {
		// Escape values.
		$values = array(&$name,
						&$description
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Format integers to strip thousand-separators.
		$values = array(&$duration
						);
 		foreach ($values as &$value) {
			$value = number_format(str_replace(',', '', $value), 0, '', '');
		}
		unset($value);

		$success = true;
		$item = globalize('item', get_class($this));

		//if ( $duration <= 0 ) {
			// The following 'else', warning and redirect is temporarily disabled so that CSAs can be scheduled.
			// state::setMessage( 'warning', 'Duration must be greater than zero seconds.' );
			// module::forward_to_script('',array('item'=>'CampaignAudio','action'=>'edit','campaignID'=>$campaignID));
		//} else {

		//This is the temporary replacement if statement.
		if ($duration <= 0) {
			state::setMessage( 'warning', 'Duration is zero seconds. This will not count towards the time limit.' );
		}

			if (!checkdate($startMonth,$startDay,$startYear)) {
				state::setMessage('warning', 'Invalid start date.' );
				return;
			} else {
				$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
			}

			if (!checkdate($endMonth,$endDay,$endYear)) {
				state::setMessage('warning', 'Invalid end date.' );
				return;
			} else {
				$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
			}

			if (!checkdate($deadlineMonth,$deadlineDay,$deadlineYear)) {
				state::setMessage('warning', 'Invalid deadline date.');
				return;
			} else {
				$deadlineDate = $deadlineYear.'-'.$deadlineMonth.'-'.$deadlineDay;
			}

			$query = "SELECT clientID as clientID, contractID as contractID FROM {$this->store->table_traffic_campaign} WHERE campaignID = '$campaignID'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$clientID = $line['clientID'];
			$contractID = $line['contractID'];

			if ($filename != '' && $_FILES[$filename]['name'] != '') {
				// /* Define the audio mimetypes we want to allow for upload */
				// $acceptMimetype = array('audio/mpeg','audio/x-wav');

				/* User is attempting to upload a file */
				$fileAttributes = upload_media($_FILES[$filename],'','',$maxfilesize);
				$success = $fileAttributes['success'];
				$message = $fileAttributes['message'];

				if ( !$success ) {
					/* Upload failed */
					state::setMessage('warning', $message );
				} else {
					$mediaID = $fileAttributes['mediaID'];
					$filename = $fileAttributes['filename'];
					$filesize = $fileAttributes['filesize'];
					$mimetype = $fileAttributes['mimetype'];
				}
			} else {
				/* User is not trying to upload a file, but is still able
					to add a record to the database */
				$success = true;
				$mediaID = create_media();
				$filename = '';
				$filesize = '';
				$mimetype = '';
			}
//			}

			if($success){
				// If a new Producer was added on the inline form, add it.
				if ($producerActorID != '') {
					Producer::add($producerActorID);

					// Fetch the newly inserted producerID.
					$query = <<<EOQ
						SELECT {$this->store->field_producer_producerID} AS {$this->store->field_campaignaudio_producerID}
						FROM {$this->store->table_traffic_producer}
						WHERE {$this->store->field_producer_actorID} = '$producerActorID'
EOQ;
					$newProducerID = sysdb::queryOne($query);
				}
				$query = <<<EOQ
					INSERT INTO {$this->store->table_traffic_campaignaudio} (
						{$this->store->field_campaignaudio_name},
						{$this->store->field_campaignaudio_productionStatus},
						{$this->store->field_campaignaudio_description},
						{$this->store->field_campaignaudio_mediaID},
						{$this->store->field_campaignaudio_filename},
						{$this->store->field_campaignaudio_mimetype},
						{$this->store->field_campaignaudio_duration},
						{$this->store->field_campaignaudio_talentGender},
						{$this->store->field_campaignaudio_startDate},
						{$this->store->field_campaignaudio_endDate},
						{$this->store->field_campaignaudio_deadlineDate},
						{$this->store->field_campaignaudio_createdDateTime},
						{$this->store->field_campaignaudio_producerID},
						{$this->store->field_campaignaudio_campaignID},
						{$this->store->field_campaignaudio_contractID},
						{$this->store->field_campaignaudio_clientID}
					) VALUES (
						'$name',
						'$productionStatus',
						'$description',
						'$mediaID',
						'$filename',
						'$mimetype',
						'$duration',
						'$talentGender',
						'$startDate',
						'$endDate',
						'$deadlineDate',
						'$createdDateTime',
EOQ;
				// To be compatible with MySQL 5, integers needs to be set to NULL (not '') if blank.
				if ($producerID != '')
					$query .= "'$producerID'";
				elseif (isset($newProducerID) && $newProducerID != '')
					$query .= "'$newProducerID'";
				else
					$query .= "NULL";

				$query .= ",'$campaignID','".$line['contractID']."','".$line['clientID']."')";
				$result = sysdb::query($query);
				state::setMessage('notify', 'Successfully added new campaign audio: '.utf8_decode($name));
				$campaignAudioID = sysdb::insert_id();
				if (!empty($productTypeIDList)) {
					foreach($productTypeIDList as $productTypeID ) {
						if ($productTypeID != '') {
							$query = "INSERT INTO {$this->store->table_traffic_campaignaudioproducttype} (productTypeID,campaignAudioID,campaignID,contractID,clientID) VALUES ('$productTypeID','$campaignAudioID','$campaignID','$contractID','$clientID')";
							$result = sysdb::query($query);
						}
					}
				}
				// If details for a new ProductType was added on the inline form, add it.
				if ($productTypeName != '') {
					ProductType::add($productTypeName,$productTypeStartYear,$productTypeStartMonth,$productTypeStartDay,$productTypeEndYear,$productTypeEndMonth,$productTypeEndDay);

					// Escape value for productTypeName, after it has been sent to ProductType class above (so that it's not escaped twice).
					$productTypeName = sysdb::escape_string($productTypeName);

					// Fetch the newly inserted productTypeID and add it into the campaignaudioproducttype table.
					$query = <<<EOQ
						INSERT INTO {$this->store->table_traffic_campaignaudioproducttype} (
							{$this->store->field_campaignaudioproducttype_productTypeID},
							{$this->store->field_campaignaudioproducttype_campaignAudioID},
							{$this->store->field_campaignaudioproducttype_campaignID},
							{$this->store->field_campaignaudioproducttype_contractID},
							{$this->store->field_campaignaudioproducttype_clientID}
						)
						SELECT {$this->store->field_producttype_productTypeID} AS {$this->store->field_campaignaudioproducttype_productTypeID},
							'$campaignAudioID' AS {$this->store->field_campaignaudioproducttype_campaignAudioID},
							'$campaignID' AS {$this->store->field_campaignaudioproducttype_campaignID},
							'$contractID' AS {$this->store->field_campaignaudioproducttype_contractID},
							'$clientID' AS {$this->store->field_campaignaudioproducttype_clientID}
						FROM {$this->store->table_traffic_producttype}
						WHERE {$this->store->field_producttype_name} = '$productTypeName'
EOQ;
					sysdb::query($query);
				}
				if (!empty($talentIDList)) {
					foreach($talentIDList as $talentID ) {
						if ($talentID != '') {
							$query = "INSERT INTO {$this->store->table_traffic_campaignaudiotalent} (talentID,campaignAudioID) VALUES ('$talentID','$campaignAudioID')";
							$result = sysdb::query($query);
						}
					}
				}
				// If details for a new talent was added on the inline form, add it.
				if ($talentTitle != '' ||
					$talentFirstName != '' ||
					$talentLastName != '' ||
					$talentAddress != '' ||
					$talentCity != '' ||
					$talentPostcode != '' ||
					$talentWork != '' ||
					$talentMobile != '' ||
					$talentFax != '' ||
					$talentEmail != '') {
					$talentActorID = create_actor();
					Talent::save('',$talentActorID,$talentTitle,$talentFirstName,$talentLastName,
								$talentAddress,$talentCity,$talentPostcode,$talentWork,$talentMobile,
								$talentFax,$talentEmail);

					// Fetch the newly inserted talentID and add it into the campaignaudiotalent table.
					$query = <<<EOQ
						INSERT INTO {$this->store->table_traffic_campaignaudiotalent} (
							{$this->store->field_campaignaudiotalent_talentID},
							{$this->store->field_campaignaudiotalent_campaignAudioID}
						)
						SELECT {$this->store->field_talent_talentID} AS {$this->store->field_campaignaudiotalent_talentID},
							'$campaignAudioID' AS {$this->store->field_campaignaudiotalent_campaignAudioID}
						FROM {$this->store->table_traffic_talent}
						WHERE {$this->store->field_talent_actorID} = '$talentActorID'
EOQ;
					sysdb::query($query);
				}
				// Forward user to new Audio if not using function from foreign class, or if not action=multi_add.
				if ($item == 'CampaignAudio' && globalize('action') == 'add') {
	        		module::forward_to_script('',array('item'=>'Campaign','action'=>'schedule','id'=>$campaignID));
				}
				//module::forward_to_script('',array('item'=>'CampaignAudio','action'=>'view','id'=>$campaignAudioID));
			}
		//} This is temporarily disabled as described above regarding zero duration files.
    }

    public function save($id,$name,$productionStatus,$description,$duration,$talentGender,
						$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,
						$deadlineYear,$deadlineMonth,$deadlineDay,$createdDateTime,$producerID,$producerActorID,$filename,$maxfilesize,
						$mediaID,$productTypeIDList,$productTypeName,$productTypeStartYear,
						$productTypeStartMonth,$productTypeStartDay,$productTypeEndYear,$productTypeEndMonth,
						$productTypeEndDay,$talentIDList,$talentTitle,$talentFirstName,
						$talentLastName,$talentAddress,$talentCity,$talentPostcode,$talentWork,
						$talentMobile,$talentFax,$talentEmail)
	{
		// Escape values.
		$values = array(&$name,
						&$description,
						&$filename
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Format integers to strip thousand-separators.
		$values = array(&$duration
						);
 		foreach ($values as &$value) {
			$value = number_format(str_replace(',', '', $value), 0, '', '');
		}
		unset($value);

		//if ( $duration <= 0 ) {
			// The following 'else', warning and redirect is temporarily disabled so that CSAs can be scheduled.
			//state::setMessage( 'warning', 'Duration must be greater than zero seconds.' );
			// module::forward_to_script('',array('item'=>'CampaignAudio','action'=>'edit','id'=>$id));
		//} else {

		//This is the temporary replacement if statement.
		if ($duration <= 0) {
			state::setMessage( 'warning', 'Duration is zero seconds. This will not count towards the time limit.' );
		}

			if (!checkdate($startMonth,$startDay,$startYear)) {
				state::setMessage('warning', 'Invalid start date.' );
				return;
			} else {
				$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
			}

			if (!checkdate($endMonth,$endDay,$endYear)) {
				state::setMessage('warning', 'Invalid end date.' );
				return;
			} else {
				$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
			}

			if (!checkdate($deadlineMonth,$deadlineDay,$deadlineYear)) {
				state::setMessage('warning', 'Invalid deadline date.' );
				return;
			} else {
				$deadlineDate = $deadlineYear.'-'.$deadlineMonth.'-'.$deadlineDay;
			}

			/* Retrieve production status prior to saving new data */
			$query = "SELECT productionStatus FROM {$this->store->table_traffic_campaignaudio} WHERE campaignAudioID = '$id'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$emailPrior_state = $line['productionStatus'];

			// If a new Producer was added on the inline form, add it.
			if ($producerActorID != '') {
				Producer::add($producerActorID);

				// Fetch the newly inserted producerID.
				$query = <<<EOQ
					SELECT {$this->store->field_producer_producerID} AS {$this->store->field_campaignaudio_producerID}
					FROM {$this->store->table_traffic_producer}
					WHERE {$this->store->field_producer_actorID} = '$producerActorID'
EOQ;
				$newProducerID = sysdb::queryOne($query);
			}

			$query = "UPDATE {$this->store->table_traffic_campaignaudio} SET name = '$name', productionStatus = '$productionStatus', description = '$description', duration = '$duration', talentGender = '$talentGender', startDate = '$startDate', endDate = '$endDate', deadlineDate = '$deadlineDate'";

			if ($producerID != '')
				$query .= ", producerID = '$producerID'";
			elseif (isset($newProducerID) && $newProducerID != '')
				$query .= ", producerID = '$newProducerID'";

			// state::setMessage('warning', 'if statement'.print_r($filename,true));
			if ($filename != '' && $_FILES[$filename]['name'] != '') {
				// /* Define the audio mimetypes we want to allow for upload */
				// $acceptMimetype = array('audio/mpeg','audio/x-wav');

				/* User is attempting to upload a file */
				if ($mediaID == 0)
					$mediaID = '';
				/* User is attempting to upload a file */
				$fileAttributes = upload_media($_FILES[$filename],'','',$maxfilesize,$mediaID);
				$success = $fileAttributes['success'];
				$message = $fileAttributes['message'];

				if (!$success) {
					/* Upload failed */
					state::setMessage('warning', $message );
				} else {
					$mediaID = $fileAttributes['mediaID'];
					$filename = $fileAttributes['filename'];
					$filesize = $fileAttributes['filesize'];
					$mimetype = $fileAttributes['mimetype'];

					$query .= ", mediaID = '$mediaID', filename = '$filename', mimetype = '$mimetype'";

				}
			} else {
				/* User is not trying to upload a file, but is still able
					update the database */
				$success = true;
			}

			if ($success) {
				$query .= " WHERE campaignAudioID = '$id'";
				$result = sysdb::query($query);
				state::setMessage('notify', 'Successfully updated campaign audio: '.utf8_decode($name));

				/* If the production status has been changed, send the required notification emails */
				if ($productionStatus != $emailPrior_state) {
					$notification_type = $this->production_status($productionStatus);
					$email_success = email_notification($id,$notification_type,$emailPrior_state);
					if ($email_success) state::setMessage('notify', "Sent notification email of production status change from '".$emailPrior_state."' to '".$productionStatus."'");
				}

				$query = "SELECT clientID as clientID, contractID as contractID, campaignID as campaignID FROM {$this->store->table_traffic_campaignaudio} WHERE campaignAudioID = '$id'";
				$result = sysdb::query($query);
				$line = sysdb::fetch_assoc($result);
				$clientID = $line['clientID'];
				$contractID = $line['contractID'];
				$campaignID = $line['campaignID'];

				$query = "DELETE FROM {$this->store->table_traffic_campaignaudioproducttype} WHERE campaignAudioID = '$id'";
				$result = sysdb::query($query);
				if (!empty($productTypeIDList)) {
					foreach($productTypeIDList as $productTypeID) {
						if ($productTypeID != '') {
							$query = "INSERT INTO {$this->store->table_traffic_campaignaudioproducttype} (productTypeID,campaignAudioID,campaignID,contractID,clientID) VALUES ('$productTypeID','$id','".$line['campaignID']."','".$line['contractID']."','".$line['clientID']."')";
							$result = sysdb::query($query);
						}
					}
				}
				// If details for a new ProductType was added on the inline form, add it.
				if ($productTypeName != '') {
					ProductType::add($productTypeName,$productTypeStartYear,$productTypeStartMonth,$productTypeStartDay,$productTypeEndYear,$productTypeEndMonth,$productTypeEndDay);

					// Escape value for productTypeName, after it has been sent to ProductType class above (so that it's not escaped twice).
					$productTypeName = sysdb::escape_string($productTypeName);

					// Fetch the newly inserted productTypeID and add it into the campaignaudioproducttype table.
					$query = <<<EOQ
						INSERT INTO
						{$this->store->table_traffic_campaignaudioproducttype} (
							{$this->store->field_campaignaudioproducttype_productTypeID},
							{$this->store->field_campaignaudioproducttype_campaignAudioID},
							{$this->store->field_campaignaudioproducttype_campaignID},
							{$this->store->field_campaignaudioproducttype_contractID},
							{$this->store->field_campaignaudioproducttype_clientID}
						)
						SELECT {$this->store->field_producttype_productTypeID} AS {$this->store->field_campaignaudioproducttype_productTypeID},
							'$id' AS {$this->store->field_campaignaudioproducttype_campaignAudioID},
							'$campaignID' AS {$this->store->field_campaignaudioproducttype_campaignID},
							'$contractID' AS {$this->store->field_campaignaudioproducttype_contractID},
							'$clientID' AS {$this->store->field_campaignaudioproducttype_clientID}
						FROM {$this->store->table_traffic_producttype}
						WHERE {$this->store->field_producttype_name} = '$productTypeName'
EOQ;
					sysdb::query($query);
				}
				$query = "DELETE FROM {$this->store->table_traffic_campaignaudiotalent} WHERE campaignAudioID = '$id'";
				$result = sysdb::query($query);
				if (!empty($talentIDList)) {
					foreach($talentIDList as $talentID) {
						if ($talentID != '') {
							$query = "INSERT INTO {$this->store->table_traffic_campaignaudiotalent} (talentID,campaignAudioID) VALUES ('$talentID','$id')";
							$result = sysdb::query($query);
						}
					}
				}
				// If details for a new talent was added on the inline form, add it.
				if ($talentTitle != '' ||
					$talentFirstName != '' ||
					$talentLastName != '' ||
					$talentAddress != '' ||
					$talentCity != '' ||
					$talentPostcode != '' ||
					$talentWork != '' ||
					$talentMobile != '' ||
					$talentFax != '' ||
					$talentEmail != '') {
					$talentActorID = create_actor();
					Talent::save('',$talentActorID,$talentTitle,$talentFirstName,$talentLastName,
								$talentAddress,$talentCity,$talentPostcode,$talentWork,$talentMobile,
								$talentFax,$talentEmail);

					// Fetch the newly inserted talentID and add it into the campaignaudiotalent table.
					$query = <<<EOQ
						INSERT INTO {$this->store->table_traffic_campaignaudiotalent} (
							{$this->store->field_campaignaudiotalent_talentID},
							{$this->store->field_campaignaudiotalent_campaignAudioID}
						)
						SELECT {$this->store->field_talent_talentID} AS {$this->store->field_campaignaudiotalent_talentID},
							'$id' AS {$this->store->field_campaignaudiotalent_campaignAudioID}
						FROM {$this->store->table_traffic_talent}
						WHERE {$this->store->field_talent_actorID} = '$talentActorID'
EOQ;
					sysdb::query($query);
				}
				module::forward_to_script('',array('item'=>'CampaignAudio','action'=>'view','id'=>$id));
			}
		//} This is temporarily disabled as described above regarding zero duration files.
    }

    public function download($campaignAudioID,$id) {
		/* If there is a file associated, try to download it */
		if ( $id != 0 ) {
			/* Download the campaign audio file */
			$query = <<<EOQ
				SELECT A.{$this->store->field_campaignaudio_mimetype} AS mimetype,
					A.{$this->store->field_campaignaudio_filename} AS filename,
					M.{$this->store->field_media_path} AS path
				FROM ({$this->store->table_traffic_campaignaudio} A,
					{$this->store->table_media} M
				)
				WHERE A.{$this->store->field_campaignaudio_mediaID} = '$id'
				AND A.{$this->store->field_campaignaudio_mediaID} = M.{$this->store->field_media_mediaID}
EOQ;
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$path = $line['path'];
			$mimetype = $line['mimetype'];
			$filename = $line['filename'];
			header('Content-Description: File Transfer');
			header('Content-Type: '.$mimetype);
			header("Content-Disposition: attachment; filename=\"$filename\"");
			header('Content-Transfer-Encoding: binary');
			header('Expires: 0');
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
			header('Pragma: public');
			if (ob_get_level()) {
				ob_end_clean();
			}
			flush();
			readfile($path);
			exit;
		} else {
			state::setMessage('warning', 'File does not exist: could not download file.' );
			module::forward_to_script('',array('item'=>'CampaignAudio','action'=>'view','id'=>$campaignAudioID));
		}
    }

    public function delete($id) {
		$success = false;
        $query = <<<EOQ
			SELECT {$this->store->field_campaignaudio_name},
				{$this->store->field_campaignaudio_mediaID}
			FROM {$this->store->table_traffic_campaignaudio}
			WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$id'
EOQ;
		$result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$mediaID = $line['mediaID'];

		// Remove any daughter spots.
        $query = <<<EOQ
            SELECT {$this->store->field_spot_spotID}
			FROM {$this->store->table_traffic_spot}
			WHERE {$this->store->field_spot_mediaID} = '$mediaID'
EOQ;
		$spotIDList = sysdb::query2vector($query, 'spotID');

		if (Spot::delete_many($spotIDList)) {
			$success = true;
		} else {
			state::setMessage('warning', 'Could not delete spots.');
			$success = false;
		}

		/* If there is a file associated, try to delete it */
		if ( $mediaID != 0 ) {
			if (delete_media($mediaID)) {
				$success = true;
			} else {
				state::setMessage('warning', 'Could not delete the file.');
				$success = false;
			}
		}

		/* If we succesfuly deleted the file, or if there was no file at all, delete the record */
		if ($success || $mediaID == 0) {
			// Remove assignments for campaign audio.
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_campaignaudioproducttype}
				WHERE {$this->store->field_campaignaudioproducttype_campaignAudioID} = '$id'
EOQ;
			sysdb::query($query);

			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_campaignaudiotalent}
				WHERE {$this->store->field_campaignaudiotalent_campaignAudioID} = '$id'
EOQ;
			sysdb::query($query);

			// Remove campaign audio.
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_campaignaudio}
				WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$id'
EOQ;
			sysdb::query($query);
			state::setMessage('notify', 'Successfully deleted campaign audio: '.utf8_decode($line['name']));
		}
		return $success;
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this Campaign Audio item?</p>';
		$message .= '<p>The item and all its daughter audio and spots will be permanently deleted if you proceed.</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);
		return;
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','id'=>$id));
		return;
    }

    public function search($doc,$string) {
        $string = strtolower($string);
        $query = "SELECT campaignAudioID FROM {$this->store->table_traffic_campaignaudio} WHERE LCASE(name) LIKE '%$string%' OR LCASE(description) LIKE '%$string%' OR LCASE(filename) LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'campaignAudioID')));
        }
    }

	public function include_header($doc,$parentIDType) {

		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			case 'CampaignAudio':
				$parentFieldName = 'campaignAudioID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		$item = globalize('item', get_class($this));
		$id = globalize('id');
        if ($id == '') $id = globalize('campaignAudioID');
		$extras = globalize('extras');
		$includeHeader = $doc->createElement('div');
		$includeHeader->setAttribute('id', 'inline_menu');

		$link = module::link_to_script_dom($doc,'Contracts','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Contract'),'Contracts');
		$contractsLink = $doc->createElement('span');
		$contractsLink->setAttribute('id', 'link_contracts');
		$contractsLink->setAttribute('class', 'inline_link');
		$contractsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Campaigns','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Campaign'),'Campaigns');
		$campaignsLink = $doc->createElement('span');
		$campaignsLink->setAttribute('id', 'link_campaigns');
		$campaignsLink->setAttribute('class', 'inline_link');
		$campaignsLink->appendChild($link);

		// $link = module::link_to_script_dom($doc,'Promotions','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignPromotion'),'Promotions');
		// $campaignPromotionsLink = $doc->createElement('span');
		// $campaignPromotionsLink->setAttribute('id', 'link_campaign_promotions');
		// $campaignPromotionsLink->setAttribute('class', 'inline_link');
		// $campaignPromotionsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Materials','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignMaterial'),'Materials');
		$campaignMaterialsLink = $doc->createElement('span');
		$campaignMaterialsLink->setAttribute('id', 'link_campaign_materials');
		$campaignMaterialsLink->setAttribute('class', 'inline_link');
		$campaignMaterialsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Audio','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignAudio'),'Audio');
		$campaignAudioLink = $doc->createElement('span');
		if ($extras == 'CampaignAudio' || $extras == '')
			$campaignAudioLink->setAttribute('id', 'link_campaign_audio_selected');
		else
			$campaignAudioLink->setAttribute('id', 'link_campaign_audio');
		$campaignAudioLink->setAttribute('class', 'inline_link');
		$campaignAudioLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Traffic','',array('item'=>'Traffic','mode'=>$item,$parentFieldName=>$id),'Traffic');
		$trafficLink = $doc->createElement('span');
		$trafficLink->setAttribute('id', 'link_traffic');
		$trafficLink->setAttribute('class', 'inline_link');
		$trafficLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Log','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Log'),'Log');
		$logLink = $doc->createElement('span');
		$logLink->setAttribute('id', 'link_traffic');
		$logLink->setAttribute('class', 'inline_link');
		$logLink->appendChild($link);

		/* 	This switch is specifically designed *without* break statements.
			This is because once we hit our current item, all those below it are required as well.
			-CH
		*/
		switch ($item) {
			case 'Client':
				$includeHeader->appendChild($contractsLink);
			case 'Contract':
				$includeHeader->appendChild($campaignsLink);
			case 'Campaign':
				if ($parentIDType == 'Campaign') {
					// $includeHeader->appendChild($campaignPromotionsLink);
					$includeHeader->appendChild($campaignMaterialsLink);
				}
				$includeHeader->appendChild($campaignAudioLink);
			case 'CampaignAudio':
				$includeHeader->appendChild($logLink);
				$includeHeader->appendChild($trafficLink);
				break;
		}

		return $includeHeader;

	}

    public function inline_list($doc,$ids='',$isInclude=false) {

		$item = get_class($this);
		$parentID = globalize('id');
		$parentIDType = globalize('item', get_class($this));
		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			case 'CampaignAudio':
				$parentFieldName = 'campaignAudioID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		if ($parentIDType == 'Client')
			$x = 'C';
		if ($parentIDType == 'Contract')
			$x = 'T';
		if ($parentIDType == 'Campaign')
			$x = 'G';
		if ($parentIDType == 'CampaignAudio')
			$x = 'A';
		$query = "SELECT $x.name FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} T, {$this->store->table_traffic_campaign} G, {$this->store->table_traffic_campaignaudio} A) WHERE $x.$parentFieldName = '$parentID' AND C.clientID = $x.clientID";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$caption_name = utf8_decode($line['name']);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module_right');
		$container->appendChild($this->include_header($doc,$parentIDType));

		$sortby = globalize('sortby');
		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
							break;
				case 'campaign':
							$sortby = 'campaignName';
							break;
				case 'status':
							$sortby = 'productionStatus, name';
							break;
				case 'producerID':
							$sortby = 'producerID, name';
							break;
				default:
							$sortby = 'name';
							break;
			}
		}

		function inline_list_actions($doc,$id) {
			global $module_parameter;
			$item = 'CampaignAudio';
			$div = $doc->createElement('div');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
			/* I had to substitute the $item variable for the hardcoded 'Contract' because using the variable would require modification of the db.php callback */
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$id),'View'));
            $div->appendChild($span);
			$div->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$id),'Edit'));
            $div->appendChild($span);
			$div->appendChild($doc->createTextNode(' '));

			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_schedule_small');
			$span->appendChild(module::link_to_script_dom($doc,'schedule','',array('item'=>$item,'action'=>'schedule','id'=>$id),'Schedule'));
            $div->appendChild($span);
			return $div;
		}

		function inline_list_header($doc) {
			$item = 'CampaignAudio';
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			$th1 = $doc->createElement('th');
			if ($parentIDType == 'Client' || $parentIDType == 'Contract')
				$th2 = $doc->createElement('th');
			$th3 = $doc->createElement('th');
			$th4 = $doc->createElement('th');
			$actiontd = $doc->createElement('th');
			$actiontd->setAttribute('class', 'action');
			$th1->appendChild(module::link_to_script_dom($doc,'Name','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'name'),'Name'));
			if ($parentIDType == 'Client' || $parentIDType == 'Contract')
				$th2->appendChild(module::link_to_script_dom($doc,'Campaign','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'campaign'),'Campaign'));
			$th3->appendChild(module::link_to_script_dom($doc,'Status','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'status'),'Status'));
			$th4->appendChild(module::link_to_script_dom($doc,'Producer','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'producerID'),'Producer'));

			if ($parentIDType == 'Client') {
				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Audio','',array('item'=>$item,'action'=>'inline_add','clientID'=>$parentID),'Add New Audio'));
				$actiontd->appendChild($span);
			}

			if ($parentIDType == 'Contract') {
				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Audio','',array('item'=>$item,'action'=>'inline_add','contractID'=>$parentID),'Add New Audio'));
				$actiontd->appendChild($span);
			}

			if ($parentIDType == 'Campaign') {
				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Audio','',array('item'=>$item,'action'=>'edit','campaignID'=>$parentID),'Add New Audio'));
				$actiontd->appendChild($span);
			}
			$tr->appendChild($th1);
			if ($parentIDType == 'Client' || $parentIDType == 'Contract')
				$tr->appendChild($th2);
			$tr->appendChild($th3);
//			$tr->appendChild($th4);
			$tr->appendChild($actiontd);

			return $tr;
		}

		function inline_list_footer($doc) {
			$item = 'CampaignAudio';
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			if ($parentIDType == 'Client' || $parentIDType == 'Contract' || $parentIDType == 'Campaign') {
				$td1 = $doc->createElement('td');
				if ($parentIDType == 'Client' || $parentIDType == 'Contract')
					$td2 = $doc->createElement('td');
				$td3 = $doc->createElement('td');
				$td4 = $doc->createElement('td');
				$actiontd = $doc->createElement('td');
				$actiontd->setAttribute('class', 'number');

				if ($parentIDType == 'Client') {
					$span = $doc->createElement('span');
					$span->setAttribute('class', 'link_add_small');
					$span->appendChild(module::link_to_script_dom($doc,'Add New Audio','',array('item'=>$item,'action'=>'inline_add','clientID'=>$parentID),'Add New Audio'));
					$actiontd->appendChild($span);
				}

				if ($parentIDType == 'Contract') {
					$span = $doc->createElement('span');
					$span->setAttribute('class', 'link_add_small');
					$span->appendChild(module::link_to_script_dom($doc,'Add New Audio','',array('item'=>$item,'action'=>'inline_add','contractID'=>$parentID),'Add New Audio'));
					$actiontd->appendChild($span);
				}

				if ($parentIDType == 'Campaign') {
					$span = $doc->createElement('span');
					$span->setAttribute('class', 'link_add_small');
					$span->appendChild(module::link_to_script_dom($doc,'Add New Audio','',array('item'=>$item,'action'=>'edit','campaignID'=>$parentID),'Add New Audio'));
					$actiontd->appendChild($span);
				}

				$tr->appendChild($td1);
				if ($parentIDType == 'Client' || $parentIDType == 'Contract')
					$tr->appendChild($td2);
				$tr->appendChild($td3);
//				$tr->appendChild($td4);
				$tr->appendChild($actiontd);
			}
			return $tr;
		}

		function inline_list_field($field,$value) {
			if ($field == '4') {
				if ($value == 'Pending Draft Approval') {
					$class = 'audiostatus_draft';
					return $class;
				}
				if ($value == 'In Production') {
					$class = 'audiostatus_production';
					return $class;
				}
				if ($value == 'Pending Internal Approval') {
					$class = 'audiostatus_pending_internal';
					return $class;
				}
				if ($value == 'Pending Client Approval') {
					$class = 'audiostatus_pending_external';
					return $class;
				}
				if ($value == 'Approved') {
					$class = 'audiostatus_approved';
					return $class;
				}
			}
		}

		function inline_list_colgroups($doc) {
			$parentIDType = globalize('item');
			$col1 = $doc->createElement('col');

			$col2 = $doc->createElement('col');
			$col2->setAttribute('width', '110px');

			$col3 = $doc->createElement('col');
//			$col4 = $doc->createElement('col');
			$colactions = $doc->createElement('col');
			$colactions->setAttribute('width', '75px');

			if ($parentIDType == 'Client' || $parentIDType == 'Contract') {
				$colgroup = array($col1,$col2,$col3,$colactions);
			}
			if ($parentIDType == 'Campaign') {
				$colgroup = array($col1,$col3,$colactions);
			}
			return $colgroup;
		}

		/* All the functions need to be loaded up as variables, to avoid undefined variable errors from call_user_func_array() */
		$action_func = 'inline_list_actions';
		$footer_func = 'inline_list_footer';
		$header_func = 'inline_list_header';
		$field_func = 'inline_list_field';
		$col_func = 'inline_list_colgroups';
		$colgroup = call_user_func_array($col_func,array($doc));
		$caption = "Audio for $caption_name";

		if ($parentIDType == 'Campaign') {
			$ignore = array('0','2','3');
		} else {
			$ignore = array('0','2');
		}

		$query = "SELECT A.campaignAudioID, A.name, ";
		$query .= "A.campaignID, G.name as campaignName, ";
		$query .= "A.productionStatus FROM ({$this->store->table_traffic_campaign} G, {$this->store->table_traffic_campaignaudio} A)";
		$query .= " WHERE A.$parentFieldName = '$parentID'";
		$query .= " AND G.campaignID = A.campaignID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " A.campaignAudioID IN (".implode(',',$ids).") ";
        if(isset($sortby))
			$query .= " ORDER BY ".$sortby;
        // $result = sysdb::query($query);

		// Turn result query into a matrix.
		$matrix = sysdb::query2matrix($query,false);

		// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
		$vectors = sysdb::rotatematrix($matrix);

		// Perform data transformation on any column (vector), row by row (key by key).
        $audioNames = array();
        $campaignNames = array();
        $actions = array();
		if (!empty($vectors[0])) {
			foreach ($vectors[0] as $key=>$value) {
				$audioNames[$key] = module::link_to_script_dom($doc,utf8_decode($vectors[1][$key]),'',array('item'=>'CampaignAudio','action'=>'view','id'=>$vectors[0][$key]),'');
				$campaignNames[$key] = module::link_to_script_dom($doc,utf8_decode($vectors[3][$key]),'',array('item'=>'Campaign','action'=>'view','id'=>$vectors[2][$key]),'');
				$actions[$key] = inline_list_actions($doc,$value);
			}
		}

		// Replace the original matrix column(s) with the new the vector(s).
		$vectors[1] = $audioNames;
		$vectors[3] = $campaignNames;
		$vectors[5] = $actions;

		// Rotate the new matrix 270 degrees to put it back the right way.
		$matrix_rotated_180 = sysdb::rotatematrix($vectors);
		$matrix_rotated_270 = sysdb::rotatematrix($matrix_rotated_180);
		$matrix_upright = sysdb::rotatematrix($matrix_rotated_270);

		$containertable = $doc->createElement('div');
		$containertable->setAttribute('id', 'inline_table');

		$table = sysdb::dom_matrix2table
		(
			$doc,
			$matrix_upright,
			false,
			'',
			'',
			$ignore,
			$footer_func,
			$header_func,
			array('table'=>'list','tr'=>'even','td'=>''),
			$caption,
			$colgroup,
			$field_func
		);

		$containertable->appendChild($table);
 		$container->appendChild($containertable);

        return($container);
    }

	public function production_status($productionStatus) {
		if ($productionStatus == 'Pending Draft Approval') {
			$class = 'audiostatus_draft';
			return $class;
		}
		if ($productionStatus == 'In Production') {
			$class = 'audiostatus_production';
			return $class;
		}
		if ($productionStatus == 'Pending Internal Approval') {
			$class = 'audiostatus_pending_internal';
			return $class;
		}
		if ($productionStatus == 'Pending Client Approval') {
			$class = 'audiostatus_pending_external';
			return $class;
		}
		if ($productionStatus == 'Approved') {
			$class = 'audiostatus_approved';
			return $class;
		}
	}

	public function resolve_producer_name($producerID) {
        $query = "SELECT U.name ";
		$query .= "FROM ({$this->store->table_traffic_producer} P, {$this->store->table_user} U) ";
		$query .= "WHERE P.producerID = '$producerID' ";
		$query .= "AND U.actorID = P.actorID";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$name = $line['name'];
		return $name;
	}

	public function resolve_product_type($productTypeIDList) {
		if (!empty($productTypeIDList)) {
			foreach ($productTypeIDList as $productTypeID) {
				if ($productTypeID != '') {
					$query = "SELECT P.name ";
					$query .= "FROM ({$this->store->table_traffic_campaignaudioproducttype} C, {$this->store->table_traffic_producttype} P) ";
					$query .= "WHERE C.productTypeID = '$productTypeID'";
					$result = sysdb::query($query);
					$line = sysdb::fetch_assoc($result);
					$name = $line['name'];
					return $name;
				}
			}
		}
	}

    public function schedule($doc,$campaignAudioID) {
        return(Schedule::displayGridTickboxes($doc,$campaignAudioID));
    }

    public function inline_add($doc,$ids='') {
		$item = get_class($this);
		$errors = false;
		if (globalize('clientID') != '') {
			$parentID = globalize('clientID');
			$parentIDType = 'Client';
			$parentFieldName = 'clientID';
		} elseif (globalize('contractID') != '') {
			$parentID = globalize('contractID');
			$parentIDType = 'Contract';
			$parentFieldName = 'contractID';
		} else {
			$errors = true;
		}

		if (!$errors) {
			$query = "SELECT campaignID FROM ({$this->store->table_traffic_campaign}) WHERE $parentFieldName = '$parentID'";
			$ids = sysdb::query2vector($query,'campaignID');
			if (is_array($ids) && sizeof($ids) == 1) { $default = $ids[0]; }
			else if (is_array($ids) && sizeof($ids) != 1) { $default = ''; }

			$container = $doc->createElement('div');
			$container->setAttribute('class','module_left');

			$header = $doc->createElement('h1');
			$header->appendChild($doc->createTextNode('Add Campaign Audio'));
			$container->appendChild($header);

			$subheader = $doc->createElement('h2');
			$subheader->appendChild($doc->createTextNode('Specify the parent campaign for the new campaign audio.'));
			$container->appendChild($subheader);

			$campaign = new Campaign();
			$container->appendChild($campaign->display_select($doc, $ids, $default));

			$container->appendChild($select = $doc->createElement('input'));
			$select->setAttribute('type','submit');
			$select->setAttribute('name','action');
			$select->setAttribute('value','select');

			$container->appendChild($br = $doc->createElement('br'));
			$container->appendChild($br = $doc->createElement('br'));
			$container->appendChild($br = $doc->createElement('br'));

			$altsubheader = $doc->createElement('h2');
			$altsubheader->appendChild($doc->createTextNode('Alternatively, add a new campaign.'));
			$container->appendChild($altsubheader);

			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			if ($parentIDType == 'Client') {
				$a = module::link_to_script_dom_unappended($doc,'Add Campaign','',array('item'=>'Campaign','action'=>'inline_add',$parentFieldName=>$parentID),'Add Campaign','link_button');
			} elseif ($parentIDType == 'Contract') {
				$a = module::link_to_script_dom_unappended($doc,'Add Campaign','',array('item'=>'Campaign','action'=>'edit',$parentFieldName=>$parentID),'Add Campaign','link_button');
			}
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_add');
			$label = $doc->createTextNode('Add Campaign');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			return($container);
		} else {
			state::setMessage('warning', 'Not a valid parent.');
			module::forward_to_script('',array('item'=>$item));
		}
    }

    public function select($campaignID) {
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','campaignID'=>$campaignID));
    }

	/** Resolves media id for given campaign audio id. */
    public function resolve_media_id($id) {
        $query = <<<EOQ
			SELECT {$this->store->field_campaignaudio_mediaID}
			FROM  {$this->store->table_traffic_campaignaudio}
			WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$id'
EOQ;
        return(sysdb::queryOne($query));
    }

	/** Resolves media id for given campaign audio id.
	*
	* @todo Test that this function works properly.
	*/
    public function resolve_many_media_id($idList) {
		$campaignAudioIDs = implode($idList, ',');
        $query = <<<EOQ
			SELECT {$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID,
				{$this->store->field_campaignaudio_mediaID} AS mediaID
			FROM  {$this->store->table_traffic_campaignaudio}
			WHERE {$this->store->field_campaignaudio_campaignAudioID} IN ($campaignAudioIDs)
EOQ;
        $matrix = sysdb::query2matrix($query, false);

		if (sizeof($matrix) > 0) {
			// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
			$vectors = sysdb::rotatematrix($matrix);
			$master_list = array_combine($vectors[0], $vectors[1]);

			// Match corresponding entry to emulate original list.
			$mediaIDList = array();
			foreach ($idList as $campaignAudioID) {
				if(array_key_exists($campaignAudioID, $master_list)) {
					$mediaIDList[] = $master_list[$campaignAudioID];
				} else {
					// Cannot find corresponding media id.
					return false;
				}
			}
			return ($mediaIDList);
		} else {
			return false;
		}
    }

}
?>