<?php
// $Id$

class CampaignPromotion {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('campaignPromotionName'),
							globalize('campaignPromotionDescription'),
							globalize('campaignID'),
							'campaignPromotionFilename',
							globalize('MAX_FILE_SIZE'));
				break;
            case 'save':
				$this->save(globalize('campaignPromotionID'),
							globalize('campaignPromotionName'),
							globalize('campaignPromotionDescription'),
							'campaignPromotionFilename',
							globalize('MAX_FILE_SIZE'),
							globalize('campaignPromotionMediaID'));
				break;
            case "remove":
				$this->remove(globalize('id'));
				break;
            case "cancel":
				$this->cancel(globalize('id'));
				break;
            case 'download':
				$this->download(globalize('campaignPromotionID'),
							globalize('id'));
				break;
        }
    }

    public function form($doc, $id='') {

		$campaignID = globalize('campaignID');

		$form = module::form_dom($doc);
		$form->setAttribute('enctype','multipart/form-data');

		$item = globalize('item', get_class($this));

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','item');
		$iteminput->setAttribute('value',$item);
		$form->appendChild($iteminput);

		$maxFileSize = $doc->createElement('input');
		$maxFileSize->setAttribute('type','hidden');
		$maxFileSize->setAttribute('name','MAX_FILE_SIZE');
		$maxFileSize->setAttribute('value','28000000');
		$form->appendChild($maxFileSize);


		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$form->appendChild($terminate);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Campaign Promotion';
        else
            $headerText = 'Edit Campaign Promotion';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		if ($id != '') {
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'remove','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $campaignPromotionID = $doc->createElement('input');
        $campaignPromotionID->setAttribute('type','hidden');
        $campaignPromotionID->setAttribute('name','campaignPromotionID');
        $campaignPromotionID->setAttribute('value',$id);
        $container->appendChild($campaignPromotionID);

		$input = $doc->createElement('input');
        $input->setAttribute('type','hidden');
        $input->setAttribute('name','campaignID');
        $input->setAttribute('value',$campaignID);
        $container->appendChild($input);

        if ($id != '') {

			$query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.contractID as contractID, B.name as campaignName, I.* ";
			$query.= "FROM {$this->store->table_traffic_campaignpromotion} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A, {$this->store->table_traffic_campaign} B ";
			$query .= "WHERE I.campaignPromotionID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID AND B.campaignID = I.campaignID";

			$result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $campaignPromotionID = $line['campaignPromotionID'];
			$mediaID = $line['mediaID'];
            $name = $line['name'];
			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$campaignName = $line['campaignName'];
			$clientID = $line['clientID'];
			$contractID = $line['contractID'];
            $description = $line['description'];
            $filename = $line['filename'];

			// Decode UTF-8 character encoding.
			$values = array(&$name,
							&$description,
							&$filename,
							&$clientName,
							&$contractName,
							&$campaignName
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			if ($mediaID == 0)
				$mediaID = '';

			$campaignPromotionMediaID = $doc->createElement('input');
			$campaignPromotionMediaID->setAttribute('type','hidden');
			$campaignPromotionMediaID->setAttribute('name','campaignPromotionMediaID');
			$campaignPromotionMediaID->setAttribute('value',$mediaID);
			$container->appendChild($campaignPromotionMediaID);

        } else {

			$query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.contractID as contractID, B.name as campaignName ";
			$query .= "FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A, {$this->store->table_traffic_campaign} B) ";
			$query .= "WHERE B.campaignID = '$campaignID' AND A.contractID = B.contractID AND C.clientID = B.clientID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);

			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$campaignName = $line['campaignName'];
			$clientID = $line['clientID'];
			$contractID = $line['contractID'];
            $campaignPromotionID = '';
            $name = '';
            $description = '';
            $filename = '';
		}

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$campaignNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$campaignName,'',array('item'=>'Campaign','action'=>'view','id'=>$campaignID),'View'));
        $campaignNametr->appendChild($labeltd);
        $campaignNametr->appendChild($inputtd);

		// $clientNametr = $doc->createElement('tr');
        // $labeltd = $doc->createElement('th');
        // $label = $doc->createTextNode('Client');
        // $inputtd = $doc->createElement('td');
        // $input = $doc->createTextNode($clientName);
        // $labeltd->appendChild($label);
        // $inputtd->appendChild($input);
        // $clientNametr->appendChild($labeltd);
        // $clientNametr->appendChild($inputtd);

		// $contractNametr = $doc->createElement('tr');
        // $labeltd = $doc->createElement('th');
        // $label = $doc->createTextNode('Contract');
        // $inputtd = $doc->createElement('td');
        // $input = $doc->createTextNode($contractName);
        // $labeltd->appendChild($label);
        // $inputtd->appendChild($input);
        // $contractNametr->appendChild($labeltd);
        // $contractNametr->appendChild($inputtd);

		// $campaignNametr = $doc->createElement('tr');
        // $labeltd = $doc->createElement('th');
        // $label = $doc->createTextNode('Campaign');
        // $inputtd = $doc->createElement('td');
        // $input = $doc->createTextNode($campaignName);
        // $labeltd->appendChild($label);
        // $inputtd->appendChild($input);
        // $campaignNametr->appendChild($labeltd);
        // $campaignNametr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign Promotion Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignPromotionName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $descriptiontr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Description');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignPromotionDescription');
        $input->setAttribute('value',$description);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $descriptiontr->appendChild($labeltd);
        $descriptiontr->appendChild($inputtd);

		$currentFilenametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Current Filename');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($filename);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $currentFilenametr->appendChild($labeltd);
        $currentFilenametr->appendChild($inputtd);

        $filenametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('File Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','file');
        $input->setAttribute('name','campaignPromotionFilename');
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $filenametr->appendChild($labeltd);
        $filenametr->appendChild($inputtd);

        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($campaignNametr);
        $table->appendChild($nametr);
        $table->appendChild($descriptiontr);
		if ( $filename != '' )
			$table->appendChild($currentFilenametr);
        $table->appendChild($filenametr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);
		$form->appendChild($container);

        return($form);
    }

    public function view($doc, $id) {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');
		$containerLeft = $doc->createElement('div');
		$containerLeft->setAttribute('class','module_left');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Campaign Promotion'));
		$container->appendChild($header);

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $campaignPromotionID = $doc->createElement('input');
        $campaignPromotionID->setAttribute('type','hidden');
        $campaignPromotionID->setAttribute('name','campaignPromotionID');
        $campaignPromotionID->setAttribute('value',$id);
        $container->appendChild($campaignPromotionID);

        $query = "SELECT C.name as clientName, C.clientID as clientID, A.name as contractName, A.contractID as contractID, B.name as campaignName, B.campaignID, I.* ";
		$query.= "FROM {$this->store->table_traffic_campaignpromotion} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A, {$this->store->table_traffic_campaign} B ";
		$query .= "WHERE I.campaignPromotionID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID AND B.campaignID = I.campaignID";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $campaignPromotionID = $line['campaignPromotionID'];
        $campaignID = $line['campaignID'];
        $contractID = $line['contractID'];
        $clientID = $line['clientID'];
        $mediaID = $line['mediaID'];
        $name = $line['name'];
		$clientName = $line['clientName'];
		$contractName = $line['contractName'];
		$campaignName = $line['campaignName'];
        $description = $line['description'];
        $filename = $line['filename'];
        $mimetype = $line['mimetype'];

		// Decode UTF-8 character encoding.
		$values = array(&$name,
						&$description,
						&$filename,
						&$clientName,
						&$contractName,
						&$campaignName
						);
		foreach ($values as &$value) {
			$value = utf8_decode($value);
		}
		unset($value);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name');
        $inputtd = $doc->createElement('td');
        $inputtd->setAttribute('class','name');
        $input = $doc->createTextNode($name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$contractName,'',array('item'=>'Contract','action'=>'view','id'=>$contractID),'View'));
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$campaignNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$campaignName,'',array('item'=>'Campaign','action'=>'view','id'=>$campaignID),'View'));
        $campaignNametr->appendChild($labeltd);
        $campaignNametr->appendChild($inputtd);

        $descriptiontr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Description');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($description);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $descriptiontr->appendChild($labeltd);
        $descriptiontr->appendChild($inputtd);

		if ($line['mediaID'] != 0) {
			$filenametr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('File Name');
			$inputtd = $doc->createElement('td');
			$labeltd->appendChild($label);
			$inputtd->appendChild(module::link_to_script_dom($doc,$filename,'',array('item'=>get_class($this),'action'=>'download','id'=>$line['mediaID'],'campaignPromotionID'=>$line['campaignPromotionID']),'Download'));
			$inputtd->appendChild($labeltd);
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_download_small');
			$span->appendChild(module::link_to_script_dom($doc,'download','',array('item'=>get_class($this),'action'=>'download','id'=>$line['mediaID'],'campaignPromotionID'=>$line['campaignPromotionID']),'Download'));
			$inputtd->appendChild($span);
			$filenametr->appendChild($labeltd);
			$filenametr->appendChild($inputtd);

			$mimetypetr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('File Type');
			$inputtd = $doc->createElement('td');
			$input = $doc->createTextNode($mimetype);
			$labeltd->appendChild($label);
			$inputtd->appendChild($input);
			$mimetypetr->appendChild($labeltd);
			$mimetypetr->appendChild($inputtd);
		}

        $table->appendChild($nametr);
        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($campaignNametr);
        $table->appendChild($descriptiontr);
		if ($line['mediaID'] != 0) {
			$table->appendChild($filenametr);
			$table->appendChild($mimetypetr);
		}

        $container->appendChild($table);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $query = "SELECT I.campaignPromotionID, I.name, I.description, I.filename FROM {$this->store->table_traffic_campaignpromotion} I";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND I.campaignPromotionID IN (".implode(',',$ids).") ";
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

		$col1 = $doc->createElement('col');
        $table->appendChild($col1);

		$col2 = $doc->createElement('col');
        $table->appendChild($col2);

		$col3 = $doc->createElement('col');
		$col3->setAttribute('width', '200px');
        $table->appendChild($col3);

		$colactions = $doc->createElement('col');
		//$colactions->setAttribute('width', '56px');
        $table->appendChild($colactions);

        $tr = $doc->createElement('tr');
		$nametd = $doc->createElement('th');
        $descriptiontd = $doc->createElement('th');
        $filenametd = $doc->createElement('th');

		$nametd->appendChild($doc->createTextNode('Name'));
        $descriptiontd->appendChild($doc->createTextNode('Description'));
        $filenametd->appendChild($doc->createTextNode('Filename'));

		$tr->appendChild($nametd);
        $tr->appendChild($descriptiontd);
        $tr->appendChild($filenametd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','3');
            $name = $doc->createTextNode('No Campaign Promotion');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
			$nametd = $doc->createElement('td');
            $descriptiontd = $doc->createElement('td');
            $filenametd = $doc->createElement('td');

			$nametd->appendChild($doc->createTextNode($line['name']));
            $descriptiontd->appendChild($doc->createTextNode($line['description']));
            $filenametd->appendChild($doc->createTextNode($line['filename']));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$line['campaignPromotionID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
            $span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
			$span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$line['campaignPromotionID']),'Edit'));
            $actiontd->appendChild($span);

            $table->appendChild($tr);
			$tr->appendChild($nametd);
            $tr->appendChild($descriptiontd);
            $tr->appendChild($filenametd);
            $tr->appendChild($actiontd);
			$i++;
        }

        return($table);
    }

    public function overview($doc,$ids='',$isInclude=false) {
		$startsWith = globalize('startswith');
		$campaignPromotionSearchColumn = globalize('campaignPromotionSearchColumn');
		$campaignPromotionSearchAction = globalize('campaignPromotionSearchAction');
		$campaignPromotionSearchText = globalize('campaignPromotionSearchText');

		$container = $doc->createElement('div');
		if ( $isInclude ) {
			$item = get_class($this);
			$parentID = globalize('id');
			$parentIDType = globalize('item', get_class($this));
			switch ($parentIDType) {
				case 'Client':
					$parentFieldName = 'clientID';
					break;
				case 'Contract':
					$parentFieldName = 'contractID';
					break;
				case 'Campaign':
					$parentFieldName = 'campaignID';
					break;
				default:
					$isInclude = false;
					$warning_message = "Not a valid parent.";
					break;
			}
			$container->setAttribute('class','module_right');
			$container->appendChild($this->include_header($doc,$parentID));
		} else {
			$item = globalize('item', get_class($this));
			$container->setAttribute('class','module');
		}

        $query = "SELECT I.campaignPromotionID, I.name, I.description, I.filename FROM {$this->store->table_traffic_campaignpromotion} I";

		if ( $startsWith != '' ) {
			$query .= " WHERE I.name LIKE '".$startsWith."%'";
		} elseif ($campaignPromotionSearchText != '') {

			// Which column does the user want to search in?
			// Default searches the contract name column
			switch ($campaignPromotionSearchColumn) {
				case 'name':
					$column = "I.name";
					break;
				case 'description':
					$column = "I.description";
					break;
				case 'filename':
					$column = "I.filename";
					break;
				default:
					$column = "I.name";
					break;
			}

			// What type of search: contains or ends with?
			// Default is contains
			switch ($campaignPromotionSearchAction) {
				case 'contains':
					$campaignPromotionSearchText = '%'.$campaignPromotionSearchText.'%';
					break;
				case 'endswith':
					$campaignPromotionSearchText = '%'.$campaignPromotionSearchText;
					break;
				default:
					$campaignPromotionSearchText = '%'.$campaignPromotionSearchText.'%';
					break;
			}

			$query .= " WHERE ".$column." LIKE '$campaignPromotionSearchText'";
		}

		if ( $isInclude )
			$query .= " WHERE I.$parentFieldName = '$parentID'";
        $query .= " ORDER BY filename, description, name ";
        $ids = sysdb::query2vector($query,'campaignPromotionID');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Campaign Promotion'));
		$container->appendChild($header);

		$searchLetters = $doc->createElement('div');
		$searchLetters->setAttribute('class','search_letters');
		$searchLetters->appendChild($doc->createTextNode('Browse: '));
		foreach ( range('A','Z') as $c ) {
			$searchLetters->appendChild(module::link_to_script_dom($doc,$c,'',array('item'=>$item,'action'=>'search','startswith'=>$c),'Starts with '.$c));
			$searchLetters->appendChild($doc->createTextNode(' '));
		}
		$container->appendChild($searchLetters);

		$searchUserText = $doc->createElement('div');
		$searchUserText->setAttribute('class','search_user_text');
		$searchUserText->appendChild($doc->createTextNode('Search: '));
		$data = array('Name'=>'name', 'Description'=>'description', 'File Name'=>'filename');
		$searchColumn = dom::createDropdown($doc, 'campaignPromotionSearchColumn', $data, $campaignPromotionSearchColumn);
		$data = array('Contains'=>'contains', 'Ends With'=>'endswith');
		$searchAction = dom::createDropdown($doc, 'campaignPromotionSearchAction', $data, $campaignPromotionSearchAction);
		$searchText = dom::createInputBox($doc, 'campaignPromotionSearchText', '', 'text');
		$searchSubmit = dom::createInputBox($doc, 'action', 'Search', 'submit');

		$searchUserText->appendChild($searchColumn);
		$searchUserText->appendChild($searchAction);
		$searchUserText->appendChild($searchText);
		$searchUserText->appendChild($searchSubmit);
		$container->appendChild($searchUserText);

		if ($startsWith != '') $container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $producerID) {
        $query = "SELECT P.actorID, P.producerID, U.name, U.login ";
		$query .= "FROM ({$this->store->table_traffic_producer} P, {$this->store->table_user} U) ";
		$query .= "WHERE U.actorID = P.actorID ";
		$query .= "ORDER BY name";
        $result = sysdb::query($query);
        $select = $doc->createElement('select');
        $select->setAttribute('name','campaignPromotionProducerID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No producers available');
            $option->appendChild($text);
			$select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
			$option->setAttribute('value','');
			$text = $doc->createTextNode('');
			$option->appendChild($text);
			$select->appendChild($option);
			while ($line = sysdb::fetch_assoc($result)) {
				$option = $doc->createElement('option');
				$option->setAttribute('value',$line['producerID']);
				if ($line['producerID'] == $producerID)
					$option->setAttribute('selected','selected');
				$text = $doc->createTextNode($line['name'].' ('.$line['login'].')');
				$option->appendChild($text);
				$select->appendChild($option);
			}
		}
        return($select);
    }

    public function add($name, $description, $campaignID, $filename, $maxfilesize) {
		// Escape values.
		$values = array(&$name,
						&$description,
						&$filename
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$query = "SELECT clientID, contractID FROM {$this->store->table_traffic_campaign} WHERE campaignID = '$campaignID'";
		$result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);

		if ( $_FILES[$filename]['name'] != '' ) {
			/* User is attempting to upload a file */
			$fileAttributes = upload_media($_FILES[$filename],'','',$maxfilesize);
			$success = $fileAttributes['success'];
			$message = $fileAttributes['message'];

			if ( !$success ) {
				/* Upload failed */
				state::setMessage('warning', $message);
			} else {
				$mediaID = $fileAttributes['mediaID'];
				$filename = $fileAttributes['filename'];
				$filesize = $fileAttributes['filesize'];
				$mimetype = $fileAttributes['mimetype'];
			}
		} else {
			/* User is not trying to upload a file, but is still able
				to add a record to the database */
			$success = true;
			$mediaID = create_media();
			$filename = '';
			$filesize = '';
			$mimetype = '';
		}

		if($success){
			$query = "INSERT INTO {$this->store->table_traffic_campaignpromotion} (name,description,mediaID,filename,mimetype,campaignID,contractID,clientID) VALUES ('$name','$description','$mediaID','$filename','$mimetype','$campaignID','".$line['contractID']."','".$line['clientID']."')";
			$result = sysdb::query($query);
			state::setMessage('notify', 'Successfully added new Campaign Promotion: '.utf8_decode($name));
			$campaignPromotionID = sysdb::insert_id();
			// Forward user to new Promo if not using function from foreign class.
			if ($item == 'CampaignPromotion') {
				module::forward_to_script('', array('item' => 'CampaignPromotion', 'action' => 'view', 'id' => $campaignPromotionID));
			}
		}
    }

    public function save($id,$name,$description,$filename,$maxfilesize,$mediaID) {
		// Escape values.
		$values = array(&$name,
						&$description,
						&$filename
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$query = "UPDATE {$this->store->table_traffic_campaignpromotion} SET name = '$name', description = '$description'";

		if ( $_FILES[$filename]['name'] != '' ) {
			/* User is attempting to upload a file */
			if ($mediaID == 0)
				$mediaID = '';
			$fileAttributes = upload_media($_FILES[$filename],'','',$maxfilesize,$mediaID);
			$success = $fileAttributes['success'];
			$message = $fileAttributes['message'];

			if ( !$success ) {
				/* Upload failed */
				state::setMessage('warning', $message );
			} else {
				$mediaID = $fileAttributes['mediaID'];
				$filename = $fileAttributes['filename'];
				$filesize = $fileAttributes['filesize'];
				$mimetype = $fileAttributes['mimetype'];

				$query .= ", mediaID = '$mediaID', filename = '$filename', mimetype = '$mimetype'";

			}
		} else {
			/* User is not trying to upload a file, but is still able
				update the database */
			$success = true;
		}

		if ($success) {
			$query .= " WHERE campaignPromotionID = '$id'";
			$result = sysdb::query($query);
			state::setMessage('notify', 'Successfully updated Campaign Promotion: '.utf8_decode($name));
			module::forward_to_script('',array('item'=>'CampaignPromotion','action'=>'view','id'=>$id));
		}
    }

    public function download($id) {
		/* If there is a file associated, try to download it */
		if ( $id != 0 ) {
			/* Download the Campaign Promotion file */
			$query = "SELECT A.mimetype, A.filename, M.path FROM ({$this->store->table_traffic_campaignpromotion} A, {$this->store->table_media} M) WHERE A.campaignPromotionID = '$id' AND A.mediaID = M.mediaID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$path = $line['path'];
			$mimetype = $line['mimetype'];
			$filename = $line['filename'];
			header('Content-Description: File Transfer');
			header('Content-Type: '.$mimetype);
			header("Content-Disposition: attachment; filename=\"$filename\"");
			header('Content-Transfer-Encoding: binary');
			header('Expires: 0');
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
			header('Pragma: public');
			if (ob_get_level()) {
				ob_end_clean();
			}
			flush();
			readfile($path);
			exit;
		} else {
			state::setMessage('warning', 'File does not exist: could not download file.');
			module::forward_to_script('',array('item'=>'campaignPromotion','action'=>'view','id'=>$id));
		}
    }

    public function delete($id) {
		$success = false;
        $query = <<<EOQ
			SELECT {$this->store->field_campaignpromotion_name},
				{$this->store->field_campaignpromotion_mediaID}
			FROM {$this->store->table_traffic_campaignpromotion}
			WHERE {$this->store->field_campaignpromotion_campaignPromotionID} = '$id'
EOQ;
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$mediaID = $line['mediaID'];

		// Remove any daughter spots.
        $query = <<<EOQ
            SELECT {$this->store->field_spot_spotID}
			FROM {$this->store->table_traffic_spot}
			WHERE {$this->store->field_spot_mediaID} = '$mediaID'
EOQ;
		$spotIDList = sysdb::query2vector($query, 'spotID');

		if (Spot::delete_many($spotIDList)) {
			$success = true;
		} else {
			state::setMessage('warning', 'Could not delete spots.');
			$success = false;
		}

		/* If there is a file associated, try to delete it */
		if ( $mediaID != 0 ) {
			if (delete_media($line['mediaID'])) {
				$success = true;
			} else {
				state::setMessage('warning', 'Could not delete the file.');
				$success = false;
			}
		}

		/* If we succesfuly deleted the file, or if there was no file at all, delete the record */
		if ($success || $mediaID == 0) {
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_campaignpromotion}
				WHERE {$this->store->field_campaignpromotion_campaignPromotionID} = '$id'
EOQ;
			sysdb::query($query);
			state::setMessage('notify', 'Successfully deleted Campaign Promotion: '.utf8_decode($line['name']));
		}
		return $success;
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this Campaign Promotion item?</p>';
		$message .= '<p>The item and all its daughter promotion spots will be permanently deleted if you proceed.</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);
		return;
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','id'=>$id));
		return;
    }

    public function search($doc,$string) {
        $query = "SELECT campaignPromotionID FROM {$this->store->table_traffic_campaignpromotion} WHERE description LIKE '%$string%' OR filename LIKE '%$string%' OR 'producer' LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'campaignPromotionID')));
        }
    }

	public function include_header($doc,$parentIDType) {

		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		$item = globalize('item', get_class($this));
		$id = globalize('id');
		$extras = globalize('extras');
		$includeHeader = $doc->createElement('div');
		$includeHeader->setAttribute('id', 'inline_menu');

		$link = module::link_to_script_dom($doc,'Contracts','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Contract'),'Contracts');
		$contractsLink = $doc->createElement('span');
		$contractsLink->setAttribute('id', 'link_contracts');
		$contractsLink->setAttribute('class', 'inline_link');
		$contractsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Campaigns','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Campaign'),'Campaigns');
		$campaignsLink = $doc->createElement('span');
		$campaignsLink->setAttribute('id', 'link_campaigns');
		$campaignsLink->setAttribute('class', 'inline_link');
		$campaignsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Audio','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignAudio'),'Audio');
		$campaignAudioLink = $doc->createElement('span');
		$campaignAudioLink->setAttribute('id', 'link_campaign_audio');
		$campaignAudioLink->setAttribute('class', 'inline_link');
		$campaignAudioLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Materials','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignMaterial'),'Materials');
		$campaignMaterialsLink = $doc->createElement('span');
		$campaignMaterialsLink->setAttribute('id', 'link_campaign_materials');
		$campaignMaterialsLink->setAttribute('class', 'inline_link');
		$campaignMaterialsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Promotions','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignPromotion'),'Promotions');
		$campaignPromotionLink = $doc->createElement('span');
		if ($extras == 'CampaignPromotion')
			$campaignPromotionLink->setAttribute('id', 'link_campaign_promotions_selected');
		else
			$campaignPromotionLink->setAttribute('id', 'link_campaign_promotions');
		$campaignPromotionLink->setAttribute('class', 'inline_link');
		$campaignPromotionLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Traffic','',array('item'=>'Traffic','mode'=>$item,$parentFieldName=>$id),'Traffic');
		$trafficLink = $doc->createElement('span');
		$trafficLink->setAttribute('id', 'link_traffic');
		$trafficLink->setAttribute('class', 'inline_link');
		$trafficLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Log','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Log'),'Log');
		$logLink = $doc->createElement('span');
		$logLink->setAttribute('id', 'link_traffic');
		$logLink->setAttribute('class', 'inline_link');
		$logLink->appendChild($link);

		/* 	This switch is specifically designed *without* break statements.
			This is because once we hit our current item, all those below it are required as well.
			-CH
		*/
		switch ($item) {
			case 'Client':
				$includeHeader->appendChild($contractsLink);
			case 'Contract':
				$includeHeader->appendChild($campaignsLink);
			case 'Campaign':
				$includeHeader->appendChild($campaignPromotionLink);
				$includeHeader->appendChild($campaignMaterialsLink);
				$includeHeader->appendChild($campaignAudioLink);
				$includeHeader->appendChild($logLink);
				$includeHeader->appendChild($trafficLink);
				break;
		}

		return $includeHeader;

	}

    public function inline_list($doc,$ids='',$isInclude=false) {
		$item = get_class($this);
		$parentID = globalize('id');
		$parentIDType = globalize('item', get_class($this));
		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		if ($parentIDType == 'Client')
			$x = 'C';
		if ($parentIDType == 'Contract')
			$x = 'T';
		if ($parentIDType == 'Campaign')
			$x = 'G';
		$query = "SELECT $x.name FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} T, {$this->store->table_traffic_campaign} G) WHERE $x.$parentFieldName = '$parentID' AND C.clientID = $x.clientID";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$caption_name = utf8_decode($line['name']);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module_right');
		$container->appendChild($this->include_header($doc,$parentIDType));

		$sortby = globalize('sortby');
		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
							break;
				case 'description':
							$sortby = 'description';
							break;
				default:
							$sortby = 'name';
							break;
			}
		}

		function inline_list_actions($doc,$line) {
			$item = 'CampaignPromotion';
			$td = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$line['campaignPromotionID']),'View'));
            $td->appendChild($span);
			$td->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$line['campaignPromotionID']),'Edit'));
            $td->appendChild($span);
			$td->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_download_small');
            $span->appendChild(module::link_to_script_dom($doc,'download','',array('item'=>$item,'action'=>'download','campaignPromotionID'=>$line['campaignPromotionID']),'Download'));
            $td->appendChild($span);
			return $td;
		}

		function inline_list_header($doc) {
			$item = 'CampaignPromotion';
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			$th1 = $doc->createElement('th');
			if ($parentIDType == 'Client' || $parentIDType == 'Contract')
				$th2 = $doc->createElement('th');
			$th3 = $doc->createElement('th');
			$th4 = $doc->createElement('th');
			$actiontd = $doc->createElement('th');
			$actiontd->setAttribute('class', 'action');
			$th1->appendChild(module::link_to_script_dom($doc,'Name','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'name'),'Name'));
			$th3->appendChild(module::link_to_script_dom($doc,'Description','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'description'),'Description'));

			if ($parentIDType == 'Campaign') {
				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Promotion','',array('item'=>$item,'action'=>'edit','campaignID'=>$parentID),'Add New Promotion'));
				$actiontd->appendChild($span);
			}
			$tr->appendChild($th1);
			if ($parentIDType == 'Client' || $parentIDType == 'Contract')
				$tr->appendChild($th2);
			$tr->appendChild($th3);
			$tr->appendChild($actiontd);

			return $tr;
		}

		function inline_list_footer($doc) {
			$item = 'CampaignPromotion';
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			if ($parentIDType == 'Campaign') {
				$td1 = $doc->createElement('td');
				if ($parentIDType == 'Client' || $parentIDType == 'Contract')
					$td2 = $doc->createElement('td');
				$td3 = $doc->createElement('td');
				$actiontd = $doc->createElement('td');
				$actiontd->setAttribute('class', 'number');

				$span = $doc->createElement('span');
				$span->setAttribute('class', 'link_add_small');
				$span->appendChild(module::link_to_script_dom($doc,'Add New Promotion','',array('item'=>$item,'action'=>'edit','campaignID'=>$parentID),'Add New Promotion'));
				$actiontd->appendChild($span);

				$tr->appendChild($td1);
				if ($parentIDType == 'Client' || $parentIDType == 'Contract')
					$tr->appendChild($td2);
				$tr->appendChild($td3);
				$tr->appendChild($actiontd);
			}
			return $tr;
		}

		function inline_list_colgroups($doc) {
			$parentIDType = globalize('item');
			$col1 = $doc->createElement('col');

			$col2 = $doc->createElement('col');
			$col2->setAttribute('width', '110px');

			$colactions = $doc->createElement('col');
			$colactions->setAttribute('width', '75px');

			if ($parentIDType == 'Client' || $parentIDType == 'Contract') {
				$colgroup = array($col1,$col2,$colactions);
			}
			if ($parentIDType == 'Campaign') {
				$colgroup = array($col1,$col2,$colactions);
			}
			return $colgroup;
		}

		/* All the functions need to be loaded up as variables, to avoid undefined variable errors from call_user_func_array() */
		$action_func = 'inline_list_actions';
		$footer_func = 'inline_list_footer';
		$header_func = 'inline_list_header';
		$col_func = 'inline_list_colgroups';
		$colgroup = call_user_func_array($col_func,array($doc));
		$caption = "Promotions for $caption_name";

		if ($parentIDType == 'Campaign') {
			$ignore = array('campaignPromotionID','campaignName');
		} else {
			$ignore = array('campaignPromotionID');
		}

		$query = "SELECT A.name, ";
		$query .= "G.name as campaignName, ";
		$query .= "A.description, A.campaignPromotionID FROM ({$this->store->table_traffic_campaign} G, {$this->store->table_traffic_campaignpromotion} A)";
		$query .= " WHERE A.$parentFieldName = '$parentID'";
		$query .= " AND G.campaignID = A.campaignID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " A.campaignPromotionID IN (".implode(',',$ids).") ";
        if(isset($sortby))
			$query .= " ORDER BY ".$sortby;
        $result = sysdb::query($query);

		$containertable = $doc->createElement('div');
		$containertable->setAttribute('id', 'inline_table');

		$table = sysdb::show_results_in_table_dom
		(
			$doc,
			$result,
			$action_func,
			'',
			$ignore,
			$footer_func,
			$header_func,
			array('table'=>'list','tr'=>'even','td'=>''),
			$caption,
			$colgroup,
			''
		);

		$containertable->appendChild($table);
 		$container->appendChild($containertable);

        return($container);
    }

	/** Resolves media id for given campaign promotion id. */
    public function resolve_media_id($id) {
        $query = <<<EOQ
			SELECT {$this->store->field_campaignpromotion_mediaID}
			FROM  {$this->store->table_traffic_campaignpromotion}
			WHERE {$this->store->field_campaignpromotion_campaignPromotionID} = '$id'
EOQ;
        return(sysdb::queryOne($query));
    }

}
?>