<?php
// $Id$

require_once('Contract.php');
require_once('Campaign.php');
require_once('CampaignAudio.php');

class Client {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('clientName'),
							globalize('clientAddress'),
							globalize('clientCity'),
							globalize('clientState'),
							globalize('clientPostcode'),
							globalize('clientWork'),
							globalize('clientMobile'),
							globalize('clientFax'),
							globalize('clientEmail'),
							globalize('clientABN'),
							globalize('clientURL'),
							globalize('date'),
							globalize('clientClientRepIDList'),
							globalize('clientRepTitle'),
							globalize('clientRepFirstName'),
							globalize('clientRepLastName'),
							globalize('clientRepAddress'),
							globalize('clientRepCity'),
							globalize('clientRepPostcode'),
							globalize('clientRepWork'),
							globalize('clientRepMobile'),
							globalize('clientRepFax'),
							globalize('clientRepEmail'),
							globalize('clientSectorIDList'),
							globalize('sectorName'),
							globalize('sectorStartYear'),
							globalize('sectorStartMonth'),
							globalize('sectorStartDay'),
							globalize('sectorEndYear'),
							globalize('sectorEndMonth'),
							globalize('sectorEndDay'));
				break;
            case 'save':
				$this->save(globalize('clientID'),
							globalize('clientName'),
							globalize('clientAddress'),
							globalize('clientCity'),
							globalize('clientState'),
							globalize('clientPostcode'),
							globalize('clientWork'),
							globalize('clientMobile'),
							globalize('clientFax'),
							globalize('clientEmail'),
							globalize('clientABN'),
							globalize('clientURL'),
							globalize('clientClientRepIDList'),
							globalize('clientRepTitle'),
							globalize('clientRepFirstName'),
							globalize('clientRepLastName'),
							globalize('clientRepAddress'),
							globalize('clientRepCity'),
							globalize('clientRepPostcode'),
							globalize('clientRepWork'),
							globalize('clientRepMobile'),
							globalize('clientRepFax'),
							globalize('clientRepEmail'),
							globalize('clientSectorIDList'),
							globalize('sectorName'),
							globalize('sectorStartYear'),
							globalize('sectorStartMonth'),
							globalize('sectorStartDay'),
							globalize('sectorEndYear'),
							globalize('sectorEndMonth'),
							globalize('sectorEndDay'));
				break;
            case "remove":
				$this->remove(globalize('id'));
				break;
            case "cancel":
				$this->cancel(globalize('id'));
				break;
            case 'annotate':
				Notes::add(
					globalize('notesActorID'),
					globalize('notesType'),
					globalize('notesId'),
					globalize('notesAction'),
					globalize('notesDetails')
					);
				break;
		}
    }

    public function headers($doc) {
		$moduleID = globalize('moduleID');
        $item = globalize('item', get_class($this));
		$script = $doc->createElement('script');
		$script->setAttribute('language', 'javascript');
		$script->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=".$item.".js");
		$script->appendChild($doc->createTextNode(''));

		return(array($script));
    }

    public function form($doc, $id='') {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Client';
        else
            $headerText = 'Edit Client';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

        $clientID = $doc->createElement('input');
        $clientID->setAttribute('type','hidden');
        $clientID->setAttribute('name','clientID');
        $clientID->setAttribute('value',$id);
        $container->appendChild($clientID);

		$datetime = date("Y-m-d H:i:s");

		$date = $doc->createElement('input');
        $date->setAttribute('type','hidden');
        $date->setAttribute('name','date');
        $date->setAttribute('value',$datetime);
        $container->appendChild($date);

        if ($id != '') {
			$query = "SELECT C.clientID, C.name, C.abn, C.url, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_client} C, {$this->store->table_detail} D) WHERE C.clientID = '$id' AND C.actorID = D.actorID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $clientID = $line['clientID'];
            $name = $line['name'];
            $address = $line['address'];
            $city = $line['city'];
			$state = $line['state'];
            $postcode = $line['postcode'];
            $work = $line['landline'];
            $mobile = $line['mobile'];
            $fax = $line['fax'];
            $email = $line['email'];
			$abn = $line['abn'];
			$url = $line['url'];

			// Decode UTF-8 character encoding.
			$values = array(&$name,
							&$address,
							&$city,
							&$email,
							&$url
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$query = "SELECT * FROM {$this->store->table_traffic_clientclientrep} WHERE clientID = '$id'";
			$result = sysdb::query($query);
			$clientRepIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($clientRepIDList, $line['clientRepID']);
			}

			$query = "SELECT * FROM {$this->store->table_traffic_clientsector} WHERE clientID = '$id'";
			$result = sysdb::query($query);
			$clientSectorIDList = array();
			while ($line = sysdb::fetch_assoc($result))
				array_push($clientSectorIDList, $line['sectorID']);

			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'','',array('item'=>"Client",'action'=>'remove','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Client",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);


		} else {
			$clientID = '';
			$name = '';
			$address = '';
			$city = '';
			$state = '';
			$postcode = '';
			$work = '';
			$mobile = '';
			$fax = '';
			$email = '';
			$abn = '';
			$url = '';
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $addresstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Address');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientAddress');
        $input->setAttribute('id','clientAddress');
        $input->setAttribute('value',$address);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $addresstr->appendChild($labeltd);
        $addresstr->appendChild($inputtd);

        $citytr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('City');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientCity');
        $input->setAttribute('id','clientCity');
        $input->setAttribute('value',$city);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $citytr->appendChild($labeltd);
        $citytr->appendChild($inputtd);

		// TODO: Add State to the javascript population of fields.
		$statetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('State');
        $inputtd = $doc->createElement('td');
		$data = array( ''=>'',
						'ACT'=>'ACT',
						'NSW'=>'NSW',
						'NT'=>'NT',
						'QLD'=>'QLD',
						'SA'=>'SA',
						'TAS'=>'TAS',
						'VIC'=>'VIC',
						'WA'=>'WA');
        $input = dom::createDropdown( $doc, 'clientState', $data, $state, '' );
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $statetr->appendChild($labeltd);
        $statetr->appendChild($inputtd);

        $postcodetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Postcode');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientPostcode');
        $input->setAttribute('id','clientPostcode');
        $input->setAttribute('value',$postcode);
		$input->setAttribute('maxlength','12');
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $postcodetr->appendChild($labeltd);
        $postcodetr->appendChild($inputtd);

        $worktr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Work');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientWork');
        $input->setAttribute('id','clientWork');
        $input->setAttribute('value',$work);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $worktr->appendChild($labeltd);
        $worktr->appendChild($inputtd);

        $mobiletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Mobile');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientMobile');
        $input->setAttribute('id','clientMobile');
        $input->setAttribute('value',$mobile);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $mobiletr->appendChild($labeltd);
        $mobiletr->appendChild($inputtd);

        $faxtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Fax');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientFax');
        $input->setAttribute('id','clientFax');
        $input->setAttribute('value',$fax);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $faxtr->appendChild($labeltd);
        $faxtr->appendChild($inputtd);

        $emailtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Email');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientEmail');
        $input->setAttribute('id','clientEmail');
        $input->setAttribute('value',$email);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $emailtr->appendChild($labeltd);
        $emailtr->appendChild($inputtd);

		$abntr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('ABN');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientABN');
        $input->setAttribute('value',$abn);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $abntr->appendChild($labeltd);
        $abntr->appendChild($inputtd);

		$urltr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('URL');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','clientURL');
        $input->setAttribute('value',$url);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $urltr->appendChild($labeltd);
        $urltr->appendChild($inputtd);

		$clientReptr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
 		$labeltd->appendChild($label = $doc->createTextNode('Client Rep(s)'));
		$clientReptr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $divShowClientRep = $doc->createElement('div');
		$divShowClientRep->setAttribute('id','show_clientrep');
        $input = $doc->createElement('select');
		$input->setAttribute('name','clientClientRepIDList[]');
		$input->setAttribute('multiple', 'multiple');
		$input->setAttribute('size', '7');

		$query = "SELECT I.clientRepID, D.firstName AS firstName, D.lastName FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID ORDER BY firstName";
		$result = sysdb::query($query);

		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($clientRepIDList)) {
				if ( in_array($line['clientRepID'],$clientRepIDList) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['clientRepID']);
			$inputOption->appendChild($doc->createTextNode($line['firstName']." ".$line['lastName']));
			$input->appendChild($inputOption);
		}

		// Start of toggleClientRepForm.
        $divbuttonClientRep = $doc->createElement('div');
		$spanbuttonClientRep = $doc->createElement('span');
		$spanbuttonClientRep->setAttribute('class', 'link_button');
		$spanbuttonClientRep->setAttribute("onclick", "toggleClientRepForm('hide_clientrep','show_clientrep');");
		$a = $doc->createElement('a');
		$a->setAttribute('title', 'Add New Client Rep');
		$a->setAttribute('class', 'link_button');
		$spanClientRep = $doc->createElement('span');
		$spanClientRep->setAttribute('class', 'link_add');
		$text = $doc->createTextNode('Add New Client Rep');
		$spanClientRep->appendChild($text);
		$a->appendChild($spanClientRep);
		$spanbuttonClientRep->appendChild($a);
		$divbuttonClientRep->appendChild($spanbuttonClientRep);
		$divShowClientRep->appendChild($divbuttonClientRep);

		$divShowClientRep->appendChild($input);
		$inputtd->appendChild($divShowClientRep);

		$inputtd->appendChild(ClientRep::inline_form($doc,''));
		// End of toggleClientRepForm.

		$clientReptr->appendChild($inputtd);

		$clientSectortr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
		$labeltd->appendChild($label = $doc->createTextNode('Client Sector(s)'));
		$clientSectortr->appendChild($labeltd);
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','clientSectorIDList[]');
		$input->setAttribute('multiple', 'multiple');
		$input->setAttribute('size', '7');

		$query = <<<EOQ
            SELECT I.{$this->store->field_sector_sectorID} AS sectorID,
				I.{$this->store->field_sector_name} AS name
            FROM ({$this->store->table_traffic_sector} I)
EOQ;
		$result = sysdb::query($query);

		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if (isset($clientSectorIDList)) {
				if (in_array($line['sectorID'], $clientSectorIDList) )
					$inputOption->setAttribute('selected', 'selected');
			}
			$inputOption->setAttribute('value', $line['sectorID']);
			$inputOption->appendChild($doc->createTextNode($line['name']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleSectorForm.
		$divShowSector = $doc->createElement('div');
		$divShowSector->setAttribute('id', 'show_sector');
		$divShowSector->appendChild($divButtonShowSector = $doc->createElement('div'));
		$divButtonShowSector->appendChild($spanButtonShowSector = $doc->createElement('span'));
		$spanButtonShowSector->setAttribute('class', 'link_button');
		$spanButtonShowSector->setAttribute("onclick", "toggleSectorForm('hide_sector','show_sector');");
		$spanButtonShowSector->appendChild($aShowSector = $doc->createElement('a'));
		$aShowSector->setAttribute('title', 'Add New Sector');
		$aShowSector->setAttribute('class', 'link_button');
		$aShowSector->appendChild($spanShowSector = $doc->createElement('span'));
		$spanShowSector->setAttribute('class', 'link_add');
		$spanShowSector->appendChild($textShowSector = $doc->createTextNode('Add New Sector'));

		$divShowSector->appendChild($input);

		$inputtd->appendChild($divShowSector);
		// End of show toggleSectorForm.

		$clientSectortr->appendChild($inputtd);

		// Start of hide toggleSectorForm.
		$divHideSector = $doc->createElement('div');
		$divHideSector->setAttribute('id','hide_sector');
		$divHideSector->appendChild($divButtonHideSector = $doc->createElement('div'));
		$divButtonHideSector->appendChild($spanButtonHideSector = $doc->createElement('span'));
		$spanButtonHideSector->setAttribute('class', 'link_button');
		$spanButtonHideSector->setAttribute("onclick", "toggleSectorForm('hide_sector','show_sector');");
		$spanButtonHideSector->appendChild($aHideSector = $doc->createElement('a'));
		$aHideSector->setAttribute('title', 'Select Existing Sector');
		$aHideSector->setAttribute('class', 'link_button');
		$aHideSector->appendChild($spanHideSector = $doc->createElement('span'));
		$spanHideSector->setAttribute('class', 'link_add');
		$spanHideSector->appendChild($textHideSector = $doc->createTextNode('Select Existing Sector'));

		$divHideSector->appendChild(Sector::inline_form($doc, ''));
		$inputtd->appendChild($divHideSector);
		// End of hide toggleSectorForm.

        $table->appendChild($nametr);
        $table->appendChild($addresstr);
        $table->appendChild($citytr);
        $table->appendChild($statetr);
        $table->appendChild($postcodetr);
        $table->appendChild($worktr);
        $table->appendChild($mobiletr);
        $table->appendChild($faxtr);
        $table->appendChild($emailtr);
		$table->appendChild($abntr);
		$table->appendChild($urltr);
		$table->appendChild($clientReptr);
		$table->appendChild($clientSectortr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);

        return($container);
    }

    public function view($doc, $id) {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');
		switch(globalize('extras','Contract')) {
			case 'Contract':
				$contract = new Contract();
				$container->appendChild($contract->inline_list($doc,'',true));
				break;
			case 'Campaign':
				$campaign = new Campaign();
				$container->appendChild($campaign->inline_list($doc,'',true));
				break;
			case 'CampaignAudio':
				$campaignAudio = new CampaignAudio();
				$container->appendChild($campaignAudio->inline_list($doc,'',true));
				break;
			case 'Log':
				$log = new Log();
				$container->appendChild($log->inline_list($doc,'',true));
				break;
		}
		$containerLeft = $doc->createElement('div');
		$containerLeft->setAttribute('class','module_left');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Client'));
		$containerLeft->appendChild($header);

		$containerLeft->appendChild($button = module::createButton_dom($doc,'Add Contract','',array('item'=>"Contract",'action'=>'edit','clientID'=>$id),'Add Contract','link_button','','link_add'));

		$containerLeft->appendChild($button = module::createButton_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button','','link_add'));

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $clientID = $doc->createElement('input');
        $clientID->setAttribute('type','hidden');
        $clientID->setAttribute('name','clientID');
        $clientID->setAttribute('value',$id);
        $containerLeft->appendChild($clientID);

		$query = "SELECT I.clientRepID, D.firstName, D.lastName FROM ({$this->store->table_traffic_clientclientrep} I, {$this->store->table_traffic_clientrep} C, {$this->store->table_detail} D) WHERE I.clientID = '$id' AND C.clientRepID = I.clientRepID AND C.actorID = D.actorID";
        $result = sysdb::query($query);

		$clientRepNames = array();
		while ($line = sysdb::fetch_assoc($result)) {
			array_push($clientRepNames, $line['firstName']." ".$line['lastName'] );
		}

		$query = "SELECT C.name FROM ({$this->store->table_traffic_clientsector} I, {$this->store->table_traffic_sector} C) WHERE I.clientID = '$id' AND C.sectorID = I.sectorID";
        $result = sysdb::query($query);

		$sectorNames = array();
		while ($line = sysdb::fetch_assoc($result)) {
			array_push($sectorNames, $line['name']);
		}

        $query = "SELECT C.clientID, C.name, C.abn, C.url, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email, C.createdDateTime FROM ({$this->store->table_traffic_client} C, {$this->store->table_detail} D) WHERE C.clientID = '$id' AND C.actorID = D.actorID";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $clientID = $line['clientID'];
        $name = $line['name'];
        $address = $line['address'];
        $city = $line['city'];
		$state = $line['state'];
        $postcode = $line['postcode'];
		$work = displayLandlineNumber($line['landline']);
		$mobile = displayMobileNumber($line['mobile']);
		$fax = displayLandlineNumber($line['fax']);
        $email = $line['email'];
		$abn = displayABN($line['abn']);
		$url = $line['url'];
		$createdDateTime = date("d-M-Y H:i:s",strtotime($line['createdDateTime']));

		// Decode UTF-8 character encoding.
		$values = array(&$name,
						&$address,
						&$city,
						&$email,
						&$url
						);
		foreach ($values as &$value) {
			$value = utf8_decode($value);
		}
		unset($value);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name');
        $inputtd = $doc->createElement('td');
        $inputtd->setAttribute('class','name');
        $inputtd->appendChild($input = $doc->createTextNode($name));
        $labeltd->appendChild($label);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $addresstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Address');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($address);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $addresstr->appendChild($labeltd);
        $addresstr->appendChild($inputtd);

        $citytr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('City');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($city);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $citytr->appendChild($labeltd);
        $citytr->appendChild($inputtd);

		$statetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('State');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($state);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $statetr->appendChild($labeltd);
        $statetr->appendChild($inputtd);

        $postcodetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Postcode');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($postcode);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $postcodetr->appendChild($labeltd);
        $postcodetr->appendChild($inputtd);

        $worktr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Work');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($work);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $worktr->appendChild($labeltd);
        $worktr->appendChild($inputtd);

        $mobiletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Mobile');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($mobile);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $mobiletr->appendChild($labeltd);
        $mobiletr->appendChild($inputtd);

        $faxtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Fax');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($fax);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $faxtr->appendChild($labeltd);
        $faxtr->appendChild($inputtd);

        $emailtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Email');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('a');
        $input->setAttribute('href','mailto:'.$email);
        $input->appendChild($doc->createTextNode($email));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $emailtr->appendChild($labeltd);
        $emailtr->appendChild($inputtd);

		$abntr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('ABN');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($abn);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $abntr->appendChild($labeltd);
        $abntr->appendChild($inputtd);

		$urltr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('URL');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($url);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $urltr->appendChild($labeltd);
        $urltr->appendChild($inputtd);

		$createdDateTimetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Created');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($createdDateTime);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $createdDateTimetr->appendChild($labeltd);
        $createdDateTimetr->appendChild($inputtd);

		$clientRepNamestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client Rep(s)');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($clientRepNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $clientRepNamestr->appendChild($labeltd);
        $clientRepNamestr->appendChild($inputtd);

		$clientSectorNamestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client Sector(s)');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($sectorNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $clientSectorNamestr->appendChild($labeltd);
        $clientSectorNamestr->appendChild($inputtd);

        $table->appendChild($nametr);
        $table->appendChild($addresstr);
        $table->appendChild($citytr);
        $table->appendChild($statetr);
        $table->appendChild($postcodetr);
        $table->appendChild($worktr);
        $table->appendChild($mobiletr);
        $table->appendChild($faxtr);
        $table->appendChild($emailtr);
		$table->appendChild($abntr);
		$table->appendChild($urltr);
		$table->appendChild($createdDateTimetr);
		$table->appendChild($clientRepNamestr);
		$table->appendChild($clientSectorNamestr);

		$containerLeft->appendChild($table);

		$containerLeft->appendChild(Notes::form($doc,$id));

		$container->appendChild($containerLeft);

		$moduleFooter = $doc->createElement('div');
		$moduleFooter->setAttribute('class','clear_both');
		$container->appendChild($moduleFooter);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $query = <<<EOQ
            SELECT C.clientID, C.name, C.createdDateTime, D.email
            FROM {$this->store->table_traffic_client} C
            LEFT OUTER JOIN {$this->store->table_detail} D USING (actorID) WHERE 1
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND C.clientID IN (".implode(',',$ids).") ";
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

		$col1 = $doc->createElement('col');
        $table->appendChild($col1);

		$col2 = $doc->createElement('col');
        $table->appendChild($col2);

//		$col3 = $doc->createElement('col');
//        $table->appendChild($col3);

		$colactions = $doc->createElement('col');
		////$colactions->setAttribute('width', '56px');
        $table->appendChild($colactions);

        $tr = $doc->createElement('tr');
        $nametd = $doc->createElement('th');
        $emailtd = $doc->createElement('th');
//		$datetd = $doc->createElement('th');

        $nametd->appendChild(module::link_to_script_dom($doc,'Name','',array('item'=>globalize('item', get_class($this)),'action'=>'sort','sortby'=>'name','startsWith'=>globalize('startsWith')),'Name'));
		$emailtd->appendChild($doc->createTextNode('Email'));
//		$datetd->appendChild(module::link_to_script_dom($doc,'Date','',array('item'=>$item,'action'=>'sort','sortby'=>'date','startsWith'=>$startsWith),'Date'));

        $tr->appendChild($nametd);
        $tr->appendChild($emailtd);
//		$tr->appendChild($datetd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
			$tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No clients entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);

            $nametd = $doc->createElement('td');
            $emailtd = $doc->createElement('td');
			$datetd = $doc->createElement('td');

            //$nametd->appendChild($doc->createTextNode($line['name']));
            $nametd->appendChild(module::link_to_script_dom($doc,$line['name'],'',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['clientID']),'View'));
            $emailhref = $doc->createElement('a');
            $emailhref->setAttribute('href','mailto:'.$line['email']);
            $emailhref->appendChild($doc->createTextNode($line['email']));
            $emailtd->appendChild($emailhref);
			$datetd->appendChild($doc->createTextNode($line['createdDateTime']));
            $actiontd = $doc->createElement('td');
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['clientID']),'View'));
			$actiontd->appendChild($doc->createTextNode(' '));
			$actiontd->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['clientID']),'Edit'));
			$actiontd->appendChild($doc->createTextNode(' '));
            $actiontd->appendChild($span = $doc->createElement('span'));
            $span->setAttribute('class','link_traffic_small');
            $span->appendChild(module::link_to_script_dom($doc,'View Traffic','',
                            array('item'=>'Traffic',
                                  'mode'=>'Client',
                                  'clientID'=>$line['clientID'],
                                    ),'View Traffic'));
            $table->appendChild($tr);
            $tr->appendChild($nametd);
            $tr->appendChild($emailtd);
//			$tr->appendChild($datetd);
            $tr->appendChild($actiontd);
			$i++;
        }
        /*$tr = $doc->createElement('tr');
        $actiontd = $doc->createElement('td');
        $actiontd->setAttribute('colspan','5');
        $actiontd->setAttribute('style','text-align: right;');
        $actiontd->appendChild(module::link_to_script_dom($doc,'add','',array('item'=>$item,'action'=>'edit')));

        $table->appendChild($tr);
        $tr->appendChild($actiontd);*/

        return($table);
    }

    public function overview($doc,$ids='') {
        $item = globalize('item', get_class($this));
		$sortby = globalize('sortby');
		$startsWith = globalize('startsWith');

		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
							break;
				case 'date':
							$sortby = 'createdDateTime';
							break;
				default:
							$sortby = 'name';
							break;
			}
		}
        $query = <<<EOQ
            SELECT C.clientID, C.name, C.createdDateTime, D.email
            FROM {$this->store->table_traffic_client} C
            LEFT OUTER JOIN {$this->store->table_detail} D USING (actorID)
            WHERE 1
EOQ;
        if ($startsWith != '')  $query .= ' AND C.name LIKE \''.$startsWith.'%\'';
        $query .= " ORDER BY $sortby ";

        $ids = sysdb::query2vector($query,'clientID');

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Clients'));
		$container->appendChild($header);

		$container->appendChild($button = module::createButton_dom($doc,'Add Client','',array('item'=>$item,'action'=>'edit'),'Add Client','link_button','','link_add'));

		$searchLetters = $doc->createElement('div');
		$searchLetters->setAttribute('class','search_letters');
		$searchLetters->appendChild($doc->createTextNode('Browse: '));
		foreach ( range('A','Z') as $c ) {
			$searchLetters->appendChild(module::link_to_script_dom($doc,$c,'',array('item'=>$item,'action'=>'search','startsWith'=>$c),'Starts with '.$c));
			$searchLetters->appendChild($doc->createTextNode(' '));
		}
		$container->appendChild($searchLetters);

		if ($startsWith != '') $container->appendChild(self::display_list($doc,$ids,$sortby));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT S.clientID, S.name FROM {$this->store->table_traffic_client} S ORDER BY name";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','clientID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No clients available');
            $option->appendChild($text);
            $select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('Please select a client...');
            $option->appendChild($text);
            $select->appendChild($option);
            while ($line = sysdb::fetch_assoc($result)) {
                $option = $doc->createElement('option');
                $option->setAttribute('value',$line['clientID']);
                $text = $doc->createTextNode(utf8_decode($line['name']));
                $option->appendChild($text);
                if ($default == $line['clientID']) $option->setAttribute('selected','selected');
                $select->appendChild($option);
            }
        }

        return($select);
    }

    public function add($name,$address,$city,$state,$postcode,$work,$mobile,$fax,$email,$abn,$url,$date,
						$clientRepIDList,$clientRepTitle,$clientRepFirstName,$clientRepLastName,
						$clientRepAddress,$clientRepCity,$clientRepPostcode,$clientRepWork,$clientRepMobile,
						$clientRepFax,$clientRepEmail,$clientSectorIDList,$sectorName,$sectorStartYear,
						$sectorStartMonth,$sectorStartDay,$sectorEndYear,$sectorEndMonth,$sectorEndDay) {
		// Escape values.
		$values = array(&$name,
						&$address,
						&$city,
						&$email,
						&$url
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Strip whitespace from phone numbers and ABN.
		$values = array(&$work,
						&$mobile,
						&$fax,
						&$abn
						);
 		foreach ($values as &$value) {
			$value = str_replace(' ', '', $value);
		}
		unset($value);

		// Verify that ABN is a valid ABN that passes the checking algorithm.
		// if (!verify_abn($abn)) {
			// state::setMessage('warning', 'The ABN you entered is not valid.');
			// return;
		// }

        $actorID = create_actor();
		$query = "INSERT INTO {$this->store->table_traffic_client} (name,abn,url,createdDateTime,actorID) VALUES ('$name','$abn','$url','$date','$actorID')";
        $result = sysdb::query($query);
		$clientID = sysdb::insert_id();
		$query = "INSERT INTO {$this->store->table_detail} (address,city,state,postcode,landline,mobile,fax,email,actorID) VALUES ('$address','$city','$state','$postcode','$work','$mobile','$fax','$email','$actorID')";
        $result = sysdb::query($query);
		if (!empty($clientRepIDList)) {
			foreach($clientRepIDList as $clientRepID ) {
				if ($clientRepID != '') {
					$query = "INSERT INTO {$this->store->table_traffic_clientclientrep} (clientRepID, clientID) VALUES ('$clientRepID', '$clientID')";
					$result = sysdb::query($query);
				}
			}
		}
		// If details for a new Rep was added on the inline form, add it.
		if ($clientRepTitle != '' ||
			$clientRepFirstName != '' ||
			$clientRepLastName != '' ||
			$clientRepAddress != '' ||
			$clientRepCity != '' ||
			$clientRepPostcode != '' ||
			$clientRepWork != '' ||
			$clientRepMobile != '' ||
			$clientRepFax != '' ||
			$clientRepEmail != '') {
			ClientRep::add($clientRepTitle,$clientRepFirstName,$clientRepLastName,
						$clientRepAddress,$clientRepCity,$clientRepPostcode,$clientRepWork,$clientRepMobile,
						$clientRepFax,$clientRepEmail,array($clientID));
		}
		if (!empty($clientSectorIDList)) {
			foreach($clientSectorIDList as $sectorID ) {
				if ($sectorID != '') {
					$query = "INSERT INTO {$this->store->table_traffic_clientsector} (sectorID, clientID) VALUES ('$sectorID', '$clientID')";
					$result = sysdb::query($query);
				}
			}
		}
		// If details for a new Sector was added on the inline form, add it.
		if ($sectorName != '') {
			Sector::add($sectorName,$sectorStartYear,$sectorStartMonth,$sectorStartDay,$sectorEndYear,$sectorEndMonth,$sectorEndDay);

			// Fetch the newly inserted sectorID and add it into the clientsector table.
			$query = <<<EOQ
				INSERT INTO {$this->store->table_traffic_clientsector} (
					{$this->store->field_clientsector_sectorID},
					{$this->store->field_clientsector_clientID}
				)
				SELECT {$this->store->field_sector_sectorID} AS {$this->store->field_clientsector_sectorID},
					'$clientID' AS {$this->store->field_clientsector_clientID}
				FROM {$this->store->table_traffic_sector}
				WHERE {$this->store->field_sector_name} = '$sectorName'
EOQ;
            sysdb::query($query);
		}
		state::setMessage('notify', 'Successfully added new client: '.utf8_decode($name));
        //Take the user to add a contract after the client has been created.
		module::forward_to_script('',array('item'=>'Contract','action'=>'edit','clientID'=>$clientID));
		//module::forward_to_script('',array('item'=>'Client','action'=>'view','id'=>$clientID));
    }

    public function save($id,$name,$address,$city,$state,$postcode,$work,$mobile,$fax,$email,$abn,$url,
						$clientRepIDList,$clientRepTitle,$clientRepFirstName,$clientRepLastName,
						$clientRepAddress,$clientRepCity,$clientRepPostcode,$clientRepWork,$clientRepMobile,
						$clientRepFax,$clientRepEmail,$clientSectorIDList,$sectorName,$sectorStartYear,
						$sectorStartMonth,$sectorStartDay,$sectorEndYear,$sectorEndMonth,$sectorEndDay) {
		// Escape values.
		$values = array(&$name,
						&$address,
						&$city,
						&$email,
						&$url
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Strip whitespace from phone numbers and ABN.
		$values = array(&$work,
						&$mobile,
						&$fax,
						&$abn
						);
 		foreach ($values as &$value) {
			$value = str_replace(' ', '', $value);
		}
		unset($value);

		// Verify that ABN is a valid ABN that passes the checking algorithm.
		// if (!verify_abn($abn)) {
			// state::setMessage('warning', 'The ABN you entered is not valid.');
			// return;
		// }

         $query = "UPDATE ({$this->store->table_traffic_client} C, {$this->store->table_detail} D) SET C.name = '$name', D.address = '$address', D.city = '$city', D.state = '$state', D.postcode = '$postcode', D.landline = '$work', D.mobile = '$mobile', D.fax = '$fax', D.email = '$email', C.abn = '$abn', C.url = '$url' WHERE C.clientID = '$id' AND C.actorID = D.actorID";
        $result = sysdb::query($query);

		// Check if update failed.
		if (!$result) {
			// There is probably no detail record for the client. This should never have happened.
			$query = <<<EOQ
				SELECT actorID as actorID
				FROM {$this->store->table_traffic_client}
				WHERE clientID = '$id'
EOQ;
			$result = sysdb::query($query);
			if ( sysdb::num_rows($result) > 0 ) {
				// Try create one.
				$line = sysdb::fetch_assoc($result);
				$missing_details = createFalseActorDetail($line['actorID']);
				if ($missing_details) {
					$query = "UPDATE ({$this->store->table_traffic_client} C, {$this->store->table_detail} D) SET C.name = '$name', D.address = '$address', D.city = '$city', D.state = '$state', D.postcode = '$postcode', D.landline = '$work', D.mobile = '$mobile', D.fax = '$fax', D.email = '$email', C.abn = '$abn', C.url = '$url' WHERE C.clientID = '$id' AND C.actorID = D.actorID";
					sysdb::query($query);
					state::setMessage('error', "Client '".$name."' was missing details. This shouldn't have occurred. Please notify your system administrator of this error message.");
				}
			}
		}

		$query = "DELETE FROM {$this->store->table_traffic_clientclientrep} WHERE clientID = '$id'";
        $result = sysdb::query($query);
		if (!empty($clientRepIDList)) {
			foreach($clientRepIDList as $clientRepID ) {
				if ($clientRepID != '') {
					$query = "INSERT INTO {$this->store->table_traffic_clientclientrep} (clientRepID, clientID) VALUES ('$clientRepID', '$id')";
					$result = sysdb::query($query);
				}
			}
		}
		// If details for a new Rep was added on the inline form, add it.
		if ($clientRepTitle != '' ||
			$clientRepFirstName != '' ||
			$clientRepLastName != '' ||
			$clientRepAddress != '' ||
			$clientRepCity != '' ||
			$clientRepPostcode != '' ||
			$clientRepWork != '' ||
			$clientRepMobile != '' ||
			$clientRepFax != '' ||
			$clientRepEmail != '') {
			ClientRep::add($clientRepTitle,$clientRepFirstName,$clientRepLastName,
						$clientRepAddress,$clientRepCity,$clientRepPostcode,$clientRepWork,$clientRepMobile,
						$clientRepFax,$clientRepEmail,array($id));
		}
		$query = "DELETE FROM {$this->store->table_traffic_clientsector} WHERE clientID = '$id'";
        $result = sysdb::query($query);
		if (!empty($clientSectorIDList)) {
			foreach($clientSectorIDList as $sectorID ) {
				if ($sectorID != '') {
					$query = "INSERT INTO {$this->store->table_traffic_clientsector} (sectorID, clientID) VALUES ('$sectorID', '$id')";
					$result = sysdb::query($query);
				}
			}
		}
		// If details for a new Sector was added on the inline form, add it.
		if ($sectorName != '') {
			Sector::add($sectorName,$sectorStartYear,$sectorStartMonth,$sectorStartDay,$sectorEndYear,$sectorEndMonth,$sectorEndDay);

			// Fetch the newly inserted sectorID and add it into the clientsector table.
			$query = <<<EOQ
				INSERT INTO
				{$this->store->table_traffic_clientsector}
				(
				{$this->store->field_clientsector_sectorID},
				{$this->store->field_clientsector_clientID}
				)
				SELECT
				{$this->store->field_sector_sectorID} as {$this->store->field_clientsector_sectorID},
				'$id' as {$this->store->field_clientsector_clientID}
				FROM
				{$this->store->table_traffic_sector}
				WHERE
				{$this->store->field_sector_name} = '$sectorName'
EOQ;
            sysdb::query($query);
		}
		state::setMessage('notify', 'Successfully updated client: '.utf8_decode($name));
		module::forward_to_script('',array('item'=>'Client','action'=>'view','id'=>$id));
    }

    public function delete($id) {

		$query = "SELECT name FROM {$this->store->table_traffic_contract} WHERE clientID = '$id'";
		$result = sysdb::query($query);

		if ( sysdb::num_rows($result) > 0 ) {
			state::setMessage('warning', 'Please delete existing contracts before deleting a client.');
		} else {
			$query = "SELECT name FROM {$this->store->table_traffic_client} WHERE clientID = '$id'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$query = "DELETE FROM {$this->store->table_traffic_clientclientrep} WHERE clientID = '$id'";
			$result = sysdb::query($query);
			$query = "DELETE FROM {$this->store->table_traffic_client} WHERE clientID = '$id'";
			$result = sysdb::query($query);
			state::setMessage('notify', 'Successfully deleted client: '.utf8_decode($line['name']));
		}
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this Client item?</p>';
		$message .= '<p>The item and all its daughter contracts, campaigns, audio and spots will be permanently deleted if you proceed.</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);
		return;
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','id'=>$id));
		return;
    }

    public function search($doc,$string) {
        $string = strtolower($string);
        $query = "SELECT clientID FROM {$this->store->table_traffic_client} WHERE LCASE(name) LIKE '%$string%' OR LCASE('email') LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'clientID')));
        }
    }

}
?>
