<?php
// $Id$

class ClientRep {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('clientRepTitle'),
							globalize('clientRepFirstName'),
							globalize('clientRepLastName'),
							globalize('clientRepAddress'),
							globalize('clientRepCity'),
							globalize('clientRepPostcode'),
							globalize('clientRepWork'),
							globalize('clientRepMobile'),
							globalize('clientRepFax'),
							globalize('clientRepEmail'),
							globalize('clientRepClientIDList'));
				break;
            case 'save':
				$this->save(globalize('clientRepID'),
							globalize('clientRepTitle'),
							globalize('clientRepFirstName'),
							globalize('clientRepLastName'),
							globalize('clientRepAddress'),
							globalize('clientRepCity'),
							globalize('clientRepPostcode'),
							globalize('clientRepWork'),
							globalize('clientRepMobile'),
							globalize('clientRepFax'),
							globalize('clientRepEmail'),
							globalize('clientRepClientIDList'));
				break;
        }
    }

    public function form($doc, $id='') {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Client Rep';
        else
            $headerText = 'Edit Client Rep';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

       /* Database Code */
        if ($id != '') {
			$query = "SELECT I.clientRepID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D) WHERE I.clientRepID = '$id' AND I.actorID = D.actorID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $clientRepID = $line['clientRepID'];
            $title = $line['title'];
            $firstName = $line['firstName'];
            $lastName = $line['lastName'];
            $address = $line['address'];
            $city = $line['city'];
            $postcode = $line['postcode'];
            $work = $line['landline'];
            $mobile = $line['mobile'];
            $fax = $line['fax'];
            $email = $line['email'];

			// Decode UTF-8 character encoding.
			$values = array(&$title,
							&$firstName,
							&$lastName,
							&$address,
							&$city,
							&$email
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$query = "SELECT * FROM {$this->store->table_traffic_clientclientrep} WHERE clientRepID = '$id'";
			$result = sysdb::query($query);
			$clientIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($clientIDList, $line['clientID']);
			}
        } else {
            $clientRepID = '';
            $title = '';
            $firstName = '';
            $lastName = '';
            $address = '';
            $city = '';
            $postcode = '';
            $work = '';
            $mobile = '';
            $fax = '';
            $email = '';
		}

		$fields = array(
         "Title"=>     array( "name"=>"clientRepTitle", "value"=>$title ),
         "First Name"=> array( "name"=>"clientRepFirstName", "value"=>$firstName),
         "Last Name"=>  array( "name"=>"clientRepLastName", "value"=>$lastName),
         "Address"=>   array( "name"=>"clientRepAddress", "value"=>$address),
         "City"=>      array( "name"=>"clientRepCity", "value"=>$city),
         "Postcode"=>  array( "name"=>"clientRepPostcode", "value"=>$postcode),
         "Work"=>   array( "name"=>"clientRepWork", "value"=>$work),
         "Mobile"=> array( "name"=>"clientRepMobile", "value"=>$mobile),
         "Fax"=>    array( "name"=>"clientRepFax", "value"=>$fax),
         "Email"=>     array( "name"=>"clientRepEmail", "value"=>$email)   );

		foreach($fields as $name=>$val) {
			$formFields[$name] = dom::createInputBox($doc, $val['name'], $val['value'], 'text');
		}

		$clientRepIDHidden = dom::createInputBox($doc, 'clientRepID', $id, 'hidden');
		$container->appendChild($clientRepIDHidden);

        $input = $doc->createElement('select');
		$input->setAttribute('name','clientRepClientIDList[]');
		$input->setAttribute('multiple', 'multiple');
		$input->setAttribute('size', '7');

		$query = "SELECT clientID, name FROM {$this->store->table_traffic_client}";
		$result = sysdb::query($query);

		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($clientIDList)) {
				if ( in_array($line['clientID'],$clientIDList) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['clientID']);
			$inputOption->appendChild($doc->createTextNode($line['name']));
			$input->appendChild($inputOption);
		}

		$formFields["Clients"] = $input;

		$table = dom::createTable($doc, $formFields, 'view');
		$container->appendChild($table);

		if ($id == '')
			$submitButtonName = "add";
		else
			$submitButtonName = "save";

		$submitButton = dom::createInputBox($doc, 'action', $submitButtonName, 'submit');
		$container->appendChild($submitButton);

		return $container;
    }

    public function inline_form($doc, $id='') {

		$container = $doc->createElement('div');
		$container->setAttribute('id','hide_clientrep');

        $divbutton = $doc->createElement('div');
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->setAttribute("onclick", "toggleClientRepForm('hide_clientrep','show_clientrep');");
		$a = $doc->createElement('a');
		$a->setAttribute('title', 'Select Existing Client Rep');
		$a->setAttribute('class', 'link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$text = $doc->createTextNode('Select Existing Client Rep');
		$span->appendChild($text);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$divbutton->appendChild($spanbutton);
		$container->appendChild($divbutton);

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

		// TODO: Add State to this array.
		$populateArray = array(
						'Address',
						'City',
						'Postcode',
						'Work',
						'Mobile',
						'Fax',
						'Email');
		$populateString = implode($populateArray,'/');
        $divToggleLink = $doc->createElement('div');
		$divToggleLink->appendChild($aToggleLink = $doc->createElement('a'));
		$aToggleLink->setAttribute("onclick", "populateClientRepForm('$populateString');");
		$aToggleLink->appendChild($doc->createTextNode('Populate with same contact details as above'));

		$container->appendChild($divToggleLink);

		$clientRepID = '';
		$title = '';
		$firstName = '';
		$lastName = '';
		$address = '';
		$city = '';
		$postcode = '';
		$work = '';
		$mobile = '';
		$fax = '';
		$email = '';

		$fields = array(
         "Title"=>     array( "name"=>"clientRepTitle", "value"=>$title ),
         "First Name"=> array( "name"=>"clientRepFirstName", "value"=>$firstName),
         "Last Name"=>  array( "name"=>"clientRepLastName", "value"=>$lastName),
         "Address"=>   array( "name"=>"clientRepAddress", "value"=>$address),
         "City"=>      array( "name"=>"clientRepCity", "value"=>$city),
         "Postcode"=>  array( "name"=>"clientRepPostcode", "value"=>$postcode),
         "Work"=>   array( "name"=>"clientRepWork", "value"=>$work),
         "Mobile"=> array( "name"=>"clientRepMobile", "value"=>$mobile),
         "Fax"=>    array( "name"=>"clientRepFax", "value"=>$fax),
         "Email"=>     array( "name"=>"clientRepEmail", "value"=>$email)   );

		foreach($fields as $name=>$val) {
			$formFields[$name] = dom::createInputBox($doc, $val['name'], $val['value'], 'text');
		}

		$clientRepIDHidden = dom::createInputBox($doc, 'clientRepID', $id, 'hidden');
		$container->appendChild($clientRepIDHidden);

		$table = dom::createTable($doc, $formFields, 'view');
		$container->appendChild($table);

		return $container;
    }

    public function view($doc, $id) {
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Client Rep'));
		$container->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $container->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        $clientRepID = $doc->createElement('input');
        $clientRepID->setAttribute('type','hidden');
        $clientRepID->setAttribute('name','clientRepID');
        $clientRepID->setAttribute('value',$id);
        $container->appendChild($clientRepID);

		$query = "SELECT I.clientID, C.name FROM {$this->store->table_traffic_clientclientrep} I, {$this->store->table_traffic_client} C WHERE I.clientRepID = '$id' AND C.clientID = I.clientID";
        $result = sysdb::query($query);

		$clientNames = array();
		while ($line = sysdb::fetch_assoc($result)) {
			array_push($clientNames, $line['name'] );
		}

		if ($id != '') {
			$query = "SELECT I.clientRepID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D) WHERE I.clientRepID = '$id' AND I.actorID = D.actorID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);

			$clientRepID = $line['clientRepID'];
			$title = $line['title'];
			$firstName = $line['firstName'];
			$lastName = $line['lastName'];
			$address = $line['address'];
			$city = $line['city'];
			$postcode = $line['postcode'];
			$work = displayLandlineNumber($line['landline']);
			$mobile = displayMobileNumber($line['mobile']);
			$fax = displayLandlineNumber($line['fax']);
			$email = $line['email'];

			// Decode UTF-8 character encoding.
			$values = array(&$title,
							&$firstName,
							&$lastName,
							&$address,
							&$city,
							&$email
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			foreach ($clientNames as &$clientName) {
				$clientName = utf8_decode($clientName);
			}
			unset($clientName);
		}

        $titletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Title');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($title);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $titletr->appendChild($labeltd);
        $titletr->appendChild($inputtd);

        $firstNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('First Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($firstName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $firstNametr->appendChild($labeltd);
        $firstNametr->appendChild($inputtd);

        $lastNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Last Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($lastName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $lastNametr->appendChild($labeltd);
        $lastNametr->appendChild($inputtd);

        $addresstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Address');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($address);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $addresstr->appendChild($labeltd);
        $addresstr->appendChild($inputtd);

        $citytr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('City');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($city);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $citytr->appendChild($labeltd);
        $citytr->appendChild($inputtd);

        $postcodetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Postcode');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($postcode);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $postcodetr->appendChild($labeltd);
        $postcodetr->appendChild($inputtd);

        $worktr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Work');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($work);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $worktr->appendChild($labeltd);
        $worktr->appendChild($inputtd);

        $mobiletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Mobile');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($mobile);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $mobiletr->appendChild($labeltd);
        $mobiletr->appendChild($inputtd);

        $faxtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Fax');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($fax);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $faxtr->appendChild($labeltd);
        $faxtr->appendChild($inputtd);

        $emailtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Email');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('a');
        $input->setAttribute('href','mailto:'.$email);
        $input->appendChild($doc->createTextNode($email));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $emailtr->appendChild($labeltd);
        $emailtr->appendChild($inputtd);

		$clientNamestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Clients');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($clientNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}
        $clientNamestr->appendChild($labeltd);
        $clientNamestr->appendChild($inputtd);

        $table->appendChild($titletr);
        $table->appendChild($firstNametr);
        $table->appendChild($lastNametr);
        $table->appendChild($addresstr);
        $table->appendChild($citytr);
        $table->appendChild($postcodetr);
        $table->appendChild($worktr);
        $table->appendChild($mobiletr);
        $table->appendChild($faxtr);
        $table->appendChild($emailtr);
		$table->appendChild($clientNamestr);

        $container->appendChild($table);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $query = <<<EOQ
            SELECT I.clientRepID, D.firstName, D.lastName, D.email
            FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D)
            WHERE I.actorID = D.actorID
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " AND I.clientRepID IN (".implode(',',$ids).") ";
        }
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

        $tr = $doc->createElement('tr');
        $firstNametd = $doc->createElement('th');
        $lastNametd = $doc->createElement('th');
        $emailtd = $doc->createElement('th');

        $firstNametd->appendChild($doc->createTextNode('First'));
        $lastNametd->appendChild($doc->createTextNode('Last'));
        $emailtd->appendChild($doc->createTextNode('Email'));

        $tr->appendChild($firstNametd);
        $tr->appendChild($lastNametd);
        $tr->appendChild($emailtd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No clientReps entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $firstNametd = $doc->createElement('td');
            $lastNametd = $doc->createElement('td');
            $emailtd = $doc->createElement('td');

            $firstNametd->appendChild($doc->createTextNode($line['firstName']));
            $lastNametd->appendChild($doc->createTextNode($line['lastName']));
            $emailhref = $doc->createElement('a');
            $emailhref->setAttribute('href','mailto:'.$line['email']);
            $emailhref->appendChild($doc->createTextNode($line['email']));
            $emailtd->appendChild($emailhref);
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['clientRepID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['clientRepID']),'Edit'));
            $actiontd->appendChild($span);

            $table->appendChild($tr);
            $tr->appendChild($firstNametd);
            $tr->appendChild($lastNametd);
            $tr->appendChild($emailtd);
            $tr->appendChild($actiontd);
			$i++;
        }

        return($table);
    }

    public function overview($doc,$ids='') {
        $item = globalize('item', get_class($this));
        $sortby = globalize('sortby');
		if ($sortby != '')
			$sortby = 'lastName';
		else {
			switch($sortby) {
				case 'lastName':
							break;
				case 'firstName':
							$sortby = 'firstName';
							break;
				case 'email':
							$sortby = 'email';
							break;
				default:
							$sortby = 'lastName';
							break;
			}
		}
        $query = "SELECT I.clientRepID FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID";
        $query .= " ORDER BY $sortby ";

        $ids = sysdb::query2vector($query,'clientRepID');

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Client Representatives'));
		$container->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $span->appendChild(module::link_to_script_dom($doc,'Add Client Rep','',array('item'=>$item,'action'=>'edit'),'Add Client Rep'));
        // $container->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Client Rep','',array('item'=>$item,'action'=>'edit'),'Add Client Rep','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Client Rep');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

		$container->appendChild(self::display_list($doc,$ids,$sortby));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT S.clientRepID, S.firstName, S.lastName, S.title FROM {$this->store->table_traffic_clientrep} S ORDER BY lastName, firstName";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','clientRepID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No clientReps available');
            $option->appendChild($text);
        }
        while ($line = sysdb::fetch_assoc($result)) {
            $option = $doc->createElement('option');
            $option->setAttribute('value',$line['clientRepID']);
            $text = $doc->createTextNode($line['lastName'].', '.$line['title'].' '.$line['firstName']);
            $option->appendChild($text);
            $select->appendChild($option);
        }

        return($select);
    }

    public function add($title,$firstName,$lastName,$address,$city,$postcode,$work,$mobile,$fax,$email,$clientIDList) {
		// Escape values.
		$values = array(&$title,
						&$firstName,
						&$lastName,
						&$address,
						&$city,
						&$email
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Strip whitespace from phone numbers and ABN.
		$values = array(&$work,
						&$mobile,
						&$fax
						);
 		foreach ($values as &$value) {
			$value = str_replace(' ', '', $value);
		}
		unset($value);

        $actorID = create_actor();
        $query = "INSERT INTO {$this->store->table_traffic_clientrep} (actorID) VALUES ('$actorID')";
        $result = sysdb::query($query);
		$clientRepID = sysdb::insert_id();
        $query = "INSERT INTO {$this->store->table_detail} (title, firstName, lastName, address, city, postcode, landline, mobile, fax, email, actorID) VALUES ('$title','$firstName','$lastName','$address','$city','$postcode','$work','$mobile','$fax','$email','$actorID')";
        $result = sysdb::query($query);
		if (!empty($clientIDList)) {
			foreach($clientIDList as $clientID ) {
				if ($clientID != '') {
					$query = "INSERT INTO {$this->store->table_traffic_clientclientrep} (clientRepID, clientID) VALUES ('$clientRepID', '$clientID')";
					$result = sysdb::query($query);
				}
			}
		}
		state::setMessage('notify', 'Successfully added client representative: '.utf8_decode($firstName.' '.$lastName));
		if ($item == 'ClientRep') {
			module::forward_to_script('', array('item' => 'ClientRep', 'action' => 'view', 'id' => $clientRepID));
		}
    }

    public function save($id,$title,$firstName,$lastName,$address,$city,$postcode,$work,$mobile,$fax,$email,$clientIDList) {
		// Escape values.
		$values = array(&$title,
						&$firstName,
						&$lastName,
						&$address,
						&$city,
						&$email
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Strip whitespace from phone numbers and ABN.
		$values = array(&$work,
						&$mobile,
						&$fax
						);
 		foreach ($values as &$value) {
			$value = str_replace(' ', '', $value);
		}
		unset($value);

        $query = "UPDATE ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D) SET D.title = '$title', D.firstName = '$firstName', D.lastName = '$lastName',  D.address = '$address', D.city = '$city', D.postcode = '$postcode', D.landline = '$work', D.mobile = '$mobile', D.fax = '$fax', D.email = '$email' WHERE I.clientRepID = '$id' AND I.actorID = D.actorID";
        $result = sysdb::query($query);
		$query = "DELETE FROM {$this->store->table_traffic_clientclientrep} WHERE clientRepID = '$id'";
        $result = sysdb::query($query);
		if (!empty($clientIDList)) {
			foreach($clientIDList as $clientID ) {
				if ($clientID != '') {
					$query = "INSERT INTO {$this->store->table_traffic_clientclientrep} (clientID, clientRepID) VALUES ('$clientID', '$id')";
					$result = sysdb::query($query);
				}
			}
		}
		state::setMessage('notify', 'Successfully updated client representative: '.utf8_decode($firstName.' '.$lastName));
		if ($item == 'ClientRep') {
			module::forward_to_script('', array('item' => 'ClientRep', 'action' => 'view', 'id' => $id));
		}
    }

    public function delete($id) {
		$query = "SELECT D.firstName, D.lastName FROM ({$this->store->table_detail} D, {$this->store->table_traffic_clientrep} I) WHERE I.clientRepID = '$id' AND I.actorID = D.actorID";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
        $query = "DELETE FROM {$this->store->table_traffic_clientrep} WHERE clientRepID = '$id'";
        $result = sysdb::query($query);
		state::setMessage('notify', 'Successfully deleted client representative: '.utf8_decode($line['firstName'].' '.$line['lastName']));
    }

    public function search($doc,$string) {
        $query = "SELECT I.clientRepID FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID AND (D.firstName LIKE '%$string%' OR D.lastName LIKE '%$string%' OR D.email LIKE '%$string%') ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'clientRepID')));
        }
    }

}
?>
