<?php
// $Id$

require_once('Campaign.php');
require_once('CampaignAudio.php');
include_once('sendemails.php');
//include_once('fpdf.php');
//include_once('svg2pdf.php');


class Contract {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    function toPDF() {
        $mySVG2 = array (

        	"filename" => ROOT_COMPONENTS."traffic/style/fire.svg",
        	"scale_x" => 100,
        	"scale_u" => "mm",
        	"scale_r" => "width",
        	"pos_x" => 55,
        	"pos_y" => 30,
        	"pos_u" => 'mm'

        );


        $pdf = new PDF_SVG('P','mm','A4');
        $pdf->Open();
        $pdf->AddPage();
        $pdf->SetFont('Arial','B',16);
        @$pdf->ImageSVG($mySVG2);
        $pdf->Output();

/*
        $factory = new PDF_SVG();
        $factory->AddPage();
        $factory->SetFont('Arial','B',16);
        $factory->Cell(40,10,'Tudor');
        $svg_info = array('filename'=>'/home/tudor/development/syn/SPO/branches/mms2-snowy/src/private/components/traffic/style/drawing.svg',
            'scale_u'=>'','scale_r'=>'1.0','scale_x'=>'1.0','scale_y'=>'1.0',
            'pos_u'=>'',                   'pos_x'=>'40',   'pos_y'=>'10');
        $factory->ImageSVG($svg_info);
        $factory->Output('RRRform.pdf','D');
*/
    }

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('contractCreatedDateTime'),
							globalize('contractStartYear'),
							globalize('contractStartMonth'),
							globalize('contractStartDay'),
							globalize('contractEndYear'),
							globalize('contractEndMonth'),
							globalize('contractEndDay'),
							globalize('contractContractStatus'),
							globalize('contractPrice'),
							globalize('contractStationPresentsStatus'),
							globalize('contractAudioPurchased'),
							globalize('contractSpotsPurchased'),
							globalize('contractServices'),
							globalize('contractNotes'),
							globalize('clientID'),
							globalize('contractClientRepIDList'),
							globalize('contractSalesRepIDList'),
							globalize('salesRepActorID')
							);
				break;
            case 'save':
				$this->save(globalize('contractID'),
							globalize('contractStartYear'),
							globalize('contractStartMonth'),
							globalize('contractStartDay'),
							globalize('contractEndYear'),
							globalize('contractEndMonth'),
							globalize('contractEndDay'),
							globalize('contractName'),
							globalize('contractContractStatus'),
							globalize('contractPrice'),
							globalize('contractStationPresentsStatus'),
							globalize('contractAudioPurchased'),
							globalize('contractSpotsPurchased'),
							globalize('contractServices'),
							globalize('contractNotes'),
							globalize('contractClientRepIDList'),
							globalize('contractSalesRepIDList'),
							globalize('salesRepActorID')
							);
				break;
            case 'remove':
				$this->remove(globalize('id'));
				break;
            case 'cancel':
				$this->cancel(globalize('id'));
				break;
            case 'annotate':
				Notes::add(
					globalize('notesActorID'),
					globalize('notesType'),
					globalize('notesId'),
					globalize('notesAction'),
					globalize('notesDetails')
					);
				break;
        }
    }

    public function headers($doc) {
		$moduleID = globalize('moduleID');
        $item = globalize('item', get_class($this));
		$script = $doc->createElement('script');
		$script->setAttribute('language', 'javascript');
		$script->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=".$item.".js");
		$script->appendChild($doc->createTextNode(''));

		return(array($script));
    }

    public function form($doc, $id='') {
		$clientID = globalize('clientID');

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Contract';
        else
            $headerText = 'Edit Contract';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		if ($id != '') {
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>"Contract",'action'=>'remove','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Contract",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);
		}

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

        $contractID = $doc->createElement('input');
        $contractID->setAttribute('type','hidden');
        $contractID->setAttribute('name','contractID');
        $contractID->setAttribute('value',$id);
        $container->appendChild($contractID);

		$datetime = date("Y-m-d H:i:s");

		$date = $doc->createElement('input');
        $date->setAttribute('type','hidden');
        $date->setAttribute('name','contractCreatedDateTime');
        $date->setAttribute('value',$datetime);
        $container->appendChild($date);

		$input = $doc->createElement('input');
        $input->setAttribute('type','hidden');
        $input->setAttribute('name','clientID');
        $input->setAttribute('value',$clientID);
        $container->appendChild($input);

        if ($id != '') {
            $query = "SELECT C.name as clientName, I.* FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} I) WHERE contractID = '$id' AND C.clientID = I.clientID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $clientID = $line['clientID'];
            $contractID = $line['contractID'];
            $contractStatus = $line['contractStatus'];
			$contractPrice = $line['price'];
			$contractPriceGST = $line['priceGST'];
            $createdDateTime = $line['createdDateTime'];
			$startDateArray = explode('-',$line['startDate']);
			$endDateArray = explode('-',$line['endDate']);
            $name = $line['name'];
			$clientName = $line['clientName'];
            $stationPresentsStatus = $line['stationPresentsStatus'];
            $audioPurchased = $line['audioPurchased'];
            $spotsPurchased = $line['spotsPurchased'];
            $services = $line['services'];
            $notes = $line['notes'];

			// Decode UTF-8 character encoding.
			$values = array(&$name,
							&$services,
							&$notes,
							&$clientName
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$query = "SELECT * FROM {$this->store->table_traffic_contractclientrep} WHERE contractID = '$id'";
			$result = sysdb::query($query);
			$clientRepIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($clientRepIDList, $line['clientRepID']);
			}

			$query = "SELECT * FROM {$this->store->table_traffic_contractsalesrep} WHERE contractID = '$id'";
			$result = sysdb::query($query);
			$salesRepIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($salesRepIDList, $line['salesRepID']);
			}
        } else {
			$query = "SELECT name FROM {$this->store->table_traffic_client} WHERE clientID = '$clientID'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$clientName = $line['name'];

            $contractID = '';
            $contractStatus = '';
			$contractPrice = '';
			$contractPriceGST = '';
            $createdDateTime = '';
            $startDateArray = array(date('Y'),date('n'),date('j'));
			$endDateArray = array(date('Y'),date('n'),date('j'));
            $name = '';
            $stationPresentsStatus = 'false';
            $audioPurchased = '';
            $spotsPurchased = '';
            $services = '';
            $notes = '';

			// If default statuses to Approved is enabled as a module parameter.
			global $module_parameter;
			if (isset($module_parameter['defaultStatusApproved']) && $module_parameter['defaultStatusApproved'] == '1') {
				$contractStatus = 'Approved';
			}
		}

		// $query = "SELECT C.name FROM {$this->store->table_traffic_client} WHERE clientID = '$clientID'";
		// $result = sysdb::query($query);
		// $line = sysdb::fetch_assoc($result);
		// $clientName = $line['name'];

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

        $contractStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract Status');
        $inputtd = $doc->createElement('td');
		$data = array( 'Proposed'=>'Proposed', 'Approved'=>'Approved', 'Invoiced'=>'Invoiced', 'Paid'=>'Paid', 'Cancelled'=>'Cancelled' );
        $input = dom::createDropdown( $doc, 'contractContractStatus', $data, $contractStatus );
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractStatustr->appendChild($labeltd);
        $contractStatustr->appendChild($inputtd);

		$pricetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Price (ex. GST)* $');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','contractPrice');
        $input->setAttribute('value',$contractPrice);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $pricetr->appendChild($labeltd);
        $pricetr->appendChild($inputtd);

		$priceGSTtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Price inc. GST');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode('$'.number_format($contractPriceGST, 2, '.', ','));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $priceGSTtr->appendChild($labeltd);
        $priceGSTtr->appendChild($inputtd);

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'contractStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'contractEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract Name *');
        $inputtd = $doc->createElement('td');
		$input = $doc->createTextNode($name);
        $inputHidden = $doc->createElement('input');
        $inputHidden->setAttribute('type','hidden');
        $inputHidden->setAttribute('name','contractName');
        $inputHidden->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
		$nametr->appendChild($inputHidden);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $stationPresentsStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Station Presents Status');
        $inputtd = $doc->createElement('td');
		$data = array( 'Yes'=>'true', 'No'=>'false' );
        $input = dom::createDropdown( $doc, 'contractStationPresentsStatus', $data, $stationPresentsStatus );
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $stationPresentsStatustr->appendChild($labeltd);
        $stationPresentsStatustr->appendChild($inputtd);

        $audioPurchasedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Audio Purchased *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','contractAudioPurchased');
        $input->setAttribute('value',$audioPurchased);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $audioPurchasedtr->appendChild($labeltd);
        $audioPurchasedtr->appendChild($inputtd);

        $spotsPurchasedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Spots Purchased *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','contractSpotsPurchased');
        $input->setAttribute('value',$spotsPurchased);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $spotsPurchasedtr->appendChild($labeltd);
        $spotsPurchasedtr->appendChild($inputtd);

        $servicestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Additional Services');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('textarea');
        $input->setAttribute('rows','4');
		$input->setAttribute('cols','16');
        $input->setAttribute('name','contractServices');
        $input->appendChild($doc->createTextNode($services));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $servicestr->appendChild($labeltd);
        $servicestr->appendChild($inputtd);

        $notestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Notes');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('textarea');
        $input->setAttribute('rows','4');
		$input->setAttribute('cols','16');
        $input->setAttribute('name','contractNotes');
        $input->appendChild($doc->createTextNode($notes));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $notestr->appendChild($labeltd);
        $notestr->appendChild($inputtd);

		$ClientRepIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
		$label = $doc->createTextNode('Assign Client Rep');
		$inputtd = $doc->createElement('td');

		$query = "SELECT I.clientRepID, D.firstName, D.lastName FROM ({$this->store->table_traffic_clientrep} I, {$this->store->table_detail} D, {$this->store->table_traffic_clientclientrep} R) WHERE R.clientID = $clientID AND I.clientRepID = R.clientRepID AND I.actorID = D.actorID";
		$result = sysdb::query($query);

		if (sysdb::num_rows($result) <= 0) {
			// Can't find any Client Reps associated with our Client.
			$input = $doc->createTextNode('Client has no reps');
		} else {
			$input = $doc->createElement('select');
			$input->setAttribute('name','contractClientRepIDList[]');

			$inputOption = $doc->createElement('option');
			$inputOption->setAttribute('value','');
			$input->appendChild($inputOption);
			$i = 0;
			while ($line = sysdb::fetch_assoc($result)) {
				$inputOption = $doc->createElement('option');
				if ( isset($clientRepIDList)) {
					// Display the previously assigned rep.
					if ( in_array($line['clientRepID'],$clientRepIDList) )
						$inputOption->setAttribute('selected','selected');
				} else {
					// Select the first rep as the default value when adding a new contract.
					if ($i == 0)
						$inputOption->setAttribute('selected','selected');
				}
				$inputOption->setAttribute('value',$line['clientRepID']);
				$inputOption->appendChild($doc->createTextNode($line['firstName'].' '.$line['lastName']));
				$input->appendChild($inputOption);
				$i++;
			}
		}

		$inputtd->appendChild($input);
		$labeltd->appendChild($label);
		$ClientRepIDtr->appendChild($labeltd);
		$ClientRepIDtr->appendChild($inputtd);

		$SalesRepIDtr = $doc->createElement('tr');
		$SalesRepIDtr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Assign Sales Rep'));
		$inputtd = $doc->createElement('td');
		$input = $doc->createElement('select');
		$input->setAttribute('name','contractSalesRepIDList[]');
		$input->setAttribute('id','contractSalesRepIDList');

		$query = <<<EOQ
			SELECT I.{$this->store->field_salesrep_salesRepID} as salesRepID,
				D.{$this->store->field_detail_firstName} AS firstName,
				D.{$this->store->field_detail_lastName} AS lastName
			FROM ({$this->store->table_traffic_salesrep} I,
				{$this->store->table_detail} D)
			WHERE I.{$this->store->field_salesrep_actorID} = D.{$this->store->field_detail_actorID}
EOQ;
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($salesRepIDList)) {
				if ( in_array($line['salesRepID'],$salesRepIDList) )
					$inputOption->setAttribute('selected','selected');
			} else {
				// Try select the currently authenticated user by default.
				$user = new user();
				$myActorID = $user->getActorID();
				// $myActorID = user::userActorID($login='');
				if ($myActorID != '') {
					$query = <<<EOQ
						SELECT {$this->store->field_salesrep_salesRepID}
						FROM {$this->store->table_traffic_salesrep}
						WHERE {$this->store->field_salesrep_actorID} = '$myActorID'
EOQ;
					$myAssignID = sysdb::queryOne($query);
					if ($line['salesRepID'] == $myAssignID)
						$inputOption->setAttribute('selected','selected');
				}
			}
			$inputOption->setAttribute('value',$line['salesRepID']);
			$inputOption->appendChild($doc->createTextNode($line['firstName'].' '.$line['lastName']));
			$input->appendChild($inputOption);
		}

		// Start of show toggleSalesRepForm.
		$inputtd->appendChild($divShowSalesRep = $doc->createElement('div'));
		$divShowSalesRep->setAttribute('id','show_salesrep');
		$divShowSalesRep->appendChild($divButtonShowSalesRep = $doc->createElement('div'));
		$divButtonShowSalesRep->appendChild($spanButtonShowSalesRep = $doc->createElement('span'));
		$spanButtonShowSalesRep->setAttribute('class', 'link_button');
		$spanButtonShowSalesRep->setAttribute("onclick", "toggleSalesRepForm('hide_salesrep','show_salesrep');");
		$spanButtonShowSalesRep->appendChild($aShowSalesRep = $doc->createElement('a'));
		$aShowSalesRep->setAttribute('title', 'Add New Sales Rep');
		$aShowSalesRep->setAttribute('class', 'link_button');
		$aShowSalesRep->appendChild($spanShowSalesRep = $doc->createElement('span'));
		$spanShowSalesRep->setAttribute('class', 'link_add');
		$spanShowSalesRep->appendChild($textShowSalesRep = $doc->createTextNode('Add New Sales Rep'));

		$divShowSalesRep->appendChild($input);
		// End of show toggleSalesRepForm.

		// Start of hide toggleSalesRepForm.
		$inputtd->appendChild($divHideSalesRep = $doc->createElement('div'));
		$divHideSalesRep->setAttribute('id','hide_salesrep');
		$divHideSalesRep->appendChild($divButtonHideSalesRep = $doc->createElement('div'));
		$divButtonHideSalesRep->appendChild($spanButtonHideSalesRep = $doc->createElement('span'));
		$spanButtonHideSalesRep->setAttribute('class', 'link_button');
		$spanButtonHideSalesRep->setAttribute("onclick", "toggleSalesRepForm('hide_salesrep','show_salesrep');");
		$spanButtonHideSalesRep->appendChild($aHideSalesRep = $doc->createElement('a'));
		$aHideSalesRep->setAttribute('title', 'Select Existing Sales Rep');
		$aHideSalesRep->setAttribute('class', 'link_button');
		$aHideSalesRep->appendChild($spanHideSalesRep = $doc->createElement('span'));
		$spanHideSalesRep->setAttribute('class', 'link_add');
		$spanHideSalesRep->appendChild($textHideSalesRep = $doc->createTextNode('Select Existing Sales Rep'));

		$divHideSalesRep->appendChild(SalesRep::inline_form($doc,'',true));
		// End of hide toggleSalesRepForm.

		$SalesRepIDtr->appendChild($inputtd);

		$table->appendChild($clientNametr);
		if ($id != '') $table->appendChild($nametr);
		$table->appendChild($contractStatustr);
		$table->appendChild($pricetr);
		if ($id != '') $table->appendChild($priceGSTtr);
		$table->appendChild($audioPurchasedtr);
		$table->appendChild($spotsPurchasedtr);
		$table->appendChild($servicestr);
		$table->appendChild($notestr);
		$table->appendChild($stationPresentsStatustr);
		$table->appendChild($startDatetr);
		$table->appendChild($endDatetr);
		$table->appendChild($ClientRepIDtr);
		$table->appendChild($SalesRepIDtr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);

        return($container);
    }

    public function view($doc, $id) {
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');
		switch(globalize('extras','Campaign')) {
			case 'Campaign':
				$campaign = new Campaign();
				$container->appendChild($campaign->inline_list($doc,'',true));
				break;
			case 'CampaignAudio':
				$campaignAudio = new CampaignAudio();
				$container->appendChild($campaignAudio->inline_list($doc,'',true));
				break;
			case 'Log':
				$log = new Log();
				$container->appendChild($log->inline_list($doc,'',true));
				break;
		}
		$containerLeft = $doc->createElement('div');
		$containerLeft->setAttribute('class','module_left');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Contract'));
		$containerLeft->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $span->appendChild(module::link_to_script_dom($doc,'Add Campaign','',array('item'=>'Campaign','action'=>'edit','contractID'=>$id),'Add Campaign'));
		// $containerLeft->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Campaign','',array('item'=>'Campaign','action'=>'edit','contractID'=>$id),'Add Campaign','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Campaign');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$containerLeft->appendChild($spanbutton);
//		$containerLeft->appendChild($doc->createElement('br'));
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $containerLeft->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$containerLeft->appendChild($spanbutton);

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Export Contract','',array('item'=>'ContractXML','action'=>'getContractSVG','id'=>$id),'Export Contract','link_button','_blank');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Export Contract');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$containerLeft->appendChild($spanbutton);

		$containerLeft->appendChild($spanbutton = Template::clone_contract_button_ui($doc, $id));

 		$containerLeft->appendChild($spanbutton = Defer::defer_schedule_button_ui($doc, $id));

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        $contractID = $doc->createElement('input');
        $contractID->setAttribute('type','hidden');
        $contractID->setAttribute('name','contractID');
        $contractID->setAttribute('value',$id);
        $containerLeft->appendChild($contractID);

        $query = "SELECT C.name as clientName, I.* FROM ({$this->store->table_traffic_contract} I, {$this->store->table_traffic_client} C) WHERE I.contractID = '$id' AND C.clientID = I.clientID";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $contractID = $line['contractID'];
        $contractStatus = $line['contractStatus'];
		$contractPrice = $line['price'];
		$contractPriceGST = $line['priceGST'];
        $createdDateTime = date("d-M-Y H:i:s", strtotime($line['createdDateTime']));
        $startDate = date("d-M-Y", strtotime($line['startDate']));
        $endDate = date("d-M-Y", strtotime($line['endDate']));
        $name = $line['name'];
		$clientName = $line['clientName'];
        $stationPresentsStatus = $line['stationPresentsStatus'];
        $audioPurchased = $line['audioPurchased'];
        $spotsPurchased = $line['spotsPurchased'];
        $services = $line['services'];
        $notes = $line['notes'];
		$clientID = $line['clientID'];

		// Decode UTF-8 character encoding.
		$values = array(&$name,
						&$services,
						&$notes,
						&$clientName
						);
		foreach ($values as &$value) {
			$value = utf8_decode($value);
		}
		unset($value);

		$queryclientRep = "SELECT D.firstName, D.lastName FROM ({$this->store->table_traffic_contractclientrep} C, {$this->store->table_traffic_clientrep} P, {$this->store->table_detail} D) WHERE C.contractID = '$id' AND P.clientRepID = C.clientRepID AND D.actorID = P.actorID";
        $resultclientRep = sysdb::query($queryclientRep);

		$clientRepNames = array();
		while ($linename = sysdb::fetch_assoc($resultclientRep)) {
			array_push($clientRepNames, $linename['firstName'].' '.$linename['lastName']);
		}

		$querysalesRep = "SELECT D.firstName as firstName, D.lastName as lastName, D.actorID as actorID FROM ({$this->store->table_traffic_contractsalesrep} C, {$this->store->table_traffic_salesrep} P, {$this->store->table_detail} D) WHERE C.contractID = '$id' AND C.salesRepID = P.salesRepID AND P.actorID = D.actorID";
        $resultsalesRep = sysdb::query($querysalesRep);

		$salesRepNames = array();
		while ($linename = sysdb::fetch_assoc($resultsalesRep)) {
			$salesRepFirstName = $linename['firstName'];
			$salesRepLastName = $linename['lastName'];
			$salesRepActorID = $linename['actorID'];

			if ($salesRepFirstName == '' && $salesRepLastName == '') {

				// If the name is blank, display the username and login info instead.
				$query = "SELECT name as name, login as login FROM ({$this->store->table_user}) WHERE actorID = '$salesRepActorID'";
				$result = sysdb::query($query);
				$line = sysdb::fetch_assoc($result);
				$userName = $line['name'];
				$userLogin = $line['login'];

				array_push($salesRepNames, $userName.' ('.$userLogin.')');
			} else {
				array_push($salesRepNames, $salesRepFirstName.' '.$salesRepLastName);
			}
		}

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name');
        $inputtd = $doc->createElement('td');
        $inputtd->setAttribute('class','name');
        $input = $doc->createTextNode($name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($clientName);
        $labeltd->appendChild($label);
        $inputtd->appendChild(module::link_to_script_dom($doc,$clientName,'',array('item'=>'Client','action'=>'view','id'=>$clientID),'View'));
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

        $contractStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract Status');
        $inputtd = $doc->createElement('td');
		$class = $this->contract_status($contractStatus);
        $inputtd->setAttribute('class',$class);
        $input = $doc->createTextNode($contractStatus);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractStatustr->appendChild($labeltd);
        $contractStatustr->appendChild($inputtd);

		$pricetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Price (ex. GST)');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode('$'.number_format($contractPrice, 2, '.', ','));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $pricetr->appendChild($labeltd);
        $pricetr->appendChild($inputtd);

		$priceGSTtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Price (inc. GST)');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode('$'.number_format($contractPriceGST, 2, '.', ','));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $priceGSTtr->appendChild($labeltd);
        $priceGSTtr->appendChild($inputtd);

        $createdDateTimetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Created');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($createdDateTime);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $createdDateTimetr->appendChild($labeltd);
        $createdDateTimetr->appendChild($inputtd);

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($startDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($endDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

		// Human readable boolean.
		if ($stationPresentsStatus == 'true') {
			$stationPresentsDisplay = 'Yes';
		} else if ($stationPresentsStatus == 'false') {
			$stationPresentsDisplay = 'No';
		} else {
			// Error.
			$stationPresentsDisplay = 'unknown';
		}
        $stationPresentsStatustr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Station Presents Status');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($stationPresentsDisplay);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $stationPresentsStatustr->appendChild($labeltd);
        $stationPresentsStatustr->appendChild($inputtd);

        $audioPurchasedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Audio Purchased');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($audioPurchased);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $audioPurchasedtr->appendChild($labeltd);
        $audioPurchasedtr->appendChild($inputtd);

        $spotsPurchasedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Spots Purchased');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($spotsPurchased);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $spotsPurchasedtr->appendChild($labeltd);
        $spotsPurchasedtr->appendChild($inputtd);

        $servicestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Additional Services');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($services);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $servicestr->appendChild($labeltd);
        $servicestr->appendChild($inputtd);

        $notestr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Notes');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($notes);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $notestr->appendChild($labeltd);
        $notestr->appendChild($inputtd);

		$contractClientReptr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client Rep');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($clientRepNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $contractClientReptr->appendChild($labeltd);
        $contractClientReptr->appendChild($inputtd);

		$contractSalesReptr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Sales Rep');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($salesRepNames as $salesRepName) {
			$input = $doc->createTextNode($salesRepName);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $contractSalesReptr->appendChild($labeltd);
        $contractSalesReptr->appendChild($inputtd);

        $table->appendChild($nametr);
		$table->appendChild($clientNametr);
        $table->appendChild($contractStatustr);
        $table->appendChild($pricetr);
        $table->appendChild($priceGSTtr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
        $table->appendChild($stationPresentsStatustr);
        $table->appendChild($audioPurchasedtr);
        $table->appendChild($spotsPurchasedtr);
        $table->appendChild($servicestr);
        $table->appendChild($notestr);
        $table->appendChild($createdDateTimetr);
        $table->appendChild($contractClientReptr);
        $table->appendChild($contractSalesReptr);

		$containerLeft->appendChild($table);

		$containerLeft->appendChild(Notes::form($doc,$id));

		$container->appendChild($containerLeft);

		$moduleFooter = $doc->createElement('div');
		$moduleFooter->setAttribute('class','clear_both');
		$container->appendChild($moduleFooter);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $query = <<<EOQ
            SELECT C.name AS clientName, I.clientID, I.contractID, I.name, I.contractStatus, I.startDate, I.endDate
            FROM ({$this->store->table_traffic_contract} I, {$this->store->table_traffic_client} C)
            WHERE C.clientID = I.clientID
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND I.contractID IN (".implode(',',$ids).") ";
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

		$col1 = $doc->createElement('col');
        $table->appendChild($col1);

		$col2 = $doc->createElement('col');
        $table->appendChild($col2);

		$col3 = $doc->createElement('col');
        $table->appendChild($col3);

		$col4 = $doc->createElement('col');
        $table->appendChild($col4);

		$colactions = $doc->createElement('col');
		//$colactions->setAttribute('width', '56px');
        $table->appendChild($colactions);

        $tr = $doc->createElement('tr');
        $nametd = $doc->createElement('th');
        $clientNametd = $doc->createElement('th');
        $contractStatustd = $doc->createElement('th');
        $startDatetd = $doc->createElement('th');
        $endDatetd = $doc->createElement('th');

        $nametd->appendChild($doc->createTextNode('Name'));
        $clientNametd->appendChild($doc->createTextNode('Client'));
        $contractStatustd->appendChild($doc->createTextNode('Status'));
        $startDatetd->appendChild($doc->createTextNode('Start'));
        $endDatetd->appendChild($doc->createTextNode('End'));
        $actiontd = $doc->createElement('td');
        $actiontd->setAttribute('style','text-align: right;');
        $actiontd->appendChild(module::link_to_script_dom($doc,'add','',array('item'=>globalize('item', get_class($this)),'action'=>'edit'),'Add'));

        $tr->appendChild($nametd);
        $tr->appendChild($clientNametd);
        $tr->appendChild($contractStatustd);
        $tr->appendChild($startDatetd);
        $tr->appendChild($endDatetd);
        //$tr->appendChild($actiontd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No contracts entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $nametd = $doc->createElement('td');
            $clientNametd = $doc->createElement('td');
            $contractStatustd = $doc->createElement('td');
            $startDatetd = $doc->createElement('td');
            $endDatetd = $doc->createElement('td');

            $nametd->appendChild(module::link_to_script_dom($doc,$line['name'],'',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['contractID']),'View'));
            $clientNametd->appendChild(module::link_to_script_dom($doc,$line['clientName'],'',array('item'=>'Client','action'=>'view','id'=>$line['clientID']),'View'));
			$contractStatustd->appendChild($doc->createTextNode($line['contractStatus']));
			$class = $this->contract_status($line['contractStatus']);
			$contractStatustd->setAttribute('class',$class);
			$startDatetd->appendChild($doc->createTextNode(date("d-M-Y", strtotime($line['startDate']))));
			$endDatetd->appendChild($doc->createTextNode(date("d-M-Y", strtotime($line['endDate']))));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['contractID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['contractID']),'Edit'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
            $actiontd->appendChild($span = $doc->createElement('span'));
            $span->setAttribute('class','link_traffic_small');
            $span->appendChild(module::link_to_script_dom_unappended($doc,'View Traffic','',
                            array('item'=>'Traffic',
                                  'mode'=>'Contract',
                                  'contractID'=>$line['contractID'],
                                    ),'View Traffic','link_traffic_small'));
            $table->appendChild($tr);
            $tr->appendChild($nametd);
			$tr->appendChild($clientNametd);
            $tr->appendChild($contractStatustd);
            $tr->appendChild($startDatetd);
            $tr->appendChild($endDatetd);
            $tr->appendChild($actiontd);
			$i++;
        }
        $tr = $doc->createElement('tr');
        $actiontd = $doc->createElement('td');
        $actiontd->setAttribute('colspan','5');
        $actiontd->setAttribute('style','text-align: right;');
        $actiontd->appendChild(module::link_to_script_dom($doc,'add','',array('item'=>globalize('item', get_class($this)),'action'=>'edit'),'Add'));

        //$table->appendChild($tr);
        $tr->appendChild($actiontd);

        return($table);
    }

    public function overview($doc,$ids='',$isInclude=false) {
		$startsWith = globalize('startswith');
		$contractSearchColumn = globalize('contractSearchColumn');
		$contractSearchAction = globalize('contractSearchAction');
		$contractSearchText = globalize('contractSearchText');

		$container = $doc->createElement('div');
		if ( $isInclude ) {
			$item = get_class($this);
			$parentID = globalize('id');
			$parentIDType = globalize('item', get_class($this));
			switch ($parentIDType) {
				case 'Client':
					$parentFieldName = 'clientID';
					break;
				default:
					$isInclude = false;
					$warning_message = "Not a valid parent.";
					break;
			}
			$container->setAttribute('class','module_left');
			$container->appendChild($this->include_header($doc,$parentID));
		} else {
			$item = globalize('item', get_class($this));
			$container->setAttribute('class','module');
		}

        $query = "SELECT I.contractID FROM ({$this->store->table_traffic_contract} I, {$this->store->table_traffic_client} C) WHERE C.clientID = I.clientID";

		if ( $startsWith != '' ) {
			$query .= " AND I.name LIKE '".$startsWith."%'";
		} elseif ($contractSearchText != '') {

			// Which column does the user want to search in?
			// Default searches the contract name column
			switch ($contractSearchColumn) {
				case 'name':
					$column = "I.name";
					break;
				case 'client':
					$column = "C.name";
					break;
				case 'status':
					$column = "I.contractStatus";
					break;
				default:
					$column = "I.name";
					break;
			}

		}

		if ( $isInclude )
			$query .= " AND I.$parentFieldName = '$parentID'";

        $query .= " ORDER BY endDate, startDate ";
        $ids = sysdb::query2vector($query,'contractID');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Contracts'));
		$container->appendChild($header);

		$searchLetters = $doc->createElement('div');
		$searchLetters->setAttribute('class','search_letters');
		$searchLetters->appendChild($doc->createTextNode('Browse: '));
		foreach ( range('A','Z') as $c ) {
			$searchLetters->appendChild(module::link_to_script_dom($doc,$c,'',array('item'=>globalize('item', get_class($this)),'action'=>'search','startswith'=>$c),'Starts with '.$c));
			$searchLetters->appendChild($doc->createTextNode(' '));
		}
		$container->appendChild($searchLetters);

		if ($startsWith != '') $container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = <<<EOQ
            SELECT {$this->store->field_contract_contractID} as contractID,
				{$this->store->field_contract_name} as name
            FROM {$this->store->table_traffic_contract}
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' WHERE 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " WHERE {$this->store->field_contract_contractID} IN (".implode(',',$ids).")";
        $query .= " ORDER BY {$this->store->field_contract_endDate}, {$this->store->field_contract_startDate}";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','contractID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No contracts available');
            $option->appendChild($text);
            $select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('Please select a Contract...');
            $option->appendChild($text);
            $select->appendChild($option);
            while ($line = sysdb::fetch_assoc($result)) {
                $option = $doc->createElement('option');
                $option->setAttribute('value',$line['contractID']);
                $text = $doc->createTextNode($line['name']);
                $option->appendChild($text);
                if ($default == $line['contractID']) $option->setAttribute('selected','selected');
                $select->appendChild($option);
            }
        }

        return($select);
    }

    public function add($createdDateTime,$startYear,$startMonth,$startDay,
						$endYear,$endMonth,$endDay,$contractStatus,$contractPrice,
						$stationPresentsStatus,$audioPurchased,
						$spotsPurchased,$services,$notes,$clientID,$clientRepIDList,$salesRepIDList,$salesRepActorID) {
		// Escape values.
		$values = array(&$services,
						&$notes
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Format integers to strip thousand-separators.
		$values = array(&$audioPurchased,
						&$spotsPurchased
						);
 		foreach ($values as &$value) {
			$value = number_format((float)str_replace(',', '', $value), 0, '', '');
		}
		unset($value);

		// Format currency integers to strip thousand-separators and round to cents.
		$values = array(&$contractPrice
						);
 		foreach ($values as &$value) {
			$value = number_format((float)str_replace(',', '', $value), 2, '.', '');
		}
		unset($value);

		$errors = false;
		$item = globalize('item', get_class($this));
		global $module_parameter;
		if ( $module_parameter['gstEnabled'] == '1' )
			$priceGST = $contractPrice + ($contractPrice * ( $module_parameter['gstPercentage'] / 100 ));
		else
			$priceGST = '';

		if (!checkdate($startMonth,$startDay,$startYear)) {
			state::setMessage('warning', 'Invalid start date.');
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			state::setMessage('warning', 'Invalid end date.');
			$errors = true;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ( !$errors ) {

			$query = "INSERT INTO {$this->store->table_traffic_contract} (createdDateTime,startDate,endDate,contractStatus,price,priceGST,stationPresentsStatus,audioPurchased,spotsPurchased,services,notes,clientID) VALUES ('$createdDateTime','$startDate','$endDate','$contractStatus','$contractPrice','$priceGST','$stationPresentsStatus','$audioPurchased','$spotsPurchased','$services','$notes','$clientID')";
			$result = sysdb::query($query);
			$contractID = sysdb::insert_id();
			/** @todo Turn 06d into a moduleparameter to allow specification of digit length. */
			$name = sprintf($module_parameter['contractNamePrefix']."%06d",$contractID);
			$query = "UPDATE {$this->store->table_traffic_contract} SET name = '$name' WHERE contractID = '$contractID'";
			$result = sysdb::query($query);
			state::setMessage('notify', 'Successfully added new contract: '.utf8_decode($name));

			if (!empty($clientRepIDList)) {
				foreach($clientRepIDList as $clientRepID ) {
					if ($clientRepID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_contractclientrep} (clientRepID,contractID) VALUES ('$clientRepID','$contractID')";
						$result = sysdb::query($query);
					}
				}
			}

			// If details for a new Sales Rep was added on the inline form, add it.
			if ($salesRepActorID != '') {
				SalesRep::add($salesRepActorID);

				// Fetch the newly inserted salesRepID and add it into the contractsalesrep table.
				$query = <<<EOQ
					INSERT INTO {$this->store->table_traffic_contractsalesrep} (
						{$this->store->field_contractsalesrep_salesRepID},
						{$this->store->field_contractsalesrep_contractID}
					)
					SELECT {$this->store->field_salesrep_salesRepID} AS {$this->store->field_contractsalesrep_salesRepID},
						'$contractID' AS {$this->store->field_contractsalesrep_contractID}
					FROM {$this->store->table_traffic_salesrep}
					WHERE {$this->store->field_salesrep_actorID} = '$salesRepActorID'
EOQ;
				sysdb::query($query);
/*
			}
			if (!empty($salesRepIDList)) {
*/
			// The above two lines of code are replaced by the following elseif statement because currently
			// only one salesrep may be assigned to each contract. So $salesRepActorID overrides $salesRepIDList.
			// If you want to be able to assign multiple salesreps, replace the elseif and change the input box
			// to a multi-select box instead of a combo box.
			} elseif (!empty($salesRepIDList)) {
				foreach($salesRepIDList as $salesRepID ) {
					if ($salesRepID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_contractsalesrep} (salesRepID,contractID) VALUES ('$salesRepID','$contractID')";
						$result = sysdb::query($query);
					}
				}
			}
            // Forward user to new Campaign if not using function from foreign class.
			if ($item == 'Contract') {
				module::forward_to_script('',array('item'=>'Campaign','action'=>'edit','contractID'=>$contractID));
			}
			//module::forward_to_script('',array('item'=>'Contract','action'=>'view','id'=>$contractID));
		}

    }

    public function save($id,$startYear,$startMonth,$startDay,
							$endYear,$endMonth,$endDay,$name,
							$contractStatus,$contractPrice,$stationPresentsStatus,
							$audioPurchased,$spotsPurchased,$services,$notes,$clientRepIDList,$salesRepIDList,$salesRepActorID) {
		// Escape values.
		$values = array(&$name,
						&$services,
						&$notes
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Format integers to strip thousand-separators.
		$values = array(&$audioPurchased,
						&$spotsPurchased
						);
 		foreach ($values as &$value) {
			$value = number_format(str_replace(',', '', $value), 0, '', '');
		}
		unset($value);

		// Format currency integers to strip thousand-separators and round to cents.
		$values = array(&$contractPrice
						);
 		foreach ($values as &$value) {
			$value = number_format(str_replace(',', '', $value), 2, '.', '');
		}
		unset($value);

		$errors = false;
		global $module_parameter;
		if ( $module_parameter['gstEnabled'] == '1' )
			$priceGST = $contractPrice + ($contractPrice * ( $module_parameter['gstPercentage'] / 100 ));
		else
			$priceGST = '';

		if (!checkdate($startMonth,$startDay,$startYear)) {
			state::setMessage('warning', 'Invalid start date.');
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			state::setMessage('warning', 'Invalid end date.');
			$errors = true;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ( !$errors ) {
			/* Retrieve contract status prior to saving new data */
			$query = "SELECT contractStatus FROM {$this->store->table_traffic_contract} WHERE contractID = '$id'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$emailPrior_state = $line['contractStatus'];

			$query = "UPDATE {$this->store->table_traffic_contract} SET startDate = '$startDate', endDate = '$endDate', name = '$name', contractStatus = '$contractStatus', price = '$contractPrice', priceGST = '$priceGST', stationPresentsStatus = '$stationPresentsStatus', audioPurchased = '$audioPurchased', spotsPurchased = '$spotsPurchased', services = '$services', notes = '$notes' WHERE contractID = '$id'";
			$result = sysdb::query($query);
			state::setMessage('notify', 'Successfully updated contract: '.utf8_decode($name));

			/* If the contract status has been changed, send the required notification emails */
			if ($contractStatus != $emailPrior_state) {
				$notification_type = $this->contract_status($contractStatus);
				$email_success = email_notification($id,$notification_type,$emailPrior_state);
				if ($email_success) state::setMessage('notify', "Sent notification email of contract status change from '".$emailPrior_state."' to '".$contractStatus."'");
			}

			// Purge existing client rep assignments for contract.
			$query = "DELETE FROM {$this->store->table_traffic_contractclientrep} WHERE contractID = '$id'";
			sysdb::query($query);

			if (!empty($clientRepIDList)) {
				foreach($clientRepIDList as $clientRepID) {
					if ($clientRepID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_contractclientrep} (clientRepID,contractID) VALUES ('$clientRepID','$id')";
						$result = sysdb::query($query);
					}
				}
			}

			// Purge existing sales rep assignments for contract.
			$query = "DELETE FROM {$this->store->table_traffic_contractsalesrep} WHERE contractID = '$id'";
			sysdb::query($query);

			if ($salesRepActorID != '') {
				SalesRep::add($salesRepActorID);

				// Fetch the newly inserted salesRepID and add it into the contractsalesrep table.
				$query = <<<EOQ
					INSERT INTO {$this->store->table_traffic_contractsalesrep} (
						{$this->store->field_contractsalesrep_salesRepID},
						{$this->store->field_contractsalesrep_contractID}
					)
					SELECT {$this->store->field_salesrep_salesRepID} AS {$this->store->field_contractsalesrep_salesRepID},
						'$id' AS {$this->store->field_contractsalesrep_contractID}
					FROM {$this->store->table_traffic_salesrep}
					WHERE {$this->store->field_salesrep_actorID} = '$salesRepActorID'
EOQ;
				sysdb::query($query);
/*
			}
			if (!empty($salesRepIDList)) {
*/
			// The above two lines of code are replaced by the following elseif statement because currently
			// only one salesrep may be assigned to each contract. So $salesRepActorID overrides $salesRepIDList.
			// If you want to be able to assign multiple salesreps, replace the elseif and change the input box
			// to a multi-select box instead of a combo box.
			} elseif (!empty($salesRepIDList)) {
				foreach($salesRepIDList as $salesRepID) {
					if ($salesRepID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_contractsalesrep} (salesRepID,contractID) VALUES ('$salesRepID','$id')";
						$result = sysdb::query($query);
					}
				}
			}
			module::forward_to_script('',array('item'=>'Contract','action'=>'view','id'=>$id));
		}
    }

    public function cancel($id) {
		// Cancel remove action and return to edit page.
        $item = globalize('item', get_class($this));
        module::forward_to_script('',array('item'=>$item,'action'=>'edit','id'=>$id));
		return;
    }

    public function remove($id) {
		// The core message display uses 'echo' type page assembly instead of DOMDocument.
        $item = globalize('item', get_class($this));
		$message = '<p>Are you really sure you want to delete this Contract item?</p>';
		$message .= '<p>The item and all its daughter campaigns, audio and spots will be permanently deleted if you proceed.</p>';
		$message .= '<div class="message_buttons">';
		$message .= '<div class="left">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Yes, Delete', '', array('item' => $item, 'action' => 'delete', 'id' => $id), false, false, 'Yes, Delete', 'link_button');
		$message .= '" title="Delete" class="link_button">';
		$message .= '<span class="link_delete">Yes, Delete</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '<div class="right">';
		$message .= '<span class="link_button">';
		$message .= '<a href="';
		$message .= module::link_to_script('Cancel', '', array('item' => $item, 'action' => 'cancel', 'id' => $id), false, false, 'Cancel', 'link_button');
		$message .= '" title="Cancel" class="link_button">';
		$message .= '<span class="link_delete">Cancel</span>';
		$message .= '</a>';
		$message .= '</span>';
		$message .= '</div>';
		$message .= '</div>';
		state::setMessage('warning', $message);
		return;
    }

    public function delete($id) {
		$success = false;

        $query = <<<EOQ
            SELECT {$this->store->field_contract_name}
			FROM {$this->store->table_traffic_contract}
			WHERE {$this->store->field_contract_contractID} = '$id'
EOQ;
		$contractName = sysdb::queryOne($query);

		// Delete daughter campaigns.
        $query = <<<EOQ
            SELECT {$this->store->field_campaign_campaignID} AS campaignID
			FROM {$this->store->table_traffic_campaign}
			WHERE {$this->store->field_campaign_contractID} = '$id'
EOQ;
		$result = sysdb::query($query);
		if (sysdb::num_rows($result) > 0) {
			while ($line = sysdb::fetch_assoc($result)) {
				$status = Campaign::delete($line['campaignID']);
				if ($status) {
					$success = true;
				} else {
					state::setMessage('warning', 'Could not delete campaigns.');
					$success = false;
				}
			}
		}

		// Proceed if all daughter objects successfully removed.
		if ($success) {
			// Remove assignments for contract.
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_contractclientrep}
				WHERE {$this->store->field_contractclientrep_contractID} = '$id'
EOQ;
			sysdb::query($query);

			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_contractsalesrep}
				WHERE {$this->store->field_contractclientrep_contractID} = '$id'
EOQ;
			sysdb::query($query);

			// Remove campaign.
			$query = <<<EOQ
				DELETE FROM {$this->store->table_traffic_contract}
				WHERE {$this->store->field_contract_contractID} = '$id'
EOQ;
			sysdb::query($query);

			state::setMessage('notify', 'Successfully deleted contract: '.utf8_decode($contractName));
		}
		return $success;
    }

    public function search($doc,$string) {
        $string = strtolower($string);
        $query = "SELECT contractID FROM {$this->store->table_traffic_contract} WHERE LCASE(name) LIKE '%$string%' OR startDate LIKE '%$string%' OR endDate LIKE '%$string%' OR 'email' LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'contractID')));
        }
    }

	public function include_header($doc,$parentIDType) {

		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		$item = globalize('item', get_class($this));
		$id = globalize('id');
		$extras = globalize('extras');
		$includeHeader = $doc->createElement('div');
		$includeHeader->setAttribute('id', 'inline_menu');

		$link = module::link_to_script_dom($doc,'Contracts','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Contract'),'Contracts');
		$contractsLink = $doc->createElement('span');
		if ($extras == 'Contract' || $extras == '')
			$contractsLink->setAttribute('id', 'link_contracts_selected');
		else
			$contractsLink->setAttribute('id', 'link_contracts');
		$contractsLink->setAttribute('class', 'inline_link');
		$contractsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Campaigns','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Campaign'),'Campaigns');
		$campaignsLink = $doc->createElement('span');
		$campaignsLink->setAttribute('id', 'link_campaigns');
		$campaignsLink->setAttribute('class', 'inline_link');
		$campaignsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Audio','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignAudio'),'Audio');
		$campaignAudioLink = $doc->createElement('span');
		$campaignAudioLink->setAttribute('id', 'link_campaign_audio');
		$campaignAudioLink->setAttribute('class', 'inline_link');
		$campaignAudioLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Traffic','',array('item'=>'Traffic','mode'=>$item,$parentFieldName=>$id),'Traffic');
		$trafficLink = $doc->createElement('span');
		$trafficLink->setAttribute('id', 'link_traffic');
		$trafficLink->setAttribute('class', 'inline_link');
		$trafficLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Log','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Log'),'Log');
		$logLink = $doc->createElement('span');
		$logLink->setAttribute('id', 'link_logs');
		$logLink->setAttribute('class', 'inline_link');
		$logLink->appendChild($link);


		/* 	This switch is specifically designed *without* break statements.
			This is because once we hit our current item, all those below it are required as well.
			-CH
		*/
		switch ($item) {
			case 'Client':
				$includeHeader->appendChild($contractsLink);
			case 'Contract':
				$includeHeader->appendChild($campaignsLink);
			case 'Campaign':
				$includeHeader->appendChild($campaignAudioLink);
				$includeHeader->appendChild($logLink);
				$includeHeader->appendChild($trafficLink);
				break;
		}

		return $includeHeader;
	}

    public function inline_list($doc,$ids='',$isInclude=false) {
		$item = get_class($this);
		$parentID = globalize('id');
		$parentIDType = globalize('item', get_class($this));
		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		if ($parentIDType == 'Client')
			$x = 'C';
		if ($parentIDType == 'Contract')
			$x = 'T';
		if ($parentIDType == 'Campaign')
			$x = 'G';
		$query = "SELECT $x.name FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} T, {$this->store->table_traffic_campaign} G) WHERE $x.$parentFieldName = '$parentID' AND C.clientID = $x.clientID";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$caption_name = utf8_decode($line['name']);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module_right');
		$container->appendChild($this->include_header($doc,$parentIDType));

		$sortby = globalize('sortby');
		if (!isset($sortby))
			$sortby = 'contractname';
		else {
			switch($sortby) {
				case 'contractname':
							break;
				case 'contractstatus':
							$sortby = 'contractStatus';
							break;
				case 'enddate':
							$sortby = 'endDate';
							break;
				default:
							$sortby = 'contractname';
							break;
			}
		}

		function inline_list_actions($doc,$id) {
			$div = $doc->createElement('div');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
			/* I had to substitute the $item variable for the hardcoded 'Contract' because using the variable would require modification of the db.php callback */
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>'Contract','action'=>'view','id'=>$id),'View'));
            $div->appendChild($span);
			$div->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>'Contract','action'=>'edit','id'=>$id),'Edit'));
            $div->appendChild($span);
			return $div;
		}

		function inline_list_header($doc) {
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			$th1 = $doc->createElement('th');
			$th2 = $doc->createElement('th');
			$th3 = $doc->createElement('th');
			$actiontd = $doc->createElement('th');
			$actiontd->setAttribute('class', 'action');
			/* I had to substitute the $extras variable for the hardcoded 'Contract' because using the variable would require modification of the db.php callback */
			$th1->appendChild(module::link_to_script_dom($doc,'Contract #','',array('item'=>$parentIDType,'extras'=>'Contract','action'=>'view','id'=>$parentID,'sortby'=>'name'),'Contract #'));
			$th2->appendChild(module::link_to_script_dom($doc,'Status','',array('item'=>$parentIDType,'extras'=>'Contract','action'=>'view','id'=>$parentID,'sortby'=>'contractstatus'),'Status'));
			$th3->appendChild(module::link_to_script_dom($doc,'End Date','',array('item'=>$parentIDType,'extras'=>'Contract','action'=>'view','id'=>$parentID,'sortby'=>'enddate'),'End Date'));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_add_small');
			$span->appendChild(module::link_to_script_dom($doc,'Add New Contract','',array('item'=>'Contract','action'=>'edit','clientID'=>$parentID),'Add New Contract'));
            $actiontd->appendChild($span);

			$tr->appendChild($th1);
			$tr->appendChild($th2);
			$tr->appendChild($th3);
			$tr->appendChild($actiontd);

			return $tr;
		}

		function inline_list_footer($doc) {
			$parentID = globalize('id');
			$parentIDType = globalize('item');
			$tr = $doc->createElement('tr');
			$td1 = $doc->createElement('td');
			$td2 = $doc->createElement('td');
			$td3 = $doc->createElement('td');
			$actiontd = $doc->createElement('td');
			$actiontd->setAttribute('class', 'number');

			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_add_small');
			$span->appendChild(module::link_to_script_dom($doc,'Add New Contract','',array('item'=>'Contract','action'=>'edit','clientID'=>$parentID),'Add New Contract'));
            $actiontd->appendChild($span);

			$tr->appendChild($td1);
			$tr->appendChild($td2);
			$tr->appendChild($td3);
			$tr->appendChild($actiontd);

			return $tr;
		}

		function inline_list_field($field,$value) {
			if ($field == '2') {
				if ($value == 'Proposed') {
					$class = 'contractstatus_proposed';
					return $class;
				}
				if ($value == 'Approved') {
					$class = 'contractstatus_approved';
					return $class;
				}
				if ($value == 'Invoiced') {
					$class = 'contractstatus_invoiced';
					return $class;
				}
				if ($value == 'Paid') {
					$class = 'contractstatus_paid';
					return $class;
				}
				if ($value == 'Cancelled') {
					$class = 'contractstatus_cancelled';
					return $class;
				}
			}
		}

		function inline_list_colgroups($doc) {
			$parentIDType = globalize('item');
			$col1 = $doc->createElement('col');

			$col2 = $doc->createElement('col');
			$col2->setAttribute('width', '110px');

			$col3 = $doc->createElement('col');

			$colactions = $doc->createElement('col');
			//$colactions->setAttribute('width', '56px');

			$colgroup = array($col1,$col2,$col3,$colactions);

			return $colgroup;
		}

		$action_func = 'inline_list_actions';
		$footer_func = 'inline_list_footer';
		$header_func = 'inline_list_header';
		$fields_func = 'inline_list_field';
		$col_func = 'inline_list_colgroups';
		$colgroup = call_user_func_array($col_func,array($doc));
		$caption = "Contracts for $caption_name";

        $query = "SELECT I.contractID, I.name AS contractname, I.contractStatus, I.endDate FROM ({$this->store->table_traffic_contract} I, {$this->store->table_traffic_client} C) WHERE C.clientID = I.clientID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " AND I.contractID IN (".implode(',',$ids).") ";
		$query .= " AND I.$parentFieldName = '$parentID'";

        if(isset($sortby))
			$query .= " ORDER BY ".$sortby;
        // $result = sysdb::query($query);

		// Turn result query into a matrix.
		$matrix = sysdb::query2matrix($query,false);

		// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
		$vectors = sysdb::rotatematrix($matrix);

		// Perform data transformation on any column (vector), row by row (key by key).
        $contractNames = array();
        $endDates = array();
        $actions = array();
		if (!empty($vectors[0])) {
			foreach ($vectors[0] as $key=>$value) {
				$value = utf8_decode($value);
				$contractNames[$key] = module::link_to_script_dom($doc,$vectors[1][$key],'',array('item'=>$item,'action'=>'view','id'=>$value),$vectors[1][$key],'');
				$endDates[$key] = date("d-M-Y", strtotime($vectors[3][$key]));
				$actions[$key] = inline_list_actions($doc,$value);
			}
		}

		// Replace the original matrix column(s) with the new the vector(s).
		$vectors[1] = $contractNames;
		$vectors[3] = $endDates;
		$vectors[4] = $actions;

		// Rotate the new matrix 270 degrees to put it back the right way.
		$matrix_rotated_180 = sysdb::rotatematrix($vectors);
		$matrix_rotated_270 = sysdb::rotatematrix($matrix_rotated_180);
		$matrix_upright = sysdb::rotatematrix($matrix_rotated_270);

		$containertable = $doc->createElement('div');
		$containertable->setAttribute('id', 'inline_table');

		$table = sysdb::dom_matrix2table
		(
			$doc,
			$matrix_upright,
			false,
			'',
			'',
			array('0'),
			$footer_func,
			$header_func,
			array('table'=>'list','tr'=>'even'),
			$caption,
			$colgroup,
			$fields_func
		);

		$containertable->appendChild($table);
 		$container->appendChild($containertable);

        return($container);
    }

	public function contract_status($contractStatus) {
		if ($contractStatus == 'Proposed') {
			$class = 'contractstatus_proposed';
			return $class;
		}
		if ($contractStatus == 'Approved') {
			$class = 'contractstatus_approved';
			return $class;
		}
		if ($contractStatus == 'Invoiced') {
			$class = 'contractstatus_invoiced';
			return $class;
		}
		if ($contractStatus == 'Paid') {
			$class = 'contractstatus_paid';
			return $class;
		}
		if ($contractStatus == 'Cancelled') {
			$class = 'contractstatus_cancelled';
			return $class;
		}
	}

}
?>
