<?php
// $Id$

class Defer {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'defer':
				$this->add(globalize('deferID'),
							globalize('deferItem'),
							globalize('deferSpotID', array()),
							globalize('deferDateTime', array()),
							globalize('deferPromoSpotID', array()),
							globalize('deferPromoDateTime', array()),
							globalize('deferStartYear'),
							globalize('deferStartMonth'),
							globalize('deferStartDay'),
							globalize('deferScheduleStartYear'),
							globalize('deferScheduleStartMonth'),
							globalize('deferScheduleStartDay'),
							globalize('deferPromoStartYear'),
							globalize('deferPromoStartMonth'),
							globalize('deferPromoStartDay'));
				break;
            case 'defer-disabled':
				$this->move_many(globalize('deferSpotID'),
							globalize('deferDateTime'));
				break;
        }
    }

    public function defer_schedule_button_ui($doc, $id = '') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc, 'Defer Schedule', '', array('item' => 'Defer', 'extras' => $item, 'action' => 'edit', 'id' => $id), 'Defer Schedule', 'link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_delete');
		$label = $doc->createTextNode('Defer Schedule');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);

        return($spanbutton);
    }

    public function form($doc, $id = '') {
		$success = true;
        $item = globalize('item', get_class($this));
        $extras = globalize('extras');

        $startDateArray = array(date('Y'), date('n'), date('j'));

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');

		$container->appendChild($header = $doc->createElement('h1'));
		$header->appendChild($doc->createTextNode("Defer spot schedule"));

		$container->appendChild($input = dom::createInputBox($doc, 'deferID', $id, 'hidden'));
		$container->appendChild($input = dom::createInputBox($doc, 'deferItem', $extras, 'hidden'));

        switch(strtolower($extras)) {
            case 'contract':
				// // Fetch contract details.
				// $queryO = <<<EOQ
					// SELECT O.{$this->store->field_contract_name} AS contractName,
						// L.{$this->store->field_client_name} AS clientName,
						// L.{$this->store->field_client_clientID} AS clientID,
						// O.{$this->store->field_contract_startDate} AS contractStart,
						// O.{$this->store->field_contract_endDate} AS contractEnd
					// FROM ({$this->store->table_traffic_contract} O)
					// LEFT OUTER JOIN {$this->store->table_traffic_client} L
					// ON O.{$this->store->field_contract_clientID} = L.{$this->store->field_client_clientID}
					// WHERE O.{$this->store->field_contract_contractID} = '$id'
// EOQ;
				// Fetch schedule for campaign.
				$query = <<<EOQ
					SELECT S.{$this->store->field_spot_spotID} AS spotID,
						S.{$this->store->field_spot_mediaID} AS mediaID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S)
					LEFT OUTER JOIN {$this->store->table_traffic_campaignaudio} A
					ON A.{$this->store->field_campaignaudio_mediaID} = S.{$this->store->field_spot_mediaID}
					LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON M.{$this->store->field_campaign_campaignID} = A.{$this->store->field_campaignaudio_campaignID}
					LEFT OUTER JOIN {$this->store->table_traffic_contract} O
					ON O.{$this->store->field_contract_contractID} = M.{$this->store->field_campaign_contractID}
					WHERE O.{$this->store->field_contract_contractID} = '$id'
					ORDER BY dateTime
EOQ;
				$result = sysdb::query($query);
				$spot_count = sysdb::num_rows($result);

				// Fetch promotion schedule for campaign.
				$query_promo = <<<EOQ
					SELECT S.{$this->store->field_spot_spotID} AS spotID,
						S.{$this->store->field_spot_mediaID} AS mediaID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S)
					LEFT OUTER JOIN {$this->store->table_traffic_campaignpromotion} P
					ON P.{$this->store->field_campaignpromotion_mediaID} = S.{$this->store->field_spot_mediaID}
					LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON M.{$this->store->field_campaign_campaignID} = P.{$this->store->field_campaignpromotion_campaignID}
					LEFT OUTER JOIN {$this->store->table_traffic_contract} O
					ON O.{$this->store->field_contract_contractID} = M.{$this->store->field_campaign_contractID}
					WHERE O.{$this->store->field_contract_contractID} = '$id'
					ORDER BY dateTime
EOQ;
				$result_promo = sysdb::query($query_promo);
				$promospot_count = sysdb::num_rows($result_promo);

				if ($spot_count <= 0) {
					// No spots, cannot proceed.
					$success = false;
				} else {
					$success = true;
				}
				break;
            case 'campaign':
				// Fetch schedule for campaign.
				$query = <<<EOQ
					SELECT S.{$this->store->field_spot_spotID} AS spotID,
						S.{$this->store->field_spot_mediaID} AS mediaID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S)
					LEFT OUTER JOIN {$this->store->table_traffic_campaignaudio} A
					ON A.{$this->store->field_campaignaudio_mediaID} = S.{$this->store->field_spot_mediaID}
					LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON M.{$this->store->field_campaign_campaignID} = A.{$this->store->field_campaignaudio_campaignID}
					WHERE M.{$this->store->field_campaign_campaignID} = '$id'
					ORDER BY dateTime
EOQ;
				$result = sysdb::query($query);
				$spot_count = sysdb::num_rows($result);

				// Fetch promotion schedule for campaign.
				$query_promo = <<<EOQ
					SELECT S.{$this->store->field_spot_spotID} AS spotID,
						S.{$this->store->field_spot_mediaID} AS mediaID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S)
					LEFT OUTER JOIN {$this->store->table_traffic_campaignpromotion} P
					ON P.{$this->store->field_campaignpromotion_mediaID} = S.{$this->store->field_spot_mediaID}
					LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON M.{$this->store->field_campaign_campaignID} = P.{$this->store->field_campaignpromotion_campaignID}
					WHERE M.{$this->store->field_campaign_campaignID} = '$id'
					ORDER BY dateTime
EOQ;
				$result_promo = sysdb::query($query_promo);
				$promospot_count = sysdb::num_rows($result_promo);

				if ($spot_count <= 0) {
					// No spots, cannot proceed.
					$success = false;
				} else {
					$success = true;
				}
				break;
            case 'campaignaudio':
				// Fetch schedule for campaign audio.
				$query = <<<EOQ
					SELECT S.{$this->store->field_spot_spotID} AS spotID,
						S.{$this->store->field_spot_mediaID} AS mediaID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S)
					LEFT OUTER JOIN {$this->store->table_traffic_campaignaudio} A
					ON A.{$this->store->field_campaignaudio_mediaID} = S.{$this->store->field_spot_mediaID}
					WHERE A.{$this->store->field_campaignaudio_campaignAudioID} = '$id'
					ORDER BY dateTime
EOQ;
				$result = sysdb::query($query);
				$spot_count = sysdb::num_rows($result);

				// Fetch promotion schedule for campaign audio.
				$query_promo = <<<EOQ
					SELECT S.{$this->store->field_spot_spotID} AS spotID,
						S.{$this->store->field_spot_mediaID} AS mediaID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S)
					LEFT OUTER JOIN {$this->store->table_traffic_campaignpromotion} P
					ON P.{$this->store->field_campaignpromotion_mediaID} = S.{$this->store->field_spot_mediaID}
					WHERE P.{$this->store->field_campaignpromotion_campaignPromotionID} = '$id'
					ORDER BY dateTime
EOQ;
				$result_promo = sysdb::query($query_promo);
				$promospot_count = sysdb::num_rows($result_promo);

				if ($spot_count <= 0) {
					// No spots, cannot proceed.
					$success = false;
				} else {
					$success = true;
				}

				break;
            case 'campaignpromotion':
				break;
        }

		if ($success) {
			$container->appendChild($subheader = $doc->createElement('h2'));
			$subheader->appendChild($doc->createTextNode('Schedule details for campaign audio: '));

			$table = $doc->createElement('table');
			$table->setAttribute('class', 'view');

			// Display number of objects to defer.
			$table->appendChild($tr = $doc->createElement('tr'));
			$tr->appendChild($labeltd = $doc->createElement('th'));
			$labeltd->appendChild($label = $doc->createTextNode('Spot Count'));
			$tr->appendChild($inputtd = $doc->createElement('td'));
			$inputtd->appendChild($label = $doc->createTextNode($spot_count));

			$table->appendChild($tr = $doc->createElement('tr'));
			$tr->appendChild($labeltd = $doc->createElement('th'));
			$labeltd->appendChild($label = $doc->createTextNode('Promo Spot Count'));
			$tr->appendChild($inputtd = $doc->createElement('td'));
			$inputtd->appendChild($label = $doc->createTextNode($promospot_count));

			$i = 1;
			// Process spot results.
			while ($line = sysdb::fetch_assoc($result)) {
				if ($i == 1) {
					// Remember first spot in schedule for display.
					$scheduleStartDate = date("Y-m-d", strtotime($line['dateTime']));
					$scheduleStartDateArray = explode('-', $scheduleStartDate);
					$container->appendChild($input = dom::createInputBox($doc, 'deferScheduleStartYear', $scheduleStartDateArray[0], 'hidden'));
					$container->appendChild($input = dom::createInputBox($doc, 'deferScheduleStartMonth', $scheduleStartDateArray[1], 'hidden'));
					$container->appendChild($input = dom::createInputBox($doc, 'deferScheduleStartDay', $scheduleStartDateArray[2], 'hidden'));
				}

				$container->appendChild($label = dom::createInputBox($doc, 'deferSpotID[]', $line['spotID'], 'hidden'));
				$container->appendChild($label = dom::createInputBox($doc, 'deferDateTime[]', $line['dateTime'], 'hidden'));

				$i++;
			}

			$j = 1;
			// Process promotion spot results.
			while ($line_promo = sysdb::fetch_assoc($result_promo)) {
				if ($j == 1) {
					// Remember first spot in schedule for display.
					$promoStartDate = date("Y-m-d", strtotime($line_promo['dateTime']));
					$promoStartDateArray = explode('-', $promoStartDate);
					$container->appendChild($input = dom::createInputBox($doc, 'deferPromoStartYear', $promoStartDateArray[0], 'hidden'));
					$container->appendChild($input = dom::createInputBox($doc, 'deferPromoStartMonth', $promoStartDateArray[1], 'hidden'));
					$container->appendChild($input = dom::createInputBox($doc, 'deferPromoStartDay', $promoStartDateArray[2], 'hidden'));
				}

				$container->appendChild($label = dom::createInputBox($doc, 'deferPromoSpotID[]', $line_promo['spotID'], 'hidden'));
				$container->appendChild($label = dom::createInputBox($doc, 'deferPromoDateTime[]', $line_promo['dateTime'], 'hidden'));

				$j++;
			}

			$table->appendChild($tr = $doc->createElement('tr'));
			$tr->appendChild($labeltd = $doc->createElement('th'));
			$labeltd->appendChild($label = $doc->createTextNode('Original schedule start date'));

			$tr->appendChild($inputtd = $doc->createElement('td'));
			$inputtd->appendChild($label = $doc->createTextNode(date("l, jS F Y", strtotime($scheduleStartDate))));

			$table->appendChild($tr = $doc->createElement('tr'));
			$tr->appendChild($labeltd = $doc->createElement('th'));
			$labeltd->appendChild($label = $doc->createTextNode('New schedule start date *'));

			$tr->appendChild($inputtd = $doc->createElement('td'));
			WriteDateSelect_dom($doc, $inputtd, 'deferStart', date('Y') - 3, date('Y') + 2, '', $startDateArray[0], $startDateArray[1], $startDateArray[2], 'd-m-Y');

			$table->appendChild($defertr = $doc->createElement('tr'));
			$defertr->appendChild($labeltd = $doc->createElement('th'));
			$defertr->appendChild($defertd = $doc->createElement('td'));
			$defertd->setAttribute('class', 'right');
			$defertd->appendChild($defer = $doc->createElement('input'));
			$defer->setAttribute('type', 'submit');
			$defer->setAttribute('name', 'action');
			$defer->setAttribute('value', 'defer');

			$container->appendChild($table);

		} else {
			$container->appendChild($subheader = $doc->createElement('h2'));
			$subheader->appendChild($doc->createTextNode('No schedule exists.'));
		}

        return($container);
    }

    public function add($id,
						$extras,
						$spotIDList,
						$dateTimeList,
						$promoSpotIDList,
						$promoDateTimeList,
						$startYear,
						$startMonth,
						$startDay,
						$scheduleStartYear,
						$scheduleStartMonth,
						$scheduleStartDay,
						$promoStartYear,
						$promoStartMonth,
						$promoStartDay
						) {

		$success = false;
		$item = globalize('item', get_class($this));

		// Process schedule.
		if (!is_array($spotIDList)
			&& !is_array($dateTimeList)) {
			// Unexpected format of arrays. An error occurred.
			$success = false;
			state::setMessage('error', 'An error occurred. Schedule could not be deferred.');
			state::setMessage('debug', 'Unexpected format of arrays. An error occurred.');
			if ($item == 'Defer') {
				module::forward_to_script('', array('item' => $item, 'extras' => $extras, 'action' => 'edit', 'id' => $id));
			}
		} else {
			// Calculate absolute date offset between old and new start date.
			$newStartDate = date("Y-m-d", strtotime($startYear.'-'.$startMonth.'-'.$startDay));
			$oldStartDate = date("Y-m-d", strtotime($scheduleStartYear.'-'.$scheduleStartMonth.'-'.$scheduleStartDay));
			$dateOffsetDiff = self::date_diff($oldStartDate, $newStartDate);

			if (strtotime($newStartDate) <= strtotime(date('Y-m-d', strtotime("now")))) {
				/** @todo Do a time check on the first spot and schedule today if later than the current time. */
				if ($item == 'Defer') {
					state::setMessage('warning', 'You cannot schedule in the past (or today). Schedule could not be deferred.');
				}
				module::forward_to_script('', array('item' => $item, 'extras' => $extras, 'action' => 'edit', 'id' => $id));
				return $success;
			} else {
				$success = true;
			}

			// Process promotion schedule.
			if (!is_array($promoSpotIDList)
				&& !is_array($promoDateTimeList)) {
				// Unexpected format of arrays. An error occurred.
				$success = false;
				state::setMessage('error', 'An error occurred. Promotion schedule could not be deferred.');
				state::setMessage('debug', 'Unexpected format of arrays. An error occurred.');
				if ($item == 'Defer') {
					module::forward_to_script('', array('item' => $item, 'extras' => $extras, 'action' => 'edit', 'id' => $id));
				}
			} else {
				// Calculate absolute date offset between old and new start date.
				$newPromoStartDate = date("Y-m-d", strtotime($startYear.'-'.$startMonth.'-'.$startDay));
				$oldPromoStartDate = date("Y-m-d", strtotime($promoStartYear.'-'.$promoStartMonth.'-'.$promoStartDay));
				$promoDateOffsetDiff = self::date_diff($oldPromoStartDate, $newPromoStartDate);

				if (strtotime($newPromoStartDate) <= strtotime(date('Y-m-d', strtotime("now")))) {
					/** @todo Do a time check on the first spot and schedule today if later than the current time. */
					if ($item == 'Defer') {
						state::setMessage('warning', 'You cannot schedule in the past (or today). Schedule could not be deferred.');
					}
					module::forward_to_script('', array('item' => $item, 'extras' => $extras, 'action' => 'edit', 'id' => $id));
					return $success;
				} else {
					$success = true;
				}
			}

			if ($success) {
				// Transform the dates to the new schedule.
				$scheduleDateTimeList = array();
				foreach ($spotIDList as $key => $spotID) {
					// Fetch datetime for the corresponding spot.
					$dateTime = $dateTimeList[$key];

					// Modify the spot date by the date offset.
					$scheduleDateTimeList[$key] = date('Y-m-d H:i:s', strtotime($dateOffsetDiff.' day', strtotime($dateTime)));
				}
				// Move spots.
				Spot::move_many($spotIDList, $scheduleDateTimeList);

				// Transform the dates to the new promotion schedule.
				$promoScheduleDateTimeList = array();
				foreach ($promoSpotIDList as $key => $spotID) {
					// Fetch datetime for the corresponding spot.
					$dateTime = $promoDateTimeList[$key];

					// Modify the spot date by the date offset.
					$promoScheduleDateTimeList[$key] = date('Y-m-d H:i:s', strtotime($promoDateOffsetDiff.' day', strtotime($dateTime)));
				}
				// Move promotion spots.
				Spot::move_many($promoSpotIDList, $promoScheduleDateTimeList);

				state::setMessage('notify', 'Successfully deferred schedule by '.$dateOffsetDiff.' days.');
				state::setMessage('warning', 'Please verify all spot priority details in Traffic.');

			}
			if ($item == 'Defer') {
				module::forward_to_script('', array('item' => $extras, 'action' => 'view', 'id' => $id));
			}
		}
		return $success;
	}

	/**
	 * Finds the difference in days between two calendar dates.
	 *
	 * @param Date $startDate
	 * @param Date $endDate
	 * @return Int
	 */
	public function date_diff($startDate, $endDate) {
		// Parse dates for conversion
		$startArry = date_parse($startDate);
		$endArry = date_parse($endDate);

		// Convert dates to Julian Days
		$start_date = gregoriantojd($startArry["month"], $startArry["day"], $startArry["year"]);
		$end_date = gregoriantojd($endArry["month"], $endArry["day"], $endArry["year"]);

		// Return difference
		return round(($end_date - $start_date), 0);
	}

}
?>