<?php
// $Id$

class Log {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete': $this->delete(globalize('id')); break;
            case 'add':
				$this->add(	globalize('campaignStartYear'),
							globalize('campaignStartMonth'),
							globalize('campaignStartDay'),
							globalize('campaignEndYear'),
							globalize('campaignEndMonth'),
							globalize('campaignEndDay'),
							globalize('campaignCreatedDateTime'),
							globalize('campaignName'),
							globalize('audioAllotted'),
							globalize('spotsAllotted'),
							globalize('contractID'),
							globalize('campaignSAMIDList')
							);
				break;
            case 'save':
				$this->save(globalize('campaignID'),
							globalize('campaignStartYear'),
							globalize('campaignStartMonth'),
							globalize('campaignStartDay'),
							globalize('campaignEndYear'),
							globalize('campaignEndMonth'),
							globalize('campaignEndDay'),
							globalize('campaignName'),
							globalize('audioAllotted'),
							globalize('spotsAllotted'),
							globalize('campaignSAMIDList')
							);
				break;
			case 'export': $this->export(globalize('parent'),globalize('id')); break;
			case 'export_dates': $this->export_dates(globalize('dates')); break;
			case 'export_dates_programs': $this->export_dates_programs(globalize('dates')); break;
		}
    }

    public function form($doc,$id='') {

		$contractID = globalize('contractID');
		$item = globalize('item',get_class($this));

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Campaign';
        else
            $headerText = 'Edit Campaign';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		if ($id != '') {
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'delete','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Campaign",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

		/* This input is to end execution of the module index file.
			Because we are forwarding to another page each time we add or save,
			we need to make sure the page doesn't get generated twice */
		$terminate = $doc->createElement('input');
		$terminate->setAttribute('type','hidden');
		$terminate->setAttribute('name','terminate');
		$terminate->setAttribute('value','true');
		$container->appendChild($terminate);

        $campaignID = $doc->createElement('input');
        $campaignID->setAttribute('type','hidden');
        $campaignID->setAttribute('name','campaignID');
        $campaignID->setAttribute('value',$id);
        $container->appendChild($campaignID);

		$input = $doc->createElement('input');
        $input->setAttribute('type','hidden');
        $input->setAttribute('name','contractID');
        $input->setAttribute('value',$contractID);
        $container->appendChild($input);

		$datetime = date("Y-m-d H:i:s");

		$date = $doc->createElement('input');
        $date->setAttribute('type','hidden');
        $date->setAttribute('name','campaignCreatedDateTime');
        $date->setAttribute('value',$datetime);
        $container->appendChild($date);

        if ($id != '') {
			$query = "SELECT C.name as clientName, A.name as contractName, A.audioPurchased, A.spotsPurchased, I.* ";
			$query .= "FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A) ";
			$query .= "WHERE I.campaignID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

			$contractID = $line['contractID'];
            $campaignID = $line['campaignID'];
            $startDateArray = explode('-',$line['startDate']);
            $endDateArray = explode('-',$line['endDate']);
            $createdDateTime = $line['createdDateTime'];
            $name = $line['name'];
			$clientName = $line['clientName'];
			$contractName = $line['contractName'];
			$audioAllotted = $line['audioAllotted'];
			$spotsAllotted = $line['spotsAllotted'];

			$query = "SELECT * FROM {$this->store->table_traffic_campaignsam} WHERE campaignID = '$id'";
			$result = sysdb::query($query);
			$samIDList = array();
			while ($line = sysdb::fetch_assoc($result)) {
				array_push($samIDList, $line['samID']);
			}

        } else {

			$query = "SELECT C.name as clientName, A.name as contractName, A.audioPurchased, A.spotsPurchased ";
			$query .= "FROM ({$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A) ";
			$query .= "WHERE A.contractID = '$contractID' AND C.clientID = A.clientID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$clientName = $line['clientName'];
			$contractName = $line['contractName'];

            $campaignID = '';
            $startDateArray = array(date('Y'),date('n'),date('j'));
			$endDateArray = array(date('Y'),date('n'),date('j'));
            $createdDateTime = '';
            $name = '';
			$audioAllotted = '';
			$spotsAllotted = '';
		}

		$contractData = $this->getContractDetails($contractID);

		$totalActualAudio = $contractData['totalActualAudio'];
		$totalActualSpots = $contractData['totalActualSpots'];
		$contractAudioRemaining = $contractData['audioRemaining'];
		$contractSpotsRemaining = $contractData['spotsRemaining'];

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date *');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'campaignEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($clientName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Campaign Name *');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','campaignName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

		$contractAudioRemainingtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Remaining purchased contract audio');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractAudioRemaining);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractAudioRemainingtr->appendChild($labeltd);
        $contractAudioRemainingtr->appendChild($inputtd);

		$contractSpotsRemainingtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Remaining purchased contract spots');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractSpotsRemaining);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractSpotsRemainingtr->appendChild($labeltd);
        $contractSpotsRemainingtr->appendChild($inputtd);

		$totalActualAudiotr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Total actual contract audio');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($totalActualAudio);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $totalActualAudiotr->appendChild($labeltd);
        $totalActualAudiotr->appendChild($inputtd);

		$audioAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Audio allotted to campaign');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','audioAllotted');
        $input->setAttribute('value',$audioAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $audioAllottedtr->appendChild($labeltd);
        $audioAllottedtr->appendChild($inputtd);

		$spotsAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Spots allotted to campaign');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','spotsAllotted');
        $input->setAttribute('value',$spotsAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $spotsAllottedtr->appendChild($labeltd);
        $spotsAllottedtr->appendChild($inputtd);

		$totalActualSpotstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Total actual contract spots');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($totalActualSpots);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $totalActualSpotstr->appendChild($labeltd);
        $totalActualSpotstr->appendChild($inputtd);

		$SAMIDtr = $doc->createElement('tr');
		$labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Assign Sponsor Account Manager');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('select');
		$input->setAttribute('name','campaignSAMIDList[]');

		$query = "SELECT I.samID, D.firstName, D.lastName FROM ({$this->store->table_traffic_sam} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID";
		$result = sysdb::query($query);

		$inputOption = $doc->createElement('option');
		$inputOption->setAttribute('value','');
		$text = $doc->createTextNode('');
		$inputOption->appendChild($text);
		$input->appendChild($inputOption);
		while ($line = sysdb::fetch_assoc($result)) {
			$inputOption = $doc->createElement('option');
			if ( isset($campaignSAMID)) {
				if ( in_array($line['samID'],$campaignSAMID) )
					$inputOption->setAttribute('selected','selected');
			}
			$inputOption->setAttribute('value',$line['samID']);
			$inputOption->appendChild($doc->createTextNode($line['firstName'].' '.$line['lastName']));
			$input->appendChild($inputOption);
		}

		$inputtd->appendChild($input);
		$labeltd->appendChild($label);
		$SAMIDtr->appendChild($labeltd);
		$SAMIDtr->appendChild($inputtd);

        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($nametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($audioAllottedtr);
        $table->appendChild($totalActualAudiotr);
        $table->appendChild($contractAudioRemainingtr);
		$table->appendChild($spotsAllottedtr);
        $table->appendChild($totalActualSpotstr);
        $table->appendChild($contractSpotsRemainingtr);
		$table->appendChild($SAMIDtr);


        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);

        return($container);
    }

    public function view($doc,$id) {
        $container = $doc->createElement('div');
		$container->setAttribute('class','module');
		switch(globalize('extras','Log')) {
			case 'CampaignAudio':
				$campaignAudio = new CampaignAudio();
				$container->appendChild($campaignAudio->inline_list($doc,'',true));
				break;
			case 'CampaignMaterial':
				$campaignMaterial = new CampaignMaterial();
				$container->appendChild($campaignMaterial->inline_list($doc,'',true));
				break;
			case 'Log':
				$log = new Log();
				$container->appendChild($log->inline_list($doc,'',true));
				break;
		}
		$containerLeft = $doc->createElement('div');
		$containerLeft->setAttribute('class','module_left');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Schedule Logs'));
		$container->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $span->appendChild(module::link_to_script_dom($doc,'Add Audio','',array('item'=>"CampaignAudio",'action'=>'edit','campaignID'=>$id),'Add Audio'));
        // $container->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Audio','',array('item'=>"CampaignAudio",'action'=>'edit','campaignID'=>$id),'Add Audio','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Audio');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Material','',array('item'=>"CampaignMaterial",'action'=>'edit','campaignID'=>$id),'Add Material','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Material');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

//		$container->appendChild($doc->createElement('br'));
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $container->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'view');

        $campaignID = $doc->createElement('input');
        $campaignID->setAttribute('type','hidden');
        $campaignID->setAttribute('name','campaignID');
        $campaignID->setAttribute('value',$id);
        $container->appendChild($campaignID);

        $query = "SELECT C.name as clientName, A.name as contractName, I.* FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_contract} A) WHERE I.campaignID = '$id' AND C.clientID = I.clientID AND A.contractID = I.contractID";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $campaignID = $line['campaignID'];
        $startDate = $line['startDate'];
        $endDate = $line['endDate'];
        $createdDateTime = $line['createdDateTime'];
        $name = $line['name'];
		$clientName = $line['clientName'];
		$contractName = $line['contractName'];
		$audioAllotted = $line['audioAllotted'];
		$spotsAllotted = $line['spotsAllotted'];

		$querysam = "SELECT D.firstName, D.lastName FROM ({$this->store->table_traffic_campaignsam} C, {$this->store->table_traffic_sam} P, {$this->store->table_detail} D) WHERE C.campaignID = '$id' AND C.samID = P.samID AND P.actorID = D.actorID";
        $resultsam = sysdb::query($querysam);

		$samNames = array();
		while ($linename = sysdb::fetch_assoc($resultsam)) {
			array_push($samNames, $linename['firstName'].' '.$linename['lastName']);
		}

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($startDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($endDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

        $createdDateTimetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Created');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($createdDateTime);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $createdDateTimetr->appendChild($labeltd);
        $createdDateTimetr->appendChild($inputtd);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

		$clientNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Client');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($clientName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $clientNametr->appendChild($labeltd);
        $clientNametr->appendChild($inputtd);

		$contractNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Contract');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($contractName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $contractNametr->appendChild($labeltd);
        $contractNametr->appendChild($inputtd);

		$audioAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Audio Allotted');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($audioAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $audioAllottedtr->appendChild($labeltd);
        $audioAllottedtr->appendChild($inputtd);

		$spotsAllottedtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('# Spots Allotted');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($spotsAllotted);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $spotsAllottedtr->appendChild($labeltd);
        $spotsAllottedtr->appendChild($inputtd);

		$campaignSAMtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Sponsor Account Manager');
		$labeltd->appendChild($label);
        $inputtd = $doc->createElement('td');
		$inputbr = $doc->createElement('br');

		foreach ($samNames as $name) {
			$input = $doc->createTextNode($name);
			$inputbr = $doc->createElement('br');
			$inputtd->appendChild($input);
			$inputtd->appendChild($inputbr);
		}

        $campaignSAMtr->appendChild($labeltd);
        $campaignSAMtr->appendChild($inputtd);

        $table->appendChild($nametr);
        $table->appendChild($clientNametr);
        $table->appendChild($contractNametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
		$table->appendChild($audioAllottedtr);
		$table->appendChild($spotsAllottedtr);
        $table->appendChild($createdDateTimetr);
        $table->appendChild($campaignSAMtr);

		$containerLeft->appendChild($table);
		$container->appendChild($containerLeft);

		$moduleFooter = $doc->createElement('div');
		$moduleFooter->setAttribute('class','clear_both');
		$container->appendChild($moduleFooter);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
		$item = get_class($this);
		$query = <<<EOQ
            SELECT C.name as clientName, I.campaignID, I.name, I.startDate, I.endDate, I.createdDateTime
            FROM ({$this->store->table_traffic_campaign} I, {$this->store->table_traffic_client} C)
            WHERE C.clientID = I.clientID
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
          $query .= " AND I.campaignID IN (".implode(',',$ids).") ";
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

		$col1 = $doc->createElement('col');
        $table->appendChild($col1);

		$col2 = $doc->createElement('col');
        $table->appendChild($col2);

		$col3 = $doc->createElement('col');
        $table->appendChild($col3);

		$col4 = $doc->createElement('col');
        $table->appendChild($col4);

		$colactions = $doc->createElement('col');
		//$colactions->setAttribute('width', '56px');
        $table->appendChild($colactions);

        $tr = $doc->createElement('tr');
        $nametd = $doc->createElement('th');
        $clientNametd = $doc->createElement('th');
        $startDatetd = $doc->createElement('th');
        $endDatetd = $doc->createElement('th');

        $nametd->appendChild($doc->createTextNode('Name'));
        $clientNametd->appendChild($doc->createTextNode('Client'));
        $startDatetd->appendChild($doc->createTextNode('Start'));
        $endDatetd->appendChild($doc->createTextNode('End'));


        $tr->appendChild($nametd);
        $tr->appendChild($clientNametd);
        $tr->appendChild($startDatetd);
        $tr->appendChild($endDatetd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No campaigns entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $nametd = $doc->createElement('td');
            $clientNametd = $doc->createElement('td');
            $startDatetd = $doc->createElement('td');
            $endDatetd = $doc->createElement('td');
            $emailtd = $doc->createElement('td');

            $nametd->appendChild($doc->createTextNode($line['name']));
            $clientNametd->appendChild($doc->createTextNode($line['clientName']));
            $startDatetd->appendChild($doc->createTextNode($line['startDate']));
            $endDatetd->appendChild($doc->createTextNode($line['endDate']));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item',get_class($this)),'action'=>'view','id'=>$line['campaignID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item',get_class($this)),'action'=>'edit','id'=>$line['campaignID']),'Edit'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
            $actiontd->appendChild($span = $doc->createElement('span'));
            $span->setAttribute('class','link_traffic_small');
            $span->appendChild(module::link_to_script_dom_unappended($doc,'View Traffic','',
                            array('item'=>'Traffic',
                                  'mode'=>'Campaign',
                                  'campaignID'=>$line['campaignID'],
                                    ),'View Traffic','link_traffic_small'));
            $table->appendChild($tr);
            $tr->appendChild($nametd);
            $tr->appendChild($clientNametd);
            $tr->appendChild($startDatetd);
            $tr->appendChild($endDatetd);
            $tr->appendChild($actiontd);
			$i++;
        }
        $tr = $doc->createElement('tr');
        $actiontd = $doc->createElement('td');
        $actiontd->setAttribute('colspan','5');
        $actiontd->setAttribute('style','text-align: right;');
        $actiontd->appendChild(module::link_to_script_dom($doc,'add','',array('item'=>globalize('item',get_class($this)),'action'=>'edit'),'Add'));

        //$table->appendChild($tr);
        $tr->appendChild($actiontd);

        return($table);
    }

	public function overview($doc,$ids='',$isInclude=false) {
		include_once('calendar.php');
		$g = array('moduleID','modulecategory','item','action','id');
		extract(globalize_many($g));

		$monthdate = globalize('monthdate');
		$scheduledates = globalize('scheduledates');

//		$startsWith = globalize('startswith');

		$container = $doc->createElement('div');
		if ( $isInclude ) {
			$item = get_class($this);
			$parentID = globalize('id');
			$parentIDType = globalize('item',get_class($this));
			switch ($parentIDType) {
				case 'Client':
					$parentFieldName = 'clientID';
					break;
				case 'Contract':
					$parentFieldName = 'contractID';
					break;
				default:
					$isInclude = false;
					$warning_message = "Not a valid parent.";
					break;
			}
			$container->setAttribute('class','module_right');
			$container->appendChild($this->include_header($doc,$parentID));
		} else {
			$item = globalize('item',get_class($this));
			$container->setAttribute('class','module');
		}

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Select Log Date'));
		$container->appendChild($header);

		$form = module::form_dom($doc);

		// $iteminput = $doc->createElement('input');
		// $iteminput->setAttribute('type','hidden');
		// $iteminput->setAttribute('name','id');
		// $iteminput->setAttribute('value',$id);
		// $form->appendChild($iteminput);

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','item');
		$iteminput->setAttribute('value',get_class($this));
		$form->appendChild($iteminput);

		$shownDates = $this->printnonshowndates($doc,$monthdate,$scheduledates);
		$form->appendChild($shownDates);

		$calendar = calendar::printcalendar($doc,$monthdate,array($this,'printcalendarday'),'left','center',$scheduledates);
		$form->appendChild($calendar);

		$deleteSelected = $doc->createElement('input');
		$deleteSelected->setAttribute('type','submit');
		$deleteSelected->setAttribute('name','action');
		$deleteSelected->setAttribute('value','select dates');
		$form->appendChild($deleteSelected);

		$container->appendChild($form);

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT S.campaignID, S.name, S.startDate, S.endDate, S.createdDateTime FROM {$this->store->table_traffic_campaign} S ORDER BY endDate, startDate";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','campaignID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No campaigns available');
            $option->appendChild($text);
            $select->appendChild($option);
        } else {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('Please select a campaign...');
            $option->appendChild($text);
            $select->appendChild($option);
            while ($line = sysdb::fetch_assoc($result)) {
                $option = $doc->createElement('option');
                $option->setAttribute('value',$line['campaignID']);
                $text = $doc->createTextNode(utf8_decode($line['name']));
                $option->appendChild($text);
                if ($default == $line['campaignID']) $option->setAttribute('selected','selected');
                $select->appendChild($option);
            }
        }

        return($select);
    }

    public function add($startYear,$startMonth,$startDay,
						$endYear,$endMonth,$endDay,$createdDateTime,
						$name,$audioAllotted,$spotsAllotted,$contractID,$samIDList) {
		$errors = false;

		if (!checkdate($startMonth,$startDay,$startYear)) {
			state::setMessage('warning', 'Invalid start date.');
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			state::setMessage('warning', 'Invalid end date.');
			$errors = true;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ( !$errors ) {
			$query = "SELECT clientID FROM {$this->store->table_traffic_contract} WHERE contractID = '$contractID'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$query = "INSERT INTO {$this->store->table_traffic_campaign} (startDate,endDate,createdDateTime,name,audioAllotted,spotsAllotted,contractID,clientID) VALUES ('$startDate','$endDate','$createdDateTime','$name','$audioAllotted','$spotsAllotted','$contractID','".$line['clientID']."')";
			$result = sysdb::query($query);

			$contractData = $this->getContractDetails($contractID);
			$audio = ($contractData['audioRemaining'] < 0);
			$spots = ($contractData['spotsRemaining'] < 0);
			if ( $audio || $spots ) {

				$msg = 'This campaign\'s contract is now exceeding its purchased amounts for ';

				if ( $audio && $spots )
					$msg .= 'audio and spots.';
				elseif ( $audio )
					$msg .= 'audio.';
				elseif ( $spots )
					$msg .= 'spots.';

				state::setMessage('warning', $msg );
			}

			state::setMessage('notify', 'Successfully added new campaign: '.$name);
			$campaignID = sysdb::insert_id();

			if (!empty($samIDList)) {
				foreach($samIDList as $samID ) {
					if ($samID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_campaignsam} (samID,campaignID) VALUES ('$samID','$campaignID')";
						$result = sysdb::query($query);
					}
				}
			}
			module::forward_to_script('',array('item'=>'Campaign','action'=>'view','id'=>$campaignID));
		}
    }

    public function save($id,$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,$name,$audioAllotted,$spotsAllotted,$samIDList) {
 		$errors = false;

		if (!checkdate($startMonth,$startDay,$startYear)) {
			state::setMessage('warning', 'Invalid start date.');
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			state::setMessage('warning', 'Invalid end date.');
			$errors = true;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ( !$errors ) {
			$query = "UPDATE {$this->store->table_traffic_campaign} SET startDate = '$startDate', endDate = '$endDate', name = '$name', audioAllotted = '$audioAllotted', spotsAllotted = '$spotsAllotted' WHERE campaignID = '$id'";
			$result = sysdb::query($query);

			$query = "SELECT contractID FROM {$this->store->table_traffic_campaign} WHERE campaignID = '$id'";
			$line = sysdb::fetch_assoc(sysdb::query($query));
			$contractID = $line['contractID'];

			$contractData = $this->getContractDetails($contractID);
			$audio = ($contractData['audioRemaining'] < 0);
			$spots = ($contractData['spotsRemaining'] < 0);
			if ( $audio || $spots ) {

				$msg = 'This campaign\'s contract is now exceeding its purchased amounts for ';

				if ( $audio && $spots )
					$msg .= 'audio and spots.';
				elseif ( $audio )
					$msg .= 'audio.';
				elseif ( $spots )
					$msg .= 'spots.';

				state::setMessage('warning', $msg );
			}

			state::setMessage('notify', 'Successfully updated campaign: '.$name);

			$query = "DELETE FROM {$this->store->table_traffic_campaignsam} WHERE campaignID = '$id'";
			$result = sysdb::query($query);
			if (!empty($samIDList)) {
				foreach($samIDList as $samID) {
					if ($samID != '') {
						$query = "INSERT INTO {$this->store->table_traffic_campaignsam} (samID,campaignID) VALUES ('$samID','$id')";
						$result = sysdb::query($query);
					}
				}
			}
			module::forward_to_script('',array('item'=>'Campaign','action'=>'view','id'=>$id));
		}
    }

    public function delete($id) {

		$query = "SELECT name FROM {$this->store->table_traffic_campaignaudio} WHERE campaignID = '$id'";
		$resultCA = sysdb::query($query);
		$query = "SELECT name FROM {$this->store->table_traffic_campaignmaterial} WHERE campaignID = '$id'";
		$resultCM = sysdb::query($query);

		if ( sysdb::num_rows($resultCA) > 0 ) {
			state::setMessage('warning', 'Please delete existing campaign audio before deleting a campaign.');
		}elseif ( sysdb::num_rows($resultCM) > 0 ) {
			state::setMessage('warning', 'Please delete existing campaign materials before deleting a campaign.');
		} else {
			$query = "SELECT name FROM {$this->store->table_traffic_campaign} WHERE campaignID = '$id'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$query = "DELETE FROM {$this->store->table_traffic_campaignsam} WHERE campaignID = '$id'";
			$result = sysdb::query($query);
			$query = "DELETE FROM {$this->store->table_traffic_campaign} WHERE campaignID = '$id'";
			$result = sysdb::query($query);
			state::setMessage('notify', 'Successfully deleted campaign: '.$line['name'] );
		}
    }

    public function search($doc,$string) {
        $string = strtolower($string);
        $query = "SELECT campaignID FROM {$this->store->table_traffic_campaign} WHERE LCASE(name) LIKE '%$string%' OR startDate LIKE '%$string%' OR endDate LIKE '%$string%' OR createdDateTime LIKE '%$string%' ";
        $result = sysdb::query($query);
        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'campaignID')));
        }
    }

	public function include_header($doc,$parentIDType) {

		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			case 'CampaignAudio':
				$parentFieldName = 'campaignAudioID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		$item = globalize('item',get_class($this));
		$id = globalize('id');
		// Need this to resolve a page after using the Schedule UI.
        if ($id == '') $id = globalize('campaignAudioID');
		$extras = globalize('extras');
		$includeHeader = $doc->createElement('div');
		$includeHeader->setAttribute('id', 'inline_menu');

		$link = module::link_to_script_dom($doc,'Contracts','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Contract'),'Contracts');
		$contractsLink = $doc->createElement('span');
		$contractsLink->setAttribute('id', 'link_contracts');
		$contractsLink->setAttribute('class', 'inline_link');
		$contractsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Campaigns','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Campaign'),'Campaigns');
		$campaignsLink = $doc->createElement('span');
		$campaignsLink->setAttribute('id', 'link_campaigns');
		$campaignsLink->setAttribute('class', 'inline_link');
		$campaignsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Materials','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignMaterial'),'Materials');
		$campaignMaterialsLink = $doc->createElement('span');
		$campaignMaterialsLink->setAttribute('id', 'link_campaign_materials');
		$campaignMaterialsLink->setAttribute('class', 'inline_link');
		$campaignMaterialsLink->appendChild($link);

		$link = module::link_to_script_dom($doc,'Audio','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'CampaignAudio'),'Audio');
		$campaignAudioLink = $doc->createElement('span');
		$campaignAudioLink->setAttribute('id', 'link_campaign_audio');
		$campaignAudioLink->setAttribute('class', 'inline_link');
		$campaignAudioLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Traffic','',array('item'=>'Traffic','mode'=>$item,$parentFieldName=>$id),'Traffic');
		$trafficLink = $doc->createElement('span');
		$trafficLink->setAttribute('id', 'link_traffic');
		$trafficLink->setAttribute('class', 'inline_link');
		$trafficLink->appendChild($link);

        $link = module::link_to_script_dom($doc,'Log','',array('item'=>$item,'action'=>'view','id'=>$id,'extras'=>'Log'),'Log');
		$logLink = $doc->createElement('span');
		if ($extras == 'Log' || $extras == '')
			$logLink->setAttribute('id', 'link_logs_selected');
		else
			$logLink->setAttribute('id', 'link_logs');
		$logLink->setAttribute('class', 'inline_link');
		$logLink->appendChild($link);

		/* 	This switch is specifically designed *without* break statements.
			This is because once we hit our current item, all those below it are required as well.
			-CH
		*/
		switch ($item) {
			case 'Client':
				$includeHeader->appendChild($contractsLink);
			case 'Contract':
				$includeHeader->appendChild($campaignsLink);
			case 'Campaign':
				if ($parentIDType == 'Campaign') {
					$includeHeader->appendChild($campaignMaterialsLink);
				}
				$includeHeader->appendChild($campaignAudioLink);
			case 'CampaignAudio':
				$includeHeader->appendChild($logLink);
				$includeHeader->appendChild($trafficLink);
				break;
		}

		return $includeHeader;

	}

    public function inline_list($doc,$ids='',$isInclude=false) {
		$item = get_class($this);
		$campaignAudioID = globalize('campaignAudioID');
		$parentID = globalize('campaignAudioID');
        if ($parentID == '') $parentID = globalize('id');
		$parentIDType = globalize('item',get_class($this));
		switch ($parentIDType) {
			case 'Client':
				$parentFieldName = 'clientID';
				break;
			case 'Contract':
				$parentFieldName = 'contractID';
				break;
			case 'Campaign':
				$parentFieldName = 'campaignID';
				break;
			case 'CampaignAudio':
				$parentFieldName = 'campaignAudioID';
				break;
			default:
				$isInclude = false;
				$warning_message = "Not a valid parent.";
				break;
		}
		if ($parentIDType == 'Client')
			$x = 'C';
		if ($parentIDType == 'Contract')
			$x = 'O';
		if ($parentIDType == 'Campaign')
			$x = 'M';
		if ($parentIDType == 'CampaignAudio')
			$x = 'A';
		$query = <<<EOQ
			SELECT $x.name AS name
			FROM ({$this->store->table_traffic_client} C, 
				{$this->store->table_traffic_contract} O, 
				{$this->store->table_traffic_campaign} M, 
				{$this->store->table_traffic_campaignaudio} A
			)
			WHERE $x.$parentFieldName = '$parentID' 
			AND C.clientID = $x.clientID
EOQ;
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
		$caption_name = utf8_decode($line['name']);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module_right');
		$container->appendChild($this->include_header($doc,$parentIDType));

		$sortby = globalize('sortby');
		if (!isset($sortby))
			$sortby = 'dateTime, name';
		else {
			switch($sortby) {
				case 'name':
							$sortby = 'name, dateTime';
							break;
				case 'datetime':
							$sortby = 'dateTime, name';
							break;
				case 'playeddatetime':
							$sortby = 'playedDateTime, dateTime, name';
							break;
				default:
							$sortby = 'dateTime, name';
							break;
			}
		}

		$parentID = globalize('id');
		$parentIDType = globalize('item');

		$caption = "Log for $caption_name";

        $table = $doc->createElement('table');
        $table->setAttribute('class', 'list');

		$table->appendChild($captiontable = $doc->createElement('caption'));
		$captiontable->appendChild($doc->createTextNode($caption));

		$table->appendChild($colgroup = $doc->createElement('colgroup'));
		$colgroup->appendChild($col1 = $doc->createElement('col'));
		$colgroup->appendChild($col2 = $doc->createElement('col'));
		$col2->setAttribute('width', '145px');
		$colgroup->appendChild($col3 = $doc->createElement('col'));
		$col3->setAttribute('width', '145px');
		$colgroup->appendChild($col4 = $doc->createElement('col'));

		$table->appendChild($thead = $doc->createElement('thead'));
		$thead->appendChild($trhead = $doc->createElement('tr'));
		$trhead->appendChild($th1 = $doc->createElement('th'));
		$trhead->appendChild($th2 = $doc->createElement('th'));
		$trhead->appendChild($th3 = $doc->createElement('th'));
		$trhead->appendChild($th4 = $doc->createElement('th'));
		$th1->appendChild(module::link_to_script_dom($doc,'Name','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'name'),'Name'));
		$th2->appendChild(module::link_to_script_dom($doc,'Scheduled','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'datetime'),'Scheduled'));
		$th3->appendChild(module::link_to_script_dom($doc,'Played','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'playeddatetime'),'Played'));
		$th4->appendChild($doc->createTextNode('Difference'));

		$table->appendChild($tbody = $doc->createElement('tbody'));

		$query = <<<EOQ
			SELECT A.{$this->store->field_campaignaudio_name} AS name,
				S.{$this->store->field_spot_dateTime} AS dateTime,
				S.{$this->store->field_spot_playedDateTime} AS playedDateTime
			FROM ({$this->store->table_traffic_campaignaudio} A,
				{$this->store->table_traffic_spot} S
			)
			WHERE A.$parentFieldName = '$parentID'
			AND A.{$this->store->field_campaignaudio_mediaID} = S.{$this->store->field_spot_mediaID}
EOQ;
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0)
            $query .= " A.$parentFieldName IN (".implode(',',$ids).") ";
        if(isset($sortby))
			$query .= " ORDER BY ".$sortby;

		$containertable = $doc->createElement('div');
		$containertable->setAttribute('id', 'inline_table');

		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_csv_small');
		$span->appendChild(module::link_to_script_dom($doc,'Export as CSV','',array('item'=>$item,'action'=>'export','parent'=>$parentFieldName,'id'=>$parentID),'Export as CSV'));
		$containertable->appendChild($span);

		// Turn result query into a matrix.
		$matrix = sysdb::query2matrix($query,false);

		// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
		$vectors = sysdb::rotatematrix($matrix);

		// Perform data transformation on any column (vector), row by row (key by key).
        $dateTime = array();
        $playedDateTime = array();
		if (!empty($vectors[0])) {
			foreach ($vectors[0] as $key=>$value) {
				if ($vectors[0][$key] != '') {
					$vectors[0][$key] = utf8_decode($vectors[0][$key]);
				}
				$dateTime[$key] = date("d-M-Y H:i:s", strtotime($vectors[1][$key]));
				if ($vectors[2][$key] != '') {
					$playedDateTime[$key] = date("d-M-Y H:i:s", strtotime($vectors[2][$key]));
				} else {
					$playedDateTime[$key] = '';
				}
			}
		}

		// Replace the original matrix column(s) with the new the vector(s).
		$vectors[1] = $dateTime;
		$vectors[2] = $playedDateTime;

		// Rotate the new matrix 270 degrees to put it back the right way.
		$matrix_rotated_180 = sysdb::rotatematrix($vectors);
		$matrix_rotated_270 = sysdb::rotatematrix($matrix_rotated_180);
		$matrix_upright = sysdb::rotatematrix($matrix_rotated_270);

		$i = 1;

		// Assemble table.
		foreach ($matrix_upright as $row) {
			$tbody->appendChild($tr = $doc->createElement('tr'));
			$tr->appendChild($td1 = $doc->createElement('td'));
			$td1->appendChild($label = $doc->createTextNode($row[0]));
			$tr->appendChild($td2 = $doc->createElement('td'));
			$td2->appendChild($label = $doc->createTextNode($row[1]));
			$tr->appendChild($td3 = $doc->createElement('td'));
			$td3->appendChild($label = $doc->createTextNode($row[2]));

			$ontime = true;
			$skipped = false;
			$difference = '';
			if ($row[2] != '') {
				// Work out the difference between scheduled and played times.
				$date1 = strtotime($row[1]);
				$date2 = strtotime($row[2]);

				if (($date1 !== false) && ($date2 !== false)) {
					$diff = ($date2 - $date1);

					if ($diff < 0) {
						if ($days = intval((ceil($diff / 86400))))
							$diff %= 86400;
						if ($hours = intval((ceil($diff / 3600))))
							$diff %= 3600;
						if ($minutes = intval((ceil($diff / 60))))
							$diff %= 60;
					} else {
						if ($days = intval((floor($diff / 86400))))
							$diff %= 86400;
						if ($hours = intval((floor($diff / 3600))))
							$diff %= 3600;
						if ($minutes = intval((floor($diff / 60))))
							$diff %= 60;
					}

					$slothour = intval((floor($date1 / 3600)));
					$acthour = intval((floor($date2 / 3600)));

					if ($slothour != $acthour)
						$ontime = false;
					else
						$ontime = true;
				}
				if ($days != 0)
					$difference .= $days.' days '.$hours.' hrs '.$minutes.' mins';
				elseif ($hours != 0)
					$difference .= $hours.' hrs '.$minutes.' mins';
				else
					$difference .= $minutes.' mins';

			} else {
				if (strtotime("-1 hour") > strtotime($row[1])) {
					// Spot was not played.
					$skipped = true;
				}
			}
			$tr->appendChild($td4 =  $doc->createElement('td'));
			$td4->appendChild($doc->createTextNode($difference));

			if ($skipped) {
				$td1->setAttribute('class', 'error');
				$td1->setAttribute('title', 'Spot was not played');
				$td2->setAttribute('class', 'error');
				$td2->setAttribute('title', 'Spot was not played');
				$td3->setAttribute('class', 'error');
				$td3->setAttribute('title', 'Spot was not played');
				$td4->setAttribute('class', 'error number');
				$td4->setAttribute('title', 'Spot was not played');
			} else if ($ontime) {
				// Normal.
				$tdStyle = module::row_style_dom($i);
				$td1->setAttribute('class', $tdStyle);
				$td1->setAttribute('class', $tdStyle);
				$td2->setAttribute('class', $tdStyle);
				$td3->setAttribute('class', $tdStyle);
				$td4->setAttribute('class', $tdStyle.' number');
			} else {
				// Played late.
				$td1->setAttribute('class', 'highlight');
				$td1->setAttribute('title', 'Played outside the scheduled hour');
				$td2->setAttribute('class', 'highlight');
				$td2->setAttribute('title', 'Played outside the scheduled hour');
				$td3->setAttribute('class', 'highlight');
				$td3->setAttribute('title', 'Played outside the scheduled hour');
				$td4->setAttribute('class', 'highlight number');
				$td4->setAttribute('title', 'Played outside the scheduled hour');
			}
			$i++;
		}

		$containertable->appendChild($table);
 		$container->appendChild($containertable);

        return($container);
    }

    public function export($parentFieldName,$parentID) {
		$query = <<<EOQ
            SELECT
			A.{$this->store->field_campaignaudio_name},
			S.{$this->store->field_spot_dateTime},
			S.{$this->store->field_spot_playedDateTime}
			FROM (
			{$this->store->table_traffic_campaignaudio} A,
			{$this->store->table_traffic_spot} S
			)
            WHERE
			A.$parentFieldName = '$parentID'
			AND
			A.{$this->store->field_campaignaudio_mediaID} = S.{$this->store->field_spot_mediaID}
			ORDER BY {$this->store->field_spot_dateTime}
EOQ;
        $result = sysdb::query($query);

		$datetime = date("Y-m-d-H-i-s");
		sysdb::export_results($result,'Log_'.$parentFieldName.'_'.$parentID.'_'.$datetime.'.csv');
		exit;
    }

    public function export_dates($dates) {
		$exportDates = explode(",",$dates);
		$query = "SELECT A.name, ";
		$query .= "S.dateTime, S.playedDateTime FROM ({$this->store->table_traffic_campaignaudio} A, {$this->store->table_traffic_spot} S) WHERE S.mediaID = A.mediaID AND (";
		$increment = 0;
		foreach ($exportDates as $exportDate) {
			if ($increment++ != 0)
				$query .= " OR ";
			$query .= "S.dateTime LIKE '".$exportDate."%'";
		}
		$query .= ") ORDER BY dateTime";

		$result = sysdb::query($query);
		$count = count($exportDates);
		$i = $count - 1;
		$datetime = date("Y-m-d-H-i-s");
		sysdb::export_results($result,'Log_'.$exportDates[0].'-'.$exportDates[$i].'_'.$datetime.'.csv');
		exit;
    }

    public function export_dates_programs($dates) {
		$exportDates = explode(",",$dates);

		// Check for programs component dependency.
		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
			// Include dependency storage method.
			include_once(ROOT_COMPONENTS.'programs/moduleconfig.php');

			$periodID = globalize('periodID');

			echo '<?xml version="1.0" ?>';
			echo '<html>';
			echo '<body>';
			echo '<style>';
			echo 'th { vertical-align: top; }';
			echo 'td { vertical-align: top; }';
			echo '</style>';
			echo '<table border="1">';


			$query = "SELECT A.name, ";
			$query .= "S.dateTime, S.playedDateTime FROM ({$this->store->table_traffic_campaignaudio} A, {$this->store->table_traffic_spot} S) WHERE S.mediaID = A.mediaID AND (";
			$increment = 0;
			foreach ($exportDates as $exportDate) {
				if ($increment++ != 0)
					$query .= " OR ";
				$query .= "S.dateTime LIKE '".$exportDate."%'";
			}
			$query .= ") ORDER BY dateTime";

			$result = sysdb::query($query);
			$count = count($exportDates);
			$i = $count - 1;
			$datetime = date("Y-m-d-H-i-s");
			sysdb::export_results($result,'Log_'.$exportDates[0].'-'.$exportDates[$i].'_'.$datetime.'.csv');




			echo '</table>';
			echo '<body>';
			echo '<html>';
		}
		exit;
    }

    public function printnonshowndates($doc,$monthdate,$scheduledates) {
		if (is_array($scheduledates)) {
			if (isset($monthdate)) {
				$datearray = getdate(strtotime("1 ".$monthdate));
			} else {
				$datearray = getdate();
			}
			$nonshowndates = array();
			foreach ($scheduledates as $scheduledate) {
				$scheduledatearray = getdate(strtotime($scheduledate));
				if ($scheduledatearray['month'] != $month || $scheduledatearray['year'] != $year) {
					$nonshowndates[sizeof($nonshowndates)] = $scheduledate;
				}
			}
			$input = $doc->createElement('input');
			$input->setAttribute('type','hidden');
			$input->setAttribute('name','nonshowndates');
			$input->setAttribute('value',implode('|',$nonshowndates));
			return $input;
		} else {
			$input = $doc->createElement('input');
			$input->setAttribute('type','hidden');
			$input->setAttribute('name','nonshowndates');
			$input->setAttribute('value','');
			return $input;
		}
    }

	public function printcalendarday($doc,$date,$checkeddates) {
		$datearray = getdate($date);

		$input = $doc->createElement('input');
		$input->setAttribute('type','checkbox');
		$input->setAttribute('name','scheduledates[]');
		$input->setAttribute('value',date("Y-m-d",$date));

		if (is_array($checkeddates)) {
			if (in_array(date("Y-m-d",$date),$checkeddates))
				$input->setAttribute('checked','checked');
		}
		$timearray = getdate();
		$startoftoday = time()-($timearray['hours']*3600+$timearray['minutes']*60+$timearray['seconds']);
//		if ($date < $startoftoday)
//			$input->setAttribute('disabled','disabled');

		$input->appendChild($doc->createTextNode($datearray['mday']));

		return $input;
    }

    public function display_logs($doc,$id) {
		$g = array('moduleID','modulecategory','item','action','id');
		extract(globalize_many($g));
		$campaignAudioID = globalize('id');
		$monthdate = globalize('monthdate');
		$spotDates = globalize('scheduledates');
		$item = globalize('item',get_class($this));

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Schedule Logs'));
		$container->appendChild($header);

		// $p = $doc->createElement('p');
		// $p->setAttribute('class', 'warning');
		// $p->appendChild($doc->createTextNode($name));
		// $container->appendChild($p);

		$form = module::form_dom($doc);

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','action');
		$iteminput->setAttribute('value','export_dates');
		$form->appendChild($iteminput);

		$exportDates = implode(",",$spotDates);

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','dates');
		$iteminput->setAttribute('value',$exportDates);
		$form->appendChild($iteminput);

		if (isset($nonshowndates)) {
			$spotDates = array_merge($spotDates,explode("|",$nonshowndates));
			asort($spotDates);
			reset($spotDates);
		}
        $i = 0;
		/* Process each date selected from calendar */
		foreach($spotDates as $spotDate) {

			/* deadcode
			// $query = "SELECT S.dateTime, S.playedDateTime, S.spotID, I.name, I.mediaID FROM ({$this->store->table_traffic_campaignaudio} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_spot} S) WHERE S.dateTime  LIKE '".$spotDate."%' AND S.mediaID = I.mediaID AND C.clientID = I.clientID ORDER BY dateTime";
			// //		$query = "SELECT I.name, I.mediaID FROM ({$this->store->table_traffic_campaignaudio} I, {$this->store->table_traffic_client} C) WHERE C.clientID = I.clientID";
			// //		$query = "SELECT I.name, I.mediaID FROM ({$this->store->table_traffic_campaignaudio} I, {$this->store->table_traffic_client} C) WHERE I.campaignAudioID = '$campaignAudioID' AND C.clientID = I.clientID";
			// $result = sysdb::query($query);
			// $line = sysdb::fetch_assoc($result);
			// $name = $line['name'];
			// $mediaID = $line['mediaID'];

			//		$query = "SELECT dateTime, playedDateTime, spotID FROM {$this->store->table_traffic_spot} WHERE mediaID = '$mediaID' ORDER BY dateTime";
				//		$query = "SELECT dateTime, playedDateTime, activated, spotID FROM {$this->store->table_traffic_spot} WHERE mediaID = '$mediaID' ORDER BY dateTime";
				//		$result = sysdb::query($query);

				//		$query = "SELECT S.dateTime, S.playedDateTime, S.spotID, I.name, I.mediaID FROM ({$this->store->table_traffic_campaignaudio} I, {$this->store->table_traffic_client} C, {$this->store->table_traffic_spot} S) WHERE S.mediaID = I.mediaID AND C.clientID = I.clientID ORDER BY dateTime";
				//		$result = sysdb::query($query);
*/

			/* Create new heading for each date */
			$datestamp = strtotime($spotDate);
			$datearray = getdate($datestamp);
			$date = date("Y-m-d",$datestamp);
			$dow = ucfirst($datearray['weekday']);

			$header = $doc->createElement('h1');
			$header->appendChild($doc->createTextNode(date("d/m/Y",$datestamp)));
			$container->appendChild($header);

			/* Get the slots for the requested date(s) */
			$query = "SELECT * FROM {$this->store->table_traffic_slot} ";
			$query .= "WHERE startDate <= '$date' ";
			$query .= "AND (endDate IS NULL OR endDate >= '$date') ";
			$query .= "AND dow = '$dow' ";
			$query .= "ORDER BY time";

			if ($result = sysdb::query($query)) {
				$positioncount = 0;

				/* Create a new table for each date */
				$table = $doc->createElement('table');
				$table->setAttribute('class', 'list');

				$tr = $doc->createElement('tr');
				// $dateth = $doc->createElement('th');
				// $timesth = $doc->createElement('th');
				// $timesth->setAttribute('colspan','4');

				// $dateth->appendChild($doc->createTextNode('Date'));
				// $timesth->appendChild($doc->createTextNode('Times'));

				$th1 = $doc->createElement('th');
				$th2 = $doc->createElement('th');
				$th3 = $doc->createElement('th');
				$th4 = $doc->createElement('th');
				$th5 = $doc->createElement('th');
				$th1->appendChild($doc->createTextNode('Slot'));
				$th2->appendChild($doc->createTextNode('Name'));
				$th3->appendChild($doc->createTextNode('Scheduled'));
				$th4->appendChild($doc->createTextNode('Played'));
				$th5->appendChild($doc->createTextNode('Difference'));
	//			$th2->appendChild(module::link_to_script_dom($doc,'Name','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'name'),'Name'));
	//			$th3->appendChild(module::link_to_script_dom($doc,'Scheduled','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'datetime'),'Scheduled'));
	//			$th4->appendChild(module::link_to_script_dom($doc,'Played','',array('item'=>$parentIDType,'extras'=>$item,'action'=>'view','id'=>$parentID,'sortby'=>'playeddatetime'),'Played'));


				// $input = $doc->createElement('input');
				// $input->setAttribute('type', 'checkbox');
				// $input->setAttribute('name', 'allbox');
				// $input->setAttribute('onClick', 'switchAllCheckboxes(this.form);');

				// $checkboxtd->appendChild($input);

				$tr->appendChild($th1);
				$tr->appendChild($th2);
				$tr->appendChild($th3);
				$tr->appendChild($th4);
				$tr->appendChild($th5);

				$table->appendChild($tr);

				$i = 1;
				/* Process each time slot */
				while ($record = sysdb::fetch_assoc($result)) {
					/* For each Slot create a new row */

					$timestamp = strtotime($record['time']);
					$timearray = getdate($timestamp);

					$tr = $doc->createElement('tr');

					/* Add in new rows for each Spot */
					$newdatetime = $date.' '.date("H:i:s",$timestamp);
					$queryrows = "SELECT A.name, P.dateTime, P.playedDateTime FROM ({$this->store->table_traffic_campaignaudio} A, {$this->store->table_traffic_spot} P) WHERE P.dateTime = '$newdatetime' AND A.mediaID = P.mediaID";
					$result_row_count = sysdb::query($queryrows);
					$num_rows = sysdb::num_rows($result_row_count);

					$tdslot = $doc->createElement('td');
					$tdslot->setAttribute('rowspan', $num_rows);

					$string = date("g",$timestamp);
					if ($timearray['minutes'] != 0)
						$string .= date("i",$timestamp);
					$string .= ' '.strtoupper(date("a",$timestamp));
					$tdslot->appendChild($doc->createTextNode($string));
					++$positioncount;

					$trStyle = module::row_style_dom($i);
					$tdslot->setAttribute('class', $trStyle);

					$tr->appendChild($tdslot);

					$resultrows = sysdb::query($queryrows);

					if ($num_rows > 0) {
						while ($row = sysdb::fetch_assoc($resultrows)) {
							$dateTime = date("d-M-Y H:i:s", strtotime($row['dateTime']));
							if ($row['playedDateTime'] != '')
								$playedDateTime = date("d-M-Y H:i:s", strtotime($row['playedDateTime']));
							else
								$playedDateTime = '';

							$tr->appendChild($td1 = $doc->createElement('td'));
							$td1->appendChild($doc->createTextNode($row['name']));
							$tr->appendChild($td2 = $doc->createElement('td'));
							$td2->appendChild($doc->createTextNode($dateTime));
							$tr->appendChild($td3 = $doc->createElement('td'));
							$td3->appendChild($doc->createTextNode($playedDateTime));

							$ontime = true;
							$skipped = false;
							$difference = '';
							if ($playedDateTime != '') {
								// Work out the difference between scheduled and played times.
								$date1 = strtotime($dateTime);
								$date2 = strtotime($playedDateTime);

								if (($date1 !== false) && ($date2 !== false)) {
									$diff = ($date2 - $date1);

									if ($diff < 0) {
										if ($days = intval((ceil($diff / 86400))))
											$diff %= 86400;
										if ($hours = intval((ceil($diff / 3600))))
											$diff %= 3600;
										if ($minutes = intval((ceil($diff / 60))))
											$diff %= 60;
									} else {
										if ($days = intval((floor($diff / 86400))))
											$diff %= 86400;
										if ($hours = intval((floor($diff / 3600))))
											$diff %= 3600;
										if ($minutes = intval((floor($diff / 60))))
											$diff %= 60;
									}

									$slothour = intval((floor($date1 / 3600)));
									$acthour = intval((floor($date2 / 3600)));

									if ($slothour != $acthour)
										$ontime = false;
									else
										$ontime = true;
								}
								if ($days != 0)
									$difference .= $days.' days '.$hours.' hrs '.$minutes.' mins';
								elseif ($hours != 0)
									$difference .= $hours.' hrs '.$minutes.' mins';
								else
									$difference .= $minutes.' mins';

							} else {
								if (strtotime("-1 hour") > strtotime($dateTime)) {
									// Spot was not played.
									$skipped = true;
								}

							}
							$tr->appendChild($td4 = $doc->createElement('td'));
							$td4->appendChild($doc->createTextNode($difference));



							if ($skipped) {
								$td1->setAttribute('class', 'error');
								$td1->setAttribute('title', 'Spot was not played');
								$td2->setAttribute('class', 'error');
								$td2->setAttribute('title', 'Spot was not played');
								$td3->setAttribute('class', 'error');
								$td3->setAttribute('title', 'Spot was not played');
								$td4->setAttribute('class', 'error number');
								$td4->setAttribute('title', 'Spot was not played');
							} else if ($ontime) {
								// Normal.
								$tdStyle = module::row_style_dom($i);
								$tr->setAttribute('class', $tdStyle);
								$td1->setAttribute('class', $tdStyle);
								$td2->setAttribute('class', $tdStyle);
								$td3->setAttribute('class', $tdStyle);
								$td4->setAttribute('class', $tdStyle.' number');
							} else {
								// Played late.
								$td1->setAttribute('class', 'highlight');
								$td1->setAttribute('title', 'Played outside the scheduled hour');
								$td2->setAttribute('class', 'highlight');
								$td2->setAttribute('title', 'Played outside the scheduled hour');
								$td3->setAttribute('class', 'highlight');
								$td3->setAttribute('title', 'Played outside the scheduled hour');
								$td4->setAttribute('class', 'highlight number');
								$td4->setAttribute('title', 'Played outside the scheduled hour');
							}
							$table->appendChild($tr);
							$tr = $doc->createElement('tr');
						}
						$increment = true;
					} else {
						//There are no slots in this column.
						$increment = false;
					}
					if ($increment) {
						$i++;
					}
				} // end print list of slots
				$container->appendChild($table);
			} // end every slot for spotDate
		} // end for each spotDate

		// Check for program component dependency.
		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
			// This HTML link is the temporary link to test HTML export by program
			$exportHTML = module::link_to_script_dom($doc,'Export by Programs','programlogs2html.php',array('dates'=>$exportDates),true,true,'Export by Programs');
			$form->appendChild($exportHTML);
		}

		$exportCSV = $doc->createElement('input');
		$exportCSV->setAttribute('type','submit');
		$exportCSV->setAttribute('value','export to CSV');
		$form->appendChild($exportCSV);

		$container->appendChild($form);

        return($container);
    }

}
?>