<?php
// $Id$


class Notes {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function form($doc, $id='') {
        $item = globalize('item', get_class($this));

		$container = $doc->createElement('div');

        $table = $doc->createElement('table');
        $table->setAttribute('class','notes');

		$table->appendChild($caption = $doc->createElement('caption'));
		$caption->appendChild($label = $doc->createTextNode('Notes: '));

		$idname = strtolower($item{0}).substr($item,1).'ID';

        if ($id != '') {
			$query = <<<EOQ
				SELECT {$this->store->field_history_actorID} AS actorID,
					{$this->store->field_history_timestamp} AS timestamp,
					{$this->store->field_history_id} AS id,
					{$this->store->field_history_details} AS details
				FROM {$this->store->table_traffic_history}
				WHERE {$this->store->field_history_type} = '$idname'
				AND {$this->store->field_history_action} = 'note'
				AND {$this->store->field_history_id} = '$id'
				ORDER BY timestamp DESC
EOQ;
            $result = sysdb::query($query);
		}

		$user = new user();
		$myActorID = $user->getActorID();
		// $myActorID = user::userActorID();
        $table->appendChild($hidden = dom::createInputBox($doc,'notesActorID',$myActorID,'hidden'));
        $table->appendChild($hidden = dom::createInputBox($doc,'notesType',$idname,'hidden'));
        $table->appendChild($hidden = dom::createInputBox($doc,'notesId',$id,'hidden'));
        $table->appendChild($hidden = dom::createInputBox($doc,'notesAction','note','hidden'));

		$i = 0;
		while ($line = sysdb::fetch_assoc($result)) {
			$actorID = $line['actorID'];
			$timestamp = date("d/m/Y H:i", strtotime($line['timestamp']));
			$id = $line['id'];
			$details = $line['details'];

			// Decode UTF-8 character encoding.
			$details = utf8_decode($details);

			$query = <<<EOQ
				SELECT CONCAT({$this->store->field_detail_firstName},' ',{$this->store->field_detail_lastName}) AS username
				FROM {$this->store->table_detail}
				WHERE {$this->store->field_detail_actorID} = '$actorID'
EOQ;
			$username = sysdb::queryOne($query);

			$table->appendChild($notetr = $doc->createElement('tr'));
			$notetr->setAttribute('id','notesRow['.$i.']');
			$notetr->appendChild($labeltd = $doc->createElement('th'));
			$labeltd->setAttribute('id','notesHeader['.$i.']');
			$labeltd->appendChild($label = $doc->createTextNode($username));
            $labeltd->appendChild($doc->createElement('br'));
            $labeltd->appendChild($doc->createTextNode($timestamp));
			$notetr->appendChild($inputtd = $doc->createElement('td'));
			$inputtd->setAttribute('id','notesInput['.$i.']');
			$inputtd->appendChild($input = $doc->createTextNode($details));
		}

		$table->appendChild($addNotetr = $doc->createElement('tr'));
		$addNotetr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->setAttribute('id','notesHeader');
		$labeltd->appendChild($label = $doc->createTextNode('Add a new note: '));
		$labeltd->appendChild($doc->createElement('br'));
		$labeltd->appendChild($doc->createTextNode('(Strictly for internal use)'));
		$labeltd->setAttribute('rowspan','2');
		$addNotetr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->setAttribute('id','notesInput');
        $textarea = $doc->createElement('textarea');
        $textarea->setAttribute('name','notesDetails');
        $textarea->setAttribute('id','notesDetails');
        $input = $doc->createTextNode('');
        $textarea->appendChild($input);
		$inputtd->appendChild($textarea);

		$table->appendChild($addSubmittr = $doc->createElement('tr'));
		$addSubmittr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->setAttribute('id','notesSubmit');
		$save = $doc->createElement('input');
		$save->setAttribute('type','submit');
		$save->setAttribute('name','action');
		$save->setAttribute('value','annotate');
		$inputtd->appendChild($save);

		$container->appendChild($table);

        return($container);
    }

    public function add($actorID,$type,$id,$action,$details) {
		// Escape values.
		$values = array(&$type,
						&$action,
						&$details
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$success = false;
		$warning_message = '';

		if ($actorID != '' || $type != '' || $id != '' || $action != '' || $details != '') {
			$success = true;
		} else {
			$warning_message .= 'Notes not initializing properly. Appears to be missing input data. ';
		}

		if ( !$success ) {
			state::setMessage('warning', $warning_message );
		}
		if ( $success ) {
			$query = <<<EOQ
				INSERT INTO {$this->store->table_traffic_history} (
					{$this->store->field_history_actorID},
					{$this->store->field_history_id},
					{$this->store->field_history_type},
					{$this->store->field_history_action},
					{$this->store->field_history_details}
				) VALUES (
					'$actorID',
					'$id',
					'$type',
					'$action',
					'$details'
				)
EOQ;
            sysdb::query($query);
			state::setMessage('notify', 'Note added.');
			$classname = ucfirst(substr($type, 0, -2));

			module::forward_to_script('',array('item'=>$classname,'action'=>'view','id'=>$id));
		}
    }

}
?>
