<?php
// $Id$

class ProductType {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete': $this->delete(globalize('id')); break;
            case 'add':
				$this->add(	globalize('productTypeName'),
							globalize('productTypeStartYear'),
							globalize('productTypeStartMonth'),
							globalize('productTypeStartDay'),
							globalize('productTypeEndYear'),
							globalize('productTypeEndMonth'),
							globalize('productTypeEndDay'));
				break;
            case 'save':
				$this->save(globalize('productTypeID'),
							globalize('productTypeName'),
							globalize('productTypeStartYear'),
							globalize('productTypeStartMonth'),
							globalize('productTypeStartDay'),
							globalize('productTypeEndYear'),
							globalize('productTypeEndMonth'),
							globalize('productTypeEndDay'));
				break;
        }
    }

    public function headers($doc) {
		$moduleID = globalize('moduleID');
        $item = globalize('item', get_class($this));
		$script = $doc->createElement('script');
		$script->setAttribute('language', 'javascript');
		$script->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=".$item.".js");
		$script->appendChild($doc->createTextNode(''));

		return(array($script));
    }

    public function form($doc, $id='') {
		$item = globalize('item', get_class($this));
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Product Type';
        else
            $headerText = 'Edit Product Type';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

		if ($id != '') {
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'delete','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Campaign",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);

			$productTypeID = $doc->createElement('input');
			$productTypeID->setAttribute('type','hidden');
			$productTypeID->setAttribute('name','productTypeID');
			$productTypeID->setAttribute('value',$id);
			$container->appendChild($productTypeID);
		}

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        if ($id != '') {
            $query = "SELECT * FROM {$this->store->table_traffic_producttype} WHERE productTypeID = '$id'";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $productTypeID = $line['productTypeID'];
            $startDateArray = explode('-',$line['startDate']);
			if ($line['endDate'] == '') {
				$endDateArray = array(date('Y'),date('n'),date('j'));
				$disabled_date = true;
			} else {
				$endDateArray = explode('-',$line['endDate']);
				$disabled_date = false;
			}
            $name = $line['name'];

			// Decode UTF-8 character encoding.
			$values = array(&$name
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);
        } else {
		    $productTypeID = '';
            $startDateArray = array(date('Y'),date('n'),date('j'));
			$endDateArray = array(date('Y'),date('n'),date('j'));
            $name = '';
			$disabled_date = true;
		}

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Product Type Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','productTypeName');
        $input->setAttribute('value',$name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $startDatetr = $doc->createElement('tr');
        $startDatetr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('Start Date'));
        $startDatetr->appendChild($inputtd = $doc->createElement('td'));
        WriteDateSelect_dom($doc,$inputtd,'productTypeStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');

        $endDatetr = $doc->createElement('tr');
        $endDatetr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('End Date'));
        $endDatetr->appendChild($inputtd = $doc->createElement('td'));
        WriteDateSelect_dom($doc,$inputtd,'productTypeEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y',$disabled_date);

        $expirytr = $doc->createElement('tr');
        $expirytr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('Never Ends'));
        $expirytr->appendChild($inputtd = $doc->createElement('td'));
        $inputtd->appendChild($input = $doc->createElement('input'));
        $input->setAttribute('type','checkbox');
        $input->setAttribute('name','productTypeExpiry');
        $input->setAttribute('id','productTypeExpiry');
		if ($disabled_date)
			$input->setAttribute('checked',true);
		$input->setAttribute('onclick', "enableProductTypeEndDate();");

        $table->appendChild($nametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
        $table->appendChild($expirytr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);

		$container->appendChild($table);

        return($container);
    }

    public function inline_form($doc, $id='',$disabled) {

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

		$productTypeID = '';
		$startDateArray = array(date('Y'),date('n'),date('j'));
		$endDateArray = array(date('Y'),date('n'),date('j'));
		$name = '';

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Product Type Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('input');
        $input->setAttribute('type','text');
        $input->setAttribute('name','productTypeName');
        $input->setAttribute('id','productTypeName');
        $input->setAttribute('value',$name);
		if ($disabled)
	        $input->setAttribute('disabled','disabled');
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $startDatetr = $doc->createElement('tr');
        $startDatetr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('Start Date'));
        $startDatetr->appendChild($inputtd = $doc->createElement('td'));
        WriteDateSelect_dom($doc,$inputtd,'productTypeStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');

        $endDatetr = $doc->createElement('tr');
        $endDatetr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('End Date'));
        $endDatetr->appendChild($inputtd = $doc->createElement('td'));
        WriteDateSelect_dom($doc,$inputtd,'productTypeEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y',true);

        $expirytr = $doc->createElement('tr');
        $expirytr->appendChild($labeltd = $doc->createElement('th'));
        $labeltd->appendChild($label = $doc->createTextNode('Never Ends'));
        $expirytr->appendChild($inputtd = $doc->createElement('td'));
        $inputtd->appendChild($input = $doc->createElement('input'));
        $input->setAttribute('type','checkbox');
        $input->setAttribute('name','productTypeExpiry');
        $input->setAttribute('id','productTypeExpiry');
        $input->setAttribute('checked',true);
		$input->setAttribute('onclick', "enableProductTypeEndDate();");

        $table->appendChild($nametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
        $table->appendChild($expirytr);

        return($table);
    }

    public function view($doc, $id) {
        $container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Product Type'));
		$container->appendChild($header);

        $productTypeID = $doc->createElement('input');
        $productTypeID->setAttribute('type','hidden');
        $productTypeID->setAttribute('name','productTypeID');
        $productTypeID->setAttribute('value',$id);
        $container->appendChild($productTypeID);

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        $query = "SELECT * FROM ".$this->store->table_traffic_producttype." WHERE productTypeID = '$id'";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $productTypeID = $line['productTypeID'];
        $name = $line['name'];
        $startDate = $line['startDate'];
        $endDate = $line['endDate'];

		// Decode UTF-8 character encoding.
		$values = array(&$name
						);
		foreach ($values as &$value) {
			$value = utf8_decode($value);
		}
		unset($value);

        $nametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Product Type Name');
        $inputtd = $doc->createElement('td');
        $inputtd->setAttribute('class','name');
        $input = $doc->createTextNode($name);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $nametr->appendChild($labeltd);
        $nametr->appendChild($inputtd);

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($startDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($endDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

        $table->appendChild($nametr);
        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);

		$container->appendChild($table);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $item = globalize('item', get_class($this));

		$sortby = globalize('sortby');
		if (!isset($sortby))
			$sortby = 'name';
		else {
			switch($sortby) {
				case 'name':
						break;
				default:
					$sortby = 'name';
					break;
			}
		}

        $query = "SELECT I.productTypeID, I.name FROM {$this->store->table_traffic_producttype} I";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " WHERE I.productTypeID IN (".implode(',',$ids).") ";
        }
        if ($sortby != '') $query .= " ORDER BY ".$sortby;

        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');
        $tr = $doc->createElement('tr');
        $td = $doc->createElement('th');
        $td->setAttribute('colspan','5');
        $name = $doc->createTextNode('Product Types');

        $table->appendChild($tr);
        $tr->appendChild($td);
        $td->appendChild($name);

        $tr = $doc->createElement('tr');
        $startDatetd = $doc->createElement('th');
        $endDatetd = $doc->createElement('th');

        // $actiontd = $doc->createElement('td');
        // $actiontd->setAttribute('style','text-align: right;');
        // $actiontd->appendChild(module::link_to_script_dom($doc,'add',$module_script,array('item'=>$item,'action'=>'edit')));

        // $tr->appendChild($actiontd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $name = $doc->createTextNode('No productTypes entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        while ($line = sysdb::fetch_assoc($result)) {
            $tr = $doc->createElement('tr');

			$nametd = $doc->createElement('td');
            $nametd->appendChild($doc->createTextNode($line['name']));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$line['productTypeID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$line['productTypeID']),'Edit'));
            $actiontd->appendChild($span);

            // $actiontd = $doc->createElement('td');
            // $actiontd->appendChild(module::link_to_script_dom($doc,'view',$module_script,array('item'=>$item,'action'=>'view','id'=>$line['productTypeID']),'View'));
            // $actiontd->appendChild($doc->createTextNode(' | '));
            // $actiontd->appendChild(module::link_to_script_dom($doc,'[-]',$module_script,array('item'=>$item,'action'=>'delete','id'=>$line['productTypeID']),'View'));

            $table->appendChild($tr);
            $tr->appendChild($nametd);
            $tr->appendChild($actiontd);
        }
//        $tr = $doc->createElement('tr');
        // $actiontd = $doc->createElement('td');
        // $actiontd->setAttribute('colspan','5');
        // $actiontd->setAttribute('style','text-align: right;');
        // $actiontd->appendChild(module::link_to_script_dom($doc,'add',$module_script,array('item'=>$item,'action'=>'edit')));

        $table->appendChild($tr);
        // $tr->appendChild($actiontd);

        return($table);
    }

    public function overview($doc,$ids='',$sortby='') {
        $item = globalize('item', get_class($this));
        // $query = "SELECT I.productTypeID, I.name FROM {$this->store->table_traffic_producttype} I";
        // if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            // $query .= " WHERE I.productTypeID IN (".implode(',',$ids).") ";
        // }
        // $query .= " ORDER BY name ";

        // $result = sysdb::query($query);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Product Type'));
		$container->appendChild($header);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Product Type','',array('item'=>$item,'action'=>'edit'),'Add Product Type','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Product Type');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

		$container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT S.productTypeID, S.name FROM {$this->store->table_traffic_producttype} S ORDER BY name";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','productTypeID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No productTypes available');
            $option->appendChild($text);
        }
        while ($line = sysdb::fetch_assoc($result)) {
            $option = $doc->createElement('option');
            $option->setAttribute('value',$line['productTypeID']);
               $text = $doc->createTextNode(utf8_decode($line['name']));
            $option->appendChild($text);
            $select->appendChild($option);
        }

        return($select);
    }

    public function add($name, $startYear, $startMonth, $startDay, $endYear, $endMonth, $endDay) {
		// Escape values.
		$values = array(&$name
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$errors = false;
		$warning_message = '';

		if (!checkdate($startMonth, $startDay, $startYear)) {
			$warning_message .= "Invalid start date. ";
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if ($endDay == '') $endDay = 0;
		if ($endMonth == '') $endMonth = 0;
		if ($endYear == '') $endYear = 0;

		if (!checkdate($endMonth, $endDay, $endYear)) {
			$endDate = '';
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ($errors) {
			state::setMessage('warning', $warning_message);
		} elseif (!$errors) {
			$query = <<<EOQ
				INSERT INTO {$this->store->table_traffic_producttype} (
					{$this->store->field_producttype_name},
					{$this->store->field_producttype_startDate},
					{$this->store->field_producttype_endDate}
				) VALUES (
					'$name',
					'$startDate',
EOQ;
			if ($endDate != '') {
				$query .= "'$endDate'";
			} else {
				$query .= "NULL";
			}
			$query .= ")";
			sysdb::query($query);
			state::setMessage('notify', 'Successfully added new product type: '.utf8_decode($name));
		}
    }

    public function save($id, $name, $startYear, $startMonth, $startDay, $endYear, $endMonth, $endDay) {
		// Escape values.
		$values = array(&$name
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		$errors = false;
		$warning_message = '';

		if (!checkdate($startMonth, $startDay, $startYear)) {
			$warning_message .= "Invalid start date. ";
			$errors = true;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if ($endDay == '') $endDay = 0;
		if ($endMonth == '') $endMonth = 0;
		if ($endYear == '') $endYear = 0;

		if (!checkdate($endMonth, $endDay, $endYear)) {
			$endDate = '';
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		if ($errors) {
			state::setMessage('warning', $warning_message);
		} elseif (!$errors) {
			$query = <<<EOQ
				UPDATE {$this->store->table_traffic_producttype}
				SET {$this->store->field_producttype_name} = '$name',
					{$this->store->field_producttype_startDate} = '$startDate',
					{$this->store->field_producttype_endDate} =
EOQ;
			if ($endDate != '') {
				$query .= " '$endDate'";
			} else {
				$query .= " NULL";
			}
			$query .= " WHERE {$this->store->field_producttype_productTypeID} = '$id'";
			sysdb::query($query);
			state::setMessage('notify', 'Successfully updated product type: '.utf8_decode($name));
		}
    }

    public function delete($id) {
        global $notify_message;
		$query = "SELECT name FROM {$this->store->table_traffic_producttype} WHERE productTypeID = '$id'";
        $result = sysdb::query($query);
		$line = sysdb::fetch_assoc($result);
        $query = "DELETE FROM {$this->store->table_traffic_producttype} WHERE productTypeID = '$id'";
        $result = sysdb::query($query);
		$notify_message = 'Successfully deleted product type: '.$line['name'];
    }

    public function search($doc,$string) {
        $query = "SELECT productTypeID FROM {$this->store->table_traffic_producttype} WHERE name LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'productTypeID')));
        }
    }

}
?>
