<?php
// $Id$

class SAM {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('samActorID'));
				break;
            case 'save':
				$this->save(globalize('samID'),
							globalize('samActorID'),
							globalize('samTitle'),
							globalize('samFirstName'),
							globalize('samLastName'),
							globalize('samAddress'),
							globalize('samCity'),
							globalize('samPostcode'),
							globalize('samWork'),
							globalize('samMobile'),
							globalize('samFax'),
							globalize('samEmail'));
				break;
        }
    }

    public function form($doc, $id='') {
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Sponsor Account Manager';
        else
            $headerText = 'Edit Sponsor Account Manager';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

       /* Database Code */
        if ($id != '') {
			$item = globalize('item', get_class($this));
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'delete','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Contract",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);

			$query = "SELECT I.samID, I.actorID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_sam} I, {$this->store->table_detail} D) WHERE I.samID = '$id' AND I.actorID = D.actorID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $samID = $line['samID'];
            $actorID = $line['actorID'];
            $title = $line['title'];
            $firstName = $line['firstName'];
            $lastName = $line['lastName'];
            $address = $line['address'];
            $city = $line['city'];
            $postcode = $line['postcode'];
            $work = $line['landline'];
            $mobile = $line['mobile'];
            $fax = $line['fax'];
            $email = $line['email'];

			// Decode UTF-8 character encoding.
			$values = array(&$title,
							&$firstName,
							&$lastName,
							&$address,
							&$city,
							&$email
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$fields = array(
			 "Title"=>     array( "name"=>"samTitle", "value"=>$title ),
			 "First Name"=> array( "name"=>"samFirstName", "value"=>$firstName),
			 "Last Name"=>  array( "name"=>"samLastName", "value"=>$lastName),
			 "Address"=>   array( "name"=>"samAddress", "value"=>$address),
			 "City"=>      array( "name"=>"samCity", "value"=>$city),
			 "Postcode"=>  array( "name"=>"samPostcode", "value"=>$postcode),
			 "Work"=>   array( "name"=>"samWork", "value"=>$work),
			 "Mobile"=> array( "name"=>"samMobile", "value"=>$mobile),
			 "Fax"=>    array( "name"=>"samFax", "value"=>$fax),
			 "Email"=>     array( "name"=>"samEmail", "value"=>$email)   );

			foreach($fields as $name=>$val) {
				$formFields[$name] = dom::createInputBox($doc, $val['name'], $val['value'], 'text');
			}

			$samIDHidden = dom::createInputBox($doc, 'samID', $id, 'hidden');
			$container->appendChild($samIDHidden);

			$actorIDHidden = dom::createInputBox($doc, 'samActorID', $actorID, 'hidden');
			$container->appendChild($actorIDHidden);

			$table = dom::createTable($doc, $formFields, 'view');
			$container->appendChild($table);

			$savetr = $doc->createElement('tr');
			$savetd = $doc->createElement('td');
			$save = $doc->createElement('input');
			$save->setAttribute('type','submit');
			$save->setAttribute('name','action');
			$save->setAttribute('value','save');
			$savetd->appendChild($save);
			$savetr->appendChild($savetd);
			$table->appendChild($savetr);

        } else {
            $samID = '';
            $title = '';
            $firstName = '';
            $lastName = '';
            $address = '';
            $city = '';
            $postcode = '';
            $work = '';
            $mobile = '';
            $fax = '';
            $email = '';

			$table = $doc->createElement('table');
			$table->setAttribute('class','view');

			$usertr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('Select User');
			$inputtd = $doc->createElement('td');
			$labeltd->appendChild($label);
			$input = $this->display_select($doc);
			$inputtd->appendChild($input);
			$usertr->appendChild($labeltd);
			$usertr->appendChild($inputtd);

			$table->appendChild($usertr);

			$savetr = $doc->createElement('tr');
			$savetd = $doc->createElement('td');
			$save = $doc->createElement('input');
			$save->setAttribute('type','submit');
			$save->setAttribute('name','action');
			$save->setAttribute('value','add');
			$savetd->appendChild($save);
			$savetr->appendChild($savetd);
			$table->appendChild($savetr);
		}
        $container->appendChild($table);
        return($container);
    }

    public function inline_form($doc, $id='',$disabled) {
		// $container = $doc->createElement('div');
		// $container->setAttribute('class','module');

		// if ($id == '')
            // $headerText = 'Add Sponsor Account Manager';
        // else
            // $headerText = 'Edit Sponsor Account Manager';

		// $header = $doc->createElement('h1');
		// $header->appendChild($doc->createTextNode($headerText));
		// $container->appendChild($header);

       // /* Database Code */
        // if ($id != '') {
			// $item = globalize('item', get_class($this));
			// $spanbutton = $doc->createElement('span');
			// $spanbutton->setAttribute('class', 'link_button');
			// $a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'delete','id'=>$id),'Delete','link_button');
			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $label = $doc->createTextNode('Delete');
			// $span->appendChild($label);
			// $a->appendChild($span);
			// $spanbutton->appendChild($a);
			// $container->appendChild($spanbutton);

			// // $span = $doc->createElement('span');
			// // $span->setAttribute('class', 'link_delete');
			// // $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Contract",'action'=>'delete','id'=>$id),'Delete'));
			// // $container->appendChild($span);

			// $query = "SELECT I.samID, I.actorID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_sam} I, {$this->store->table_detail} D) WHERE I.samID = '$id' AND I.actorID = D.actorID";
            // $result = sysdb::query($query);
            // $line = sysdb::fetch_assoc($result);

            // $samID = $line['samID'];
            // $actorID = $line['actorID'];
            // $title = $line['title'];
            // $firstName = $line['firstName'];
            // $lastName = $line['lastName'];
            // $address = $line['address'];
            // $city = $line['city'];
            // $postcode = $line['postcode'];
            // $work = $line['landline'];
            // $mobile = $line['mobile'];
            // $fax = $line['fax'];
            // $email = $line['email'];

			// $fields = array(
			 // "Title"=>     array( "name"=>"samTitle", "value"=>$title ),
			 // "First Name"=> array( "name"=>"samFirstName", "value"=>$firstName),
			 // "Last Name"=>  array( "name"=>"samLastName", "value"=>$lastName),
			 // "Address"=>   array( "name"=>"samAddress", "value"=>$address),
			 // "City"=>      array( "name"=>"samCity", "value"=>$city),
			 // "Postcode"=>  array( "name"=>"samPostcode", "value"=>$postcode),
			 // "Work"=>   array( "name"=>"samWork", "value"=>$work),
			 // "Mobile"=> array( "name"=>"samMobile", "value"=>$mobile),
			 // "Fax"=>    array( "name"=>"samFax", "value"=>$fax),
			 // "Email"=>     array( "name"=>"samEmail", "value"=>$email)   );

			// foreach($fields as $name=>$val) {
				// $formFields[$name] = dom::createInputBox($doc, $val['name'], $val['value'], 'text');
			// }

			// $samIDHidden = dom::createInputBox($doc, 'samID', $id, 'hidden');
			// $container->appendChild($samIDHidden);

			// $actorIDHidden = dom::createInputBox($doc, 'samActorID', $actorID, 'hidden');
			// $container->appendChild($actorIDHidden);

			// $table = dom::createTable($doc, $formFields, 'view');
			// $container->appendChild($table);

			// $savetr = $doc->createElement('tr');
			// $savetd = $doc->createElement('td');
			// $save = $doc->createElement('input');
			// $save->setAttribute('type','submit');
			// $save->setAttribute('name','action');
			// $save->setAttribute('value','save');
			// $savetd->appendChild($save);
			// $savetr->appendChild($savetd);
			// $table->appendChild($savetr);

        // } else {
            // $samID = '';
            // $title = '';
            // $firstName = '';
            // $lastName = '';
            // $address = '';
            // $city = '';
            // $postcode = '';
            // $work = '';
            // $mobile = '';
            // $fax = '';
            // $email = '';

			$table = $doc->createElement('table');
			$table->setAttribute('class','view');

			$usertr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('Select User');
			$inputtd = $doc->createElement('td');
			$labeltd->appendChild($label);
			$input = SAM::display_select($doc);
			if ($disabled)
				$input->setAttribute('disabled','disabled');
			$inputtd->appendChild($input);
			$usertr->appendChild($labeltd);
			$usertr->appendChild($inputtd);

			$table->appendChild($usertr);

			// $savetr = $doc->createElement('tr');
			// $savetd = $doc->createElement('td');
			// $save = $doc->createElement('input');
			// $save->setAttribute('type','submit');
			// $save->setAttribute('name','action');
			// $save->setAttribute('value','add');
			// $savetd->appendChild($save);
			// $savetr->appendChild($savetd);
			// $table->appendChild($savetr);
		// }
        // $container->appendChild($table);
        // return($container);
        return($table);
    }

    public function view($doc, $id) {
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Sponsor Account Manager'));
		$container->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $container->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        $samID = $doc->createElement('input');
        $samID->setAttribute('type','hidden');
        $samID->setAttribute('name','samID');
        $samID->setAttribute('value',$id);
        $container->appendChild($samID);

//		$query = "SELECT I.samID, D.firstName, D.lastName FROM {$this->store->table_traffic_sam} I, {$this->store->table_detail} D WHERE I.samID = '$id' AND D.actorID = I.actorID";
//        $result = sysdb::query($query);

		if ($id != '') {
			$query = "SELECT I.samID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_sam} I, {$this->store->table_detail} D) WHERE I.samID = '$id' AND I.actorID = D.actorID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);

			$samID = $line['samID'];
			$title = $line['title'];
			$firstName = $line['firstName'];
			$lastName = $line['lastName'];
			$address = $line['address'];
			$city = $line['city'];
			$postcode = $line['postcode'];
			$work = displayLandlineNumber($line['landline']);
			$mobile = displayMobileNumber($line['mobile']);
			$fax = displayLandlineNumber($line['fax']);
			$email = $line['email'];

			// Decode UTF-8 character encoding.
			$values = array(&$title,
							&$firstName,
							&$lastName,
							&$address,
							&$city,
							&$email
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);
		}

        $titletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Title');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($title);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $titletr->appendChild($labeltd);
        $titletr->appendChild($inputtd);

        $firstNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('First Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($firstName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $firstNametr->appendChild($labeltd);
        $firstNametr->appendChild($inputtd);

        $lastNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Last Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($lastName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $lastNametr->appendChild($labeltd);
        $lastNametr->appendChild($inputtd);

        $addresstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Address');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($address);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $addresstr->appendChild($labeltd);
        $addresstr->appendChild($inputtd);

        $citytr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('City');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($city);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $citytr->appendChild($labeltd);
        $citytr->appendChild($inputtd);

        $postcodetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Postcode');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($postcode);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $postcodetr->appendChild($labeltd);
        $postcodetr->appendChild($inputtd);

        $worktr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Work');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($work);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $worktr->appendChild($labeltd);
        $worktr->appendChild($inputtd);

        $mobiletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Mobile');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($mobile);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $mobiletr->appendChild($labeltd);
        $mobiletr->appendChild($inputtd);

        $faxtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Fax');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($fax);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $faxtr->appendChild($labeltd);
        $faxtr->appendChild($inputtd);

        $emailtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Email');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('a');
        $input->setAttribute('href','mailto:'.$email);
        $input->appendChild($doc->createTextNode($email));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $emailtr->appendChild($labeltd);
        $emailtr->appendChild($inputtd);

        $table->appendChild($titletr);
        $table->appendChild($firstNametr);
        $table->appendChild($lastNametr);
        $table->appendChild($addresstr);
        $table->appendChild($citytr);
        $table->appendChild($postcodetr);
        $table->appendChild($worktr);
        $table->appendChild($mobiletr);
        $table->appendChild($faxtr);
        $table->appendChild($emailtr);

        $container->appendChild($table);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $query = "SELECT I.samID, I.actorID, U.name, U.login FROM ({$this->store->table_traffic_sam} I, {$this->store->table_user} U) WHERE I.actorID = U.actorID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " AND I.samID IN (".implode(',',$ids).") ";
        }
        if ($sortby != '') $query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

        $tr = $doc->createElement('tr');
        $logintd = $doc->createElement('th');
        $firstNametd = $doc->createElement('th');
        $lastNametd = $doc->createElement('th');
        $emailtd = $doc->createElement('th');

        $logintd->appendChild($doc->createTextNode('Login'));
        $firstNametd->appendChild($doc->createTextNode('First'));
        $lastNametd->appendChild($doc->createTextNode('Last'));
        $emailtd->appendChild($doc->createTextNode('Email'));

        $tr->appendChild($logintd);
        $tr->appendChild($firstNametd);
        $tr->appendChild($lastNametd);
        $tr->appendChild($emailtd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','4');
            $name = $doc->createTextNode('No SAMs entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$actorID = $line['actorID'];
			$samID = $line['samID'];

			$querydetails = "SELECT D.firstName, D.lastName, D.email FROM ({$this->store->table_traffic_sam} I, {$this->store->table_detail} D) WHERE I.actorID = '$actorID' AND I.actorID = D.actorID";
			$resultdetails = sysdb::query($querydetails);
			$linedetails  = sysdb::fetch_assoc($resultdetails);

			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $logintd = $doc->createElement('td');
            $firstNametd = $doc->createElement('td');
            $lastNametd = $doc->createElement('td');
            $emailtd = $doc->createElement('td');

            $logintd->appendChild($doc->createTextNode($line['login']));
            $firstNametd->appendChild($doc->createTextNode($linedetails['firstName']));
            $lastNametd->appendChild($doc->createTextNode($linedetails['lastName']));
            $emailhref = $doc->createElement('a');
            $emailhref->setAttribute('href','mailto:'.$linedetails['email']);
            $emailhref->appendChild($doc->createTextNode($linedetails['email']));
            $emailtd->appendChild($emailhref);
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>globalize('item', get_class($this)),'action'=>'view','id'=>$line['samID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>globalize('item', get_class($this)),'action'=>'edit','id'=>$line['samID']),'Edit'));
            $actiontd->appendChild($span);

            $table->appendChild($tr);
            $tr->appendChild($logintd);
            $tr->appendChild($firstNametd);
            $tr->appendChild($lastNametd);
            $tr->appendChild($emailtd);
            $tr->appendChild($actiontd);
			$i++;
        }

        return($table);
    }

    public function overview($doc,$ids='',$sortby='') {
        $item = globalize('item', get_class($this));
		if (!isset($sortby))
			$sortby = 'lastName';
		else {
			switch($sortby) {
				case 'lastName':
							break;
				case 'firstName':
							$sortby = 'firstName';
							break;
				case 'email':
							$sortby = 'email';
							break;
				default:
							$sortby = 'lastName';
							break;
			}
		}
        $query = "SELECT I.samID, I.actorID, U.name, U.login FROM ({$this->store->table_traffic_sam} I, {$this->store->table_user} U) WHERE I.actorID = U.actorID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " AND I.samID IN (".implode(',',$ids).") ";
        }
//        $query .= " ORDER BY $sortby ";

        $ids = sysdb::query2vector($query,'samID');

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Sponsor Account Managers'));
		$container->appendChild($header);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add SAM','',array('item'=>$item,'action'=>'edit'),'Add SAM','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add SAM');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

		$container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
		$query = <<<EOQ
			SELECT U.actorID,
				U.name,
				U.login
			FROM ({$this->store->table_user} U
			)
			WHERE U.actorID NOT IN
				(SELECT {$this->store->field_sam_actorID}
				FROM {$this->store->table_traffic_sam}
				)
			ORDER BY name
EOQ;
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','samActorID');
        $select->setAttribute('id','samActorID');
		$option = $doc->createElement('option');
		$option->setAttribute('value','');
		$option->appendChild($text = $doc->createTextNode(''));
		$select->appendChild($option);

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No Users available');
            $option->appendChild($text);
        }
        while ($line = sysdb::fetch_assoc($result)) {
            $option = $doc->createElement('option');
            $option->setAttribute('value',$line['actorID']);
            $text = $doc->createTextNode($line['name'].' ('.$line['login'].')');
            $option->appendChild($text);
            $select->appendChild($option);
        }
        return($select);
    }

    public function add($actorID) {
		// Check for duplicate user.
		$query = <<<EOQ
			SELECT
			{$this->store->field_sam_samID}
			FROM
			{$this->store->table_traffic_sam}
			WHERE
			{$this->store->field_sam_actorID} = '$actorID'
EOQ;
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) > 0) {
			state::setMessage('warning',"User is already assigned a Sponsor Accounts Manager role. ");
		} else {
			// Inject the record into storage.
			$query = <<<EOQ
				INSERT INTO
				{$this->store->table_traffic_sam}
				({$this->store->field_sam_actorID})
				VALUES
				('$actorID')
EOQ;
			sysdb::query($query);
		}
		// Check to see if actor has details, and if not create them.
		createFalseActorDetail($actorID);
    }

    public function save($id,$actorID,$title,$firstName,$lastName,$address,$city,$postcode,$work,$mobile,$fax,$email) {
		// Escape values.
		$values = array(&$title,
						&$firstName,
						&$lastName,
						&$address,
						&$city,
						&$email
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Strip whitespace from phone numbers and ABN.
		$values = array(&$work,
						&$mobile,
						&$fax
						);
 		foreach ($values as &$value) {
			$value = str_replace(' ', '', $value);
		}
		unset($value);

		if ($actorID == '') {
			$query = "SELECT actorID FROM {$this->store->table_traffic_sam} WHERE samID = '$id'";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);
			$actorID = $line['actorID'];
			$query = "INSERT INTO {$this->store->table_detail} (title, firstName, lastName, address, city, postcode, landline, mobile, fax, email, actorID) VALUES ('$title','$firstName','$lastName','$address','$city','$postcode','$work','$mobile','$fax','$email','$actorID')";
			$result = sysdb::query($query);
			state::setMessage('notify',"Successfully added contact details for ".utf8_decode($firstName." ".$lastName));
        } else {
			$query = "UPDATE ({$this->store->table_traffic_sam} I, {$this->store->table_detail} D) SET D.title = '$title', D.firstName = '$firstName', D.lastName = '$lastName',  D.address = '$address', D.city = '$city', D.postcode = '$postcode', D.landline = '$work', D.mobile = '$mobile', D.fax = '$fax', D.email = '$email' WHERE I.samID = '$id' AND I.actorID = D.actorID";
			$result = sysdb::query($query);
			state::setMessage('notify',"Successfully updated contact details for ".utf8_decode($firstName." ".$lastName));
		}
    }

    public function delete($id) {
        $query = "DELETE FROM {$this->store->table_traffic_sam} WHERE samID = '$id'";
        $result = sysdb::query($query);
		state::setMessage('notify',"Successfully removed user from SAM list");
    }

    public function search($doc,$string) {
        $query = <<<EOQ
            SELECT samID
            FROM ({$this->store->table_traffic_sam} T, {$this->store->table_detail} D)
            WHERE T.actorID = D.actorID
            AND (D.firstName LIKE '%$string%'
            OR D.lastName LIKE '%$string%'
            OR D.email LIKE '%$string%')
EOQ;
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'samID')));
        }
    }

}
?>
