<?php
// $Id$

/**
 * Manages the scheduling of campaign audio as spots with respect to timeslots (slots).
 */
class Schedule {
	var $store;

	/**
	 * Automatically loads core and component storage parameters.
	 */
	function __construct() {
	}

//    private $info = array('display_modes'=> array('displayGridByHour'));

    public function get_info($key) {
        if(isset($this->info[$key])) {
           return $this->info[$key];
        } else {
           return false;
        }
    }

    public function actions() {
        switch(globalize('action')) {
            case 'example': $this->example(globalize('params')); break;
        }
    }

    public function form($doc, $id='') {

       // form, returns FORM dom document

    }

    public function view($doc, $id) {

       // view, returns VIEW dom document

    }

	/**
	 * Displays the spots by campaign audio in a calendar grid as slots with tickboxes.
	 */
    public function displayGridTickboxes($doc, $id) {

        // display_list, return DISPLAY GRID dom document

		global $module_parameter;

		$moduleID = globalize('moduleID');
		$action = globalize('action');
		$act = globalize('act');
		$campaignAudioID = globalize('campaignAudioID');

		// Check to see if a max hourly time is set as a module parameter.
		if (isset($module_parameter['maxTimePerHour'])) {
			$maxtime = $module_parameter['maxTimePerHour'];
		} else {
			$maxtime = 300;
		}

        if ($action != 'reschedule') {
			if ($campaignAudioID == '') $campaignAudioID = globalize('id');
		} else if ($action == 'reschedule') {
			$highlightoverlay = globalize('highlightoverlay');
			$old_spotdateTime = globalize('old_spotdateTime');
			$old_spotID = globalize('id');
			if ($old_spotdateTime == '') {
				$query = <<<EOQ
					SELECT A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID,
						S.{$this->store->field_spot_dateTime} AS dateTime
					FROM ({$this->store->table_traffic_spot} S,
						{$this->store->table_traffic_campaignaudio} A
					)
					WHERE S.{$this->store->field_spot_spotID} = '$old_spotID'
					AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
EOQ;
				$result = sysdb::query($query);
				$line = sysdb::fetch_assoc($result);
				$campaignAudioID = $line['campaignAudioID'];
				$old_spotdateTime = $line['dateTime'];
				// Fetch display start date.
				$day_display_start = globalize('day_start');
			}
		}
		// Retrieve the spots that can be modified (that is younger than now) for display purposes.
        if (globalize('spots_loaded') == '') {
            $query = <<<EOQ
                SELECT S.{$this->store->field_spot_dateTime} AS dateTime
                FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaignaudio} A
				)
                WHERE A.{$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
                AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
				ORDER BY dateTime
EOQ;
            $selected_spots = sysdb::query2vector($query, 'dateTime');

			if ($action == 'reschedule' && $highlightoverlay == '') {
				$highlightoverlay = $selected_spots;

				$display_days = globalize('view_days', 14);
				if ($display_days == '1') {
					$display_day_offset = 0;
				} else {
					$display_day_offset = $display_days / 2;
				}

				// Check if the spot date (minus 6 days for display purposes) is in the past, and then set the display start.
				if (strtotime($old_spotdateTime." - ".$display_day_offset." days") <= strtotime(date('Y-m-d'))) {
					// Set display start date as today.
					$day_display_start = date('Y-m-d');
				} else {
					// Set display start date as spot date.
					$day_display_start = date('Y-m-d', strtotime($old_spotdateTime." - ".$display_day_offset." days"));
				}
			} else {
			    // Determine the first scheduled spot's dateTime to use as the start date.
			    reset($selected_spots);
			    $startDate = key($selected_spots);

			    // If nothing has been scheduled, grab campaign start date as start date.
			    if ($startDate == '') {
				    $query = <<<EOQ
					    SELECT C.{$this->store->field_campaign_startDate} AS campaignStartDate
					    FROM ({$this->store->table_traffic_campaign} C, {$this->store->table_traffic_campaignaudio} A)
					    WHERE A.{$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
                        AND A.{$this->store->field_campaignaudio_campaignID} = C.{$this->store->field_campaign_campaignID}
EOQ;
				    $startDate = sysdb::queryOne($query);
			    } else {
                    $startDateObj = new DateTime($startDate);
                    if (date('h:i:s',strtotime($startDate)) < $display_start_time) $startDateObj->modify('-1 day');
                    $startDate = $startDateObj->format('Y-m-d h:i:s');
                }
			    // Check if the audio start date is in the past, and then set the display start.
			    if (strtotime($startDate) <= strtotime(date('Y-m-d'))) {
				    // Set display start date as today.
				    $day_display_start = date('Y-m-d');
			    } else {
				    // Set display start date as audio start date.
				    $day_display_start = $startDate;
			    }
			}
        } else {
			if ($action == 'reschedule') {
				$highlighted_spots = globalize('highlightoverlay',array());
			}
			$selected_spots = globalize('traffic_tickbox',array());

			// Fetch display start date.
			$day_display_start = globalize('day_start');
		}


		// Pull schedule for the rest of the campaign.
		$query = <<<EOQ
			SELECT S.{$this->store->field_spot_dateTime}
			FROM ({$this->store->table_traffic_spot} S,
				{$this->store->table_traffic_campaignaudio} A
			)
			WHERE A.{$this->store->field_campaignaudio_campaignID} = (
				SELECT {$this->store->field_campaignaudio_campaignID}
				FROM {$this->store->table_traffic_campaignaudio}
				WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
			)
			AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
			AND A.{$this->store->field_campaignaudio_campaignAudioID} != '$campaignAudioID'
EOQ;
		$campaign_spots = sysdb::query2vector($query, 'dateTime');

		// Retrieve the number of spots for the whole campaign audio for spot counter purposes.
//		if ($action != 'reschedule') {
/*
			$query = <<<EOQ
				SELECT COUNT(S.{$this->store->field_spot_spotID})
				FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaignaudio} A
				)
				WHERE A.{$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
				AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
EOQ;
			$spotsScheduled = sysdb::queryOne($query);
*/
			$query = <<<EOQ
				SELECT M.{$this->store->field_campaign_spotsAllotted}
				FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaignaudio} A
				)
				LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON A.{$this->store->field_campaignaudio_campaignID} = M.{$this->store->field_campaign_campaignID}
				WHERE A.{$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
EOQ;
			$spot_allotted_count = sysdb::queryOne($query);

			$query = <<<EOQ
					SELECT COUNT(S.{$this->store->field_spot_spotID})
					FROM ({$this->store->table_traffic_spot} S,
						{$this->store->table_traffic_campaignaudio} A
					)
					WHERE A.{$this->store->field_campaignaudio_campaignID} = (
						SELECT {$this->store->field_campaignaudio_campaignID}
						FROM {$this->store->table_traffic_campaignaudio}
						WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
					)
					AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
					AND A.{$this->store->field_campaignaudio_campaignAudioID} != '$campaignAudioID'
EOQ;
			$other_media_spot_count = sysdb::queryOne($query);

//            echo 'Spots allotted:'.$spot_allotted_count.' This media uses '.sizeof($selected_spots).' spots. Other campaign media uses '.$other_media_spot_count.' spots.';

			$spot_count = sizeof($selected_spots);
			$spot_remaining_count = $spot_allotted_count - $other_media_spot_count - $spot_count;
//        }

		// Check to see if the spots exist already.
		// If so, preserve the priority value.
		// If not, increment the result by one to get the new priority value.

		// When the Schedule button is pressed perform the following.
        if ($act == 'Schedule') {
            $alloccount = 0;
            $removecount = 0;

			/** @todo Ascertain whether this query needs to pull spot id and priority. */
            $query = <<<EOQ
                SELECT {$this->store->field_spot_dateTime} AS dateTime,
					{$this->store->field_spot_spotID} AS spotID,
					{$this->store->field_spot_priority} AS priority
				FROM {$this->store->table_traffic_spot}
                WHERE {$this->store->field_spot_mediaID} IN (
                    SELECT {$this->store->field_campaignaudio_mediaID} AS mediaID
                    FROM {$this->store->table_traffic_campaignaudio}
                    WHERE {$this->store->field_campaignaudio_campaignAudioID} = $campaignAudioID
                )
				AND {$this->store->field_spot_dateTime} > TIMESTAMP(NOW())
EOQ;
			// Turn result query into a matrix.
			$matrix = sysdb::query2matrix($query,false);

			// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
			$vectors = sysdb::rotatematrix($matrix);

			// If there are no existing spots, create a blank array for diff checking.
			if (!empty($vectors)) {
				$existing_spots = $vectors[0];
			} else {
				$existing_spots = array();
			}

			if ($action == 'reschedule') {
				// Because reschedule only changes one spot we can just add and remove them.
				$spots_to_delete = array($old_spotdateTime);
				$spots_to_add = $selected_spots;
			} else {
				// Diff check old and new spots to see what needs changing.
				$spots_to_delete = array_diff($existing_spots, $selected_spots);
				$spots_to_add = array_diff($selected_spots, $existing_spots);
			}

			if ($action == 'reschedule') {
				if (is_array($spots_to_delete) && sizeof($spots_to_delete) == 1) {
					$removecount = Spot::move(globalize('old_spotID'), $spots_to_add['0']);
					$alloccount = $removecount;
				}
			} else {
				// Remove those spots that were deselected.
				if (is_array($spots_to_delete) && sizeof($spots_to_delete) > 0) {
					$removecount = Spot::remove_many($spots_to_delete, 'datetime');
				}

				// Add those spots that were designated.
				if (is_array($spots_to_add) && sizeof($spots_to_add) > 0) {
					$mediaID = CampaignAudio::resolve_media_id($campaignAudioID);

					// Create an array of mediaIDs.
					$num_elements = sizeof($spots_to_add);
					$mediaIDList = array_fill(0, $num_elements, $mediaID);

					$alloccount = Spot::add_many($mediaIDList, $spots_to_add);
				}
			}

            if ($alloccount > 0 || $removecount > 0) {
				$message = '';
				$s = '';
				if ($alloccount == $removecount) {
					$message .= 'reallocated '.$alloccount;
				} else {
					if ($alloccount > 0)
						$message .= 'allocated '.$alloccount;
					if ($alloccount && $removecount > 0)
						$message .= ' and ';
					if ($removecount > 0)
						$message .= 'removed '.$removecount;
				}
				if ($alloccount > 1 || $removecount > 1)
					$s .= 's';
				state::setMessage('notify',ucfirst($message.' spot'.$s.'.'));
			} else {
				state::setMessage('warning',"Didn't allocate any spots. No change to the schedule.");
			}
			if ($action != 'reschedule') {
				module::forward_to_script('',array('item'=>'CampaignAudio', 'action'=>'view', 'id'=>$campaignAudioID));
			} else {
				// module::forward_to_script('', array('item' => 'Traffic'));
				return(Traffic::displayGridByHour($doc));
			}
        }

        $day_start = $day_display_start;
        $view_days = globalize('view_days',14);

        $num_of_days = globalize('num_of_days', $view_days);
        $num_of_hours = globalize('num_of_hours',24);
		// TODO: the following variable needs to be a Module Parameter
        $display_start_time = globalize('hour_start', '06:00:00');
        list($display_start_time_hours, $display_start_time_minutes, $display_start_time_seconds) = preg_split('/:/', $display_start_time);

        $display_start_day = new DateTime($day_start);

        $display_end_day = clone $display_start_day;
		$display_end_day->modify('+'.$num_of_days.' day');

        $display_start_day_str = $display_start_day->format('Y-m-d');
        $display_end_day_str = $display_end_day->format('Y-m-d');

        $query = <<<EOQ
            SELECT DISTINCT ({$this->store->field_slot_time}) AS time
            FROM {$this->store->table_traffic_slot}
            WHERE {$this->store->field_slot_startDate} <= '$display_start_day_str'
            AND ({$this->store->field_slot_endDate} IS NULL
			OR {$this->store->field_slot_endDate} >= '$display_end_day_str')
            ORDER BY time
EOQ;
        $alltimes = sysdb::query2vector($query, 'time');
        $alltimes = self::rotate($alltimes, $display_start_time);
        $alltimes[] = $alltimes[0]; //Append the last one so we can detect end of the final slot.
        //print_r($alltimes);

        $date_counter = clone $display_start_day;

		// Select campaign audio name for display on the page.
        $query = <<<EOQ
            SELECT {$this->store->field_campaignaudio_name} AS name
            FROM {$this->store->table_traffic_campaignaudio}
            WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
EOQ;
		$audioName = utf8_decode(sysdb::queryOne($query));

		// Check for program component dependency.
		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
			// This is a temporary implementation of the ability to see the equivalent
			//  program related to this time slot.

			require_once(ROOT_COMPONENTS.'programs/moduleconfig.php');
			$remoteStore = new programStorage();

			$program_array = array();
			for ($t = strtotime($display_start_day_str), $max = strtotime($display_end_day_str); $t <= $max; $t = strtotime('+1 day', $t)) {
				$date_in_question = date('Y-m-d', $t);
				$dow_in_question = date('l', $t);

				// Find the periodID of the program grid corresponding to the date.
				$query = <<<EOQ
					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_grid G
					)
					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
					AND (D.$remoteStore->field_period_endDate >= '$date_in_question'
						&& D.$remoteStore->field_period_startDate <= '$date_in_question'
					)
EOQ;
				$periodID = sysdb::queryOne($query);

				$query = <<<EOQ
					SELECT P.$remoteStore->field_programs_program_name AS name,
						G.$remoteStore->field_programs_grid_startTime AS startTime,
						G.$remoteStore->field_programs_grid_endTime AS endTime
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_program P,
						$remoteStore->table_programs_grid G
					)
					WHERE D.$remoteStore->field_programs_grid_periodID = '$periodID'
					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
					AND G.$remoteStore->field_programs_grid_programID = P.$remoteStore->field_programs_program_programID
					AND G.$remoteStore->field_programs_grid_dow = '$dow_in_question'
EOQ;

				// Turn result query into a matrix.
				$matrix = sysdb::query2keyedmatrix($query,false);
				//array_push($program_array, $matrix);
				$program_array[$date_in_question] = $matrix;
			}
			//print_r($program_array);
			$programName = array();

			// $program_array = globalize('program_array');
			// $grid->appendChild($input = dom::createInputBox($doc, 'program_array', $program_array, 'hidden'));
		}

        $grid = $doc->createElement('div');

        $grid->appendChild($hidden = dom::createInputBox($doc, 'item', globalize('item', get_class($this)), 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'action', $action, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'spots_loaded', 'true', 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'num_of_days', $num_of_days, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'num_of_hours', $num_of_hours, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'day_start', $day_start, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'hour_start', $display_start_time, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'campaignAudioID', $campaignAudioID, 'hidden'));
//        $grid->appendChild($input = dom::createInputBox($doc, 'tickcounter_count', $spot_count, 'hidden'));
		if ($action == 'reschedule') {
			$grid->appendChild($input = dom::createInputBox($doc,'old_spotID',$old_spotID,'hidden'));
			$grid->appendChild($input = dom::createInputBox($doc,'old_spotdateTime',$old_spotdateTime,'hidden'));
			$grid->appendChild($input = dom::createInputBox($doc,'view_days',$view_days,'hidden'));
			if (is_array($highlightoverlay)) {
				foreach ($highlightoverlay as $highlight) {
					$grid->appendChild($input = dom::createInputBox($doc, 'highlightoverlay[]', $highlight, 'hidden'));
				}
			}
		}

		if ($action != 'reschedule') { // Not needed in reschedule mode, as only changing one spot.
			if (is_array($selected_spots)) {
				foreach ($selected_spots as $spot) {
					$spottime = new DateTime($spot);
					if ($spottime->format('U') < $display_start_day->format('U')
						|| $spottime->format('U') > $display_end_day->format('U')
						|| $spottime->format('U') <= strtotime('now')) {
						$grid->appendChild($input = $doc->createElement('input'));
						$input->setAttribute('type', 'hidden');
						$input->setAttribute('name', 'traffic_tickbox[]');
						$input->setAttribute('value', $spottime->format('Y-m-d H:i:s'));
					}
				}
			}
		}

        $h1 = $doc->createElement('h1');
		if ($action != 'reschedule') {
			$h1->appendChild($doc->createTextNode('Schedule Spots'));
		} else if ($action == 'reschedule') {
			// When in reschedule mode, we only want to be able to select one slot.
			$h1->appendChild($doc->createTextNode('Reschedule Spot'));
		}
        $grid->appendChild($h1);
        $h2 = $doc->createElement('h2');
        $h2->appendChild($doc->createTextNode($audioName));
        $grid->appendChild($h2);

        if (globalize('action') == 'Add Spot' && $campaignAudioID != '') {
			// Adds a new single spot, adding it as the lowest priority.
            $spot = globalize('spot');
			$query = <<<EOQ
				INSERT INTO {$this->store->table_traffic_spot} (
					{$this->store->field_spot_mediaID},
					{$this->store->field_spot_dateTime},
					{$this->store->field_spot_priority}
				)
				SELECT {$this->store->field_campaignaudio_mediaID} AS mediaID,
					'$spot' AS dateTime,
					(SELECT COALESCE(MAX({$this->store->field_spot_priority}),0) + 1
					FROM {$this->store->table_traffic_spot}
					WHERE {$this->store->field_spot_dateTime} = '$spot'
					) AS priority
				FROM {$this->store->table_traffic_campaignaudio}
				WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
EOQ;
            sysdb::query($query);
        }

        $query = <<<EOQ
            SELECT {$this->store->field_campaignaudio_duration} AS duration
            FROM {$this->store->table_traffic_campaignaudio}
            WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
EOQ;
        $duration = sysdb::queryOne($query);

		// Change the date navigation values when in daily view.
        if ($num_of_days == 1) {
			$short_interval = 'Day';
			$long_interval = 'Week';
		} elseif ($num_of_days == 7) {
			$short_interval = 'Week';
			$long_interval = 'Month';
		} elseif ($num_of_days == 14) {
			$short_interval = 'Fortnight';
			$long_interval = 'Month';
		} elseif ($num_of_days == 31) {
			$short_interval = 'Month';
			$long_interval = 'Year';
		} else {
			$short_interval = 'Week';
			$long_interval = 'Month';
		}

        $grid->appendChild($divHeader = $doc->createElement('div'));
        $divHeader->setAttribute('id', 'traffic_header_container');
        $divHeader->appendChild($tblnav = $doc->createElement('table'));
//        $grid->appendChild($tblnav = $doc->createElement('table'));
        $tblnav->setAttribute('id', 'navtble');
        $tblnav->setAttribute('class', 'traffic_table');

        $tblnav->appendChild($tr = $doc->createElement('tr'));
        $tr->appendChild($left = $doc->createElement('td'));

        $display_minus_month = clone $display_start_day;
        $display_minus_month->modify('-1 '.$long_interval);
        $left->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_minus_month->format('Y-m-d'));
        $button->setAttribute('class', 'link_prev2_small');
        $button->setAttribute('title', 'Previous '.$long_interval);

        $display_minus_week = clone $display_start_day;
        $display_minus_week->modify('-1 '.$short_interval);
        $left->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_minus_week->format('Y-m-d'));
        $button->setAttribute('class', 'link_prev_small');
        $button->setAttribute('title', 'Previous '.$short_interval);

        $tr->appendChild($middle = $doc->createElement('td'));

		// TODO: The daily calendar view should probably redirect to a daily log-type page
        $middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'view_day');
        $button->setAttribute('class', 'link_day_small');
        $button->setAttribute('title', 'View Day');

        $middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'num_of_days');
        $button->setAttribute('value', 7);
        $button->setAttribute('class', 'link_week_small');
        $button->setAttribute('title', 'View Week');

		$middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'num_of_days');
        $button->setAttribute('value', 14);
        $button->setAttribute('class', 'link_range_small');
        $button->setAttribute('title', 'View Fortnight');

		$middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'num_of_days');
        $button->setAttribute('value', 31);
        $button->setAttribute('class', 'link_month_small');
        $button->setAttribute('title', 'View Month');

        $tr->appendChild($right = $doc->createElement('td'));

        $display_plus_week = clone $display_start_day;
        $display_plus_week->modify('+1 '.$short_interval);
        $right->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_plus_week->format('Y-m-d'));
        $button->setAttribute('class', 'link_next_small');
        $button->setAttribute('title', 'Next '.$short_interval);

        $display_plus_month = clone $display_start_day;
        $display_plus_month->modify('+1 '.$long_interval);
        $right->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_plus_month->format('Y-m-d'));
        $button->setAttribute('class', 'link_next2_small');
        $button->setAttribute('title', 'Next '.$long_interval);


		// Draw a legend/key for describing the colours used.
		$divHeader->appendChild($tblkey = $doc->createElement('table'));
        $tblkey->setAttribute('id', 'keytble');
        $tblkey->setAttribute('class', 'traffic_table');
        $tblkey->appendChild($tr = $doc->createElement('tr'));

		$styleshade = 10;

		$shadetype = '';
        $tr->appendChild($label = $doc->createElement('td'));
//		$label->setAttribute('class', 'traffic_key');
		$label->appendChild($div = $doc->createElement('div'));
		$div->appendChild($doc->createTextNode('KEY: '));

		$varpop = 'normal';
        $tr->appendChild($normal = $doc->createElement('td'));
		$normal->setAttribute('class', 'traffic_key');
		$normal->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start normal popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('AVAILABLE TIME'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Everything is within specified date ranges.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker colours denoting heavier scheduling.'));
		$div->appendChild($popupdiv);
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view time remaining.'));
		$div->appendChild($popupdiv);
		// End normal popup box.

		$styleshade = 10;
		$varpop = 'warn';
		$shadetype = '_warn';
        $tr->appendChild($warning = $doc->createElement('td'));
		$warning->setAttribute('class', 'traffic_key');
		$warning->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start warning popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('OUTSIDE AUDIO DATE RANGE'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot is outside of the specified campaign audio date range, but still within the parent campaign date range.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker colours denoting heavier scheduling.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('The two warning notifications are:'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is before allocated Audio start date.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is after allocated Audio start date.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view these notifications.'));
		$div->appendChild($popupdiv);
		// End warning popup box.

		$styleshade = 6;
		$varpop = 'grey';
		$shadetype = '_grey';
        $tr->appendChild($grey = $doc->createElement('td'));
		$grey->setAttribute('class', 'traffic_key');
		$grey->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start grey popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('OUTSIDE CAMPAIGN DATE RANGE'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot is outside of the specified parent campaign date range.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker shades denoting heavier scheduling.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('The four warning notifications are:'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is before Contract start date. '));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is before Campaign start date.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is after Campaign end date. '));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is after Contract end date.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view these notifications.'));
		$div->appendChild($popupdiv);
		// End grey popup box.

		$styleshade = 10;
		$varpop = 'blue';
		$shadetype = '_blue';
        $tr->appendChild($warning = $doc->createElement('td'));
		$warning->setAttribute('class', 'traffic_key');
		$warning->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start blue popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('CONTAINS SAME CAMPAIGN'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot already contains scheduled audio from the same campaign.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker colours denoting heavier scheduling.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode("Hover over time slot to view the other campaign audio's name."));
		$div->appendChild($popupdiv);
		// End blue popup box.

		if ($action == 'reschedule') {
			$styleshade = 20;
			$varpop = 'highlight';
			$shadetype = 'traffic_highlight';
			$tr->appendChild($error = $doc->createElement('td'));
			$error->setAttribute('class', 'traffic_key');
			$error->appendChild($div = $doc->createElement('div'));
			$div->setAttribute('class', "$shadetype");
			$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
			$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
			// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
			$div->appendChild($doc->createTextNode(' '));

			// Start highlight popup box.
			$popupdiv = $doc->createElement('div');
			$popupdiv->setAttribute('class', 'popup_small');
			$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
			$popupdiv->setAttribute('visibility', 'hidden');
			$popupdiv->appendChild($popuptable = $doc->createElement('table'));
			$popuptable->setAttribute('class', 'traffic_popkey');
			$popuptable->appendChild($trP = $doc->createElement('tr'));
			$trP->appendChild($tdP = $doc->createElement('td'));
			// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
			$span->setAttribute('class', 'link_close_small');
			$span->setAttribute('style', 'float: right;');
			$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
			$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
			$trP->appendChild($thP = $doc->createElement('th'));
			$thP->appendChild($doc->createTextNode('CONTAINS SAME CAMPAIGN AUDIO'));
			$thP->setAttribute('class', "$shadetype");
			$popuptable->appendChild($trP = $doc->createElement('tr'));
			$trP->appendChild($tdP = $doc->createElement('td'));
			$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot already contains scheduled audio from the same campaign audio.'));
			$popuptable->appendChild($trP = $doc->createElement('tr'));
			$trP->appendChild($tdP = $doc->createElement('td'));
			$tdP->appendChild($doc->createTextNode('Rescheduling to that time slot will result in it being scheduled twice in that time.'));
			$popuptable->appendChild($trP = $doc->createElement('tr'));
			$trP->appendChild($tdP = $doc->createElement('td'));
			$tdP->appendChild($doc->createTextNode('Hover over time slot to view time remaining.'));
			$div->appendChild($popupdiv);
			// End highlight popup box.
		}

		$styleshade = 20;
		$varpop = 'error';
		$shadetype = '_error';
        $tr->appendChild($error = $doc->createElement('td'));
		$error->setAttribute('class', 'traffic_key');
		$error->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start error popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('INSUFFICIENT TIME REMAINING'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot has insufficient remaining time to accomodate this audio duration.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view duration and time remaining.'));
		$div->appendChild($popupdiv);
		// End error popup box.

		$styleshade = 20;
		$varpop = 'full';
		$shadetype = '_full';
        $tr->appendChild($full = $doc->createElement('td'));
		$full->setAttribute('class', 'traffic_key');
		$full->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start full popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('TIME EXCEEDED'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('A time exceeded error denotes that the time slot is full, and has been overbooked.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This may cause a breach in broadcasting terms of service and should be addressed immediately.'));
		$div->appendChild($popupdiv);
		// End full popup box.

        $tblmain = $doc->createElement('table');
        $tblmain->setAttribute('id', 'xytble');
        $tblmain->setAttribute('class', 'traffic_table');

        $tblmain->appendChild($linehead = $doc->createElement('tr'));
        $linehead->setAttribute('id', 'traffic_head_row');
        $linehead->setAttribute('class', 'traffic_head_row');

        $blank = $doc->createElement('td');
        $blank->appendChild($tickcounter = $doc->createElement('input'));
        $blank->setAttribute('style', 'text-align:center;');
   		// if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php'))
            // $blank->setAttribute('colspan', '2');
        $tickcounter->setAttribute('id', 'tickcounter');
        $tickcounter->setAttribute('name', 'fieldcounter_count');
        $tickcounter->setAttribute('value', $spot_count);
		$tickcounter->setAttribute('type', 'text');
        $tickcounter->setAttribute('title', 'Total spots scheduled to campaign.');
        $tickcounter->setAttribute('style', 'text-align:right; width: 45px;');
        $tickcounter->setAttribute('readonly', '');
        $blank->appendChild($totalcounter = $doc->createElement('input'));
        $blank->setAttribute('style', 'text-align:center;');
        $totalcounter->setAttribute('id', 'totalcounter');
        $totalcounter->setAttribute('name', 'totalcounter_count');
        $totalcounter->setAttribute('value', $spot_remaining_count);
		$totalcounter->setAttribute('type', 'text');
        $totalcounter->setAttribute('title', 'Remaining spots allotted to campaign.');
        $totalcounter->setAttribute('style', 'text-align:right; width: 45px;');
        $totalcounter->setAttribute('readonly', '');
        $blank->appendChild($spotsAllottedvalue = dom::createInputBox($doc, 'totalspotsallotted', $spot_allotted_count, 'hidden'));

        $linehead->appendChild($blank);

        for($j=0;$j<$num_of_days;$j++) {
            $linehead->appendChild($boxhead[$j] = $doc->createElement('td'));
            $boxhead[$j]->setAttribute('id', "traffic_head_box[{$j}]");
			if ($num_of_days == 31) {
				if ($date_counter->format('N') == 6 || $date_counter->format('N') == 7) {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box_month_we');
				} else {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box_month');
				}
			} else {
				if ($date_counter->format('N') == 6 || $date_counter->format('N') == 7) {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box_we');
				} else {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box');
				}
			}
            $boxhead[$j]->setAttribute('title', $date_counter->format('l jS \of F, Y'));
			if ($num_of_days == 31) {
				$boxhead[$j]->appendChild($doc->createTextNode(substr($date_counter->format('D'), 0, 1)));
				$boxhead[$j]->appendChild($doc->createElement('br'));
				$boxhead[$j]->appendChild($doc->createTextNode($date_counter->format('j')));
				$boxhead[$j]->appendChild($doc->createElement('br'));
				$boxhead[$j]->appendChild($doc->createTextNode(substr($date_counter->format('M'), 0, 1)));
			} else {
				$boxhead[$j]->appendChild($doc->createTextNode($date_counter->format('D')));
				$boxhead[$j]->appendChild($doc->createElement('br'));
				$boxhead[$j]->appendChild($doc->createTextNode($date_counter->format('d/m')));
			}
            $date_counter->modify('+1 day');
        }

        $date_counter->modify("+$display_start_time_hours hours $display_start_time_minutes minutes $display_start_time_seconds seconds");

		for ($i = 0, $max = count($alltimes)-1; $i < $max; $i++) {
            $row_start = $alltimes[$i];
            $row_next = $alltimes[$i+1];

            $line[$i] = $doc->createElement('tr');
            $line[$i]->setAttribute('id', "traffic_row[{$i}]");
            $line[$i]->setAttribute('class', 'traffic_row');

       		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
                $cell_day = $date_counter->format('Y-m-d');

				// Find the periodID of the program grid corresponding to the date.
				$query = <<<EOQ
					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_grid G
					)
					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
					AND ((D.$remoteStore->field_period_endDate >= '$cell_day'
							OR D.$remoteStore->field_period_endDate IS NULL
						)
						AND (D.$remoteStore->field_period_startDate <= '$cell_day'
							OR D.$remoteStore->field_period_startDate IS NULL
						)
					)
EOQ;
				$periodID = sysdb::queryOne($query);

				// // TODO: This only returns whole hours. A slotgroup from 2:00-5:30 for instance would not be displayed properly.
				// // TODO: This query is being run 24 times in the header, then 24 times in the footer. Should be single query.
    			// $query = <<<EOQ
    				// SELECT G.$remoteStore->field_programs_slotgroup_name as name,
						// (HOUR(IF(G.$remoteStore->field_programs_slotgroup_endTime = '00:00:00', '24:00:00', G.$remoteStore->field_programs_slotgroup_endTime)) - HOUR(G.$remoteStore->field_programs_slotgroup_startTime)) AS hours
    				// FROM ($remoteStore->table_period D,
    					// $remoteStore->table_programs_slotgroup G
    				// )
    				// WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
    				// AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    // AND G.$remoteStore->field_programs_slotgroup_startTime = '{$row_start}'
// EOQ;
                // $slotgroupResult = sysdb::query($query);
                // if (sysdb::num_rows($slotgroupResult) > 0) {
                    // $group = $doc->createElement('td');
                    // $slotgroup = sysdb::fetch_assoc($slotgroupResult);
                    // $group->setAttribute('id', "traffic_slot_group[$i]");
                    // $group->setAttribute('rowspan', $slotgroup['hours']);
                    // $group->setAttribute('style', 'border-bottom: 2px solid black;');
                    // $group->appendChild($doc->createTextNode($slotgroup['name']));
                    // $line[$i]->appendChild($group);
                // }
            }

            $time = $doc->createElement('td');
            $time->setAttribute('id', "traffic_row_lead[$i]");
            $time->setAttribute('class', 'traffic_head_box');
            $time->appendChild($doc->createTextNode(date('G:i', strtotime($row_start))));

            //Put a line under it if it's at the end of a slotgroup
    		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
				$query = <<<EOQ
					SELECT G.$remoteStore->field_programs_slotgroup_endTime AS endtime
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_slotgroup G
					)
					WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    AND G.$remoteStore->field_programs_slotgroup_endTime = '{$row_next}'
EOQ;
                if ($row_next == '00:00:00' || sysdb::num_rows(sysdb::query($query)) > 0)
                    $time->setAttribute('style', 'border-bottom: solid black 2px;');
            }

            $line[$i]->appendChild($time);

            $query = <<<EOQ
                SELECT {$this->store->field_slot_slotID} AS slotID,
					{$this->store->field_slot_dow} AS dow
                FROM {$this->store->table_traffic_slot}
                WHERE {$this->store->field_slot_startDate} <= '$display_start_day_str'
                AND ({$this->store->field_slot_endDate} IS NULL
					OR {$this->store->field_slot_endDate} >= '$display_end_day_str'
				)
                AND {$this->store->field_slot_time} = '$row_start'
                ORDER BY dow
EOQ;
            $timeSlots = sysdb::query_assoc($query, 'time');

            $date_counter = clone $display_start_day;

            if ($row_start < $display_start_time) {
                $date_counter->modify('+1 day');
            }

            for($j=0;$j<$num_of_days;$j++) {
                $cell_day = $date_counter->format('Y-m-d');
                $cell_dow = $date_counter->format('l');
                if ($row_next < $row_start) {
                    $date_counter->modify('+1 day');
                }
                $cell_next_day = $date_counter->format('Y-m-d');

                //Check to see our overlap with other slots
           		$query = <<<EOQ
                    SELECT {$this->store->field_slot_time} AS time
                    FROM {$this->store->table_traffic_slot}
                    WHERE {$this->store->field_slot_startDate} <= '$cell_day'
                    AND ({$this->store->field_slot_endDate} IS NULL
						OR {$this->store->field_slot_endDate} >= '$cell_next_day'
					)
                    AND {$this->store->field_slot_dow} = "$cell_dow"
                    AND {$this->store->field_slot_time} >= "$row_start"
                    ORDER BY time
                    LIMIT 0, 2
EOQ;
                //This query tells us two things:
                //1) Does a slot exist at this time?
                //2) When is the next known slot in this column?
                $result = sysdb::query_assoc($query,false);
                if (sizeof($result) <= 0) {
                    if ($row_next < $row_start) {
                        $slot_exists = true;
                    } else {
                        $slot_exists = false;
                    }
                    //There are no slots in this column
                } else if (sizeof($result) == 1) {
                    if ($result[0]['time'] == $row_start) {
                        //There is no next slot
                        $slot_exists = true;
                        $next_known_slot_in_column = null;
                    } else {
                        //There is no slot for this time
                        $slot_exists = false;
                        $next_known_slot_in_column = $result[0]['time'];
                    }
                } else if (sizeof($result) == 2) {
                    if ($result[0]['time'] == $row_start) {
                        $slot_exists = true;
                        $next_known_slot_in_column = $result[1]['time'];
                    } else {
                        $slot_exists = false;
                        $next_known_slot_in_column = $result[0]['time'];
                    }
                } else {
                    print_r($result);
                    die('This should never happen. Did someone remove the limit on the query?');
                }

                if ($slot_exists) {
                    $rowspan = 1;
                    while ($alltimes[$i+($rowspan)] < $next_known_slot_in_column) $rowspan++;

                    //if ($alltimes[$i+$rowspan] != $next_known_slot_in_column) echo 'Error! Rowspan calculation failed!';


            		$query = <<<EOQ
                        SELECT SUM(A.{$this->store->field_campaignaudio_duration}) AS total
                        FROM ({$this->store->table_traffic_spot} S,
							{$this->store->table_traffic_campaignaudio} A
						)
                        WHERE S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
                        AND S.{$this->store->field_spot_dateTime} >= "$cell_day $row_start"
                        AND S.{$this->store->field_spot_dateTime} < "$cell_next_day $row_next"
EOQ;
            		$timeoccupied = sysdb::queryOne($query);
                    //if ($timeoccupied > 0) echo $query;

                    $box[$i][$j] = $doc->createElement('td');
                    $box[$i][$j]->setAttribute('id', "traffic_checkbox[{$i}][{$j}]");
                    $box[$i][$j]->setAttribute('class', 'traffic_box');
                    if ($rowspan != 1) $box[$i][$j]->setAttribute('rowspan', $rowspan);

                    //Put a line under it if it's at the end of a slotgroup
            		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
                        $date_in_question = $cell_day;

        				// Find the periodID of the program grid corresponding to the date.
        				$query = <<<EOQ
        					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
        					FROM ($remoteStore->table_period D,
        						$remoteStore->table_programs_grid G
        					)
        					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
        					AND ((D.$remoteStore->field_period_endDate >= '$date_in_question'
									OR D.$remoteStore->field_period_endDate IS NULL
								)
        						AND (D.$remoteStore->field_period_startDate <= '$date_in_question'
									OR D.$remoteStore->field_period_startDate IS NULL
								)
        					)
EOQ;
        				$periodID = sysdb::queryOne($query);

        				$query = <<<EOQ
        					SELECT G.$remoteStore->field_programs_slotgroup_endTime AS endtime
        					FROM ($remoteStore->table_period D,
        						$remoteStore->table_programs_slotgroup G
        					)
        					WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
        					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                            AND G.$remoteStore->field_programs_slotgroup_endTime = '{$next_known_slot_in_column}'
EOQ;
                        if ($next_known_slot_in_column == null || sysdb::num_rows(sysdb::query($query)) > 0)
                            $box[$i][$j]->setAttribute('style', "border-bottom: solid black 2px;");
                    }

					$styleshades = 20;
                    $timeremaining = $maxtime-$timeoccupied;
                    $timeprojected = $maxtime-$timeoccupied-$duration;

            		$query = <<<EOQ
                        SELECT O.{$this->store->field_contract_startDate} AS contractStartDate,
							O.{$this->store->field_contract_endDate} AS contractEndDate,
							M.{$this->store->field_campaign_startDate} AS campaignStartDate,
							M.{$this->store->field_campaign_endDate} AS campaignEndDate,
							A.{$this->store->field_campaignaudio_startDate} AS campaignAudioStartDate,
							A.{$this->store->field_campaignaudio_endDate} AS campaignAudioEndDate
                        FROM ({$this->store->table_traffic_contract} O,
							{$this->store->table_traffic_campaign} M,
							{$this->store->table_traffic_campaignaudio} A
						)
                        WHERE A.{$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
                        AND A.{$this->store->field_campaignaudio_campaignID} = M.{$this->store->field_campaign_campaignID}
                        AND A.{$this->store->field_campaignaudio_contractID} = O.{$this->store->field_contract_contractID}
EOQ;
					$result = sysdb::query($query);
					if (sizeof($result) <= 0) {
						$contractStart = '';
						$contractEnd = '';
						$campaignStart = '';
						$campaignEnd = '';
						$campaignAudioStart = '';
						$campaignAudioEnd = '';
					} else {
						$row = sysdb::fetch_assoc($result);
						$contractStart = $row['contractStartDate'].' 00:00:00';
						$contractEnd = $row['contractEndDate'].' 23:59:59';
						$campaignStart = $row['campaignStartDate'].' 00:00:00';
						$campaignEnd = $row['campaignEndDate'].' 23:59:59';
						$campaignAudioStart = $row['campaignAudioStartDate'].' 00:00:00';
						$campaignAudioEnd = $row['campaignAudioEndDate'].' 23:59:59';
					}

                    $div = $doc->createElement('div');
					$div->setAttribute('id', 'traffic_checkbox['.$i.']['.$j.']');
					$div->setAttribute('onclick', 'checkbox(this,'.$i.','.$j.');');
					$title_text = '';
					// TODO: All of the reschedule action changes in this section should be routed through $highlightoverlay and $selected_spots
                    if (strtotime($cell_day.' '.$row_start) <= strtotime('now')) {
						// If in the past.
						$title_text .= 'Time is in the past.';
                    } else if (isset($highlightoverlay) && is_array($highlightoverlay) && (array_search($cell_day.' '.$row_start, $highlightoverlay) != false)) {
                        // If the cell requires highlighting.
						$div->setAttribute('class', 'traffic_highlight');
                    } else if ($timeremaining <= 0) {
						// If overbooked.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_full");
						$title_text .= 'Time is over allocated by '.(-$timeremaining).' seconds';
                    } else if ($timeremaining > 0 && $timeprojected <= 0 && (!in_array($cell_day.' '.$row_start, $selected_spots))) {
						// If spot will not fit in the hour, and isn't already scheduled.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_error");
						$title_text .= 'Audio duration of '.$duration.' secs is larger than the '.$timeremaining.' secs remaining.';
                    } else if (in_array($cell_day.' '.$row_start,array_intersect($selected_spots, $campaign_spots)) || (!in_array($cell_day.' '.$row_start, $selected_spots) && in_array($cell_day.' '.$row_start, $campaign_spots))) {
						// If other audio from the same campaign is scheduled in the hour.
						$query = <<<EOQ
							SELECT A.{$this->store->field_campaignaudio_name} AS campaignAudioName
							FROM ({$this->store->table_traffic_spot} S,
								{$this->store->table_traffic_campaignaudio} A
							)
							WHERE A.{$this->store->field_campaignaudio_campaignID} = (
								SELECT {$this->store->field_campaignaudio_campaignID}
								FROM {$this->store->table_traffic_campaignaudio}
								WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
							)
							AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
							AND A.{$this->store->field_campaignaudio_campaignAudioID} != '$campaignAudioID'
							AND S.{$this->store->field_spot_dateTime} = '$cell_day $row_start'
EOQ;
						$campaignAudioName = sysdb::queryOne($query);
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_blue");
						$title_text .= 'Time already contains "'.$campaignAudioName.'" from the same campaign. '.$timeremaining.' secs remaining.';
                    } else if ($contractStart != ''
							&& $campaignStart != ''
							&& $campaignAudioStart != ''
							&& (strtotime($cell_day.' '.$row_start) < strtotime($contractStart))
							&& (strtotime($contractStart) <= strtotime($campaignStart))
							&& (strtotime($contractStart) <= strtotime($campaignAudioStart))
							) {
						// If earlier than contract start.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is before Contract start date. '.$timeremaining.' secs remaining.';
                    } else if ($contractStart != ''
							&& $campaignStart != ''
							&& $campaignAudioStart != ''
							&& (strtotime($cell_day.' '.$row_start) >= strtotime($contractStart))
							&& (strtotime($cell_day.' '.$row_start) < strtotime($campaignStart))
							&& (strtotime($campaignStart) <= strtotime($campaignAudioStart))
							) {
						// If between contract start and campaign start.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is before Campaign start date. '.$timeremaining.' secs remaining';
                    } else if ($contractStart != ''
							&& $campaignStart != ''
							&& $campaignAudioStart != ''
							&& (strtotime($cell_day.' '.$row_start) >= strtotime($campaignStart))
							&& (strtotime($campaignStart) < strtotime($campaignAudioStart))
							&& (strtotime($cell_day.' '.$row_start) < strtotime($campaignAudioStart))
							) {
						// If between campaign start and audio start.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_warn");
						$title_text .= 'Time is before allocated Audio start date. '.$timeremaining.' secs remaining.';
                    } else if ($contractEnd != ''
							&& $campaignEnd != ''
							&& $campaignAudioEnd != ''
							&& (strtotime($cell_day.' '.$row_start) < strtotime($campaignEnd))
							&& (strtotime($campaignEnd) >= strtotime($campaignAudioEnd))
							&& (strtotime($cell_day.' '.$row_start) >= strtotime($campaignAudioEnd))
							) {
						// If between audio end and campaign end.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_warn");
						$title_text .= 'Time is after allocated Audio start date. '.$timeremaining.' secs remaining.';
                    } else if ($contractEnd != ''
							&& $campaignEnd != ''
							&& $campaignAudioEnd != ''
							&& (strtotime($cell_day.' '.$row_start) <= strtotime($contractEnd))
							&& (strtotime($cell_day.' '.$row_start) > strtotime($campaignEnd))
							&& (strtotime($campaignEnd) >= strtotime($campaignAudioEnd))
							) {
						// If between campaign end and contract end.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is after Campaign end date. '.$timeremaining.' secs remaining.';
                    } else if ($contractEnd != ''
							&& $campaignEnd != ''
							&& $campaignAudioEnd != ''
							&& (strtotime($cell_day.' '.$row_start) > strtotime($contractEnd))
							&& (strtotime($contractEnd) >= strtotime($campaignEnd))
							&& (strtotime($contractEnd) >= strtotime($campaignAudioEnd))
							) {
						// If after contract end.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is after Contract end date. '.$timeremaining.' secs remaining.';
                    } else {
						// Time is available and within all parameters.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}");
						$title_text .= $timeremaining." secs remaining.";
                    }
					// Check for program component dependency.
					if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
						// This is a temporary implementation of the ability to see the equivalent
						//  program related to this time slot.

						// echo $cell_day.' DAY<br/>';
						// echo $row_start.' TIME<br/>';

						$search = $row_start;
						$found = array();
						// Try find a matching start time.
						foreach ($program_array[$cell_day] as $key => $value) {
							if (trim($value['startTime']) == $search) {
								// echo $row_start.' 1<br/>';
								// echo $value['name'].' 2<br/>';
								// echo $value['startTime'].' 3<br/>';

								// If it matches, change today's program in the array.
								$programName[$cell_day] = $value['name'];
								break;
							}
						}
						// Print the current program in the tool tip.
						if (isset($programName[$cell_day])) {
							$title_text .= ' [Program: '.$programName[$cell_day].']';
						} else {
							$title_text .= ' [No Program]';
						}
					}
					$div->setAttribute('title', $title_text);

                    if (strtotime($cell_day.' '.$row_start) > strtotime('now')) {
                        $tickbox = $doc->createElement('input');
						if ($action != 'reschedule') {
							$tickbox->setAttribute('type', 'checkbox');
						} else if ($action == 'reschedule') {
							// When in reschedule mode, we only want to be able to select one slot.
							$tickbox->setAttribute('type', 'radio');
						}
						$tickbox->setAttribute('onclick', 'checkedbox(this,'.$i.','.$j.');');
                        $tickbox->setAttribute('name', 'traffic_tickbox[]');
                        $tickbox->setAttribute('value', $cell_day.' '.$row_start);
						if ($action != 'reschedule') {
							if (in_array($cell_day.' '.$row_start, $selected_spots)) $tickbox->setAttribute('checked', 'checked');
						} else if ($action == 'reschedule') {
							// When in reschedule mode, only check the spot being moved.
							if (in_array($cell_day.' '.$row_start,array($old_spotdateTime))) $tickbox->setAttribute('checked', 'checked');
						}
                        $div->appendChild($tickbox);
                    } else {
                        $div->appendChild($doc->createTextNode(''));
                    }
                    $box[$i][$j]->appendChild($div);

                    $line[$i]->appendChild($box[$i][$j]);
                }

                if ($row_next > $row_start) {
                    $date_counter->modify('+1 day');
                }
            }

            $time = $doc->createElement('td');
            $time->setAttribute('id', "traffic_row_lead[$i]");
            $time->setAttribute('class', 'traffic_head_box');
            $time->appendChild($doc->createTextNode(date('G:i', strtotime($row_start))));

            //Put a line under it if it's at the end of a slotgroup
    		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
                $date_in_question = $cell_day;

				// Find the periodID of the program grid corresponding to the date.
				$query = <<<EOQ
					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_grid G
					)
					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
					AND ((D.$remoteStore->field_period_endDate >= '$date_in_question'
							OR D.$remoteStore->field_period_endDate IS NULL
						)
						AND (D.$remoteStore->field_period_startDate <= '$date_in_question'
							OR D.$remoteStore->field_period_startDate IS NULL
						)
					)
EOQ;
				$periodID = sysdb::queryOne($query);

				$query = <<<EOQ
					SELECT G.$remoteStore->field_programs_slotgroup_endTime AS endtime
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_slotgroup G
					)
					WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    AND G.$remoteStore->field_programs_slotgroup_endTime = '{$next_known_slot_in_column}'
EOQ;
                if ($next_known_slot_in_column == null || sysdb::num_rows(sysdb::query($query)) > 0)
                    $time->setAttribute('style', 'border-bottom: solid black 2px;');
            }

            $line[$i]->appendChild($time);

       		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
				// TODO: This only returns whole hours. A slotgroup from 2:00-5:30 for instance would not be displayed properly.
				// TODO: This query is being run 24 times in the header, then 24 times in the footer. Should be single query.
    			$query = <<<EOQ
    				SELECT G.$remoteStore->field_programs_slotgroup_name as name,
						(HOUR(IF(G.$remoteStore->field_programs_slotgroup_endTime = '00:00:00', '24:00:00', G.$remoteStore->field_programs_slotgroup_endTime)) - HOUR(G.$remoteStore->field_programs_slotgroup_startTime)) AS hours
    				FROM ($remoteStore->table_period D,
    					$remoteStore->table_programs_slotgroup G
    				)
    				WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
    				AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    AND G.$remoteStore->field_programs_slotgroup_startTime = '{$row_start}'
EOQ;
                $slotgroupResult = sysdb::query($query);
                if (sysdb::num_rows($slotgroupResult) > 0) {
                    $group = $doc->createElement('td');
                    $slotgroup = sysdb::fetch_assoc($slotgroupResult);
                    $group->setAttribute('id', "traffic_slot_group[$i]");
                    $group->setAttribute('class', 'traffic_slot_group');
                    $group->setAttribute('rowspan', $slotgroup['hours']);
                    $group->setAttribute('style', 'border-bottom: 2px solid black;');
                    $group->appendChild($doc->createTextNode($slotgroup['name']));
                    $line[$i]->appendChild($group);
                }
            }

            $tblmain->appendChild($line[$i]);
        }

        //TAIL

		$linetail = clone $linehead;
		$counter = $linetail->getElementsByTagName('td')->item(0);
		while($counter->hasChildNodes()) {
		  $counter->removeChild($counter->childNodes->item(0));
		}

        $tblmain->appendChild($linetail);

        $grid->appendChild($tblmain);

        $grid->appendChild($input = dom::createInputBox($doc, 'act', 'Schedule', 'submit'));

        return $grid;

    }

	/**
	 * Displays the spots by campaign in a calendar grid as slots with text input boxes.
	 */
/**
* Description of the counter system, and promos/giveaways:
*   The counter displays (a) the Total spots scheduled for the given campaign,
*   and (b) the Remaining spots allotted to the given campaign. Because of the
*   addition of promotional giveaways using the '1' numeric designation, the
*   counter process is somewhat complicated. The values displayed in the UI are
*   (a) $spot_count and (b) $spot_remaining_count. Because the date navigation
*   arrows may be used prior to actually finalising and saving a schedule, the
*   counters must be recalculated on each page to make sure that promos are not
*   included in the spot count. This all makes the code somewhat difficult for
*   a newcomer to follow. The following description should help.
*
*   Firstly the total number of spots and promos scheduled for a given campaign
*   must be calculated on each page refresh. For a newly opened schedule
*   session this information is extracted from the database. For a provisional
*   schedule (i.e. if the date navigation arrows have been used) we must
*   remove the promos from the total spot count returned from the previous
*   page.
*
*
*
*
*
*
*
*
*
*
*
*
*
*
*/
    public function displayGridInputboxes($doc, $campaignID) {

        // display_list, return DISPLAY GRID dom document

		global $module_parameter;

		$moduleID = globalize('moduleID');
		$action = globalize('action');
		$act = globalize('act');
		if ($campaignID == '') $campaignID = globalize('id');
		if ($campaignID == '') $campaignID = globalize('campaignID');
        $display_start_time = globalize('hour_start', '06:00:00');
        list($display_start_time_hours, $display_start_time_minutes, $display_start_time_seconds) = preg_split('/:/', $display_start_time);

		// Check to see if a max hourly time is set as a module parameter.
		if (isset($module_parameter['maxTimePerHour'])) {
			$maxtime = $module_parameter['maxTimePerHour'];
		} else {
			$maxtime = 300;
		}

		$newlyLoadedPage = false;
		if (globalize('spots_loaded') == '') $newlyLoadedPage = true;
// echo "newlyLoadedPage: ".$newlyLoadedPage;

$loadtime = microtime(true);
$trial = '';
$click = 0;

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
		// If a fresh schedule page.
        if ($newlyLoadedPage) {
			// Establish the audio pieces for this campaign, and designate a letter
			$query = <<<EOQ
				SELECT A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID,
					A.{$this->store->field_campaignaudio_name} AS name,
					A.{$this->store->field_campaignaudio_mediaID} AS mediaID,
					A.{$this->store->field_campaignaudio_duration} AS duration,
					A.{$this->store->field_campaignaudio_startDate} AS startDate,
					A.{$this->store->field_campaignaudio_endDate} AS endDate
				FROM ({$this->store->table_traffic_campaignaudio} A)
				LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON A.{$this->store->field_campaignaudio_campaignID} = M.{$this->store->field_campaign_campaignID}
				WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
				ORDER BY campaignAudioID
EOQ;
			$result = sysdb::query($query);
			/* // Part of an unfinished feature to show number spots per audio.
			$query = <<<EOQ
				SELECT A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID,
					A.{$this->store->field_campaignaudio_name} AS name,
					A.{$this->store->field_campaignaudio_mediaID} AS mediaID,
					A.{$this->store->field_campaignaudio_duration} AS duration,
					A.{$this->store->field_campaignaudio_startDate} AS startDate,
					A.{$this->store->field_campaignaudio_endDate} AS endDate,
					COUNT(COALESCE(S.{$this->store->field_spot_mediaID},0)) AS spotCount
				FROM ({$this->store->table_traffic_campaignaudio} A)
				LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON A.{$this->store->field_campaignaudio_campaignID} = M.{$this->store->field_campaign_campaignID}
				LEFT OUTER JOIN {$this->store->table_traffic_spot} S
					ON S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
				WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
				GROUP BY campaignAudioID
				ORDER BY campaignAudioID
EOQ;
			$result = sysdb::query($query);
			// echo $query.'<br/>';
			// echo '<pre>'.print_r($result, true).'</pre>';

			// TODO: The above query is attempting to count spots for each audio.
			//  There is currently an error whereby a count of NULL/'0'
			//  (ie. there are no spots scheduled for that campaignAudioID)
			//  is returned as '1'. Counts of >= '1' seem to return perfectly.
			//  This needs to be corrected if the counter for each audio is to
			//  be implemented in the future.
			//
			//  The reason this feature is incomplete is because it was deemed
			//  excessive for a station's needs at the time. However I have left
			//  the code commented out because I believe it might be a worthwhile
			//  feature to implement via a module_parameter; to be switched on or
			//  off by the system administrator.
			//
			//  Ken McLean, 1st February, 2010.
			*/

			$char = 'A';
			$campaign_audio = array();
			while ($line = sysdb::fetch_assoc($result)) {
				$array = array('#' => $char,
								'name' => utf8_decode($line['name']),
								'mediaID' => $line['mediaID'],
								'duration' => $line['duration'],
								'startDate' => $line['startDate'],
								'endDate' => $line['endDate'],
								'spotCount' => '');
				/* // Part of an unfinished feature to show number spots per audio.
				$array = array('#' => $char,
								'name' => $line['name'],
								'mediaID' => $line['mediaID'],
								'duration' => $line['duration'],
								'startDate' => $line['startDate'],
								'endDate' => $line['endDate'],
								'spotCount' => $line['spotCount']);
				*/
				$campaign_audio[$line['campaignAudioID']] = $array;
				unset($array);
				$char++;
			}
			unset($result);

			// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
			// Append a giveaway designation to the display list.
			$array = array('#' => '1',
							'name' => 'Promotion or Giveaway',
							'mediaID' => '',
							'duration' => '',
							'startDate' => '',
							'endDate' => '',
							'spotCount' => '');
			$campaign_audio['Promo'] = $array;
			unset($array);
			// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //

			// Fetch the maximum length of the designations used.
			$max_length = strlen($char);

			$all_designation = array();
            $audio_designation = array();
			foreach ($campaign_audio as $key => $value) {
                if ($key != 'Promo') $audio_designation[$key] = $value['#'];
				$all_designation[$key] = $value['#'];
			}

			// Retrieve the spots that can be modified (that is younger than now) for display purposes.
            $query = <<<EOQ
                SELECT S.{$this->store->field_spot_dateTime} AS dateTime,
					A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID
                FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaignaudio} A
				)
				LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON A.{$this->store->field_campaignaudio_campaignID} = M.{$this->store->field_campaign_campaignID}
                WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
                AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
				ORDER BY dateTime
EOQ;
			$result = sysdb::query($query);

			// Build list of spots and their designation letter.
			$selected_spots = array();
			$conflicting_spots = array();
			while ($line = sysdb::fetch_assoc($result)) {
				if(array_key_exists($line['dateTime'], $selected_spots)) {
					// If there is a conflicting spot in the same slot, add it to the conflicting spots array.
					$conflicting_spots[$line['dateTime']] = '!';
				} else {
					// Assign timestamp as key and designation letter as value.
					$selected_spots[$line['dateTime']] = $all_designation[$line['campaignAudioID']];
				}
			}
			unset($result);
// echo "<b>conflicting_spots</b><br/>".print_r($conflicting_spots, true)."<br/>";

			// Remove the conflicting spot times from the selected spots array so they don't get displayed.
			foreach ($conflicting_spots as $key => $value) {
				unset($selected_spots[$key]);
			}

			// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
			// Retrieve the spots that can be modified (that is younger than now) for display purposes.
            $query = <<<EOQ
                SELECT S.{$this->store->field_spot_dateTime} AS dateTime,
					'Promo' AS campaignPromotionID
                FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaignpromotion} P
				)
				LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
					ON P.{$this->store->field_campaignpromotion_campaignID} = M.{$this->store->field_campaign_campaignID}
                WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
                AND S.{$this->store->field_spot_mediaID} = P.{$this->store->field_campaignpromotion_mediaID}
				AND S.{$this->store->field_spot_dateTime} > TIMESTAMP(NOW())
				ORDER BY dateTime
EOQ;
			$result = sysdb::query($query);

			// Build list of promo spots and their designation number.
			$selected_promo_spots = array();
			$conflicting_promo_spots = array();
			while ($line = sysdb::fetch_assoc($result)) {
				if(array_key_exists($line['dateTime'], $selected_promo_spots)) {
					// If there is a conflicting spot in the same slot, add it to the conflicting spots array.
					$conflicting_promo_spots[$line['dateTime']] = '!';
				} else {
					// Assign timestamp as key and designation number as value.
					$selected_promo_spots[$line['dateTime']] = $all_designation[$line['campaignPromotionID']];
				}
			}
			unset($result);
// echo "<b>conflicting_promo_spots</b><br/>".print_r($conflicting_promo_spots, true)."<br/>";

			// Remove the conflicting spot times from the selected spots array so they don't get displayed.
			foreach ($conflicting_promo_spots as $key => $value) {
				unset($selected_promo_spots[$key]);
			}
			// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //

			// Determine the first scheduled spot's dateTime to use as the start date.
			reset($selected_spots);
			$startDate = key($selected_spots);

			// If nothing has been scheduled, grab campaign start date as start date.
			if ($startDate == '') {
				$query = <<<EOQ
					SELECT {$this->store->field_campaign_startDate} AS campaignStartDate
					FROM ({$this->store->table_traffic_campaign})
					WHERE {$this->store->field_campaign_campaignID} = '$campaignID'
EOQ;
				$startDate = sysdb::queryOne($query);
			} else {
                $startDateObj = new DateTime($startDate);
                if (date('h:i:s', strtotime($startDate)) < $display_start_time)
					$startDateObj->modify('-1 day');
                $startDate = $startDateObj->format('Y-m-d h:i:s');
            }
			// Check if the audio start date is in the past, and then set the display start.
			if (strtotime($startDate) <= strtotime(date('Y-m-d'))) {
				// Set display start date as today.
				$day_display_start = date('Y-m-d');
			} else {
				// Set display start date as audio start date.
				$day_display_start = $startDate;
			}

// echo "<b>selected_spots</b><br/>".print_r($selected_spots, true)."<br/>";

        } else {
			$selected_spots = globalize('traffic_input', array());
// echo "<b>selected_spots</b><br/>".print_r($selected_spots, true)."<br/>";
            $selected_audio_spots = array();
            $selected_promo_spots = array();
            foreach ($selected_spots as $time => $inputtext) {
				// This strips giveaways off the tail end of a conjoined slot schedule.
				// e.g. 'A1', which is spot A and giveaway 1 within the same slot.
				/**
				* @todo Move the scheduling of giveaways to another tab or similar so that
				*   this kind of code hack is not required. It's messy and against original
				*   design principes.
				*/
                $pos = strpos($inputtext, '1');
// echo "<b>pos</b><br/>".$pos." -- ".$inputtext."<br/>";
                if ($pos !== FALSE) {
                    //echo $input.'=>';
                    $selected_promo_spots[$time] = 'Promo';
// echo "<b>substr... </b>".substr($inputtext, 0, $pos).substr($inputtext, $pos + 1, strlen($inputtext) - $pos)."<br/>";
// echo "<b>substr.2. </b><br/>".substr($inputtext, 0, $pos);
// echo "<b>substr... </b><br/>".substr($inputtext, $pos + 1, strlen($inputtext) - $pos);
                    $selected_audio_spots[$time] = substr($inputtext, 0, $pos).substr($inputtext, $pos + 1, strlen($inputtext) - $pos);
                }
            }
// echo "<b>selected_spots</b><br/>".print_r($selected_spots, true)."<br/>";


			$all_designation = globalize('all_designation', array());
            $audio_designation = array();
			foreach ($all_designation as $key => $value) {
                if ($key != 'Promo') $audio_designation[$key] = $value;
			}
			$conflicting_spots = globalize('conflicting_spots', array());

			if (!empty($all_designation)) {
				// Establish the audio pieces for this campaign, and designate a letter
				$query = <<<EOQ
					SELECT A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID,
						A.{$this->store->field_campaignaudio_name} AS name,
						A.{$this->store->field_campaignaudio_mediaID} AS mediaID,
						A.{$this->store->field_campaignaudio_duration} AS duration,
						A.{$this->store->field_campaignaudio_startDate} AS startDate,
						A.{$this->store->field_campaignaudio_endDate} AS endDate
					FROM ({$this->store->table_traffic_campaignaudio} A)
					LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
						ON A.{$this->store->field_campaignaudio_campaignID} = M.{$this->store->field_campaign_campaignID}
					WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
					ORDER BY campaignAudioID
EOQ;
				$result = sysdb::query($query);
				/* // Part of an unfinished feature to show number spots per audio.
				// TODO: The above query is not counting spots for each audio.
				//  If implementing the feature described above, this query
				//  should be modified to also count spots.
				*/

				$campaign_audio = array();
				while ($line = sysdb::fetch_assoc($result)) {
					if (array_key_exists($line['campaignAudioID'], $all_designation)) {
						$char = $all_designation[$line['campaignAudioID']];

						$array = array('#' => $char,
										'name' => utf8_decode($line['name']),
										'mediaID' => $line['mediaID'],
										'duration' => $line['duration'],
										'startDate' => $line['startDate'],
										'endDate' => $line['endDate'],
										'spotCount' => '');
						/* // Part of an unfinished feature to show number spots per audio.
						$array = array('#' => $char,
										'name' => $line['name'],
										'mediaID' => $line['mediaID'],
										'duration' => $line['duration'],
										'startDate' => $line['startDate'],
										'endDate' => $line['endDate'],
										'spotCount' => $line['spotCount']);
						*/
						$campaign_audio[$line['campaignAudioID']] = $array;
						unset($array);
					}
				}
				unset($result);

				// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
				$query = <<<EOQ
					SELECT P.{$this->store->field_campaignpromotion_mediaID} AS mediaID
					FROM {$this->store->table_traffic_campaignpromotion} P
					LEFT OUTER JOIN {$this->store->table_traffic_campaign} M
						ON P.{$this->store->field_campaignpromotion_campaignID} = M.{$this->store->field_campaign_campaignID}
					WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
					ORDER BY mediaID
EOQ;
				$mediaID = sysdb::queryOne($query);

				// Append a giveaway designation to the display list.
				$array = array('#' => '1',
								'name' => 'Promotion or Giveaway',
								'mediaID' => $mediaID,
								'duration' => 0,
								'startDate' => '',
								'endDate' => '',
								'spotCount' => '');
				$campaign_audio['Promo'] = $array;
				unset($array);
				// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
			}

			// Fetch display start date.
			$day_display_start = globalize('day_start');
		}

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
		// Fetch the maximum length of the designations used.
		if (!isset($max_length) || $max_length == '') {
			$longest = NULL;
			$longestLength = -1;
			foreach ($all_designation as $value) {
				$length = strlen($value);
				if ($length > $longestLength) {
					$longest = $value;
					$longestLength = $length;
				}
			}
			$longest = str_replace('\r\n', '\n', $longest);
			if (get_magic_quotes_gpc()) {
				$longest = stripslashes($longest);
			}
			$max_length = strlen($longest);
		}
        // Add 1 for promo space.
    	$max_length++;

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
		// If a fresh schedule page, calculate counter.
        if ($newlyLoadedPage) {
			// Retrieve the number of spots for the whole campaign for spot counter purposes.
			$query = <<<EOQ
				SELECT {$this->store->field_campaign_spotsAllotted}
				FROM ({$this->store->table_traffic_campaign})
				WHERE {$this->store->field_campaign_campaignID} = '$campaignID'
EOQ;
			$spot_allotted_count = sysdb::queryOne($query);
			$query = <<<EOQ
				SELECT COUNT(S.{$this->store->field_spot_spotID})
				FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaign} M,
					{$this->store->table_traffic_campaignaudio} A
				)
				WHERE A.{$this->store->field_campaignaudio_campaignID} = '$campaignID'
				AND M.{$this->store->field_campaign_campaignID} = A.{$this->store->field_campaignaudio_campaignID}
				AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
EOQ;
			$spot_count = sysdb::queryOne($query);
			$spot_remaining_count = $spot_allotted_count - $spot_count;
		} else {
			$spot_allotted_count = globalize('totalspotsallotted');
			$spot_count = globalize('tickcounter_count');
			$spot_remaining_count = globalize('totalcounter_count');
		}


		// Check to see if the spots exist already.
		// If so, preserve the priority value.
		// If not, increment the result by one to get the new priority value.

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
		// When the Schedule button is pressed perform the following.
        if ($act == 'Schedule') {
            $alloccount = 0;
            $removecount = 0;
			$errors = false;
			$warning_msg = '';
			$debug = '';
			// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
            $promoalloccount = 0;
            $promoremovecount = 0;
			// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //

			// Fetch a list of the existing schedule currently in storage.
			if (is_array($campaign_audio) && sizeof($campaign_audio) > 0) {
				foreach ($campaign_audio as $key => $value) {
					$ids[] = $value['mediaID'];
				}
				$ids = array_filter($ids);
				$debug .= 'Fetching existing schedule for mediaIDs: '.implode(',', $ids).'<br/>';
				$query = <<<EOQ
					SELECT S.{$this->store->field_spot_dateTime} AS dateTime,
						A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID
					FROM ({$this->store->table_traffic_spot} S,
						{$this->store->table_traffic_campaignaudio} A
					)
EOQ;
				if (is_array($ids) && sizeof($ids) <= 0) {
					$query .= ' WHERE 0=1';
				} else if (is_array($ids) && sizeof($ids) > 0) {
					$query .= " WHERE S.{$this->store->field_spot_mediaID} IN (".implode(',', $ids).") ";
				}
				$query .= " AND S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}";
				$query .= " AND S.{$this->store->field_spot_dateTime} > TIMESTAMP(NOW())";
				// Turn result query into a matrix.
				$matrix = sysdb::query2matrix($query, false);

				// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
				$vectors = sysdb::rotatematrix($matrix);
				unset($matrix);

				// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
				$query = <<<EOQ
					SELECT S.{$this->store->field_spot_dateTime} AS dateTime,
						'Promo' AS campaignPromotionID
					FROM ({$this->store->table_traffic_spot} S,
						{$this->store->table_traffic_campaignpromotion} P
					)
EOQ;
				if (is_array($ids) && sizeof($ids) <= 0) {
					$query .= ' WHERE 0=1';
				} else if (is_array($ids) && sizeof($ids) > 0) {
					$query .= " WHERE S.{$this->store->field_spot_mediaID} IN (".implode(',', $ids).") ";
				}
				$query .= " AND S.{$this->store->field_spot_mediaID} = P.{$this->store->field_campaignpromotion_mediaID} ";
				$query .= " AND S.{$this->store->field_spot_dateTime} > TIMESTAMP(NOW())";
				// Turn result query into a matrix.
				$matrixPromo = sysdb::query2matrix($query, false);

				// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
				$vectorsPromo = sysdb::rotatematrix($matrixPromo);
				unset($matrixPromo);
				// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //

// echo "<b>vectors</b><br/>".print_r($vectors, true)."<br/>";
// echo "<b>vectorsPromo</b><br/>".print_r($vectorsPromo, true)."<br/>";
			}
			// If there are no existing spots, create a blank array for diff checking.
			if (is_array($vectors) && sizeof($vectors) > 0) {
				$existing_spots = array();
				$existing_conflict = array();
				// foreach ($vectors[0] as $key => $value) {
					// if(!array_key_exists($value, $existing_spots)) {
						// $existing_spots[$value] = $vectors[1][$key];
					// } else {
						// // Conflicting spots found. Remember what they are.
						// $existing_conflict[$value] = '';
						// $debug .= 'Conflicting spots found.<br/>';
					// }
				// }
				// // Remove the conflicting spot times from the existing spots array so they don't get removed.
				// if (!empty($existing_conflict)) {
					// foreach ($existing_conflict as $key => $value) {
						// unset($existing_spots[$key]);
					// }
				// }
				$conflicts = Schedule::resolve_conflicting_spots($vectors, $existing_spots, $existing_conflict);
				if ($conflicts)
					$debug .= 'Existing spots found.<br/>';
			} else {
				$existing_spots = array();
				$debug .= 'No existing spots found.<br/>';
			}

			// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
			// If there are no existing spots, create a blank array for diff checking.
			$existing_promo_spots = array();
			$existing_promo_conflict = array();
			if (is_array($vectorsPromo) && sizeof($vectorsPromo) > 0) {
// echo "<b>vectorsPromo</b><br/>".print_r($vectorsPromo, true)."<br/>";
				// foreach ($vectorsPromo[0] as $key => $value) {
					// if(!array_key_exists($value, $existing_promo_spots)) {
						// $existing_promo_spots[$value] = 'Promo';
						// echo '<h1>';
						// echo $vectorsPromo[1][$key];
						// echo '</h1>';
					// } else {
						// // Conflicting spots found. Remember what they are.
						// $existing_promo_conflict[$value] = '';
						// $debug .= 'Conflicting promo spots found.<br/>';
					// }
				// }
				// // Remove the conflicting spot times from the existing spots array so they don't get removed.
				// if (!empty($existing_promo_conflict)) {
					// foreach ($existing_promo_conflict as $key => $value) {
						// unset($existing_promo_spots[$key]);
					// }
				// }
				$conflicts = Schedule::resolve_conflicting_spots($vectorsPromo, $existing_promo_spots, $existing_promo_conflict);
				if ($conflicts)
					$debug .= 'Existing promo spots found.<br/>';
			} else {
				$debug .= 'No existing promo spots found.<br/>';
			}
			// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
// echo "<b>existing_spots</b><br/>".print_r($existing_spots, true)."<br/>";
// echo "<b>existing_promo_spots</b><br/>".print_r($existing_promo_spots, true)."<br/>";

			$corrected_spots = array();

			// Convert the alphabetical designation into its corresponding campaignAudioID.
            $rotation_wheel = array();
			if (is_array($selected_spots) && sizeof($selected_spots) > 0) {
				// Sort the array by date (key) so that rotating spots are designated correctly.
				ksort($selected_spots);
				foreach ($selected_spots as $key => $value) {
                    if ($value != '') {
    					$audio_key = array_search(strtoupper($value), $all_designation);
                        //$audio_key = $key;
    					if ($audio_key === false) {
							$debug .= 'Designation cannot be found. Checking for rotating spot...<br/>';
    						// Check if designation is a rotating spot.
    						if ($value == '*') {
    							// Cycle through the $all_designation array and allocate to that key.
                                if (sizeof($rotation_wheel) <= 0)
									$rotation_wheel = array_keys($audio_designation);
                                $audio_key = array_shift($rotation_wheel);
        						$corrected_spots[$key] = $audio_key;
								$debug .= 'Rotating spot. Assigning designation: '.$audio_key.'<br/>';
    						} else {
								$debug .= 'Not a rotating spot. Checking for promo designation "1"...<br/>';
								// Check if value is two designations.
								$valueArray = str_split($value);

// echo "<b>valueArray</b><br/>".print_r($valueArray, true)."<br/>";
								foreach ($valueArray as $desig) {
									$desig_key = array_search(strtoupper($desig), $all_designation);
									if ($desig_key !== false) {
										// Check if designation is a promo, and if there is a conflict.
										$vectors = array(array($key), array($desig_key));
										if ($desig_key == 'Promo') {
											// Promos have already been dealt with.

											// $selected_promo_spots_conflict = array();
											// $conflicts = Schedule::resolve_conflicting_spots($vectors, $selected_promo_spots, $selected_promo_spots_conflict);
											// if ($conflicts) {
												// $debug .= 'Existing promo spots found.<br/>';
											// } else {
												// $selected_promo_spots[$key] = $desig_key;
												// $debug .= "Contains a promo designation. Assigning spot for: <b>".$desig_key."</b><br/>";
											// }
										} else {
											$corrected_spots_conflict = array();
											$conflicts = Schedule::resolve_conflicting_spots($vectors, $corrected_spots, $corrected_spots_conflict);
											if ($conflicts) {
												$debug .= 'Contains an audio designation. Existing spots found.<br/>';
											} else {
												//$corrected_spots[$key] = $desig_key;
												$debug .= 'Contains an audio designation. Assigning spot for: <b>'.$desig_key.'</b><br/>';
											}
										}

// echo "<b>key</b><br/>".$key."<br/>";
// echo "<b>value</b><br/>".$value."<br/>";
// echo "<b>desig</b><br/>".$desig."<br/>";
// echo "<b>desig_key</b><br/>".$desig_key."<br/>";
									} else {
										$warning_msg .= "The designation '".$value."' at spot ".$key." does not correspond with any campaign audio. Please correct. <br/>";
										$errors = true;
										$debug .= 'Mismatched designation. Process fail.<br/>';
									}
								}
    						}
    					} else {

							if ($value == '1') {
								$selected_promo_spots[$key] = $audio_key;
							} else {
								$corrected_spots[$key] = $audio_key;
							}
    					}
                    }
				}
// echo "<b>existing_spots</b><br/>".print_r($existing_spots, true)."<br/>";
// echo "<b>existing_promo_spots</b><br/>".print_r($existing_promo_spots, true)."<br/>";

// echo "<b>corrected_spots</b><br/>".print_r($corrected_spots, true)."<br/>";
			}
//$existing_spots = '';

						// *** START TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
			// Diff check old and new spots to see what needs changing.
			$promo_spots_to_delete = array_diff_assoc($existing_promo_spots, $selected_promo_spots);
			$promo_spots_to_add = array_diff_assoc($selected_promo_spots, $existing_promo_spots);

			// Debug.
            $debug .= '<b>'.sizeof($existing_promo_spots).' existing promos. </b><br/>'.print_r($existing_promo_spots,true).'<br />';
            $debug .= '<b>'.sizeof($selected_promo_spots).' selected promos. </b><br/>'.print_r($selected_promo_spots,true).'<br />';
            $debug .= '<b>'.sizeof($promo_spots_to_delete).' deleted promos. </b><br/>'.print_r($promo_spots_to_delete,true).'<br />';
            $debug .= '<b>'.sizeof($promo_spots_to_add).' added promos. </b><br/>'.print_r($promo_spots_to_add,true).'<br />';

			if (!$errors) {
				// Remove those spots that were deselected.
				if (is_array($promo_spots_to_delete) && sizeof($promo_spots_to_delete) > 0) {
					foreach ($promo_spots_to_delete as $spotDateTime => $campaignPromotionID) {
						$query = <<<EOQ
							SELECT S.{$this->store->field_spot_spotID} AS spotID
							FROM ({$this->store->table_traffic_spot} S,
								{$this->store->table_traffic_campaignpromotion} P
							)
							WHERE S.{$this->store->field_spot_dateTime} = '$spotDateTime'
							AND P.{$this->store->field_campaignpromotion_campaignID} = '$campaignID'
							AND P.{$this->store->field_campaignpromotion_mediaID} = S.{$this->store->field_spot_mediaID}
EOQ;
						$spotID = sysdb::queryOne($query);

						self::removeSpot($spotID);
						$promoremovecount++;
    				}
					$debug .= 'Removed '.$removecount.' promo spots.<br/>';
				}
				// Add those spots that were designated.
				if (is_array($promo_spots_to_add) && sizeof($promo_spots_to_add) > 0) {
					foreach ($promo_spots_to_add as $spotDateTime => $campaignPromotionID) {
						// The promo may or may not already have a mediaID assigned.
						$query = <<<EOQ
							SELECT P.{$this->store->field_spot_mediaID} AS mediaID
							FROM ({$this->store->table_traffic_campaignpromotion} P)
							WHERE P.{$this->store->field_campaignpromotion_campaignID} = '$campaignID'
EOQ;
						$result = sysdb::query($query);

						if (sysdb::num_rows($result) <= 0) {
							// Create a new promotion, and fetch its media ID.
							$campaignPromotion = new CampaignPromotion();
							$campaignPromotion->add('Promotion', '', $campaignID, '', '');

							$query = <<<EOQ
								SELECT {$this->store->field_campaignpromotion_mediaID} AS mediaID
								FROM ({$this->store->table_traffic_campaignpromotion})
								WHERE {$this->store->field_campaignpromotion_campaignID} = '$campaignID'
EOQ;
							$mediaID = sysdb::queryOne($query);
						} else {
							$line = sysdb::fetch_assoc($result);
							$mediaID = $line['mediaID'];
						}
						unset($result);

						$query = <<<EOQ
							INSERT INTO {$this->store->table_traffic_spot} (
								{$this->store->field_spot_mediaID},
								{$this->store->field_spot_dateTime},
								{$this->store->field_spot_priority}
							)
							SELECT {$this->store->field_campaignpromotion_mediaID} AS mediaID,
								'$spotDateTime' AS dateTime,
								(SELECT COALESCE(MAX({$this->store->field_spot_priority}),0) + 1
									FROM {$this->store->table_traffic_spot}
									WHERE {$this->store->field_spot_dateTime} = '$spotDateTime'
								) AS priority
							FROM {$this->store->table_traffic_campaignpromotion}
							WHERE {$this->store->field_campaignpromotion_campaignID} = '$campaignID'
EOQ;
						sysdb::query($query);
						$promoalloccount++;
					}
					$debug .= 'Added '.$alloccount.' promo spots.<br/>';
				}
				// *** END TEMPORARY SOLUTION TO PROMOS/GIVEAWAYS *** //
            }


			// Diff check old and new spots to see what needs changing.
			$spots_to_delete = array_diff_assoc($existing_spots, $corrected_spots);
			$spots_to_add = array_diff_assoc($corrected_spots, $existing_spots);

			// Debug.
            $debug .= '<b>'.sizeof($existing_spots).' existing spots. </b><br/>'.print_r($existing_spots,true).'<br />';
            $debug .= '<b>'.sizeof($corrected_spots).' selected spots. </b><br/>'.print_r($corrected_spots,true).'<br />';
            $debug .= '<b>'.sizeof($spots_to_delete).' deleted spots. </b><br/>'.print_r($spots_to_delete,true).'<br />';
            $debug .= '<b>'.sizeof($spots_to_add).' added spots. </b><br/>'.print_r($spots_to_add,true).'<br />';

			if (!$errors) {
				// Remove those spots that were deselected.
				if (is_array($spots_to_delete) && sizeof($spots_to_delete) > 0) {
					/** @todo Change this query to use Spot::remove_many() instead, as self::displayGridTickboxes() does. */
					foreach ($spots_to_delete as $spotDateTime => $campaignAudioID) {
						$query = <<<EOQ
							SELECT S.{$this->store->field_spot_spotID} AS spotID
							FROM ({$this->store->table_traffic_spot} S,
								{$this->store->table_traffic_campaignaudio} A
							)
							WHERE S.{$this->store->field_spot_dateTime} = '$spotDateTime'
							AND A.{$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
							AND A.{$this->store->field_campaignaudio_mediaID} = S.{$this->store->field_spot_mediaID}
EOQ;
						$spotID = sysdb::queryOne($query);

						self::removeSpot($spotID);
						$removecount++;
					}
					$debug .= 'Removed '.$removecount.' spots.<br/>';
				}

// echo "<b>spots_to_add</b><br/>".print_r($spots_to_add, true)."<br/>";
				// Add those spots that were designated.
				if (is_array($spots_to_add) && sizeof($spots_to_add) > 0) {
					/** @todo Change this query to use Spot::add_many() instead, as self::displayGridTickboxes() does. */
					foreach ($spots_to_add as $spotDateTime => $campaignAudioID) {
						$query = <<<EOQ
							INSERT INTO {$this->store->table_traffic_spot} (
								{$this->store->field_spot_mediaID},
								{$this->store->field_spot_dateTime},
								{$this->store->field_spot_priority}
							)
							SELECT {$this->store->field_campaignaudio_mediaID} AS mediaID,
								'$spotDateTime' AS dateTime,
								(SELECT COALESCE(MAX({$this->store->field_spot_priority}),0) + 1
									FROM {$this->store->table_traffic_spot}
									WHERE {$this->store->field_spot_dateTime} = '$spotDateTime'
								) AS priority
							FROM {$this->store->table_traffic_campaignaudio}
							WHERE {$this->store->field_campaignaudio_campaignAudioID} = '$campaignAudioID'
EOQ;
						sysdb::query($query);
						$alloccount++;
					}
					$debug .= 'Added '.$alloccount.' spots.<br/>';
				}

				// Construct a human readable notification.
				if ($alloccount > 0 || $removecount > 0) {
					$message = '';
					$s = '';
					if ($alloccount == $removecount) {
						$message .= 'reallocated '.$alloccount;
					} else {
						if ($alloccount > 0)
							$message .= 'allocated '.$alloccount;
						if ($alloccount && $removecount > 0)
							$message .= ' and ';
						if ($removecount > 0)
							$message .= 'removed '.$removecount;
					}
					if ($alloccount > 1 || $removecount > 1)
						$s .= 's';
					state::setMessage('notify', ucfirst($message.' spot'.$s.'.'));
				} else {
					state::setMessage('warning', "Didn't allocate any spots. No change to the schedule.");
				}
				if ($debug != '') state::setMessage('debug', $debug);
				module::forward_to_script('', array('item' => 'Campaign', 'action' => 'view', 'id' => $campaignID));
			} else {
				$warning_msg .= 'Schedule was not saved. <br/>';
				state::setMessage('warning', $warning_msg);
			}
			if ($debug != '')
				state::setMessage('debug', $debug);
        }

        $day_start = $day_display_start;
        $view_days = globalize('view_days', 14);

        $num_of_days = globalize('num_of_days', $view_days);
        $num_of_hours = globalize('num_of_hours', 24);
		// TODO: the following variable needs to be a Module Parameter


        $display_start_day = new DateTime($day_start);

        $display_end_day = clone $display_start_day;
		$display_end_day->modify('+'.$num_of_days.' day');

        $display_start_day_str = $display_start_day->format('Y-m-d');
        $display_end_day_str = $display_end_day->format('Y-m-d');

        $query = <<<EOQ
            SELECT DISTINCT({$this->store->field_slot_time}) AS time
            FROM {$this->store->table_traffic_slot}
            WHERE {$this->store->field_slot_startDate} <= '$display_start_day_str'
            AND ({$this->store->field_slot_endDate} IS NULL
				OR {$this->store->field_slot_endDate} >= '$display_end_day_str'
			)
            ORDER BY time
EOQ;
        $alltimes = sysdb::query2vector($query, 'time');
        $alltimes = self::rotate($alltimes, $display_start_time);
        $alltimes[] = $alltimes[0]; //Append the last one so we can detect end of the final slot.
        //print_r($alltimes);

        $date_counter = clone $display_start_day;

		// Select campaign name for display on the page.
        $query = <<<EOQ
            SELECT {$this->store->field_campaign_name} AS name
            FROM {$this->store->table_traffic_campaign}
            WHERE {$this->store->field_campaign_campaignID} = '$campaignID'
EOQ;
		$campaignName = utf8_decode(sysdb::queryOne($query));

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
		// Check for program component dependency.
		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
			// This is a temporary implementation of the ability to see the equivalent
			//  program related to this time slot.

			require_once(ROOT_COMPONENTS.'programs/moduleconfig.php');
			$remoteStore = new programStorage();

			$program_array = array();
			for ($t = strtotime($display_start_day_str), $max = strtotime($display_end_day_str); $t <= $max; $t = strtotime('+1 day', $t)) {
				$date_in_question = date('Y-m-d', $t);
				$dow_in_question = date('l', $t);

				// Find the periodID of the program grid corresponding to the date.
				$query = <<<EOQ
					SELECT DISTINCT G.{$remoteStore->field_programs_grid_periodID} AS periodID
					FROM ({$remoteStore->table_period} D,
						{$remoteStore->table_programs_grid} G
					)
					WHERE D.{$remoteStore->field_period_periodID} = G.{$remoteStore->field_programs_grid_periodID}
					AND (D.{$remoteStore->field_period_endDate} >= '$date_in_question'
						&& D.{$remoteStore->field_period_startDate} <= '$date_in_question'
					)
EOQ;
				$periodID = sysdb::queryOne($query);

				$query = <<<EOQ
					SELECT P.{$remoteStore->field_programs_program_name} AS name,
						G.{$remoteStore->field_programs_grid_startTime} AS startTime,
						G.{$remoteStore->field_programs_grid_endTime} AS endTime
					FROM ({$remoteStore->table_period} D,
						{$remoteStore->table_programs_program} P,
						{$remoteStore->table_programs_grid} G
					)
					WHERE D.{$remoteStore->field_programs_grid_periodID} = '$periodID'
					AND D.{$remoteStore->field_period_periodID} = G.{$remoteStore->field_programs_grid_periodID}
					AND G.{$remoteStore->field_programs_grid_programID} = P.{$remoteStore->field_programs_program_programID}
					AND G.{$remoteStore->field_programs_grid_dow} = '$dow_in_question'
EOQ;

				// Turn result query into a matrix.
				$matrix = sysdb::query2keyedmatrix($query, false);
				//array_push($program_array, $matrix);
				$program_array[$date_in_question] = $matrix;
			}
			//print_r($program_array);
			$programName = array();

			// $program_array = globalize('program_array');
			// $grid->appendChild($input = dom::createInputBox($doc, 'program_array', $program_array, 'hidden'));
		}

        $container = $doc->createElement('div');
		$container->setAttribute('class', 'module');


		// Create grid.
        $grid = $doc->createElement('div');

        $grid->appendChild($hidden = dom::createInputBox($doc, 'item',globalize('item', get_class($this)), 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'action', $action, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'spots_loaded', 'true', 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'num_of_days', $num_of_days, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'num_of_hours', $num_of_hours, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'day_start', $day_start, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'hour_start', $display_start_time, 'hidden'));
        $grid->appendChild($input = dom::createInputBox($doc, 'campaignID', $campaignID, 'hidden'));
		if (is_array($all_designation)) {
			foreach ($all_designation as $key => $designation) {
				$grid->appendChild($input = dom::createInputBox($doc, 'all_designation['.$key.']', $designation, 'hidden'));
			}
		}
		if (is_array($conflicting_spots)) {
			foreach ($conflicting_spots as $key => $confliction) {
				$grid->appendChild($input = dom::createInputBox($doc, 'conflicting_spots['.$key.']', $confliction, 'hidden'));
			}
		}
//        $grid->appendChild($input = dom::createInputBox($doc, 'tickcounter_count', $spot_count, 'hidden'));

// echo "<b>selected_spots</b><br/>".print_r($selected_spots, true)."<br/>";
		if (is_array($selected_spots)) {
			foreach ($selected_spots as $spot => $audioLetter) {
				$spottime = new DateTime($spot);
				if ($spottime->format('U') < $display_start_day->format('U')
					|| $spottime->format('U') > $display_end_day->format('U')
					|| $spottime->format('U') <= strtotime('now')) {
					$grid->appendChild($input = $doc->createElement('input'));
					$input->setAttribute('type', 'hidden');
					$input->setAttribute('name', 'traffic_input['.$spottime->format('Y-m-d H:i:s').']');
					$input->setAttribute('value', $audioLetter);
				}
			}
		}

        $h1 = $doc->createElement('h1');
		$h1->appendChild($doc->createTextNode('Schedule Spots'));
        $grid->appendChild($h1);
        $h2 = $doc->createElement('h2');
        $h2->appendChild($doc->createTextNode($campaignName.' campaign'));
        $grid->appendChild($h2);

		// Change the date navigation values when in daily view.
        if ($num_of_days == 1) {
			$short_interval = 'Day';
			$long_interval = 'Week';
		} elseif ($num_of_days == 7) {
			$short_interval = 'Week';
			$long_interval = 'Month';
		} elseif ($num_of_days == 14) {
			$short_interval = 'Fortnight';
			$long_interval = 'Month';
		} elseif ($num_of_days == 31) {
			$short_interval = 'Month';
			$long_interval = 'Year';
		} else {
			$short_interval = 'Week';
			$long_interval = 'Month';
		}

        $grid->appendChild($divHeader = $doc->createElement('div'));
        $divHeader->setAttribute('id', 'traffic_header_container');

		// This submit button must be first in the HTML flow so that pressing enter submits the form.
        $divHeader->appendChild($input = $doc->createElement('input'));
        $input->setAttribute('type', 'submit');
        $input->setAttribute('name', 'act');
        $input->setAttribute('id', 'scheduleSubmitHeader');
        $input->setAttribute('value', 'Schedule');
		// TODO: pull this style out and put it in CSS. Also use CSS trickery to keep this button first but visible on the page.
        $input->setAttribute('style', 'position: absolute; left: -9999px;');

        $divHeader->appendChild($tblnav = $doc->createElement('table'));
        $tblnav->setAttribute('id', 'navtble');
        $tblnav->setAttribute('class', 'traffic_table');

        $tblnav->appendChild($tr = $doc->createElement('tr'));
        $tr->appendChild($left = $doc->createElement('td'));

        $display_minus_month = clone $display_start_day;
        $display_minus_month->modify('-1 '.$long_interval);
        $left->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_minus_month->format('Y-m-d'));
        $button->setAttribute('class', 'link_prev2_small');
        $button->setAttribute('title', 'Previous '.$long_interval);

        $display_minus_week = clone $display_start_day;
        $display_minus_week->modify('-1 '.$short_interval);
        $left->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_minus_week->format('Y-m-d'));
        $button->setAttribute('class', 'link_prev_small');
        $button->setAttribute('title', 'Previous '.$short_interval);

        $tr->appendChild($middle = $doc->createElement('td'));

		// TODO: The daily calendar view should probably redirect to a daily log-type page
        $middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'view_day');
 //       $button->setAttribute('value', 1);
        $button->setAttribute('class', 'link_day_small');
        $button->setAttribute('title', 'View Day');

        $middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'num_of_days');
        $button->setAttribute('value', 7);
        $button->setAttribute('class', 'link_week_small');
        $button->setAttribute('title', 'View Week');

		$middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'num_of_days');
        $button->setAttribute('value', 14);
        $button->setAttribute('class', 'link_range_small');
        $button->setAttribute('title', 'View Fortnight');

		$middle->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'num_of_days');
        $button->setAttribute('value', 31);
        $button->setAttribute('class', 'link_month_small');
        $button->setAttribute('title', 'View Month');

        $tr->appendChild($right = $doc->createElement('td'));

        $display_plus_week = clone $display_start_day;
        $display_plus_week->modify('+1 '.$short_interval);
        $right->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_plus_week->format('Y-m-d'));
        $button->setAttribute('class', 'link_next_small');
        $button->setAttribute('title', 'Next '.$short_interval);


        $display_plus_month = clone $display_start_day;
        $display_plus_month->modify('+1 '.$long_interval);
        $right->appendChild($button = $doc->createElement('input'));
        $button->setAttribute('type', 'submit');
        $button->setAttribute('name', 'day_start');
        $button->setAttribute('value', $display_plus_month->format('Y-m-d'));
        $button->setAttribute('class', 'link_next2_small');
        $button->setAttribute('title', 'Next '.$long_interval);


		// Draw a legend/key for describing the colours used.
		$divHeader->appendChild($tblkey = $doc->createElement('table'));
        $tblkey->setAttribute('id', 'keytble');
        $tblkey->setAttribute('class', 'traffic_table');
        $tblkey->appendChild($tr = $doc->createElement('tr'));

		$styleshade = 10;

		$shadetype = '';
        $tr->appendChild($label = $doc->createElement('td'));
		$label->appendChild($div = $doc->createElement('div'));
		$div->appendChild($doc->createTextNode('LEGEND: '));

        //Audio Legend Popup Box
		// Print a legend of the audio pieces available for scheduling.

		// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
		$vectors = sysdb::rotatematrix($campaign_audio);
// print_r($campaign_audio);
		// Perform data transformation on any column (vector), row by row (key by key).
        $counters = array();
        $startDates = array();
        $endDates = array();
		if (!empty($vectors[0])) {
			foreach ($vectors[0] as $key=>$value) {
				$counters[$key] = $doc->createElement('input');
				$counters[$key]->setAttribute('id', 'tickcounter');
				$counters[$key]->setAttribute('name', 'tickcounter_count');
				$counters[$key]->setAttribute('value', $vectors[6][$key]);
				$counters[$key]->setAttribute('type', 'text');
				$counters[$key]->setAttribute('title', 'Total spots scheduled to campaign.');
				$counters[$key]->setAttribute('style', 'text-align:right; width: 18px;');
				$counters[$key]->setAttribute('readonly', '');

				if ($vectors[4][$key] != '')
					$startDates[$key] = date('d/m/y', strtotime($vectors[4][$key]));
				else
					$startDates[$key] = '';
				if ($vectors[5][$key] != '')
					$endDates[$key] = date('d/m/y', strtotime($vectors[5][$key]));
				else
					$endDates[$key] = '';
			}
		}

		// Replace the original matrix column(s) with the new the vector(s).
		$vectors[4] = $startDates;
		$vectors[5] = $endDates;

		$new_matrix[0] = $counters;
		$new_matrix[1] = $vectors[0];
		$new_matrix[2] = $vectors[1];
		$new_matrix[3] = $vectors[3];
		$new_matrix[4] = $startDates;
		$new_matrix[5] = $endDates;



		// Rotate the new matrix 270 degrees to put it back the right way.
		$matrix_rotated_180 = sysdb::rotatematrix($new_matrix);
		$matrix_rotated_270 = sysdb::rotatematrix($matrix_rotated_180);
		$matrix_upright = sysdb::rotatematrix($matrix_rotated_270);

		function schedule_inline_header($doc) {
			$tr = $doc->createElement('tr');

			$labels = array('#', 'Item', 'Dur', 'Start', 'End');
			/* // Part of an unfinished feature to show number spots per audio.
			$labels = array('', '#', 'Item', 'Dur', 'Start', 'End');
			*/
			foreach ($labels as $label) {
				$tr->appendChild($th = $doc->createElement('th'));
				$th->appendChild($text = $doc->createTextNode($label));
			}
			return $tr;
		}

		$header_func = 'schedule_inline_header';
		$ignore_fields = array('0');
		/* // Part of an unfinished feature to show number spots per audio.
		$ignore_fields = array();
		*/
		$popuptable = sysdb::dom_matrix2table
		(
			$doc,
			$matrix_upright,
			false,
			'',
			'',
			$ignore_fields,
			'',
			$header_func,
			array('table'=>'list', 'tr'=>'even', 'td'=>''),
			'',
			'',
			''
		);

		$varpop = 'legend';
        $tr->appendChild($legend = $doc->createElement('td'));
		$legend->setAttribute('class', 'traffic_key');
		$legend->appendChild($div = $doc->createElement('div'));
		//$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('class', 'traffic_audio');
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		$div->appendChild($doc->createTextNode('A'));

		// Start legend popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable);
        $popuptable->setAttribute('class', 'traffic_popkey');
		$div->appendChild($popupdiv);


        $tr->appendChild($label = $doc->createElement('td'));
//		$label->setAttribute('class', 'traffic_key');
		$label->appendChild($div = $doc->createElement('div'));
		$div->appendChild($doc->createTextNode('KEY: '));

		$varpop = 'normal';
        $tr->appendChild($normal = $doc->createElement('td'));
		$normal->setAttribute('class', 'traffic_key');
		$normal->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start normal popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('AVAILABLE TIME'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Everything is within specified date ranges.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker colours denoting heavier scheduling.'));
		$div->appendChild($popupdiv);
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view time remaining.'));
		$div->appendChild($popupdiv);
		// End normal popup box.

		$styleshade = 10;
		$varpop = 'warn';
		$shadetype = '_warn';
        $tr->appendChild($warning = $doc->createElement('td'));
		$warning->setAttribute('class', 'traffic_key');
		$warning->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start warning popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('UNKNOWN SPOT DESIGNATION'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a spot designation does not match those listed in the audio table.'));
		$div->appendChild($popupdiv);
		// End warning popup box.

		$styleshade = 6;
		$varpop = 'grey';
		$shadetype = '_grey';
        $tr->appendChild($grey = $doc->createElement('td'));
		$grey->setAttribute('class', 'traffic_key');
		$grey->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start grey popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('OUTSIDE CAMPAIGN DATE RANGE'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot is outside of the specified parent campaign date range.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker shades denoting heavier scheduling.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('The four warning notifications are:'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is before Contract start date. '));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is before Campaign start date.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is after Campaign end date. '));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$tdP->appendChild($doc->createTextNode('Time is after Contract end date.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view these notifications.'));
		$div->appendChild($popupdiv);
		// End grey popup box.

		$styleshade = 10;
		$varpop = 'blue';
		$shadetype = '_blue';
        $tr->appendChild($warning = $doc->createElement('td'));
		$warning->setAttribute('class', 'traffic_key');
		$warning->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start blue popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('CONTAINS SAME CAMPAIGN'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot already contains scheduled audio from the same campaign.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Cells will be weighted according to the remaining schedule time in that hour, with progressively darker colours denoting heavier scheduling.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode("Hover over time slot to view the other campaign audio's name."));
		$div->appendChild($popupdiv);
		// End blue popup box.

		$styleshade = 20;
		$varpop = 'error';
		$shadetype = '_error';
        $tr->appendChild($error = $doc->createElement('td'));
		$error->setAttribute('class', 'traffic_key');
		$error->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start error popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('INSUFFICIENT TIME REMAINING'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This warning denotes that a time slot has insufficient remaining time to accomodate this audio duration.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('Hover over time slot to view duration and time remaining.'));
		$div->appendChild($popupdiv);
		// End error popup box.

		$styleshade = 20;
		$varpop = 'full';
		$shadetype = '_full';
        $tr->appendChild($full = $doc->createElement('td'));
		$full->setAttribute('class', 'traffic_key');
		$full->appendChild($div = $doc->createElement('div'));
		$div->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$div->setAttribute('onmouseover', 'popupkey(this,"'.$varpop.'");');
		$div->setAttribute('onmouseout', 'popoutkey("'.$varpop.'");');
		// $div->setAttribute('onclick', 'popupkey(this,"'.$varpop.'");');
		$div->appendChild($doc->createTextNode(' '));

		// Start full popup box.
		$popupdiv = $doc->createElement('div');
		$popupdiv->setAttribute('class', 'popup_small');
		$popupdiv->setAttribute('id', 'popkey["'.$varpop.'"]');
		$popupdiv->setAttribute('visibility', 'hidden');
		$popupdiv->appendChild($popuptable = $doc->createElement('table'));
        $popuptable->setAttribute('class', 'traffic_popkey');
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		// TODO: Get popups closing using button (and change onmouseover to onclick). Close icon disabled until then.
/*		$tdP->appendChild($span = $doc->createElement('span'));
		$span->setAttribute('class', 'link_close_small');
		$span->setAttribute('style', 'float: right;');
		$span->setAttribute('onclick', 'popoutkey("'.$varpop.'");');
		$span->appendChild($doc->createTextNode(' '));
*/		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($thP = $doc->createElement('th'));
		$thP->appendChild($doc->createTextNode('TIME EXCEEDED'));
		$thP->setAttribute('class', "traffic_shade{$styleshade}$shadetype");
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('A time exceeded error denotes that the time slot is full, and has been overbooked.'));
		$popuptable->appendChild($trP = $doc->createElement('tr'));
		$trP->appendChild($tdP = $doc->createElement('td'));
		$tdP->appendChild($doc->createTextNode('This may cause a breach in broadcasting terms of service and should be addressed immediately.'));
		$div->appendChild($popupdiv);
		// End full popup box.

        $tblmain = $doc->createElement('table');
        $tblmain->setAttribute('id', 'xytble');
        $tblmain->setAttribute('class', 'traffic_table');

        $tblmain->appendChild($linehead = $doc->createElement('tr'));
        $linehead->setAttribute('id', 'traffic_head_row');
        $linehead->setAttribute('class', 'traffic_head_row');

        $blank = $doc->createElement('td');
        $blank->appendChild($fieldcounter = $doc->createElement('input'));
        $blank->setAttribute('style', 'text-align:center;');
        $fieldcounter->setAttribute('id', 'fieldcounter');
        $fieldcounter->setAttribute('name', 'tickcounter_count');
        $fieldcounter->setAttribute('value', $spot_count);
		$fieldcounter->setAttribute('type', 'text');
        $fieldcounter->setAttribute('title', 'Total spots scheduled to campaign.');
        $fieldcounter->setAttribute('style', 'text-align:right; width: 45px;');
        $fieldcounter->setAttribute('readonly', '');
        $blank->appendChild($totalcounter = $doc->createElement('input'));
        $blank->setAttribute('style', 'text-align:center;');
   		// if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php'))
            // $blank->setAttribute('colspan', '2');
        $totalcounter->setAttribute('id', 'totalcounter');
        $totalcounter->setAttribute('name', 'totalcounter_count');
        $totalcounter->setAttribute('value', $spot_remaining_count);
		$totalcounter->setAttribute('type', 'text');
        $totalcounter->setAttribute('title', 'Remaining spots allotted to campaign.');
        $totalcounter->setAttribute('style', 'text-align:right; width: 45px;');
        $totalcounter->setAttribute('readonly', '');
        $blank->appendChild($spotsAllottedvalue = dom::createInputBox($doc, 'totalspotsallotted', $spot_allotted_count, 'hidden'));

        $linehead->appendChild($blank);

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
        for ($j = 0; $j < $num_of_days; $j++) {
            $linehead->appendChild($boxhead[$j] = $doc->createElement('td'));
            $boxhead[$j]->setAttribute('id', "traffic_head_box[{$j}]");
			if ($num_of_days == 31) {
				if ($date_counter->format('N') == 6 || $date_counter->format('N') == 7) {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box_month_we');
				} else {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box_month');
				}
			} else {
				if ($date_counter->format('N') == 6 || $date_counter->format('N') == 7) {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box_we');
				} else {
					$boxhead[$j]->setAttribute('class', 'traffic_head_box');
				}
			}
            $boxhead[$j]->setAttribute('title', $date_counter->format('l jS \of F, Y'));
			if ($num_of_days == 31) {
				$boxhead[$j]->appendChild($doc->createTextNode(substr($date_counter->format('D'), 0, 1)));
				$boxhead[$j]->appendChild($doc->createElement('br'));
				$boxhead[$j]->appendChild($doc->createTextNode($date_counter->format('j')));
				$boxhead[$j]->appendChild($doc->createElement('br'));
				$boxhead[$j]->appendChild($doc->createTextNode(substr($date_counter->format('M'), 0, 1)));
			} else {
				$boxhead[$j]->appendChild($doc->createTextNode($date_counter->format('D')));
				$boxhead[$j]->appendChild($doc->createElement('br'));
				$boxhead[$j]->appendChild($doc->createTextNode($date_counter->format('d/m')));
			}
            $date_counter->modify('+1 day');
        }

        $date_counter->modify("+$display_start_time_hours hours $display_start_time_minutes minutes $display_start_time_seconds seconds");

$trial .= '<p>'.++$click.' --- '.(microtime(true)-$loadtime).'</p>';
$alphabeta = 'A';

		for ($i = 0, $max = count($alltimes)-1; $i < $max; $i++) {
$trial .= '<p>a'.$click.$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';
            $row_start = $alltimes[$i];
            $row_next = $alltimes[$i+1];

            $line[$i] = $doc->createElement('tr');
            $line[$i]->setAttribute('id', "traffic_row[{$i}]");
            $line[$i]->setAttribute('class', 'traffic_row');

       		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
                $cell_day = $date_counter->format('Y-m-d');

				// Find the periodID of the program grid corresponding to the date.
				$query = <<<EOQ
					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_grid G
					)
					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
					AND ((D.$remoteStore->field_period_endDate >= '$cell_day'
							OR D.$remoteStore->field_period_endDate IS NULL
						)
						AND (D.$remoteStore->field_period_startDate <= '$cell_day'
							OR D.$remoteStore->field_period_startDate IS NULL
						)
					)
EOQ;
				$periodID = sysdb::queryOne($query);
$trial .= '<p>b'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

				// // TODO: This only returns whole hours. A slotgroup from 2:00-5:30 for instance would not be displayed properly.
				// // TODO: This query is being run 24 times in the header, then 24 times in the footer. Should be single query.
    			// $query = <<<EOQ
    				// SELECT G.$remoteStore->field_programs_slotgroup_name as name,
						// (HOUR(IF(G.$remoteStore->field_programs_slotgroup_endTime = '00:00:00', '24:00:00', G.$remoteStore->field_programs_slotgroup_endTime)) - HOUR(G.$remoteStore->field_programs_slotgroup_startTime)) AS hours
    				// FROM ($remoteStore->table_period D,
    					// $remoteStore->table_programs_slotgroup G
    				// )
    				// WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
    				// AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    // AND G.$remoteStore->field_programs_slotgroup_startTime = '{$row_start}'
// EOQ;
                // $slotgroupResult = sysdb::query($query);
                // if (sysdb::num_rows($slotgroupResult) > 0) {
                    // $group = $doc->createElement('td');
                    // $slotgroup = sysdb::fetch_assoc($slotgroupResult);
                    // $group->setAttribute('id', "traffic_slot_group[$i]");
                    // $group->setAttribute('rowspan', $slotgroup['hours']);
                    // $group->setAttribute('style', 'border-bottom: 2px solid black;');
                    // $group->appendChild($doc->createTextNode($slotgroup['name']));
                    // $line[$i]->appendChild($group);
                // }
            }

            $date_counter = clone $display_start_day;

            if (strtotime($row_start) < strtotime($display_start_time)) {
                $date_counter->modify('+1 day');
            }

            $time = $doc->createElement('td');
            $time->setAttribute('id', "traffic_row_lead[$i]");
            $time->setAttribute('class', 'traffic_head_box');
            $time->appendChild($doc->createTextNode(date('G:i', strtotime($row_start))));

            // Put a line under it if it's at the end of a slotgroup.
    		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
				$query = <<<EOQ
					SELECT G.$remoteStore->field_programs_slotgroup_endTime AS endtime
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_slotgroup G
					)
					WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    AND G.$remoteStore->field_programs_slotgroup_endTime = '{$row_next}'
EOQ;
                if ($row_next == '00:00:00' || sysdb::num_rows(sysdb::query($query)) > 0)
                    $time->setAttribute('style', 'border-bottom: solid black 2px;');
            }

            $line[$i]->appendChild($time);
$trial .= '<p>c'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

            $query = <<<EOQ
                SELECT {$this->store->field_slot_slotID} AS slotID,
					{$this->store->field_slot_dow} AS dow
                FROM {$this->store->table_traffic_slot}
                WHERE {$this->store->field_slot_startDate} <= '$display_start_day_str'
                AND ({$this->store->field_slot_endDate} IS NULL
					OR {$this->store->field_slot_endDate} >= '$display_end_day_str'
				)
                AND {$this->store->field_slot_time} = '$row_start'
                ORDER BY dow
EOQ;
            $timeSlots = sysdb::query_assoc($query, 'time');
$trial .= '<p>d'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';


//            if ($row_start == '00:00:00' && $display_start_time != '00:00:00') {
//                $date_counter->modify('+1 day');
//            }


/*******************************************
			$query = <<<EOQ
				SELECT SUM(A.{$this->store->field_campaignaudio_duration}) AS total
				FROM ({$this->store->table_traffic_spot} S,
					{$this->store->table_traffic_campaignaudio} A
				)
				WHERE S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
				AND S.{$this->store->field_spot_dateTime} >= "$cell_day $row_start"
				AND S.{$this->store->field_spot_dateTime} < "$cell_next_day $row_next"
EOQ;
            $times_occupied = sysdb::query_assoc($query, 'total');

$trial .= '<p>'.$query.'</p>';
$trial .= '<p>'.print_r($times_occupied, true).'</p>';
$trial .= '<p>z'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

*******************************************/


$trial .= '<p>num_of_days: '.$num_of_days.'</p>';
            for ($j = 0; $j < $num_of_days; $j++) {
                $cell_day = $date_counter->format('Y-m-d');
                $cell_dow = $date_counter->format('l');
                if ($row_next < $row_start) {
                    $date_counter->modify('+1 day');
                }
                $cell_next_day = $date_counter->format('Y-m-d');

                // Check to see our overlap with other slots
           		$query = <<<EOQ
                    SELECT {$this->store->field_slot_time} AS time
                    FROM {$this->store->table_traffic_slot}
                    WHERE {$this->store->field_slot_startDate} <= '$cell_day'
                    AND ({$this->store->field_slot_endDate} IS NULL
						OR {$this->store->field_slot_endDate} >= '$cell_next_day'
					)
                    AND {$this->store->field_slot_dow} = '$cell_dow'
                    AND {$this->store->field_slot_time} >= '$row_start'
                    ORDER BY time
                    LIMIT 0, 2
EOQ;
                // This query tells us two things:
                //   1) Does a slot exist at this time?
                //   2) When is the next known slot in this column?
                $result = sysdb::query_assoc($query, false);
$trial .= '<p>e'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';
                if (sizeof($result) <= 0) {
                    if ($row_next < $row_start) {
                        $slot_exists = true;
                    } else {
                        $slot_exists = false;
                    }
                    //There are no slots in this column
                } else if (sizeof($result) == 1) {
                    if ($result[0]['time'] == $row_start) {
                        //There is no next slot
                        $slot_exists = true;
                        $next_known_slot_in_column = null;
                    } else {
                        //There is no slot for this time
                        $slot_exists = false;
                        $next_known_slot_in_column = $result[0]['time'];
                    }
                } else if (sizeof($result) == 2) {
                    if ($result[0]['time'] == $row_start) {
                        $slot_exists = true;
                        $next_known_slot_in_column = $result[1]['time'];
                    } else {
                        $slot_exists = false;
                        $next_known_slot_in_column = $result[0]['time'];
                    }
                } else {
                    // print_r($result);
                    die('This should never happen. Did someone remove the limit on the query?');
                }
				unset($result);

                if ($slot_exists) {
                    $rowspan = 1;
                    while ($alltimes[$i+($rowspan)] < $next_known_slot_in_column) $rowspan++;

                    //if ($alltimes[$i+$rowspan] != $next_known_slot_in_column) echo 'Error! Rowspan calculation failed!';

					// Ascertain if there is a spot conflict.
					if (array_key_exists($cell_day.' '.$row_start, $conflicting_spots)) {
						$conflicted = true;
					} else {
						$conflicted = false;
					}

					// The warning denotes if the wrong input designation was used, and it should be highlighted.
					$warning_input = false;

					// Get values for the audio
					if (array_key_exists($cell_day.' '.$row_start, $selected_spots)) {
						$search_letter = $selected_spots[$cell_day.' '.$row_start];
						$audio_key = array_search($search_letter, $all_designation);
						if ($audio_key != false) {
							$scheduled = true;
							$name = $campaign_audio[$audio_key]['name'];
							$mediaID = $campaign_audio[$audio_key]['mediaID'];
							$duration = $campaign_audio[$audio_key]['duration'];
							$campaignAudioStart = $campaign_audio[$audio_key]['startDate'].' 00:00:00';
							$campaignAudioEnd = $campaign_audio[$audio_key]['endDate'].' 23:59:59';
						} else {
							$scheduled = false;
							// If the value isn't blank, it's a foreign character. Generate a warning.
							if ($audio_key != "")
								$warning_input = true;
						}
					} else {
						$scheduled = false;
						$name = '';
						$mediaID = '';
						$duration = 0;
						$campaignAudioStart = '';
						$campaignAudioEnd = '';
					}

            		$query = <<<EOQ
                        SELECT SUM(A.{$this->store->field_campaignaudio_duration}) AS total
                        FROM ({$this->store->table_traffic_spot} S,
							{$this->store->table_traffic_campaignaudio} A
						)
                        WHERE S.{$this->store->field_spot_mediaID} = A.{$this->store->field_campaignaudio_mediaID}
                        AND S.{$this->store->field_spot_dateTime} >= '$cell_day $row_start'
                        AND S.{$this->store->field_spot_dateTime} < '$cell_next_day $row_next'
EOQ;
            		$timeoccupied = sysdb::queryOne($query);
                    //if ($timeoccupied > 0) echo $query;

$trial .= '<p>'.$query.'</p>';
$trial .= '<p>f'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

                    $box[$i][$j] = $doc->createElement('td');
                    $box[$i][$j]->setAttribute('id', "traffic_input[{$i}][{$j}]");
                    $box[$i][$j]->setAttribute('class', 'traffic_box');
                    if ($rowspan != 1)
						$box[$i][$j]->setAttribute('rowspan', $rowspan);

                    //Put a line under it if it's at the end of a slotgroup
            		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
                        $date_in_question = $cell_day;

        				// Find the periodID of the program grid corresponding to the date.
        				$query = <<<EOQ
        					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
        					FROM ($remoteStore->table_period D,
        						$remoteStore->table_programs_grid G
        					)
        					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
        					AND ((D.$remoteStore->field_period_endDate >= '$date_in_question'
									OR D.$remoteStore->field_period_endDate IS NULL
								)
        						AND (D.$remoteStore->field_period_startDate <= '$date_in_question'
									OR D.$remoteStore->field_period_startDate IS NULL
								)
        					)
EOQ;
        				$periodID = sysdb::queryOne($query);
$trial .= '<p>g'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

        				$query = <<<EOQ
        					SELECT G.$remoteStore->field_programs_slotgroup_endTime AS endtime
        					FROM ($remoteStore->table_period D,
        						$remoteStore->table_programs_slotgroup G
        					)
        					WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
        					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                            AND G.$remoteStore->field_programs_slotgroup_endTime = '{$next_known_slot_in_column}'
EOQ;
                        if ($next_known_slot_in_column == null || sysdb::num_rows(sysdb::query($query)) > 0)
                            $box[$i][$j]->setAttribute('style', 'border-bottom: solid black 2px;');
$trial .= '<p>h'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';
                    }

                    $styleshades = 20;
                    $timeremaining = $maxtime-$timeoccupied;
                    $timeprojected = $maxtime-$timeoccupied-$duration;

            		$query = <<<EOQ
                        SELECT O.{$this->store->field_contract_startDate} AS contractStartDate,
							O.{$this->store->field_contract_endDate} AS contractEndDate,
							M.{$this->store->field_campaign_startDate} AS campaignStartDate,
							M.{$this->store->field_campaign_endDate} AS campaignEndDate
                        FROM ({$this->store->table_traffic_contract} O,
							{$this->store->table_traffic_campaign} M
						)
                        WHERE M.{$this->store->field_campaign_campaignID} = '$campaignID'
                        AND M.{$this->store->field_campaign_contractID} = O.{$this->store->field_contract_contractID}
EOQ;
							// ,
							// A.{$this->store->field_campaignaudio_startDate} AS campaignAudioStartDate,
							// A.{$this->store->field_campaignaudio_endDate} AS campaignAudioEndDate
					$result = sysdb::query($query);
$trial .= '<p>i'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';
					if (sizeof($result) <= 0) {
						$contractStart = '';
						$contractEnd = '';
						$campaignStart = '';
						$campaignEnd = '';
						// $campaignAudioStart = '';
						// $campaignAudioEnd = '';
					} else {
						$row = sysdb::fetch_assoc($result);
						$contractStart = $row['contractStartDate'].' 00:00:00';
						$contractEnd = $row['contractEndDate'].' 23:59:59';
						$campaignStart = $row['campaignStartDate'].' 00:00:00';
						$campaignEnd = $row['campaignEndDate'].' 23:59:59';
						// $campaignAudioStart = $row['campaignAudioStartDate'].' 00:00:00';
						// $campaignAudioEnd = $row['campaignAudioEndDate'].' 23:59:59';
					}
					unset($result);

                    $div = $doc->createElement('div');
					$div->setAttribute('id', 'traffic_inputbox['.$i.']['.$j.']');
					$title_text = '';
					// TODO: All of the reschedule action changes in this section should be routed through $highlightoverlay and $selected_spots
                    if (strtotime($cell_day.' '.$row_start) <= strtotime('now')) {
						// If in the past.
						$title_text .= 'Time is in the past.';
                    } else if (isset($highlightoverlay) && is_array($highlightoverlay) && (array_search($cell_day.' '.$row_start, $highlightoverlay) != false)) {
                        // If the cell requires highlighting.
						$div->setAttribute('class', 'traffic_highlight');
                    } else if ($timeremaining <= 0) {
						// If overbooked.
                        if (20-ceil(( ($timeremaining / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeremaining / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_full");
						$title_text .= 'Time is over allocated by '.(-$timeremaining).' seconds';
                    } else if ($conflicted) {
						// If two or more audio from the same campaign are scheduled in the hour.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_blue");
						$title_text .= 'Time contains two or more spots from the same campaign. Use the Campaign Audio schedule or Traffic pages to resolve conflict. '.$timeremaining.' secs remaining.';
                    } else if ($warning_input) {
						// If the wrong designation was used.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_warn");
						$title_text .= 'The designation does not correspond with any campaign audio. '.$timeremaining.' secs remaining.';
                    } else if ($contractStart != ''
							&& $campaignStart != ''
							&& (strtotime($cell_day.' '.$row_start) < strtotime($contractStart))
							&& (strtotime($contractStart) <= strtotime($campaignStart))
							) {
						// If earlier than contract start.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is before Contract start date. '.$timeremaining.' secs remaining.';
                    } else if ($contractStart != ''
							&& $campaignStart != ''
							&& (strtotime($cell_day.' '.$row_start) >= strtotime($contractStart))
							&& (strtotime($cell_day.' '.$row_start) < strtotime($campaignStart))
							) {
						// If between contract start and campaign start.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is before Campaign start date. '.$timeremaining.' secs remaining.';
                    } else if ($contractEnd != ''
							&& $campaignEnd != ''
							&& (strtotime($cell_day.' '.$row_start) <= strtotime($contractEnd))
							&& (strtotime($cell_day.' '.$row_start) > strtotime($campaignEnd))
							) {
						// If between campaign end and contract end.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is after Campaign end date. '.$timeremaining.' secs remaining.';
                    } else if ($contractEnd != ''
							&& $campaignEnd != ''
							&& (strtotime($cell_day.' '.$row_start) > strtotime($contractEnd))
							&& (strtotime($contractEnd) >= strtotime($campaignEnd))
							) {
						// If after contract end.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}_grey");
						$title_text .= 'Time is after Contract end date. '.$timeremaining.' secs remaining.';
                    } else {
						// Time is available and within all parameters.
                        if (20-ceil(( ($timeprojected / $maxtime)*100)/5) > 20) $styleshade = 20; else $styleshade = 20-ceil(( ($timeprojected / $maxtime)*100)/5);
                        $div->setAttribute('class', "traffic_shade{$styleshade}");
						$title_text .= $timeremaining.' secs remaining.';
                    }
					// Check for program component dependency.
					if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
						// This is a temporary implementation of the ability to see the equivalent
						//  program related to this time slot.
						$search = $row_start;
						$found = array();
						// Try find a matching start time.
						foreach ($program_array[$cell_day] as $key => $value) {
							if (trim($value['startTime']) == $search) {
								// If it matches, change today's program in the array.
								$programName[$cell_day] = $value['name'];
								break;
							}
						}
						// Print the current program in the tool tip.
						if (isset($programName[$cell_day])) {
							$title_text .= ' [Program: '.$programName[$cell_day].']';
						} else {
							$title_text .= ' [No Program]';
						}
					}
					$div->setAttribute('title', $title_text);
$trial .= '<p>j'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

                    if (strtotime($cell_day.' '.$row_start) > strtotime('now')) {
                        $input = $doc->createElement('input');
						$input->setAttribute('type', 'input');
						$input->setAttribute('style', 'width: '.(18+8*($max_length-1)).'px;');
						$input->setAttribute('maxlength', $max_length);
						$input->setAttribute('onkeypress', 'tablekeynav(event,'.$j.','.$i.');');
						$input->setAttribute('onfocus', 'inputfield_in(this,'.$i.','.$j.');');
						$input->setAttribute('onblur', 'inputfield_out(this,'.$i.','.$j.');');
//						$input->setAttribute('onclick', 'focusInput(this,'.$i.','.$j.');');
						//$input->setAttribute('onkeypress', 'mask_input(this,'.$i.','.$j.');');
                        $input->setAttribute('id', 'traffic_input['.$cell_day.' '.$row_start.']');
                        $input->setAttribute('name', 'traffic_input['.$cell_day.' '.$row_start.']');
						if (array_key_exists($cell_day.' '.$row_start, $selected_spots)
                            || array_key_exists($cell_day.' '.$row_start, $selected_promo_spots)) {
                            $cellvalue = '';
                            if (array_key_exists($cell_day.' '.$row_start, $selected_spots))
                                $cellvalue .= $selected_spots[$cell_day.' '.$row_start];
                            if (array_key_exists($cell_day.' '.$row_start, $selected_promo_spots)) {
								/* Our method of passing promos as "1" from one page to the next,
								   while simultaneously loading up new promos from storage requires
								   a bit of trickery to ascertain whether a spot has previously been
								   accounted for. */
/********************************************************************/
							    // Firstly, determine whether we have just loaded a new Schedule UI.
								if ($newlyLoadedPage) {
									// Add promos to schedule.
									$cellvalue .= $selected_promo_spots[$cell_day.' '.$row_start];
								} else {
									// Secondly, determine whether a "1" has already been passed from the previous page.
									$designationArray = str_split($selected_spots[$cell_day.' '.$row_start]);

// echo $cell_day.' '.$row_start;
// echo "designationArray: ".print_r($designationArray,true);
									if (in_array("1", $designationArray)) {
										// If a spot already has a "1", we don't want to add a secondary "1".
										// echo "WE NEED TO SKIP THIS";
									} else {
										$cellvalue .= $selected_promo_spots[$cell_day.' '.$row_start];
									}
								}
								// Remove this value from the array, so that we can append any hidden promos afterwards.
								unset($selected_promo_spots[$cell_day.' '.$row_start]);
							}
							$input->setAttribute('value', $cellvalue);
						} elseif ($conflicted) {
							$input->setAttribute('value', $conflicting_spots[$cell_day.' '.$row_start]);
							$input->setAttribute('disabled', true);
						} else {
							$input->setAttribute('value', false);
						}
                        $div->appendChild($input);
                    } else {
                        $div->appendChild($doc->createTextNode(''));
                    }
                    $box[$i][$j]->appendChild($div);

                    $line[$i]->appendChild($box[$i][$j]);
                }


                if ($row_next > $row_start) {
                    $date_counter->modify('+1 day');
                }
            }
            $time = $doc->createElement('td');
            $time->setAttribute('id', "traffic_row_lead[$i]");
            $time->setAttribute('class', 'traffic_head_box');
            $time->appendChild($doc->createTextNode(date('G:i', strtotime($row_start))));

            //Put a line under it if it's at the end of a slotgroup
    		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
                $date_in_question = $cell_day;

				// Find the periodID of the program grid corresponding to the date.
				$query = <<<EOQ
					SELECT DISTINCT G.$remoteStore->field_programs_grid_periodID AS periodID
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_grid G
					)
					WHERE D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_grid_periodID
					AND ((D.$remoteStore->field_period_endDate >= '$date_in_question'
							OR D.$remoteStore->field_period_endDate IS NULL
						)
						AND (D.$remoteStore->field_period_startDate <= '$date_in_question'
							OR D.$remoteStore->field_period_startDate IS NULL
						)
					)
EOQ;
				$periodID = sysdb::queryOne($query);
$trial .= '<pl'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';

				$query = <<<EOQ
					SELECT G.$remoteStore->field_programs_slotgroup_endTime AS endtime
					FROM ($remoteStore->table_period D,
						$remoteStore->table_programs_slotgroup G
					)
					WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
					AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    AND G.$remoteStore->field_programs_slotgroup_endTime = '{$next_known_slot_in_column}'
EOQ;
                if ($next_known_slot_in_column == null || sysdb::num_rows(sysdb::query($query)) > 0)
                    $time->setAttribute('style', 'border-bottom: solid black 2px;');
$trial .= '<p>m'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';
            }


            $line[$i]->appendChild($time);

       		if (file_exists(ROOT_COMPONENTS.'programs/moduleconfig.php')) {
				// TODO: This only returns whole hours. A slotgroup from 2:00-5:30 for instance would not be displayed properly.
				// TODO: This query is being run 24 times in the header, then 24 times in the footer. Should be single query.
    			$query = <<<EOQ
    				SELECT G.$remoteStore->field_programs_slotgroup_name as name,
						(HOUR(IF(G.$remoteStore->field_programs_slotgroup_endTime = '00:00:00', '24:00:00', G.$remoteStore->field_programs_slotgroup_endTime)) - HOUR(G.$remoteStore->field_programs_slotgroup_startTime)) AS hours
    				FROM ($remoteStore->table_period D,
    					$remoteStore->table_programs_slotgroup G
    				)
    				WHERE D.$remoteStore->field_programs_slotgroup_periodID = '$periodID'
    				AND D.$remoteStore->field_period_periodID = G.$remoteStore->field_programs_slotgroup_periodID
                    AND G.$remoteStore->field_programs_slotgroup_startTime = '{$row_start}'
EOQ;
                $slotgroupResult = sysdb::query($query);
$trial .= '<p>n'.$click.++$alphabeta.' --- '.(microtime(true)-$loadtime).'</p>';
                if (sysdb::num_rows($slotgroupResult) > 0) {
                    $group = $doc->createElement('td');
                    $slotgroup = sysdb::fetch_assoc($slotgroupResult);
                    $group->setAttribute('id', "traffic_slot_group[$i]");
                    $group->setAttribute('class', 'traffic_slot_group');
                    $group->setAttribute('rowspan', $slotgroup['hours']);
                    $group->setAttribute('style', 'border-bottom: 2px solid black;');
                    $group->appendChild($doc->createTextNode($slotgroup['name']));
                    $line[$i]->appendChild($group);
                }
            }

            $tblmain->appendChild($line[$i]);
        }

		// Append promos that weren't displayed on the page as hidden inputs.
		if (is_array($selected_promo_spots)) {
			foreach ($selected_promo_spots as $spot => $promoLetter) {
				// Make sure we don't overwrite an existing hidden input.
				if(!array_key_exists($spot, $selected_spots)) {
					$spottime = new DateTime($spot);
					if ($spottime->format('U') < $display_start_day->format('U')
						|| $spottime->format('U') > $display_end_day->format('U')
						|| $spottime->format('U') <= strtotime('now')) {
						$grid->appendChild($input = $doc->createElement('input'));
						$input->setAttribute('type', 'hidden');
						$input->setAttribute('name', 'traffic_input['.$spottime->format('Y-m-d H:i:s').']');
						$input->setAttribute('value', '1');
					}
				}
			}
		}

        //TAIL

		$linetail = clone $linehead;
		$counter = $linetail->getElementsByTagName('td')->item(0);
		while($counter->hasChildNodes()) {
		  $counter->removeChild($counter->childNodes->item(0));
		}

        $tblmain->appendChild($linetail);

        $grid->appendChild($tblmain);

        $grid->appendChild($input = dom::createInputBox($doc, 'act', 'Schedule', 'submit'));

        $container->appendChild($grid);

$elapsed_time = microtime(true) - $loadtime;
$trial .= '<p><b>Total time elapsed: '.$elapsed_time.' seconds</b></p>';
// state::setMessage('error', $trial);

        return ($container);

    }

   /**
	* Rotates an array with keys until the search value is the first value in the array.
	*
	* If the search value does not exist, it just returns the same array.
	*/
    public function rotateWithKeys($array, $search_value) {
        $search_key = array_search($search_value, $array);
        if ($search_key == FALSE) return($array);
        //We can't use array_slice because we don't know where the key is in the array if non-numeric keys
        $newarray = array();
        $key_found = false;
        foreach($array as $key=>$value) {
            if ($key == $search_key) $key_found = true;
            if ($key_found) {
                $newarray[$key] = $value;
            }
        }

        foreach($array as $key=>$value) {
            if ($key == $search_key) break;
            $newarray[$key] = $value;
        }

        return($newarray);
    }

   /**
	* Rotates an array until the search value is the first value in the array.
	*
	* If the search value does not exist, it just returns the same array.
	*/
    public function rotate($array, $search_value) {
        $search_key = array_search($search_value, $array);
        if ($search_key == FALSE) {
            // echo 'Search key not found.';
            return($array);
        }
        // We can't use array_slice because we don't know where the key is in the array if non-numeric keys.
        $newarray = array();
        $key_found = false;
        foreach($array as $key=>$value) {
            if ($key == $search_key) $key_found = true;
            if ($key_found) {
                $newarray[] = $value;
            }
        }

        foreach($array as $key=>$value) {
            if ($key == $search_key) break;
            $newarray[] = $value;
        }

        return($newarray);
    }

    public function add() {
    }

    public function save() {
    }

    public function delete() {
    }

    public function search($doc, $string) {
    }

    public function headers($doc) {
       $moduleID = globalize('moduleID');
       $script1 = $doc->createElement('script');
       $script1->setAttribute('language', 'javascript');
       $script1->setAttribute('src', WWWROOT.'stylesheet.php?moduleID='.$moduleID.'&file=Schedule.js');
       $script1->appendChild($doc->createTextNode(''));

       $script2 = $doc->createElement('script');
       $script2->setAttribute('language', 'javascript');
       $script2->setAttribute('src', WWWROOT.'stylesheet.php?moduleID='.$moduleID.'&file=table_edgehighlight.js');
       $script2->appendChild($doc->createTextNode(''));

       $script3 = $doc->createElement('script');
       $script3->setAttribute('language', 'javascript');
       $script3->setAttribute('src', WWWROOT.'stylesheet.php?moduleID='.$moduleID.'&file=table_countticks.js');
       $script3->appendChild($doc->createTextNode(''));

       return(array($script1, $script2, $script3));
//       return(array($script2));
    }

   /**
	* Deletes a spot, and changes the priority of all other spots in a time slot accordingly.
	*
	* @param $spotID
	*   The spot ID that is being deleted.
	*/
    public function removeSpot($spotID) {
		$changes_made = false;

		// Preliminary check of variables.
		if ($spotID != '') {

			// Resolve slot date time of spot.
			$query = <<<EOQ
				SELECT DISTINCT ({$this->store->field_spot_dateTime}) AS dateTime
				FROM {$this->store->table_traffic_spot}
				WHERE {$this->store->field_spot_spotID} = '$spotID'
EOQ;
			$result = sysdb::query($query);
			if (sysdb::num_rows($result) > 0) {
				$line = sysdb::fetch_assoc($result);
				$dateTime = $line['dateTime'];

				// Grab all spots for the slot.
				$query = <<<EOQ
					SELECT {$this->store->field_spot_spotID} AS spotID,
						{$this->store->field_spot_priority} AS priority
					FROM {$this->store->table_traffic_spot}
					WHERE {$this->store->field_spot_dateTime} = '$dateTime'
					ORDER BY priority
EOQ;
				// Turn result query into a matrix.
				$matrix = sysdb::query2matrix($query,false);

				// Rotate the matrix 90 degrees so that each column is a vector within the matrix.
				$vectors = sysdb::rotatematrix($matrix);

				// Perform data transformation on any column (vector), row by row (key by key).
				if (!empty($vectors[0])) {
					if (in_array($spotID, $vectors[0])) {
						$search = array_search($spotID, $vectors[0]);
						$old_priority = $vectors[1][$search];
						$priorityList = array();

						// Process every spot in the slot.
						foreach ($vectors[0] as $key=>$value) {
							// Change their priorities if they are affected by the required change.
							if ($vectors[1][$key] >= $old_priority) {
								if ($value == $spotID) {
									// Delete the desired spot.
									$query = <<<EOQ
										DELETE FROM {$this->store->table_traffic_spot}
										WHERE {$this->store->field_spot_spotID} = '$spotID'
EOQ;
									sysdb::query($query);
								} else {
									// Increment priority of other affected spots.
									$provisional_priority = $vectors[1][$key] - 1;
									if ($provisional_priority <= 1) {
										// Cannot be a higher priority than one.
										$priorityList[$value] = 1;
									} else {
										// Set the new priority for the spot.
										$priorityList[$value] = $provisional_priority;
									}
								}
							}
							// The priority of the spot hasn't changed.
						}
						$changes_made = true;
					}
					// The requested spot is not scheduled in this slot.
				}
				// No spots in this slot.
			}
			// Spot has no scheduled time or spot doesn't exist. Something is wrong.
			unset($result);
		}
		if ($changes_made) {
			if (!empty($priorityList)) {
				// Update the priorities in storage.
				$spotList = implode(',', array_keys($priorityList));
				$query = <<<EOQ
					UPDATE {$this->store->table_traffic_spot}
					SET {$this->store->field_spot_priority} = CASE {$this->store->field_spot_spotID}
EOQ;
				foreach ($priorityList as $spotID => $priority) {
					$query .= sprintf(" WHEN '%d' THEN '%d'", $spotID, $priority);
				}
				$query .= " END WHERE {$this->store->field_spot_spotID} IN ($spotList)";
				sysdb::query($query);
			}
			return true;
		} else {
			return false;
		}
    }

    public function reschedule($doc, $id) {
        return($this->displayGridTickboxes($doc, $id));
    }

    private static function resolve_conflicting_spots($vectors,
		&$existing_spots,
		&$existing_conflict
	) {
		$conflicts = false;
// echo "<b>vectors</b><br/>".print_r($vectors, true)."<br/>";
		foreach ($vectors[0] as $key => $value) {
			if(!array_key_exists($value, $existing_spots)) {
// echo "existing_spots[".$value."] = ".$vectors[1][$key]."<br/>";
				$existing_spots[$value] = $vectors[1][$key];
			} else {
				// Conflicting spots found. Remember what they are.
				$existing_conflict[$value] = '';
// echo "Conflict! ".$value."<br/>";
				$conflicts = true;
			}
		}
		// Remove the conflicting spot times from the existing spots array so they don't get removed.
		if (!empty($existing_conflict)) {
			foreach ($existing_conflict as $key => $value) {
// echo "Unset existing_spots: ".$key."<br/>";
				unset($existing_spots[$key]);
			}
		}
		return $conflicts;
	}

}
?>
