<?php
// $Id$

class Slot {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('slotStartYear'),
							globalize('slotStartMonth'),
							globalize('slotStartDay'),
							globalize('slotEndYear'),
							globalize('slotEndMonth'),
							globalize('slotEndDay'),
							globalize('slotDOW'),
							globalize('slotTime'));
				break;
            case 'save':
				$this->save(globalize('slotID'),
							globalize('slotStartYear'),
							globalize('slotStartMonth'),
							globalize('slotStartDay'),
							globalize('slotEndYear'),
							globalize('slotEndMonth'),
							globalize('slotEndDay'),
							globalize('slotDOW'),
							globalize('slotTime'));
				break;
        }
    }

    public function form($doc,$id='') {
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '') {
            $headerText = 'Add Slot(s)';
			$isMultipleSelect = true;
			$slotDOWName = 'slotDOW[]';
			$slotTimeName = 'slotTime[]';
		} else {
            $headerText = 'Edit Slot';
			$isMultipleSelect = false;
			$slotDOWName = 'slotDOW';
			$slotTimeName = 'slotTime';
		}

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        $slotID = $doc->createElement('input');
        $slotID->setAttribute('type','hidden');
        $slotID->setAttribute('name','slotID');
        $slotID->setAttribute('value',$id);
        $container->appendChild($slotID);


        if ($id != '') {
            $query = "SELECT * FROM {$this->store->table_traffic_slot} WHERE slotID = '$id'";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $slotID = $line['slotID'];
            $startDateArray = explode('-',$line['startDate']);
			$endDateArray = explode('-',$line['endDate']);
            $dow = $line['dow'];
            $time = $line['time'];
        } else {
			$slotID = '';
			$startDateArray = array(date('Y'),date('n'),date('j'));
			$endDateArray = array(date('Y'),date('n'),date('j'));
			$dow = '';
            $time = '';
		}

		$startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'slotStart',date('Y') - 3,date('Y') + 2,'',$startDateArray[0],$startDateArray[1],$startDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

		$endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        WriteDateSelect_dom($doc,$inputtd,'slotEnd',date('Y') - 3,date('Y') + 2,'',$endDateArray[0],$endDateArray[1],$endDateArray[2],'d-m-Y');
        $labeltd->appendChild($label);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

        $dowtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Day of Week');
        $inputtd = $doc->createElement('td');
        $data = array( 'Monday'=>'Monday',
						'Tuesday'=>'Tuesday',
						'Wednesday'=>'Wednesday',
						'Thursday'=>'Thursday',
						'Friday'=>'Friday',
						'Saturday'=>'Saturday',
						'Sunday'=>'Sunday');
        $input = dom::createDropdown( $doc, $slotDOWName, $data, $dow, $isMultipleSelect, 7 );
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $dowtr->appendChild($labeltd);
        $dowtr->appendChild($inputtd);

        $timetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Time');
        $inputtd = $doc->createElement('td');
        $input = WriteTimeSelect_dom($doc,false,$slotTimeName,$time,'05:00:00','05:00:00','00:05:00',$isMultipleSelect,10);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $timetr->appendChild($labeltd);
        $timetr->appendChild($inputtd);

        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
        $table->appendChild($dowtr);
        $table->appendChild($timetr);

        $savetr = $doc->createElement('tr');
        $savetd = $doc->createElement('td');
        $save = $doc->createElement('input');
        $save->setAttribute('type','submit');
        $save->setAttribute('name','action');
        if ($id == '')
            $save->setAttribute('value','add');
        else
            $save->setAttribute('value','save');
        $savetd->appendChild($save);
        $savetr->appendChild($savetd);
        $table->appendChild($savetr);
		$container->appendChild($table);

        return($container);
    }

    public function view($doc,$id) {
        $grouptable = $doc->createElement('table');
        $grouptabletr = $doc->createElement('tr');
        $grouptabletd = $doc->createElement('td');

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');
        $headtr = $doc->createElement('tr');
        $table->appendChild($headtr);
        $headtd = $doc->createElement('th');
        $headtd->setAttribute('colspan','3');
        $headtr->appendChild($headtd);
        $heading = $doc->createTextNode('View Slot');
        $headtd->appendChild($heading);
        $actiontd = $doc->createElement('td');
        $actiontd->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id)));
        $headtr->appendChild($actiontd);

        $slotID = $doc->createElement('input');
        $slotID->setAttribute('type','hidden');
        $slotID->setAttribute('name','slotID');
        $slotID->setAttribute('value',$id);
        $headtd->appendChild($slotID);

        $table->appendChild($headtr);

        $query = "SELECT * FROM {$this->store->table_traffic_slot} WHERE slotID = '$id'";
        $result = sysdb::query($query);
        $line = sysdb::fetch_assoc($result);

        $slotID = $line['slotID'];
        $startDate = $line['startDate'];
        $endDate = $line['endDate'];
        $dow = $line['dow'];
        $time = $line['time'];

        $startDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Start Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($startDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $startDatetr->appendChild($labeltd);
        $startDatetr->appendChild($inputtd);

        $endDatetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('End Date');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($endDate);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $endDatetr->appendChild($labeltd);
        $endDatetr->appendChild($inputtd);

        $dowtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Day of Week');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($dow);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $dowtr->appendChild($labeltd);
        $dowtr->appendChild($inputtd);

        $timetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Time');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($time);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $timetr->appendChild($labeltd);
        $timetr->appendChild($inputtd);

        $table->appendChild($startDatetr);
        $table->appendChild($endDatetr);
        $table->appendChild($dowtr);
        $table->appendChild($timetr);

        $grouptabletd->appendChild($table);
        $grouptabletr->appendChild($grouptabletd);
        $grouptable->appendChild($grouptabletr);

        $grouptabletr = $doc->createElement('tr');
        $grouptabletd = $doc->createElement('td');

        return($grouptable);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $item = globalize('item',get_class($this));
        $query = "SELECT slotID, startDate, endDate, dow, time FROM {$this->store->table_traffic_slot}";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " WHERE slotID IN (".implode(',',$ids).") ";
        }
        if ($sortby == '') $query .= " ORDER BY endDate, startDate, dow, time ";
        else $query .= ' ORDER BY '.$sortby;

        $result = sysdb::query($query);

		$table = $doc->createElement('table');
        $table->setAttribute('class','list');

        $tr = $doc->createElement('tr');
        $startDatetd = $doc->createElement('th');
        $endDatetd = $doc->createElement('th');
        $dowtd = $doc->createElement('th');
        $timetd = $doc->createElement('th');

        $startDatetd->appendChild($doc->createTextNode('Start'));
        $endDatetd->appendChild($doc->createTextNode('End'));
        $dowtd->appendChild($doc->createTextNode('Day of Week'));
        $timetd->appendChild($doc->createTextNode('Time'));
        $actiontd = $doc->createElement('td');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add_small');
		$span->appendChild(module::link_to_script_dom($doc,'Add','',array('item'=>$item,'action'=>'edit'),'Add'));
		$actiontd->appendChild($span);

//			$actiontd->appendChild(module::link_to_script_dom($doc,'add','',array('item'=>$item,'action'=>'edit'),'Add'));

        $tr->appendChild($startDatetd);
        $tr->appendChild($endDatetd);
        $tr->appendChild($dowtd);
        $tr->appendChild($timetd);
        $tr->appendChild($actiontd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','2');
            $dow = $doc->createTextNode('No slots entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($dow);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$startDate = date("d-M-Y", strtotime($line['startDate']));
			if ($line['endDate'] != '')
				$endDate = date("d-M-Y", strtotime($line['endDate']));
			else
				$endDate = '';

			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $startDatetd = $doc->createElement('td');
            $endDatetd = $doc->createElement('td');
            $dowtd = $doc->createElement('td');
            $timetd = $doc->createElement('td');

            $startDatetd->appendChild($doc->createTextNode($startDate));
            $endDatetd->appendChild($doc->createTextNode($endDate));
            $dowtd->appendChild($doc->createTextNode($line['dow']));
            $timetd->appendChild($doc->createTextNode($line['time']));
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$line['slotID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$line['slotID']),'Edit'));
            $actiontd->appendChild($span);

            // $actiontd->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$line['slotID']),'View'));
            // $actiontd->appendChild($doc->createTextNode(' '));
            // $actiontd->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$line['slotID']),'Edit'));

            $table->appendChild($tr);
            $tr->appendChild($startDatetd);
            $tr->appendChild($endDatetd);
            $tr->appendChild($dowtd);
            $tr->appendChild($timetd);
            $tr->appendChild($actiontd);
			$i++;
        }
        $tr = $doc->createElement('tr');
        $actiontd = $doc->createElement('td');
        $actiontd->setAttribute('colspan','5');
        $actiontd->setAttribute('style','text-align: right;');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add_small');
		$span->appendChild(module::link_to_script_dom($doc,'Add','',array('item'=>$item,'action'=>'edit'),'Add'));
		$actiontd->appendChild($span);

        $table->appendChild($tr);
        $tr->appendChild($actiontd);

        return($table);
    }

    public function overview($doc,$ids='',$sortby='') {
        $item = globalize('item',get_class($this));
        $query = "SELECT slotID, startDate, endDate, dow, time FROM {$this->store->table_traffic_slot}";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " WHERE slotID IN (".implode(',',$ids).") ";
        }
        $query .= " ORDER BY endDate, startDate, dow, time ";

        $result = sysdb::query($query);

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

 		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Slots'));
		$container->appendChild($header);

		$container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $default = -1) {
        $query = "SELECT S.slotID, S.startDate, S.endDate, S.dow, S.time FROM {$this->store->table_traffic_slot} S ORDER BY endDate, startDate, dow, time";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','slotID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No slots available');
            $option->appendChild($text);
        }
        while ($line = sysdb::fetch_assoc($result)) {
            $option = $doc->createElement('option');
            $option->setAttribute('value',$line['slotID']);
            $text = $doc->createTextNode($line['startDate'].' '.$line['endDate'].' '.$line['dow'].' '.$line['time']);
            $option->appendChild($text);
            $select->appendChild($option);
        }

        return($select);
    }

    public function add($startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,$dow,$time) {
        global $notify_message;
		global $warning_message;

		if (!checkdate($startMonth,$startDay,$startYear)) {
			$warning_message = "Invalid Start Date. ";
			return;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			$warning_message .= "Invalid End Date. ";
			return;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		$i = 0;

		foreach($dow as $singleDay) {
			foreach($time as $singleTime) {
				$query = "INSERT INTO {$this->store->table_traffic_slot} (startDate,endDate,dow,time) VALUES ('$startDate','$endDate','$singleDay','$singleTime')";
				$result = sysdb::query($query);
				$i++;
			}
		}

		$notify_message = "Successfully added $i slots.";
    }

    public function save($id,$startYear,$startMonth,$startDay,$endYear,$endMonth,$endDay,$dow,$time) {
        global $notify_message;
		global $warning_message;

		if (!checkdate($startMonth,$startDay,$startYear)) {
			$warning_message = "Invalid Start Date. ";
			return;
		} else {
			$startDate = $startYear.'-'.$startMonth.'-'.$startDay;
		}

		if (!checkdate($endMonth,$endDay,$endYear)) {
			$warning_message .= "Invalid End Date. ";
			return;
		} else {
			$endDate = $endYear.'-'.$endMonth.'-'.$endDay;
		}

		$query = "UPDATE {$this->store->table_traffic_slot} SET startDate = '$startDate', endDate = '$endDate',  dow = '$dow', time = '$time' WHERE slotID = '$id'";
        $result = sysdb::query($query);
		$notify_message = "Successfully updated slot.";
    }

    public function delete($id) {
        echo 'Deleting Slot '.$id;
        $query = "DELETE FROM {$this->store->table_traffic_slot} WHERE slotID = '$id'";
        $result = sysdb::query($query);
    }

    public function search($doc,$string) {
        $query = "SELECT slotID FROM {$this->store->table_traffic_slot} WHERE startDate LIKE '%$string%' OR endDate LIKE '%$string%' OR 'time' LIKE '%$string%' ";
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'slotID')));
        }
    }

}
?>
