<?php
// $Id$

class Talent {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'delete':
				$this->delete(globalize('id'));
				break;
            case 'add':
				$this->add(globalize('talentActorID'));
				break;
            case 'save':
				$this->save(globalize('talentID'),
							globalize('talentActorID'),
							globalize('talentTitle'),
							globalize('talentFirstName'),
							globalize('talentLastName'),
							globalize('talentAddress'),
							globalize('talentCity'),
							globalize('talentPostcode'),
							globalize('talentWork'),
							globalize('talentMobile'),
							globalize('talentFax'),
							globalize('talentEmail')
							);
				break;
        }
    }

    public function headers($doc) {
		$moduleID = globalize('moduleID');
        $item = globalize('item', get_class($this));
		$script = $doc->createElement('script');
		$script->setAttribute('language', 'javascript');
		$script->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=".$item.".js");
		$script->appendChild($doc->createTextNode(''));

		return(array($script));
    }

    public function form($doc, $id='') {

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		if ($id == '')
            $headerText = 'Add Talent';
        else
            $headerText = 'Edit Talent';

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode($headerText));
		$container->appendChild($header);

       /* Database Code */
        if ($id != '') {
			$item = globalize('item', get_class($this));
			$spanbutton = $doc->createElement('span');
			$spanbutton->setAttribute('class', 'link_button');
			$a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'delete','id'=>$id),'Delete','link_button');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_delete');
			$label = $doc->createTextNode('Delete');
			$span->appendChild($label);
			$a->appendChild($span);
			$spanbutton->appendChild($a);
			$container->appendChild($spanbutton);

			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Contract",'action'=>'delete','id'=>$id),'Delete'));
			// $container->appendChild($span);

			$query = "SELECT I.talentID, I.actorID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.talentID = '$id' AND D.actorID = I.actorID";
            $result = sysdb::query($query);
            $line = sysdb::fetch_assoc($result);

            $talentID = $line['talentID'];
            $actorID = $line['actorID'];
            $title = $line['title'];
            $firstName = $line['firstName'];
            $lastName = $line['lastName'];
            $address = $line['address'];
            $city = $line['city'];
            $postcode = $line['postcode'];
            $work = $line['landline'];
            $mobile = $line['mobile'];
            $fax = $line['fax'];
            $email = $line['email'];

			// Decode UTF-8 character encoding.
			$values = array(&$title,
							&$firstName,
							&$lastName,
							&$address,
							&$city,
							&$email
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);

			$query = "SELECT U.name, U.login FROM (".$this->store->table_user." U) WHERE U.actorID = '$actorID'";
            $result = sysdb::query($query);
            $userline = sysdb::fetch_assoc($result);
            $name = $userline['name'];
            $login = $userline['login'];

        } else {
            $talentID = '';
            $actorID = '';
            $title = '';
            $firstName = '';
            $lastName = '';
            $address = '';
            $city = '';
            $postcode = '';
            $work = '';
            $mobile = '';
            $fax = '';
            $email = '';
		}
		// Unhide
		$containerShow = $doc->createElement('div');
		$containerShow->setAttribute('id','hide_talent');

        $divbutton = $doc->createElement('div');
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		$a = $doc->createElement('a');
		$a->setAttribute('title', 'Cancel');
		$a->setAttribute('class', 'link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$text = $doc->createTextNode('Cancel');
		$span->appendChild($text);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$divbutton->appendChild($spanbutton);
		$containerShow->appendChild($divbutton);

		$table = $doc->createElement('table');
		$table->setAttribute('class','view');

		// This temporarily disables the dropdown menu when editing a talent
		// TODO: Cannot link up a user with an existing talent. Something weird happens
		// with the "add" submit button.
        if ($id == '') {
			$usertr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('Select User');
			$inputtd = $doc->createElement('td');
			$labeltd->appendChild($label);
			$input = $this->display_select($doc, '', $actorID);
			$inputtd->appendChild($input);
			$usertr->appendChild($labeltd);
			$usertr->appendChild($inputtd);

			$table->appendChild($usertr);

			$savetr = $doc->createElement('tr');
			$savetd = $doc->createElement('td');
			$save = $doc->createElement('input');
			$save->setAttribute('type','submit');
			$save->setAttribute('name','action');
			$save->setAttribute('value','add');
			$savetd->appendChild($save);
			$savetr->appendChild($savetd);
			$table->appendChild($savetr);
		}
		// This temporarily desecribes the missing feature as noted above.
        if ($id != '') {
			$usertr = $doc->createElement('tr');
			$labeltd = $doc->createElement('th');
			$label = $doc->createTextNode('Select User');
			$inputtd = $doc->createElement('td');
			$labeltd->appendChild($label);
			$input = $doc->createTextNode('This feature is unavailable.');
			$inputtd->appendChild($input);
			$usertr->appendChild($labeltd);
			$usertr->appendChild($inputtd);

			$table->appendChild($usertr);
		}

        $containerShow->appendChild($table);

		$container->appendChild($containerShow);
		// end unhide

		// hide
		$containerHide = $doc->createElement('div');
		$containerHide->setAttribute('id','show_talent');

        if ($id != '') {
			if ($login != '') {
				$buttonText = 'Edit Link to User';
			} else {
				$buttonText = 'Link to Existing User';
			}
		} else {
			$buttonText = 'Import Existing User';
		}
        $divbutton = $doc->createElement('div');
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$spanbutton->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		$a = $doc->createElement('a');
		$a->setAttribute('title', $buttonText);
		$a->setAttribute('class', 'link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$text = $doc->createTextNode($buttonText);
		$span->appendChild($text);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$divbutton->appendChild($spanbutton);
		$containerHide->appendChild($divbutton);

		// // TODO: Add State to this array.
		// $populateArray = array(
						// 'Address',
						// 'City',
						// 'Postcode',
						// 'Work',
						// 'Mobile',
						// 'Fax',
						// 'Email');
		// $populateString = implode($populateArray,'/');
        // $divToggleLink = $doc->createElement('div');
		// $divToggleLink->appendChild($aToggleLink = $doc->createElement('a'));
		// $aToggleLink->setAttribute("onclick", "populateTalentForm('$populateString');");
		// $aToggleLink->appendChild($doc->createTextNode('Populate with same contact details as above'));

		// $containerHide->appendChild($divToggleLink);

        if ($id != '') {
			if ($login != '') {
				// Start user
				$table = $doc->createElement('table');
				$table->setAttribute('class','view');

				$titletr = $doc->createElement('tr');
				$labeltd = $doc->createElement('th');
				$label = $doc->createTextNode('Username');
				$inputtd = $doc->createElement('td');
				$input = $doc->createTextNode($name.' ('.$login.')');
				$labeltd->appendChild($label);
				$inputtd->appendChild($input);
				$titletr->appendChild($labeltd);
				$titletr->appendChild($inputtd);
				$table->appendChild($titletr);
				$containerHide->appendChild($table);
				// end user
			} else {
				// Start user
				$table = $doc->createElement('table');
				$table->setAttribute('class','view');

				$titletr = $doc->createElement('tr');
				$labeltd = $doc->createElement('th');
				$label = $doc->createTextNode('Username');
				$inputtd = $doc->createElement('td');
				$input = $doc->createTextNode('Not linked to system user.');
				$labeltd->appendChild($label);
				$inputtd->appendChild($input);
				$titletr->appendChild($labeltd);
				$titletr->appendChild($inputtd);
				$table->appendChild($titletr);
				$containerHide->appendChild($table);
				// end user
			}
		}
		$container->appendChild($containerHide);
		// end hide

		$fields = array(
		 "Title"=>     array( "name"=>"talentTitle", "value"=>$title ),
		 "First Name"=> array( "name"=>"talentFirstName", "value"=>$firstName),
		 "Last Name"=>  array( "name"=>"talentLastName", "value"=>$lastName),
		 "Address"=>   array( "name"=>"talentAddress", "value"=>$address),
		 "City"=>      array( "name"=>"talentCity", "value"=>$city),
		 "Postcode"=>  array( "name"=>"talentPostcode", "value"=>$postcode),
		 "Work"=>   array( "name"=>"talentWork", "value"=>$work),
		 "Mobile"=> array( "name"=>"talentMobile", "value"=>$mobile),
		 "Fax"=>    array( "name"=>"talentFax", "value"=>$fax),
		 "Email"=>     array( "name"=>"talentEmail", "value"=>$email)   );

		foreach($fields as $name=>$val) {
			$formFields[$name] = dom::createInputBox($doc, $val['name'], $val['value'], 'text');
		}

		$talentIDHidden = dom::createInputBox($doc, 'talentID', $id, 'hidden');
		$container->appendChild($talentIDHidden);

		$actorIDHidden = dom::createInputBox($doc, 'talentActorID', $actorID, 'hidden');
		$container->appendChild($actorIDHidden);

		$table = dom::createTable($doc, $formFields, 'view');
		$container->appendChild($table);

		$savetr = $doc->createElement('tr');
		$savetd = $doc->createElement('td');
		$save = $doc->createElement('input');
		$save->setAttribute('type','submit');
		$save->setAttribute('id','talentSave');
		$save->setAttribute('name','action');
		$save->setAttribute('value','save');
		$savetd->appendChild($save);
		$savetr->appendChild($savetd);
		$table->appendChild($savetr);

        return($container);
    }

    public function inline_form($doc, $id='') {

		// $container = $doc->createElement('div');
		// $container->setAttribute('class','module');

		// if ($id == '')
            // $headerText = 'Add Talent';
        // else
            // $headerText = 'Edit Talent';

		// $header = $doc->createElement('h1');
		// $header->appendChild($doc->createTextNode($headerText));
		// $container->appendChild($header);

       /* Database Code */
        // if ($id != '') {
			// $item = globalize('item', get_class($this));
			// $spanbutton = $doc->createElement('span');
			// $spanbutton->setAttribute('class', 'link_button');
			// $a = module::link_to_script_dom_unappended($doc,'Delete','',array('item'=>$item,'action'=>'delete','id'=>$id),'Delete','link_button');
			// $span = $doc->createElement('span');
			// $span->setAttribute('class', 'link_delete');
			// $label = $doc->createTextNode('Delete');
			// $span->appendChild($label);
			// $a->appendChild($span);
			// $spanbutton->appendChild($a);
			// $container->appendChild($spanbutton);

			// // $span = $doc->createElement('span');
			// // $span->setAttribute('class', 'link_delete');
			// // $span->appendChild(module::link_to_script_dom($doc,'Delete','',array('item'=>"Contract",'action'=>'delete','id'=>$id),'Delete'));
			// // $container->appendChild($span);

			// $query = "SELECT I.talentID, I.actorID, D.title, D.firstName, D.lastName, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.talentID = '$id' AND D.actorID = I.actorID";
            // $result = sysdb::query($query);
            // $line = sysdb::fetch_assoc($result);

            // $talentID = $line['talentID'];
            // $actorID = $line['actorID'];
            // $title = $line['title'];
            // $firstName = $line['firstName'];
            // $lastName = $line['lastName'];
            // $address = $line['address'];
            // $city = $line['city'];
            // $postcode = $line['postcode'];
            // $work = $line['landline'];
            // $mobile = $line['mobile'];
            // $fax = $line['fax'];
            // $email = $line['email'];

			// $query = "SELECT U.name, U.login FROM (".$this->store->table_user." U) WHERE U.actorID = '$actorID'";
            // $result = sysdb::query($query);
            // $userline = sysdb::fetch_assoc($result);
            // $name = $userline['name'];
            // $login = $userline['login'];

        // } else {
            // $talentID = '';
            // $actorID = '';
            $title = '';
            $firstName = '';
            $lastName = '';
            $address = '';
            $city = '';
            $postcode = '';
            $work = '';
            $mobile = '';
            $fax = '';
            $email = '';
		// }
		// // Unhide
		// $containerShow = $doc->createElement('div');
		// $containerShow->setAttribute('id','hide_talent');

        // $divbutton = $doc->createElement('div');
		// $spanbutton = $doc->createElement('span');
		// $spanbutton->setAttribute('class', 'link_button');
		// $spanbutton->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		// $a = $doc->createElement('a');
		// $a->setAttribute('title', 'Cancel');
		// $a->setAttribute('class', 'link_button');
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $text = $doc->createTextNode('Cancel');
		// $span->appendChild($text);
		// $a->appendChild($span);
		// $spanbutton->appendChild($a);
		// $divbutton->appendChild($spanbutton);
		// $containerShow->appendChild($divbutton);

		$table = $doc->createElement('table');
		$table->setAttribute('class','view');

		// This temporarily disables the dropdown menu when editing a talent
		// TODO: Cannot link up a user with an existing talent. Something weird happens
		// with the "add" submit button.
        // if ($id == '') {
			// $usertr = $doc->createElement('tr');
			// $labeltd = $doc->createElement('th');
			// $label = $doc->createTextNode('Select User');
			// $inputtd = $doc->createElement('td');
			// $labeltd->appendChild($label);
			// $input = $this->display_select($doc,'',$actorID);
			// $inputtd->appendChild($input);
			// $usertr->appendChild($labeltd);
			// $usertr->appendChild($inputtd);

			// $table->appendChild($usertr);

			// $savetr = $doc->createElement('tr');
			// $savetd = $doc->createElement('td');
			// $save = $doc->createElement('input');
			// $save->setAttribute('type','submit');
			// $save->setAttribute('name','action');
			// $save->setAttribute('value','add');
			// $savetd->appendChild($save);
			// $savetr->appendChild($savetd);
			// $table->appendChild($savetr);
		// // }
		// // This temporarily desecribes the missing feature as noted above.
        // // if ($id != '') {
			// // $usertr = $doc->createElement('tr');
			// // $labeltd = $doc->createElement('th');
			// // $label = $doc->createTextNode('Select User');
			// // $inputtd = $doc->createElement('td');
			// // $labeltd->appendChild($label);
			// // $input = $doc->createTextNode('This feature is unavailable.');
			// // $inputtd->appendChild($input);
			// // $usertr->appendChild($labeltd);
			// // $usertr->appendChild($inputtd);

			// // $table->appendChild($usertr);
		// // }

        // $containerShow->appendChild($table);

		// $container->appendChild($containerShow);
		// // end unhide

		// // hide
		// $containerHide = $doc->createElement('div');
		// $containerHide->setAttribute('id','show_talent');

        // if ($id != '') {
			// if ($login != '') {
				// $buttonText = 'Edit Link to User';
			// } else {
				// $buttonText = 'Link to Existing User';
			// }
		// } else {
			// $buttonText = 'Import Existing User';
		// }
        // $divbutton = $doc->createElement('div');
		// $spanbutton = $doc->createElement('span');
		// $spanbutton->setAttribute('class', 'link_button');
		// $spanbutton->setAttribute("onclick", "toggleTalentForm('hide_talent','show_talent');");
		// $a = $doc->createElement('a');
		// $a->setAttribute('title', $buttonText);
		// $a->setAttribute('class', 'link_button');
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_add');
		// $text = $doc->createTextNode($buttonText);
		// $span->appendChild($text);
		// $a->appendChild($span);
		// $spanbutton->appendChild($a);
		// $divbutton->appendChild($spanbutton);
		// $containerHide->appendChild($divbutton);

		// // // TODO: Add State to this array.
		// // $populateArray = array(
						// // 'Address',
						// // 'City',
						// // 'Postcode',
						// // 'Work',
						// // 'Mobile',
						// // 'Fax',
						// // 'Email');
		// // $populateString = implode($populateArray,'/');
        // // $divToggleLink = $doc->createElement('div');
		// // $divToggleLink->appendChild($aToggleLink = $doc->createElement('a'));
		// // $aToggleLink->setAttribute("onclick", "populateTalentForm('$populateString');");
		// // $aToggleLink->appendChild($doc->createTextNode('Populate with same contact details as above'));

		// // $containerHide->appendChild($divToggleLink);

        // if ($id != '') {
			// if ($login != '') {
				// // Start user
				// $table = $doc->createElement('table');
				// $table->setAttribute('class','view');

				// $titletr = $doc->createElement('tr');
				// $labeltd = $doc->createElement('th');
				// $label = $doc->createTextNode('Username');
				// $inputtd = $doc->createElement('td');
				// $input = $doc->createTextNode($name.' ('.$login.')');
				// $labeltd->appendChild($label);
				// $inputtd->appendChild($input);
				// $titletr->appendChild($labeltd);
				// $titletr->appendChild($inputtd);
				// $table->appendChild($titletr);
				// $containerHide->appendChild($table);
				// // end user
			// } else {
				// // Start user
				// $table = $doc->createElement('table');
				// $table->setAttribute('class','view');

				// $titletr = $doc->createElement('tr');
				// $labeltd = $doc->createElement('th');
				// $label = $doc->createTextNode('Username');
				// $inputtd = $doc->createElement('td');
				// $input = $doc->createTextNode('Not linked to system user.');
				// $labeltd->appendChild($label);
				// $inputtd->appendChild($input);
				// $titletr->appendChild($labeltd);
				// $titletr->appendChild($inputtd);
				// $table->appendChild($titletr);
				// $containerHide->appendChild($table);
				// // end user
			// }
		// }
		// $container->appendChild($containerHide);
		// // end hide

		$fields = array(
		 "Title"=>     array( "name"=>"talentTitle", "value"=>$title ),
		 "First Name"=> array( "name"=>"talentFirstName", "value"=>$firstName),
		 "Last Name"=>  array( "name"=>"talentLastName", "value"=>$lastName),
		 "Address"=>   array( "name"=>"talentAddress", "value"=>$address),
		 "City"=>      array( "name"=>"talentCity", "value"=>$city),
		 "Postcode"=>  array( "name"=>"talentPostcode", "value"=>$postcode),
		 "Work"=>   array( "name"=>"talentWork", "value"=>$work),
		 "Mobile"=> array( "name"=>"talentMobile", "value"=>$mobile),
		 "Fax"=>    array( "name"=>"talentFax", "value"=>$fax),
		 "Email"=>     array( "name"=>"talentEmail", "value"=>$email)   );

		foreach($fields as $name=>$val) {
			$formFields[$name] = dom::createInputBox($doc, $val['name'], $val['value'], 'text');
		}

		// $talentIDHidden = dom::createInputBox($doc, 'talentID', $id, 'hidden');
		// $table->appendChild($talentIDHidden);

		// $actorIDHidden = dom::createInputBox($doc, 'talentActorID', $actorID, 'hidden');
		// $table->appendChild($actorIDHidden);

		$table = dom::createTable($doc, $formFields, 'view');
		// $container->appendChild($table);

		// $savetr = $doc->createElement('tr');
		// $savetd = $doc->createElement('td');
		// $save = $doc->createElement('input');
		// $save->setAttribute('type','submit');
		// $save->setAttribute('id','talentSave');
		// $save->setAttribute('name','action');
		// $save->setAttribute('value','save');
		// $savetd->appendChild($save);
		// $savetr->appendChild($savetd);
		// $table->appendChild($savetr);

        return($table);
    }

    public function view($doc, $id) {
		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('View Talent'));
		$container->appendChild($header);
		// $span = $doc->createElement('span');
		// $span->setAttribute('class', 'link_edit');
		// $span->appendChild(module::link_to_script_dom($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit'));
		// $container->appendChild($span);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Edit','',array('item'=>get_class($this),'action'=>'edit','id'=>$id),'Edit','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_edit');
		$label = $doc->createTextNode('Edit');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

        $table = $doc->createElement('table');
        $table->setAttribute('class','view');

        $talentID = $doc->createElement('input');
        $talentID->setAttribute('type','hidden');
        $talentID->setAttribute('name','talentID');
        $talentID->setAttribute('value',$id);
        $container->appendChild($talentID);

		if ($id != '') {
			$query = "SELECT I.talentID, D.title, D.firstName, D.lastName, D.gender, D.address, D.city, D.state, D.postcode, D.landline, D.fax, D.mobile, D.email FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.talentID = '$id' AND I.actorID = D.actorID";
			$result = sysdb::query($query);
			$line = sysdb::fetch_assoc($result);

			$talentID = $line['talentID'];
			$title = $line['title'];
			$firstName = $line['firstName'];
			$lastName = $line['lastName'];
			$gender = $line['gender'];
			$address = $line['address'];
			$city = $line['city'];
			$postcode = $line['postcode'];
			$work = displayLandlineNumber($line['landline']);
			$mobile = displayMobileNumber($line['mobile']);
			$fax = displayLandlineNumber($line['fax']);
			$email = $line['email'];

			// Decode UTF-8 character encoding.
			$values = array(&$title,
							&$firstName,
							&$lastName,
							&$address,
							&$city,
							&$email
							);
			foreach ($values as &$value) {
				$value = utf8_decode($value);
			}
			unset($value);
		}

        $titletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Title');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($title);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $titletr->appendChild($labeltd);
        $titletr->appendChild($inputtd);

        $firstNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('First Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($firstName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $firstNametr->appendChild($labeltd);
        $firstNametr->appendChild($inputtd);

        $lastNametr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Last Name');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($lastName);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $lastNametr->appendChild($labeltd);
        $lastNametr->appendChild($inputtd);

        $gendertr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Gender');
        $inputtd = $doc->createElement('td');
		if ($gender == 'Female') {
			$inputtd->setAttribute('class', 'gender_female');
		} else if ($gender == 'Male') {
			$inputtd->setAttribute('class', 'gender_male');
		}
        $input = $doc->createTextNode($gender);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $gendertr->appendChild($labeltd);
        $gendertr->appendChild($inputtd);

        $addresstr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Address');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($address);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $addresstr->appendChild($labeltd);
        $addresstr->appendChild($inputtd);

        $citytr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('City');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($city);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $citytr->appendChild($labeltd);
        $citytr->appendChild($inputtd);

        $postcodetr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Postcode');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($postcode);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $postcodetr->appendChild($labeltd);
        $postcodetr->appendChild($inputtd);

        $worktr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Work');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($work);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $worktr->appendChild($labeltd);
        $worktr->appendChild($inputtd);

        $mobiletr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Mobile');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($mobile);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $mobiletr->appendChild($labeltd);
        $mobiletr->appendChild($inputtd);

        $faxtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Fax');
        $inputtd = $doc->createElement('td');
        $input = $doc->createTextNode($fax);
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $faxtr->appendChild($labeltd);
        $faxtr->appendChild($inputtd);

        $emailtr = $doc->createElement('tr');
        $labeltd = $doc->createElement('th');
        $label = $doc->createTextNode('Email');
        $inputtd = $doc->createElement('td');
        $input = $doc->createElement('a');
        $input->setAttribute('href','mailto:'.$email);
        $input->appendChild($doc->createTextNode($email));
        $labeltd->appendChild($label);
        $inputtd->appendChild($input);
        $emailtr->appendChild($labeltd);
        $emailtr->appendChild($inputtd);

        $table->appendChild($titletr);
        $table->appendChild($firstNametr);
        $table->appendChild($lastNametr);
        $table->appendChild($gendertr);
        $table->appendChild($addresstr);
        $table->appendChild($citytr);
        $table->appendChild($postcodetr);
        $table->appendChild($worktr);
        $table->appendChild($mobiletr);
        $table->appendChild($faxtr);
        $table->appendChild($emailtr);

        $container->appendChild($table);

        return($container);
    }

    public function display_list($doc, $ids = '', $sortby = '') {
        $item = globalize('item', get_class($this));
        $query = "SELECT I.actorID, I.talentID, D.firstName, D.lastName, D.gender, D.mobile, D.email FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID";
        if (is_array($ids) && sizeof($ids) <= 0) { $query .= ' AND 0=1'; } else if (is_array($ids) && sizeof($ids) > 0) {
            $query .= " AND I.talentID IN (".implode(',',$ids).") ";
        }
        if ($sortby != '')
			$query .= " ORDER BY $sortby ";
        $result = sysdb::query($query);

        $table = $doc->createElement('table');
        $table->setAttribute('class','list');

        $tr = $doc->createElement('tr');
        $firstNametd = $doc->createElement('th');
        $lastNametd = $doc->createElement('th');
        $gendertd = $doc->createElement('th');
        $mobiletd = $doc->createElement('th');
        $emailtd = $doc->createElement('th');

        $firstNametd->appendChild($doc->createTextNode('First'));
        $lastNametd->appendChild($doc->createTextNode('Last'));
        $gendertd->appendChild($doc->createTextNode('Gender'));
        $mobiletd->appendChild($doc->createTextNode('Mobile'));
        $emailtd->appendChild($doc->createTextNode('Email'));

        $tr->appendChild($firstNametd);
        $tr->appendChild($lastNametd);
        $tr->appendChild($gendertd);
        $tr->appendChild($mobiletd);
        $tr->appendChild($emailtd);

        $table->appendChild($tr);

        if (sysdb::num_rows($result) <= 0) {
            $tr = $doc->createElement('tr');
            $td = $doc->createElement('td');
            $td->setAttribute('colspan','4');
            $name = $doc->createTextNode('No Talent entered');

            $table->appendChild($tr);
            $tr->appendChild($td);
            $td->appendChild($name);
        }
        $i = 1;
        while ($line = sysdb::fetch_assoc($result)) {
			$actorID = $line['actorID'];
			$talentID = $line['talentID'];

			$querydetails = "SELECT D.firstName, D.lastName, D.email FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.actorID = '$actorID' AND I.actorID = D.actorID";
			$resultdetails = sysdb::query($querydetails);
			$linedetails  = sysdb::fetch_assoc($resultdetails);

			$trStyle = module::row_style_dom($i);
			$tr = $doc->createElement('tr');
			$tr->setAttribute('class',$trStyle);
            $firstNametd = $doc->createElement('td');
            $lastNametd = $doc->createElement('td');
            $gendertd = $doc->createElement('td');
			if ($line['gender'] == 'Female') {
				$gendertd->setAttribute('class', 'gender_female');
			} else if ($line['gender'] == 'Male') {
				$gendertd->setAttribute('class', 'gender_male');
			}
            $mobiletd = $doc->createElement('td');
            $emailtd = $doc->createElement('td');

            $firstNametd->appendChild($doc->createTextNode($linedetails['firstName']));
            $lastNametd->appendChild($doc->createTextNode($linedetails['lastName']));
            $gendertd->appendChild($doc->createTextNode($line['gender']));
            $mobiletd->appendChild($doc->createTextNode($line['mobile']));
            $emailhref = $doc->createElement('a');
            $emailhref->setAttribute('href','mailto:'.$linedetails['email']);
            $emailhref->appendChild($doc->createTextNode($linedetails['email']));
            $emailtd->appendChild($emailhref);
            $actiontd = $doc->createElement('td');
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_view_small');
            $span->appendChild(module::link_to_script_dom($doc,'view','',array('item'=>$item,'action'=>'view','id'=>$line['talentID']),'View'));
            $actiontd->appendChild($span);
			$actiontd->appendChild($doc->createTextNode(' '));
			$span = $doc->createElement('span');
			$span->setAttribute('class', 'link_edit_small');
            $span->appendChild(module::link_to_script_dom($doc,'edit','',array('item'=>$item,'action'=>'edit','id'=>$line['talentID']),'Edit'));
            $actiontd->appendChild($span);

            $table->appendChild($tr);
            $tr->appendChild($firstNametd);
            $tr->appendChild($lastNametd);
            $tr->appendChild($gendertd);
            $tr->appendChild($mobiletd);
            $tr->appendChild($emailtd);
            $tr->appendChild($actiontd);
			$i++;
        }

        return($table);
    }

    public function overview($doc,$ids='',$sortby='') {
        $item = globalize('item', get_class($this));

        $sortby = globalize('sortby');
		if ($sortby != '')
			$sortby = 'lastName';
		else {
			switch($sortby) {
				case 'lastName':
							break;
				case 'firstName':
							$sortby = 'firstName';
							break;
				case 'gender':
							$sortby = 'gender';
							break;
				case 'mobile':
							$sortby = 'mobile';
							break;
				case 'email':
							$sortby = 'email';
							break;
				default:
							$sortby = 'lastName';
							break;
			}
		}
        $query = "SELECT I.talentID FROM ({$this->store->table_traffic_talent} I, {$this->store->table_detail} D) WHERE I.actorID = D.actorID";
        $query .= " ORDER BY $sortby ";

        $ids = sysdb::query2vector($query,'talentID');

		$container = $doc->createElement('div');
		$container->setAttribute('class','module');

		$header = $doc->createElement('h1');
		$header->appendChild($doc->createTextNode('Talent'));
		$container->appendChild($header);
		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc,'Add Talent','',array('item'=>$item,'action'=>'edit'),'Add Talent','link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_add');
		$label = $doc->createTextNode('Add Talent');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);
		$container->appendChild($spanbutton);

		$container->appendChild(self::display_list($doc,$ids,globalize('sortby')));

        return($container);
    }

    public function display_select($doc, $ids='', $actorID) {

		$query = "SELECT U.actorID, U.name, U.login FROM (".$this->store->table_user." U) ORDER BY name";
        $result = sysdb::query($query);

        $select = $doc->createElement('select');
        $select->setAttribute('name','talentActorID');

        if (sysdb::num_rows($result) <= 0) {
            $option = $doc->createElement('option');
            $option->setAttribute('value','');
            $text = $doc->createTextNode('No Users available');
            $option->appendChild($text);
        }
        while ($line = sysdb::fetch_assoc($result)) {
            $option = $doc->createElement('option');
			if ( isset($actorID)) {
				if ($line['actorID'] == $actorID) {
					$option->setAttribute('selected','selected');
				}
			}
            $option->setAttribute('value',$line['actorID']);
            $text = $doc->createTextNode($line['name'].' ('.$line['login'].')');
            $option->appendChild($text);
            $select->appendChild($option);
       }
        return($select);
    }

    public function add($actorID) {

        $created = $this->insert($actorID);
		if ($created == true) {
			$talentID = $this->verifyTalentExists($actorID);
			state::setMessage('notify', "The actor was created");
			if ($talentID != false) {
//				state::setMessage('notify', "The talent has an ID! it is: ".$talentID);
				module::forward_to_script('',array('item'=>'Talent','action'=>'edit','id'=>$talentID));
			}
		} else {
//			state::setMessage('warning', "The actor was not created");
		}
    }

    public function save($id,$actorID,$title,$firstName,$lastName,$address,$city,$postcode,$work,$mobile,$fax,$email) {
		// Escape values.
		$values = array(&$title,
						&$firstName,
						&$lastName,
						&$address,
						&$city,
						&$email
						);
 		foreach ($values as &$value) {
			$value = sysdb::escape_string($value);
			$value = utf8_encode($value);
		}
		unset($value);

		// Strip whitespace from phone numbers and ABN.
		$values = array(&$work,
						&$mobile,
						&$fax
						);
 		foreach ($values as &$value) {
			$value = str_replace(' ', '', $value);
		}
		unset($value);


$debug = '';
		global $notify_message;
		$duplicate = false;
		if ($id == '' || $actorID == '') {
			// New talent.
			if ($id == '' && $actorID == '') {
				// Adding a new talent from the form.
$debug .= "// Adding a new talent from the form.<br/>";
				$actorID = create_actor();
				Talent::insert($actorID);
				$id = Talent::verifyTalentExists($actorID);
$debug .= "save id1=>".$id."<br/>";
				if ($id != false)
					$duplicate = true;
			} else if ($id == '' && $actorID != '') {
				// If somehow the $id got lost.
$debug .= "// If somehow the id got lost.<br/>";
				$id = Talent::verifyTalentExists($actorID);
$debug .= "save id2=>".$id."<br/>";
				if ($id != false)
					$duplicate = true;
			} else if ($id != '' && $actorID == '') {
				// After adding a new talent from existing users selection, recover actorID.
$debug .= "// After adding a new talent from existing users selection, recover actorID.<br/>";
				$query = "SELECT actorID FROM ".$this->store->table_traffic_talent." WHERE talentID = '$id'";
				$result = sysdb::query($query);
				if (sysdb::num_rows($result) > 0) {
					$line = sysdb::fetch_assoc($result);
					$actorID = $line['actorID'];
					$duplicate = true;
				}
			}
		} else {
			// Check to see if a talent record exists for this actor.
$debug .= "// Check to see if a talent record exists for this actor.<br/>";
			$id = Talent::verifyTalentExists($actorID);
$debug .= "save id3=>".$id."<br/>";
			if ($id != false)
				$duplicate = true;
		}

        if (!$duplicate) {
			// Add new talent record.
$debug .= "// Add new talent record.<br/>";
			Talent::insert($actorID);
        }
		// Check to see if a detail record exists for this actor.
$debug .= "// Check to see if a detail record exists for this actor.<br/>";
		$query = <<<EOQ
			SELECT {$this->store->field_detail_actorID}
			FROM ({$this->store->table_detail})
			WHERE {$this->store->field_detail_actorID} = '$actorID'
EOQ;
		$result = sysdb::query($query);

		if (sysdb::num_rows($result) <= 0) {
			// Add new details for new talent.
$debug .= "// Add new details for new talent.<br/>";
			$query = "INSERT INTO ".$this->store->table_detail." (title, firstName, lastName, address, city, postcode, landline, mobile, fax, email, actorID) VALUES ('$title','$firstName','$lastName','$address','$city','$postcode','$work','$mobile','$fax','$email','$actorID')";
			$result = sysdb::query($query);
		} else {
			// Editing and saving an existing talent's details.
$debug .= "// Editing and saving an existing talent's details.<br/>";
			$query = "UPDATE (".$this->store->table_detail." D) SET D.title = '$title', D.firstName = '$firstName', D.lastName = '$lastName',  D.address = '$address', D.city = '$city', D.postcode = '$postcode', D.landline = '$work', D.mobile = '$mobile', D.fax = '$fax', D.email = '$email' WHERE D.actorID = '$actorID'";
			$result = sysdb::query($query);
		}
//state::setMessage('warning', $debug);
	}

    public function delete($id) {
        echo 'Deleting Talent '.$id;
        $query = "DELETE FROM {$this->store->table_traffic_talent} WHERE talentID = '$id'";
        $result = sysdb::query($query);
    }

    public function search($doc,$string) {
        $query = <<<EOQ
            SELECT talentID
            FROM ({$this->store->table_traffic_talent} T, {$this->store->table_detail} D)
            WHERE T.actorID = D.actorID
            AND (D.firstName LIKE '%$string%'
            OR D.lastName LIKE '%$string%'
            OR D.email LIKE '%$string%')
EOQ;
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
            $empty = $doc->createElement('span');
            return($empty);
        } else {
            return($this->display_list($doc,sysdb::result2vector($result,'talentID')));
        }
    }

    public function insert($actorID) {
		$exists = verify_actor_exists($actorID);

		if ($exists == true) {
			$query = "INSERT INTO ".$this->store->table_traffic_talent." (actorID) VALUES ('$actorID')";
			$result = sysdb::query($query);

			// Check to see if actor has details, and if not create them.
			createFalseActorDetail($actorID);

//state::setMessage('notify', "TRUE: Actor does not exist");
			return true;
		} else {
//state::setMessage('notify', "FALSE: Actor exists");
			return false;
		}
    }

    public function verifyTalentExists($actorID) {
        $query = <<<EOQ
            SELECT {$this->store->field_talent_talentID} as talentID
            FROM ({$this->store->table_traffic_talent})
            WHERE {$this->store->field_talent_actorID} = '$actorID'
EOQ;
        $result = sysdb::query($query);

        if (sysdb::num_rows($result) <= 0) {
			return false;
		} else {
			$line = sysdb::fetch_assoc($result);
			$talentID = $line['talentID'];
			return ($talentID);
		}
    }

}
?>