<?php
// $Id$

class Template {
	var $store;

	function __construct() {
		$this->store = new trafficStorage();
	}

    public function actions() {
        switch(globalize('action')) {
            case 'clone':
				$this->add(globalize('templateContractID'),
							globalize('templateClientID'),
							globalize('templateCampaignNameList', array()),
							globalize('templateAudioNameList', array()),
							globalize('templatePromotionNameList', array()),
							globalize('templateCampaignList', array()),
							globalize('templateScheduleList', array()),
							globalize('templatePromoList', array()),
							globalize('templateStartYear'),
							globalize('templateStartMonth'),
							globalize('templateStartDay'),
							globalize('templateScheduleStartYear'),
							globalize('templateScheduleStartMonth'),
							globalize('templateScheduleStartDay'),
							globalize('templateScheduleEndYear'),
							globalize('templateScheduleEndMonth'),
							globalize('templateScheduleEndDay'));
				break;
        }
    }

    public function clone_contract_button_ui($doc, $id='') {
        $item = globalize('item', get_class($this));

		$spanbutton = $doc->createElement('span');
		$spanbutton->setAttribute('class', 'link_button');
		$a = module::link_to_script_dom_unappended($doc, 'Clone', '', array('item' => 'Template', 'action' => 'edit', 'id' => $id), 'Clone', 'link_button');
		$span = $doc->createElement('span');
		$span->setAttribute('class', 'link_delete');
		$label = $doc->createTextNode('Clone');
		$span->appendChild($label);
		$a->appendChild($span);
		$spanbutton->appendChild($a);

        return($spanbutton);
    }

	/** Displays the clone contract UI. */
    public function form($doc, $id = '') {

        $startDateArray = array(date('Y'), date('n'), date('j'));

		$container = $doc->createElement('div');
		$container->setAttribute('class', 'module');

		$container->appendChild($header = $doc->createElement('h1'));
		$header->appendChild($doc->createTextNode("Clone contract as template"));

		// Fetch contract details.
        $queryO = <<<EOQ
            SELECT O.{$this->store->field_contract_name} AS contractName,
				L.{$this->store->field_client_name} AS clientName,
				L.{$this->store->field_client_clientID} AS clientID,
				O.{$this->store->field_contract_startDate} AS contractStart,
				O.{$this->store->field_contract_endDate} AS contractEnd
			FROM ({$this->store->table_traffic_contract} O)
			LEFT OUTER JOIN {$this->store->table_traffic_client} L
			ON O.{$this->store->field_contract_clientID} = L.{$this->store->field_client_clientID}
			WHERE O.{$this->store->field_contract_contractID} = '$id'
EOQ;
		$resultO = sysdb::query($queryO);
		if (sysdb::num_rows($resultO) > 0) {

			$container->appendChild($subheader = $doc->createElement('h2'));
			$subheader->appendChild($doc->createTextNode('Contract details:'));

			$container->appendChild($table = $doc->createElement('table'));
			$table->setAttribute('class', 'view');

			// Process contract details.
			while ($lineO = sysdb::fetch_assoc($resultO)) {
				$oldContractStartDate = $lineO['contractStart'];
				$oldContractEndDate = $lineO['contractEnd'];
				$oldClientID = $lineO['clientID'];

				$container->appendChild($input = dom::createInputBox($doc, 'templateContractID', $id, 'hidden'));

				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$labeltd->appendChild($label = $doc->createTextNode('Contract'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$inputtd->appendChild($label = $doc->createTextNode(utf8_decode($lineO['contractName'])));

				$table->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$labeltd->appendChild($label = $doc->createTextNode('Client'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$inputtd->appendChild($label = $doc->createTextNode(utf8_decode($lineO['clientName'])));
			}
		} else {
			// Major error. Cannot proceed.
			state::setMessage('error', "Requested contract doesn't exist. Cannot perform operation.");
			return false;
		}

		// Fetch campaigns.
        $queryC = <<<EOQ
            SELECT C.{$this->store->field_campaign_name} AS campaignName,
					C.{$this->store->field_campaign_campaignID} AS campaignID,
					C.{$this->store->field_campaign_startDate} AS campaignStartDate,
					C.{$this->store->field_campaign_endDate} AS campaignEndDate
			FROM ({$this->store->table_traffic_campaign} C)
			LEFT OUTER JOIN {$this->store->table_traffic_contract} O
			ON C.{$this->store->field_campaign_contractID} = O.{$this->store->field_contract_contractID}
			WHERE C.{$this->store->field_campaign_contractID} = '$id'
EOQ;
		$resultC = sysdb::query($queryC);
		$campaignCount = sysdb::num_rows($resultC);

		// Fetch campaign audio.
        $queryA = <<<EOQ
            SELECT A.{$this->store->field_campaignaudio_campaignAudioID} AS campaignAudioID,
					A.{$this->store->field_campaignaudio_duration} AS duration,
					A.{$this->store->field_campaignaudio_name} AS campaignAudioName,
					A.{$this->store->field_campaignaudio_productionStatus} AS productionStatus,
					A.{$this->store->field_campaignaudio_filename} AS filename,
					A.{$this->store->field_campaignaudio_deadlineDate} AS productionDeadline,
					A.{$this->store->field_campaignaudio_startDate} AS audioStartDate,
					A.{$this->store->field_campaignaudio_endDate} AS audioEndDate,
					A.{$this->store->field_campaignaudio_mediaID} AS mediaID,
					A.{$this->store->field_campaignaudio_campaignID} AS campaignID
			FROM ({$this->store->table_traffic_campaignaudio} A)
			LEFT OUTER JOIN {$this->store->table_traffic_contract} O
			ON A.{$this->store->field_campaignaudio_contractID} = O.{$this->store->field_contract_contractID}
			WHERE A.{$this->store->field_campaignaudio_contractID} = '$id'
EOQ;
		$resultA = sysdb::query($queryA);
		$campaignAudioCount = sysdb::num_rows($resultA);

		// Fetch promotions.
        $queryP = <<<EOQ
            SELECT P.{$this->store->field_campaignpromotion_campaignPromotionID} AS campaignPromotionID,
					P.{$this->store->field_campaignpromotion_name} AS campaignPromotionName,
					P.{$this->store->field_campaignpromotion_mediaID} AS mediaID,
					P.{$this->store->field_campaignpromotion_campaignID} AS campaignID
			FROM ({$this->store->table_traffic_campaignpromotion} P)
			LEFT OUTER JOIN {$this->store->table_traffic_contract} O
			ON P.{$this->store->field_campaignpromotion_contractID} = O.{$this->store->field_contract_contractID}
			WHERE P.{$this->store->field_campaignpromotion_contractID} = '$id'
EOQ;
		$resultP = sysdb::query($queryP);
		$campaignPromotionCount = sysdb::num_rows($resultP);

		// Display number of objects to clone.
		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Campaign Count'));
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->appendChild($label = $doc->createTextNode($campaignCount));

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Campaign Audio Count'));
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->appendChild($label = $doc->createTextNode($campaignAudioCount));

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Campaign Promotion Count'));
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->appendChild($label = $doc->createTextNode($campaignPromotionCount));

		$container->appendChild($table);

		$container->appendChild($subheader = $doc->createElement('h2'));
		$subheader->appendChild($doc->createTextNode('Select client for new contract:'));

		$container->appendChild($table = $doc->createElement('table'));
		$table->setAttribute('class', 'view');

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Assign to client *'));
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$client = new Client();
		$input = $client->display_select($doc, '', $oldClientID);
		$input->setAttribute('id','templateClientID');
		$input->setAttribute('name','templateClientID');
        $inputtd->appendChild($input);

		if (sysdb::num_rows($resultC) > 0) {
			// Process campaign details.
			while ($lineC = sysdb::fetch_assoc($resultC)) {
				$container->appendChild($subheader = $doc->createElement('h2'));
				$subheader->appendChild($doc->createTextNode('"'.utf8_decode($lineC['campaignName']).'" campaign details:'));

				// Create one new table object per campaign using variable variables.
				$tableCampaign = $lineC['campaignID'];
				$$tableCampaign = $doc->createElement('table');
				${$tableCampaign}->setAttribute('class', 'view');

				${$tableCampaign}->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$labeltd->appendChild($label = $doc->createTextNode('Campaign'));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$inputtd->appendChild($label = dom::createInputBox($doc, 'templateCampaignNameList['.$lineC['campaignID'].']', utf8_decode($lineC['campaignName']), 'input'));

				$container->appendChild(${$tableCampaign});
			}
		}

		$mediaIDs = array();
		$campaignList = array();
		if (sysdb::num_rows($resultA) > 0) {
			$i = 1;
			// Process audio details.
			while ($lineA = sysdb::fetch_assoc($resultA)) {
				$mediaIDs[] = $lineA['mediaID'];
				$campaignList[$lineA['campaignID']]['A'][] = $lineA['mediaID'];

				// Add audio details to relevant campaign table object using variable variables.
				$tableCampaign = $lineA['campaignID'];

				${$tableCampaign}->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$labeltd->appendChild($label = $doc->createTextNode('Audio '.$i));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$inputtd->appendChild($label = dom::createInputBox($doc, 'templateAudioNameList['.$lineA['mediaID'].']', utf8_decode($lineA['campaignAudioName']), 'input'));

				$i++;
			}
		}
		if (sysdb::num_rows($resultP) > 0) {
			$i = 1;
			// Process promotion details.
			while ($lineP = sysdb::fetch_assoc($resultP)) {
				$promoMediaIDs[] = $lineP['mediaID'];
				$campaignList[$lineP['campaignID']]['P'][] = $lineP['mediaID'];

				// Add audio details to relevant campaign table object using variable variables.
				$tableCampaign = $lineP['campaignID'];

				${$tableCampaign}->appendChild($tr = $doc->createElement('tr'));
				$tr->appendChild($labeltd = $doc->createElement('th'));
				$labeltd->appendChild($label = $doc->createTextNode('Promotion '.$i));
				$tr->appendChild($inputtd = $doc->createElement('td'));
				$inputtd->appendChild($input = dom::createInputBox($doc, 'templatePromotionNameList['.$lineP['mediaID'].']', utf8_decode($lineP['campaignPromotionName']), 'input'));
				// Disable editing of the campaign promotion name field for the meantime.
				$input->setAttribute('readonly', true);

				$i++;
			}
		}

		// Fetch spots.
		$spotStartDate = '';
		$mediaIDList = implode($mediaIDs, ',');
        $queryS = <<<EOQ
            SELECT S.{$this->store->field_spot_mediaID} AS mediaID,
				S.{$this->store->field_spot_dateTime} AS dateTime
			FROM ({$this->store->table_traffic_spot} S)
			WHERE S.{$this->store->field_spot_mediaID} IN ($mediaIDList)
			ORDER BY dateTime
EOQ;
		$resultS = sysdb::query($queryS);
		$spotCount = sysdb::num_rows($resultS);

		$scheduleList = array();
		if ($spotCount > 0) {
			// Fetch first spot in schedule for display.
			$scheduleDates = sysdb::query2vector($queryS, 'dateTime');
			$scheduleStartDate = $scheduleDates[0];
			$scheduleStartDateArray = explode('-', date("Y-m-d", strtotime($scheduleStartDate)));
			// Fetch last spot in schedule for display.
			$scheduleDates = array_reverse($scheduleDates);
			$scheduleEndDateArray = explode('-', date("Y-m-d", strtotime($scheduleDates[0])));

			// Process spot details.
			while ($lineS = sysdb::fetch_assoc($resultS)) {
				$scheduleList[$lineS['mediaID']][] = $lineS['dateTime'];
			}
		} else {
			// No spots, therefore no range. Use contract range instead.
			$scheduleStartDate = $oldContractStartDate;
			$scheduleStartDateArray = explode('-', $oldContractStartDate);
			$scheduleEndDateArray = explode('-', $oldContractEndDate);
		}

		// Fetch promotion spots.
		$promoMediaIDs = array();
		$promoStartDate = '';
		$promoMediaIDList = implode($promoMediaIDs, ',');
        $queryP = <<<EOQ
            SELECT S.{$this->store->field_spot_mediaID} AS mediaID,
				S.{$this->store->field_spot_dateTime} AS dateTime
			FROM ({$this->store->table_traffic_spot} S)
			INNER JOIN {$this->store->table_traffic_campaignpromotion} P
			ON S.{$this->store->field_spot_mediaID} = P.{$this->store->field_campaignpromotion_mediaID}
			WHERE P.{$this->store->field_campaignpromotion_contractID} = '$id'
			ORDER BY dateTime
EOQ;
		$resultP = sysdb::query($queryP);
		$promoCount = sysdb::num_rows($resultP);

		$promoList = array();
		if ($promoCount > 0) {
			// Fetch first spot in promotion schedule for display.
			$promoDates = sysdb::query2vector($queryP, 'dateTime');
			$promoStartDate = $promoDates[0];
			$promoStartDateArray = explode('-', $promoStartDate);
			// Fetch last spot in promotion schedule for display.
			$promoDates = array_reverse($promoDates);
			$promoEndDateArray = explode('-', $promoDates[0]);

			// Process spot details.
			while ($lineP = sysdb::fetch_assoc($resultP)) {
				$promoList[$lineP['mediaID']][] = $lineP['dateTime'];
			}
		} else {
			// No spots, therefore no range. Use contract range instead.
			$promoStartDate = $oldContractStartDate;
			$promoStartDateArray = explode('-', $oldContractStartDate);
			$promoEndDateArray = explode('-', $oldContractEndDate);
		}

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Spot Count'));
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->appendChild($label = $doc->createTextNode($spotCount));

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		$labeltd->appendChild($label = $doc->createTextNode('Promotion Spot Count'));
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->appendChild($label = $doc->createTextNode($promoCount));

		// Schedule start and end dates.
		$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleStartYear', $scheduleStartDateArray[0], 'hidden'));
		$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleStartMonth', $scheduleStartDateArray[1], 'hidden'));
		$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleStartDay', $scheduleStartDateArray[2], 'hidden'));

		$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleEndYear', $scheduleEndDateArray[0], 'hidden'));
		$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleEndMonth', $scheduleEndDateArray[1], 'hidden'));
		$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleEndDay', $scheduleEndDateArray[2], 'hidden'));

		$container->appendChild($subheader = $doc->createElement('h2'));
		$subheader->appendChild($doc->createTextNode('Select start date for new contract:'));

		$container->appendChild($table = $doc->createElement('table'));
		$table->setAttribute('class', 'view');

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		if ($spotCount > 0) {
			$labeltd->appendChild($label = $doc->createTextNode('Original schedule start date'));
		} else {
			$labeltd->appendChild($label = $doc->createTextNode('Original contract start date'));
		}
		$tr->appendChild($inputtd = $doc->createElement('td'));
		$inputtd->appendChild($label = $doc->createTextNode(date("l, jS F Y", strtotime($scheduleStartDate))));

		$table->appendChild($tr = $doc->createElement('tr'));
		$tr->appendChild($labeltd = $doc->createElement('th'));
		if ($spotCount > 0) {
			$labeltd->appendChild($label = $doc->createTextNode('New schedule start date *'));
		} else {
			$labeltd->appendChild($label = $doc->createTextNode('New contract start date *'));
		}
		$tr->appendChild($inputtd = $doc->createElement('td'));
        WriteDateSelect_dom($doc, $inputtd, 'templateStart', date('Y') - 3, date('Y') + 2, '', $startDateArray[0], $startDateArray[1], $startDateArray[2], 'd-m-Y');

        $table->appendChild($clonetr = $doc->createElement('tr'));
		$clonetr->appendChild($labeltd = $doc->createElement('th'));
        $clonetr->appendChild($clonetd = $doc->createElement('td'));
		$clonetd->setAttribute('class', 'right');
        $clonetd->appendChild($clone = $doc->createElement('input'));
        $clone->setAttribute('type', 'submit');
        $clone->setAttribute('name', 'action');
        $clone->setAttribute('value', 'clone');

		$container->appendChild($table);

		// Arrange campaign details to the cloned.
		if (is_array($campaignList)) {
			foreach ($campaignList as $key => $campaign) {
				foreach ($campaign as $object => $objectList) {
					if (is_array($objectList)) {
						foreach ($objectList as $objectEntity) {
							$container->appendChild($input = dom::createInputBox($doc, 'templateCampaignList['.$key.']['.$object.'][]', $objectEntity, 'hidden'));
						}
					} else {
						// Unexpected format of campaignList, unless blank.
					}
				}
			}
		}

		// Arrange campaign audio details to the cloned.
		if (is_array($scheduleList)) {
			foreach ($scheduleList as $key => $schedule) {
				if (is_array($schedule)) {
					foreach ($schedule as $spot) {
						$container->appendChild($input = dom::createInputBox($doc, 'templateScheduleList['.$key.'][]', $spot, 'hidden'));
					}
				} else {
					// Unexpected format of scheduleList, unless blank.
				}
			}
		}

		// Arrange promotion details to the cloned.
		if (is_array($promoList)) {
			foreach ($promoList as $key => $promoSchedule) {
				if (is_array($promoSchedule)) {
					foreach ($promoSchedule as $spot) {
						$container->appendChild($input = dom::createInputBox($doc, 'templatePromoList['.$key.'][]', $spot, 'hidden'));
					}
				} else {
					// Unexpected format of promoList, unless blank.
				}
			}
		}
        return($container);
    }

    public function add($contractID,
						$clientID,
						$campaignNameList,
						$audioNameList,
						$promoNameList,
						$campaignList,
						$scheduleList,
						$promoList,
						$startYear,
						$startMonth,
						$startDay,
						$scheduleStartYear,
						$scheduleStartMonth,
						$scheduleStartDay,
						$scheduleEndYear,
						$scheduleEndMonth,
						$scheduleEndDay
						) {

		$success = false;
		$item = globalize('item', get_class($this));

		if (!is_array($campaignNameList)
			&& !is_array($audioNameList)
			&& !is_array($promoNameList)
			&& !is_array($campaignList)
			&& !is_array($promoList)
			&& !is_array($scheduleList)) {
			// Unexpected format of arrays. An error occurred.
			$success = false;
			state::setMessage('error', 'An  error occurred. Contract could not be cloned.');
			state::setMessage('debug', 'Unexpected format of arrays. An error occurred.');
			module::forward_to_script('', array('item' => 'Contract', 'action' => 'view', 'id' => $contractID));
		} else {
			// Select original contract's details.
			$query = <<<EOQ
				SELECT {$this->store->field_contract_price} AS price,
					{$this->store->field_contract_stationPresentsStatus} AS stationPresentsStatus,
					{$this->store->field_contract_audioPurchased} AS audioPurchased,
					{$this->store->field_contract_spotsPurchased} AS spotsPurchased,
					{$this->store->field_contract_services} AS services
				FROM {$this->store->table_traffic_contract}
				WHERE {$this->store->field_contract_contractID} = '$contractID'
EOQ;
			$result = sysdb::query($query);

			if (sysdb::num_rows($result) > 0) {
				// Process contract.
				while ($line = sysdb::fetch_assoc($result)) {

					// Calculate current time.
					$createdDateTime = date("Y-m-d H:i:s");

					// Calculate end date.
					$newStartDate = date("Y-m-d", strtotime($startYear.'-'.$startMonth.'-'.$startDay));
					$oldStartDate = date("Y-m-d", strtotime($scheduleStartYear.'-'.$scheduleStartMonth.'-'.$scheduleStartDay));
					$oldEndDate = date("Y-m-d", strtotime($scheduleEndYear.'-'.$scheduleEndMonth.'-'.$scheduleEndDay));
					$dateRangeDiff = Defer::date_diff($oldStartDate, $oldEndDate);
					$newEndDate = date('Y-m-d', strtotime('+'.$dateRangeDiff.' day', strtotime($newStartDate)));
					$endDateArray = explode('-', $newEndDate);
					$endYear = $endDateArray[0];
					$endMonth = $endDateArray[1];
					$endDay = $endDateArray[2];

					// Calculate absolute date offset between old and new start date.
					$dateOffsetDiff = Defer::date_diff($oldStartDate, $newStartDate);

					// Add new contract with cloned details.
					Contract::add($createdDateTime,
									$startYear,
									$startMonth,
									$startDay,
									$endYear,
									$endMonth,
									$endDay,
									'Proposed',
									$line['price'],
									$line['stationPresentsStatus'],
									$line['audioPurchased'],
									$line['spotsPurchased'],
									$line['services'],
									'',
									$clientID,
									array(),
									array(),
									''
									);

					// Fetch newly inserted contract ID.
					$query = <<<EOQ
						SELECT {$this->store->field_contract_contractID}
						FROM {$this->store->table_traffic_contract}
						WHERE {$this->store->field_contract_createdDateTime} = '$createdDateTime'
						AND {$this->store->field_contract_clientID} = '$clientID'
EOQ;
					$id = sysdb::queryOne($query);

					// Check to see if a default duration is set as a module parameter.
					global $module_parameter;
					if (isset($module_parameter['durationDefault'])) {
						$duration = $module_parameter['durationDefault'];
					} else {
						$duration = '';
					}

					// Check to see if a default audio status as Approved is set as a module parameter.
					if (isset($module_parameter['defaultStatusApproved']) && $module_parameter['defaultStatusApproved'] == '1') {
						$defaultAudioStatus = 'Approved';
					} else {
						$defaultAudioStatus = 'Pending Draft Approval';
					}

					// Check to see if a deadline date buffer is set as a module parameter.
					if (isset($module_parameter['deadlineDateBuffer'])) {
						$deadlineDateBuffer = $module_parameter['deadlineDateBuffer'];
					} else {
						$deadlineDateBuffer = 0;
					}
					// Calculate deadline date.
					$deadlineDate = date("Y-m-d", strtotime($deadlineDateBuffer.' days', strtotime($startYear.'-'.$startMonth.'-'.$startDay)));
					$deadlineDateArray = explode('-', $deadlineDate);

					// Process campaigns.
					foreach ($campaignList as $campaignID => $objects) {
						// Fetch campaign name.
						$campaignName = utf8_decode($campaignNameList[$campaignID]);

						// Recalculate current time.
						$createdDateTime = date("Y-m-d H:i:s");

						// Fetch the original cloned campaign's audio and spots allotted.
						$query = <<<EOQ
							SELECT {$this->store->field_campaign_audioAllotted} AS audioAllotted,
								{$this->store->field_campaign_spotsAllotted} AS spotsAllotted
							FROM {$this->store->table_traffic_campaign}
							WHERE {$this->store->field_campaign_campaignID} = '$campaignID'
EOQ;
						$audioAllotted = sysdb::query2vector($query, 'audioAllotted');
						$spotsAllotted = sysdb::query2vector($query, 'spotsAllotted');

						// Add new campaigns with cloned details.
						Campaign::add($startYear,
										$startMonth,
										$startDay,
										$endYear,
										$endMonth,
										$endDay,
										$createdDateTime,
										$campaignName,
										$audioAllotted[0],
										$spotsAllotted[0],
										$id,
										array(),
										'',
										''
										);
						// Record the new and old campaign IDs.
						$query = <<<EOQ
							SELECT {$this->store->field_campaign_campaignID}
							FROM {$this->store->table_traffic_campaign}
							WHERE {$this->store->field_campaign_contractID} = '$id'
							AND {$this->store->field_campaign_name} = '$campaignName'
							AND {$this->store->field_campaign_createdDateTime} = '$createdDateTime'
EOQ;
						$campaignIDList[$campaignID] = sysdb::queryOne($query);

						// Process campaign audio.
						foreach ($objects['A'] as $mediaID) {
							// Fetch campaign audio name.
							$audioName = $audioNameList[$mediaID];

							// Fetch campaign ID.
							$newCampaignID = $campaignIDList[$campaignID];

							// Recalculate current time.
							$createdDateTime = date("Y-m-d H:i:s");

							// Assumes duration is the same as default duration.

							// Add new campaigns with cloned details.
							CampaignAudio::add($audioName,
											$defaultAudioStatus,
											'',
											$duration,
											'Unspecified',
											$startYear,
											$startMonth,
											$startDay,
											$endYear,
											$endMonth,
											$endDay,
											$deadlineDateArray[0],
											$deadlineDateArray[1],
											$deadlineDateArray[2],
											$createdDateTime,
											'',
											'',
											$newCampaignID,
											'',
											'',
											array(),
											'',
											'',
											'',
											'',
											'',
											'',
											'',
											array(),
											'',
											'',
											'',
											'',
											'',
											'',
											'',
											'',
											'',
											''
											);

							// Record the new and old campaign audio IDs.
							$query = <<<EOQ
								SELECT {$this->store->field_campaignaudio_mediaID}
								FROM {$this->store->table_traffic_campaignaudio}
								WHERE {$this->store->field_campaignaudio_campaignID} = '$newCampaignID'
								AND {$this->store->field_campaignaudio_name} = '$audioName'
								AND {$this->store->field_campaignaudio_createdDateTime} = '$createdDateTime'
EOQ;
							$audioIDList[$mediaID] = sysdb::queryOne($query);
						}

						// Process promotions.
						foreach ($objects['P'] as $mediaID) {
							// Fetch campaign audio name.
							$promoName = $promoNameList[$mediaID];

							// Fetch campaign ID.
							$newCampaignID = $campaignIDList[$campaignID];

							// Recalculate current time.
							$createdDateTime = date("Y-m-d H:i:s");

							// Add new campaigns with cloned details.
							CampaignPromotion::add($promoName,
											'',
											$newCampaignID,
											'',
											''
											);

							// Record the new and old campaign audio IDs.
							$query = <<<EOQ
								SELECT {$this->store->field_campaignpromotion_mediaID}
								FROM {$this->store->table_traffic_campaignpromotion}
								WHERE {$this->store->field_campaignpromotion_campaignID} = '$newCampaignID'
								AND {$this->store->field_campaignpromotion_name} = '$promoName'
EOQ;
							$promoIDList[$mediaID] = sysdb::queryOne($query);
						}
					}

					// Create the new schedule for the newly created campaign.
					foreach ($scheduleList as $mediaID => $schedule) {
						if (isset($audioIDList[$mediaID])) {
							// Fetch new media ID.
							$newAudioID = $audioIDList[$mediaID];

							// Modify the spot date by the date offset.
							foreach ($schedule as $dateTime) {
								$scheduleDateTimeList[] = date('Y-m-d H:i:s', strtotime('+'.$dateOffsetDiff.' day', strtotime($dateTime)));
							}

							// Create a companion array containing the mediaID.
							$scheduleMediaList = array_fill(0, sizeof($schedule), $newAudioID);

							// Add spots.
							Spot::add_many($scheduleMediaList, $scheduleDateTimeList);
							unset($scheduleMediaList);
							unset($scheduleDateTimeList);
						}
					}

					// Create the new promotion schedule for the newly created campaign.
					foreach ($promoList as $mediaID => $promoSchedule) {
						if (isset($promoList[$mediaID])) {
							// Fetch new media ID.
							$newPromoID = $promoIDList[$mediaID];

							// Modify the spot date by the date offset.
							foreach ($promoSchedule as $dateTime) {
								$promoDateTimeList[] = date('Y-m-d H:i:s', strtotime('+'.$dateOffsetDiff.' day', strtotime($dateTime)));
							}

							// Create a companion array containing the mediaID.
							$promoMediaList = array_fill(0, sizeof($promoSchedule), $newPromoID);

							// Add spots.
							Spot::add_many($promoMediaList, $promoDateTimeList);
							unset($promoMediaList);
							unset($promoDateTimeList);
						}
					}
				}
				state::setMessage('notify', 'Successfully cloned contract.');
				state::setMessage('warning', 'Please verify all contract, campaign, campaign audio and schedule details.');
			} else {
				// Cannot find original contract. An error occurred.
				$success = false;
			}
			if ($item == 'Template') {
				module::forward_to_script('', array('item' => 'Contract', 'action' => 'edit', 'id' => $id));
			}
		}
	}

}
?>