<?php
// $Id$

    function getModuleParameters() {
        $required=array(
            'mediaStoreModule'=>'boolean',
            'shareScheduleClass'=>'boolean',
            'contractNamePrefix'=>'text',
            'contractNameDigits'=>'integer',
            'gstEnabled'=>'boolean',
            'gstPercentage'=>'integer',
            'maxTimePerHour'=>'integer',
            'disableRoleSAM'=>'boolean'
        );
        $optional=array(
            'viewClient'=>'boolean',
            'addClient'=>'boolean',
            'editClient'=>'boolean',
            'adminClient'=>'boolean',
            'viewContract'=>'boolean',
            'addContract'=>'boolean',
            'editContract'=>'boolean',
            'adminContract'=>'boolean',
            'viewCampaign'=>'boolean',
            'addCampaign'=>'boolean',
            'editCampaign'=>'boolean',
            'adminCampaign'=>'boolean',
            'viewCampaignAudio'=>'boolean',
            'addCampaignAudio'=>'boolean',
            'editCampaignAudio'=>'boolean',
            'adminCampaignAudio'=>'boolean',
            'adminSchedule'=>'boolean',
            'viewProduction'=>'boolean',
            'addProduction'=>'boolean',
            'editProduction'=>'boolean',
            'adminProduction'=>'boolean',
            'durationDefault'=>'integer',
            'deadlineDateBuffer'=>'integer',
            'defaultStatusApproved'=>'integer'
        );
        $defaults=array(
            'testTime'=>'false',
            'shareScheduleClass'=>'1',
            'contractNamePrefix'=>'INV',
            'contractNameDigits'=>'6',
            'gstEnabled'=>'1',
            'gstPercentage'=>'10',
            'durationDefault'=>'30',
            'deadlineDateBuffer'=>'-7',
            'defaultStatusApproved'=>'0',
            'maxTimePerHour'=>'300',
            'disableRoleSAM'=>'0',
            'mediaStoreModule'=>'0',
            'viewClient'=>'1',
            'addClient'=>'1',
            'editClient'=>'1',
            'adminClient'=>'1',
            'viewContract'=>'1',
            'addContract'=>'1',
            'editContract'=>'1',
            'adminContract'=>'1',
            'viewCampaign'=>'1',
            'addCampaign'=>'1',
            'editCampaign'=>'1',
            'adminCampaign'=>'1',
            'viewCampaignAudio'=>'1',
            'addCampaignAudio'=>'1',
            'editCampaignAudio'=>'1',
            'adminCampaignAudio'=>'1',
            'adminSchedule'=>'1',
            'viewProduction'=>'1',
            'addProduction'=>'1',
            'editProduction'=>'1',
            'adminProduction'=>'1'
        );
        return(array('required'=>$required,'optional'=>$optional,'defaults'=>$defaults));
    }

	function setModuleParameter($name,$value) {
		global $module_parameter;
		//echo 'Set parameter '.$name.' to '.$value;
		if (!isset($module_parameter)) $module_parameter = array();
		$module_parameter[$name] = $value;
	}

   /**
    * Checks to see if an actor has details, and if not it creates them trying to fabricate names out of the user login details.
	*
	* @param $actorID
	*   Actor identifier.
	*
	* @return
	*   Returns TRUE if false details were ascribed to the actor. Otherwise returns FALSE.
	*/
	function createFalseActorDetail($actorID) {
		$store = new storage();

		// Check to see if actor has details, and if not create them.
		$lacking_detail = create_actor_detail($actorID);
		if ($lacking_detail) {
			// Because we are converting system users into traffic roles, we can try convert usernames to details.
			$query = <<<EOQ
				SELECT {$store->field_user_login} AS {$store->field_user_login},
					{$store->field_user_name} AS {$store->field_user_name},
					{$store->field_user_email} AS {$store->field_user_email}
				FROM {$store->table_user}
				WHERE {$store->field_user_actorID} = '$actorID'
EOQ;
			$result = sysdb::query($query);
			if (sysdb::num_rows($result) > 0) {
				$line = sysdb::fetch_assoc($result);
				$login = $line[$store->field_user_login];
				$name = $line[$store->field_user_name];
				$email = $line[$store->field_user_email];

				// Escape values.
				$values = array(&$login,
								&$name,
								&$email
								);
				foreach ($values as &$value) {
					$value = sysdb::escape_string($value);
				}
				unset($value);

				// Try to perform some trickery to fabricate a first & last name.
				if ($name != '') {
					$namePieces = explode(' ', $name, 2);
					$firstName = $namePieces[0];
					$lastName = $namePieces[1];
				} elseif ($login != '') {
					$firstName = $login;
					$lastName = '';
				}
				$query = <<<EOQ
					UPDATE {$store->table_detail}
					SET {$store->field_detail_firstName} = '$firstName',
						{$store->field_detail_lastName} = '$lastName',
						{$store->field_detail_email} = '$email'
					WHERE {$store->field_detail_actorID} = '$actorID'
EOQ;
				sysdb::query($query);
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	/**
	* Turns an Australian landline phone number into a human readable output.
	*/
	function displayLandlineNumber($str) {
		if ($str != '') {
			if (strlen($str) == 8) {
				$output = '';
				$output .= substr($str, 0, 4);
				$output .= ' ';
				$output .= substr($str, 4, 4);
			} elseif (strlen($str) == 10) {
				$output = '';
				$output .= substr($str, 0, 2);
				$output .= ' ';
				$output .= substr($str, 2, 4);
				$output .= ' ';
				$output .= substr($str, 6, 4);
			} elseif (strlen($str) == 12){
				$output = '';
				$output .= substr($str, 0, 3);
				$output .= ' ';
				$output .= substr($str, 3, 1);
				$output .= ' ';
				$output .= substr($str, 4, 4);
				$output .= ' ';
				$output .= substr($str, 8, 4);
			} else {
				$output = $str;
			}
		} else {
			$output = '';
		}
		return ($output);
	}

	/**
	* Turns a mobile phone number into a human readable output.
	*/
	function displayMobileNumber($str) {
		if ($str != '') {
			if (strlen($str) == 10) {
				$output = '';
				$output .= substr($str, 0, 4);
				$output .= ' ';
				$output .= substr($str, 4, 3);
				$output .= ' ';
				$output .= substr($str, 7, 3);
			} elseif (strlen($str) == 12){
				$output = '';
				$output .= substr($str, 0, 3);
				$output .= ' ';
				$output .= substr($str, 3, 3);
				$output .= ' ';
				$output .= substr($str, 6, 3);
				$output .= ' ';
				$output .= substr($str, 9, 3);
			} else {
				$output = $str;
			}
		} else {
			$output = '';
		}
		return ($output);
	}

	/**
	* Turns an Australian business number (ABN) into a human readable output.
	*/
	function displayABN($str) {
		if ($str != '') {
			if (strlen($str) == 11){
				$output = '';
				$output .= substr($str, 0, 2);
				$output .= ' ';
				$output .= substr($str, 2, 3);
				$output .= ' ';
				$output .= substr($str, 5, 3);
				$output .= ' ';
				$output .= substr($str, 8, 3);
			} else {
				$output = $str;
			}
		} else {
			$output = '';
		}
		return ($output);
	}

	function errorHandler($errno, $errstr, $errfile, $errline, $errcontext) {
		$debug = '';
		$user = '';
		switch ($errno) {
			case E_ERROR:
			case E_USER_ERROR:
				$debug .= '<b>ERROR:</b> '.$errno.'; '.$errstr.'; '.$errfile.'; '.$errline.';<br/>';
				$user .= 'An error of type "'.$errno.'" occurred. Cannot proceed.<br/>';
				break;
			case E_WARNING:
			case E_USER_WARNING:
				$debug .= '<b>WARNING:</b>: '.$errno.'; '.$errstr.'; '.$errfile.'; '.$errline.';<br/>';
				break;
			case E_RECOVERABLE_ERROR:
				$debug .= '<b>ERROR:</b>: '.$errno.'; '.$errstr.'; '.$errfile.'; '.$errline.';<br/>';
				$user .= 'An error of type "'.$errno.'" occurred. Cannot proceed.<br/>';
				break;
			default:
				break;
		}
		if ($debug != '') {
			state::setMessage('debug', $debug);
		}
		if ($user != '') {
			state::setMessage('error', $user);
		}
	}

	/**
	* Turns an integer into a character designation. eg. 1 returns A, 2 returns B, 27 returns AA.
	*/
    function toAlphabet($number) {
        $char = '';
        while($number >= 1) {
            $number = $number - 1;
            $char = chr(($number % 26) + 65).$char;
            $number = $number / 26;
        }
        return $char;
    }

?>