<?php
// $Id$

include_once('global.php');
include_once('moduleconfig.php');
require_once('datecontrol.php');
require_once('sendemails.php');

// if (module::component_hook('debug', 'log')) {
	// module::component_invoke('debug', 'log');
// }

if (!isset($module_parameter)) $module_parameter = array();

function __autoload($class_name) {
    require_once $class_name . '.php';
}

$g = array('item','action','id','traffic_search','traffic_search_action',
           'relationship_action'=>'r_action');
extract(globalize_many($g));


$class = run_item_actions($item);

if ( globalize('terminate') == 'true' )
	exit;

if ($r_action != '') {
    foreach($r_action as $name=>$value) {
        $r_class = new $name();
        $r_class->actions();
    }
}

$accessClient = array('viewClient', 'addClient', 'editClient',
					  'adminClient', 'viewContract', 'addContract'.
					  'editContract', 'adminContract');
$accessContract = $accessClient;
$accessClientRep = $accessClient;
// Check to see if disabling of SAM role is set as a module parameter.
if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == '0') {
	$accessSAM = $accessClient;
} else {
	$accessSAM = '';
}
$accessSalesRep = $accessClient;
$accessProducer = $accessClient;
$accessProductType = $accessClient;
$accessSector = $accessClient;
$accessCampaignMaterial = $accessClient;
$accessCampaignPromotion = $accessClient;
$accessEmail = $accessClient;
$accessTalent = $accessClient;
$accessFeedback = $accessClient;
$accessLog = $accessClient;
$accessXML = $accessClient;

$accessCampaign = array('viewCampaign', 'addCampaign', 'editCampaign',
                        'adminCampaign');
$accessSlot = $accessCampaign;

$accessCampaignAudio = array('viewCampaignAudio', 'editCampaignAudio',
                             'addCampaignAudio', 'adminCampaignAudio');

// $accessCampaignMaterial = array('viewCampaignMaterial', 'editCampaignMaterial',
								// 'addCampaignMaterial', 'adminCampaignMaterial');

$accessTraffic = array('adminSchedule');

/* Changing the order of the $access array will change the order of
   the submenu menu items - CH */

$access = array(
	'Client' => $accessClient,
	'Contract' => $accessContract,
	'Campaign' => $accessCampaign,
	'CampaignAudio' => $accessCampaignAudio,
	'CampaignMaterial' => $accessCampaignMaterial,
	'CampaignPromotion' => $accessCampaignPromotion,
	'Traffic' => $accessTraffic,
	'Schedule' => $accessTraffic,
	'Deadlines' => $accessTraffic,
	'Log' => $accessLog,
	'ClientRep' => $accessClientRep,
	'Producer' => $accessProducer,
	'SAM' => $accessSAM,
	'SalesRep' => $accessSalesRep,
	'Talent' => $accessTalent,
	'Template' => $accessClient,
	'Defer' => $accessClient,
	'ProductType' => $accessProductType,
	'Sector' => $accessSector,
	'Slot' => $accessSlot,
	'ContractXML' => $accessXML,
	'Feedback' => $accessFeedback
	);

$menu_labels = array(
	'Client'=>'Clients',
	'Campaign'=>'Campaigns',
	'CampaignAudio'=>'Campaign Audio',
	'Traffic'=>'Traffic',
	'Log'=>'Logs',
	'ClientRep'=>'Client Reps',
	'Producer'=>'Producers',
	'SAM'=>'SAMs',
	'SalesRep'=>'Sales Reps',
	'Talent'=>'Talent',
	'ProductType'=>'Product Types',
	'Sector'=>'Sectors',
	'Slot'=>'Slots',
	'Deadlines'=>'Deadlines',
	'Feedback'=>'Feedback'
	);

// Check to see if disabling of SAM role is set as a module parameter.
if (isset($module_parameter['disableRoleSAM']) && $module_parameter['disableRoleSAM'] == '0') {
	$global_search_items = array(
		'Client',
		'Contract',
		'Campaign',
		'CampaignAudio',
		'ClientRep',
		'Talent',
		'SalesRep',
		'SAM',
		'Sector',
		'ProductType'
		);
} else {
	$global_search_items = array(
		'Client',
		'Contract',
		'Campaign',
		'CampaignAudio',
		'ClientRep',
		'Talent',
		'SalesRep',
		'Sector',
		'ProductType'
		);
}


/* ==== Access Control ==== */

$menu_items['Module Home'] = array('item'=>'');
$acl = module::parameter_table($module_parameter, $access, 0);
foreach($acl as $key=>$val) {
   if(($val) AND (isset($menu_labels[$key])) ) {
      $menu_items[$menu_labels[$key]] = array('item'=>$key);
	}
}


/* ==== Begin GUI/Interface Code ==== */
$doc = new DOMDocument();
//$doc->substituteEntities = false;
$doc->formatOutput = true;

$highlight = '';
$i=0;
foreach($menu_items as $key=>$val) {
	if($val['item'] == $item) {
		$highlight=$i;
	}
	$i++;
}

$doc->appendChild(dom::createMenu($doc,$menu_items,'component_menu',$highlight));

if((isset($traffic_search_action)) AND ($traffic_search_action=='search')) {  $do='search'; }
if($item!='') { $do='item'; }
if((!isset($do)) OR ($do=='')) { $do='home'; }

$headers = array();
switch($do) {
	/* Do a global search across the component */
	case 'search':
		$doc->appendChild($container = $doc->createElement('div'));
		$container->setAttribute('class','module');

		$container->appendChild($header = $doc->createElement('h1'));
		$header->appendChild($doc->createTextNode('Search Results'));

		$container->appendChild($header = $doc->createElement('h2'));
		$header->appendChild($doc->createTextNode('Results for "'.$traffic_search.'"'));

		foreach($global_search_items as $object) {
			$o_class = new $object();
			if (method_exists($o_class,'search')) {
				// Give each search return a title.
				$container->appendChild($header = $doc->createElement('h2'));
				// Convert class name from upper CamelCase to Title Case.
				$header->appendChild($doc->createTextNode(preg_replace('/([^A-Z])([A-Z])/', "$1 $2", $object)));

				$container->appendChild($o_class->search($doc,$traffic_search));
			}
		}
		break;

    /* Display an Item page */
    case 'item':
		if(!$access[$item]) {
			echo "No Access";
			break;
		}

		if($item=="Traffic" && $action != 'reschedule') {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
			$doc->appendChild($class->displayGridByHour($doc));
			break;
		}

		if($item=="Deadlines") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
			$doc->appendChild($class->displayGridByHour($doc));
			break;
		}


		// TODO: Put these edit ones into a loop of some sort.
		if ($item=="Client" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="Contract" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="Campaign" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="Talent" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="CampaignAudio" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
			// $doc->appendChild($class->form($doc,$id));
			// break;
		}

		if ($item=="Sector" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="ProductType" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if($item=="Traffic" && $action == 'reschedule') {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="CampaignAudio" && ($action=="schedule" || $action=="multi_add")) {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="Campaign" && $action=="schedule") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
		}

		if ($item=="CampaignMaterial" && $action=="edit") {
            if (method_exists($class,'headers')) {
                $objheaders = $class->headers($doc);
                if ($objheaders != null) {
                    if (is_array($objheaders)) {
                        $headers = array_merge($headers,$objheaders);
                    } else
                        $headers[] = $objheaders;
                }
            }
			$doc->appendChild($class->form($doc,$id));
			break;
		}

		if ($item=="LegacyTraffic" && $action != "select times") {
			$doc->appendChild($class->display_list($doc,$id));
			break;
		}

		if ($item=="ContractXML" && $action == "getContractSVG") {
			$class = new ContractXML();
			$svg = $class->getContractSVG($id);
			echo $svg;
			break;
		}

		$form = module::form_dom($doc);

		$iteminput = $doc->createElement('input');
		$iteminput->setAttribute('type','hidden');
		$iteminput->setAttribute('name','item');
		$iteminput->setAttribute('value',$item);
		$form->appendChild($iteminput);

		if ($action == 'edit') $form->appendChild($class->form($doc,$id));
		else if ($action == 'remove') $form->appendChild($class->form($doc,$id));
		else if ($action == 'multi_add') $form->appendChild($class->form_multi($doc,$id));
		else if ($action == 'view') $form->appendChild($class->view($doc,$id));
		else if ($action == 'select times') $form->appendChild($class->display_grid($doc,$id));
		else if ($action == 'select dates') $form->appendChild($class->display_logs($doc,$id));
		else if ($action == 'schedule') $form->appendChild($class->schedule($doc,$id));
		else if ($action == 'reschedule') $form->appendChild($class->reschedule($doc,$id));
		else if ($action == 'inline_add') $form->appendChild($class->inline_add($doc,$id));
		else $form->appendChild($class->overview($doc));
		$doc->appendChild($form);

		break;

    /* Display "Home" page */
    case 'home':
		$h1 = $doc->createElement('h1');
		$text = $doc->createTextNode('Sponsorship & Traffic Overview');
		$h1->appendChild($text);
        $doc->appendChild($h1);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$text = $doc->createTextNode('Clients negotiate a Contract with the station. Contracts are fulfilled through Campaigns. Campaigns may contain multiple Audio pieces.');
		$p->appendChild($text);
		$doc->appendChild($p);

		$br = $doc->createElement('br');
        $doc->appendChild($br);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$p->setAttribute('size','smaller');
		$text = $doc->createTextNode('Audio is then scheduled into one or more time slots as Spots. The distribution of these spots across a calendar is the Traffic grid.');
		$p->appendChild($text);
		$doc->appendChild($p);

		$br = $doc->createElement('br');
        $doc->appendChild($br);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$p->setAttribute('size','smaller');
		$text = $doc->createTextNode('Campaigns may also have extra Materials attached to them such as scripts or sound effects to aid in production.');
		$p->appendChild($text);
		$doc->appendChild($p);

		$br = $doc->createElement('br');
        $doc->appendChild($br);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$p->setAttribute('size','smaller');
		$text = $doc->createTextNode('The Search function at the top right will quickly return results to find things quickly.');
		$p->appendChild($text);
		$doc->appendChild($p);

		$br = $doc->createElement('br');
        $doc->appendChild($br);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small');
		$text = $doc->createTextNode('There are various roles for individuals, and each Client, Contract, Campaign and Audio can be assigned to these roles.');
		$p->appendChild($text);
		$doc->appendChild($p);

		$br = $doc->createElement('br');
        $doc->appendChild($br);

		$p = $doc->createElement('p');
		$p->setAttribute('style','text-align: left; font-size: small; padding: 3px');
//		$p->setAttribute('class','warning');
		$text = $doc->createTextNode('Get started by clicking "Traffic" on the left hand menu.');
		$p->appendChild($text);
        $doc->appendChild($p);



			// $p = $doc->createElement('p');
			// $p->setAttribute('style','text-align: left');
			// if ($module_parameter['viewClient'] == '1') {
				// $text = $doc->createTextNode('This is the main landing page, where we need to include plugins
										   // for the viewClient parameter.');
			// } elseif ($module_parameter['viewCampaign'] == '1') {
				// $v = $doc->createTextNode('This is the main landing page, where we need to include plugins
										   // for the viewCampaign parameter.');
			// } elseif ($module_parameter['viewCampaignAudio'] == '1') {
				// $text = $doc->createTextNode('This is the main landing page, where we need to include plugins
										   // for the viewCampaignAudio parameter.');
			// } elseif ($module_parameter['adminSchedule'] == '1') {
				// $text = $doc->createTextNode('This is the main landing page, where we need to include plugins
										   // for the adminSchedule parameter.');
			// }
			// $p->appendChild($text);

      //  $doc->appendChild($p);
}

//Convert headers to text.
//Stupid way to do it but the only way I could think of.
$headerstr = '<script language="javascript" src="'.WWWROOT.'stylesheet.php?moduleID='.$moduleID.'&file=SearchBox.js"></script>';
/* Add searchbox javascript */
$headerdoc = new DOMDocument();
$script1 = $doc->createElement('script');
$script1->setAttribute('language', 'javascript');
$script1->setAttribute('src', WWWROOT."stylesheet.php?moduleID=".$moduleID."&file=Traffic.js");
$script1->appendChild($doc->createTextNode(''));
foreach($headers as $header) {
    $headerdoc = new DOMDocument();
    $importedNode = $headerdoc->importNode($header,true);
    $headerdoc->appendChild($importedNode);
    $headerstr .= $headerdoc->saveHTML();
}

$page = new page('',$headerstr);
$page->header();
echo $doc->saveXML();
$page->footer();
?>
