<?php
// $Id$

/**
 * Extends the core storage class to contain parameters specific to this component.
 */
class trafficStorage extends storage {

	/**
	 * Automatically loads core and component storage parameters.
	 */
	public function __construct() {
		// Loads up core storage tables and fields.
		parent::__construct();

		// Define names of the table(s) and fields storing data for this component.

		$this->table_traffic_campaign = TABLE_PREFIX.'traffic_campaign';
		$this->field_campaign_campaignID = 'campaignID';
		$this->field_campaign_name = 'name';
		$this->field_campaign_createdDateTime = 'createdDateTime';
		$this->field_campaign_startDate = 'startDate';
		$this->field_campaign_endDate = 'endDate';
		$this->field_campaign_audioAllotted = 'audioAllotted';
		$this->field_campaign_spotsAllotted = 'spotsAllotted';
		$this->field_campaign_contractID = 'contractID';
		$this->field_campaign_clientID = 'clientID';
		$this->field_campaign_userID = 'userID'; // Deprecated 2010-06-21.

		$this->table_traffic_campaignaudio = TABLE_PREFIX.'traffic_campaignaudio';
		$this->field_campaignaudio_campaignAudioID = 'campaignAudioID';
		$this->field_campaignaudio_mediaID = 'mediaID';
		$this->field_campaignaudio_name = 'name';
		$this->field_campaignaudio_createdDateTime = 'createdDateTime';
		$this->field_campaignaudio_description = 'description';
		$this->field_campaignaudio_filename = 'filename';
		$this->field_campaignaudio_mimetype = 'mimetype';
		$this->field_campaignaudio_duration = 'duration';
		$this->field_campaignaudio_productionStatus = 'productionStatus';
		$this->field_campaignaudio_data = 'data';
		$this->field_campaignaudio_talentGender = 'talentGender';
		$this->field_campaignaudio_startDate = 'startDate';
		$this->field_campaignaudio_endDate = 'endDate';
		$this->field_campaignaudio_deadlineDate = 'deadlineDate';
		$this->field_campaignaudio_campaignID = 'campaignID';
		$this->field_campaignaudio_contractID = 'contractID';
		$this->field_campaignaudio_clientID = 'clientID';
		$this->field_campaignaudio_userID = 'userID'; // Deprecated 2010-06-21.
		$this->field_campaignaudio_producerID = 'producerID';

		$this->table_traffic_campaignaudioproducttype = TABLE_PREFIX.'traffic_campaignaudioproducttype';
		$this->field_campaignaudioproducttype_campaignAudioID = 'campaignAudioID';
		$this->field_campaignaudioproducttype_campaignID = 'campaignID';
		$this->field_campaignaudioproducttype_contractID = 'contractID';
		$this->field_campaignaudioproducttype_clientID = 'clientID';
		$this->field_campaignaudioproducttype_productTypeID = 'productTypeID';

		$this->table_traffic_campaignaudiotalent = TABLE_PREFIX.'traffic_campaignaudiotalent';
		$this->field_campaignaudiotalent_campaignAudioID = 'campaignAudioID';
		$this->field_campaignaudiotalent_talentID = 'talentID';

		$this->table_traffic_campaignmaterial = TABLE_PREFIX.'traffic_campaignmaterial';
		$this->field_campaignmaterial_campaignMaterialID = 'campaignMaterialID';
		$this->field_campaignmaterial_mediaID = 'mediaID';
		$this->field_campaignmaterial_name = 'name';
		$this->field_campaignmaterial_description = 'description';
		$this->field_campaignmaterial_filename = 'filename';
		$this->field_campaignmaterial_mimetype = 'mimetype';
		$this->field_campaignmaterial_campaignID = 'campaignID';
		$this->field_campaignmaterial_contractID = 'contractID';
		$this->field_campaignmaterial_clientID = 'clientID';

		$this->table_traffic_campaignpromotion = TABLE_PREFIX.'traffic_campaignpromotion';
		$this->field_campaignpromotion_campaignPromotionID = 'campaignPromotionID';
		$this->field_campaignpromotion_mediaID = 'mediaID';
		$this->field_campaignpromotion_name = 'name';
		$this->field_campaignpromotion_description = 'description';
		$this->field_campaignpromotion_filename = 'filename';
		$this->field_campaignpromotion_mimetype = 'mimetype';
		$this->field_campaignpromotion_campaignID = 'campaignID';
		$this->field_campaignpromotion_contractID = 'contractID';
		$this->field_campaignpromotion_clientID = 'clientID';

		$this->table_traffic_campaignsam = TABLE_PREFIX.'traffic_campaignsam'; // This field deprecated by campaignassign. Deprecated 2010-06-21.
		$this->field_campaignsam_campaignID = 'campaignID'; // This field deprecated by campaignassign. Deprecated 2010-06-21.
		$this->field_campaignsam_clientID = 'samID'; // This field deprecated by campaignassign. Deprecated 2010-06-21.

		$this->table_traffic_campaignassign = TABLE_PREFIX.'traffic_campaignassign';
		$this->field_campaignassign_campaignID = 'campaignID';
		$this->field_campaignassign_id = 'id';
		$this->field_campaignassign_type = 'type';

		$this->table_traffic_client = TABLE_PREFIX.'traffic_client';
		$this->field_client_clientID = 'clientID';
		$this->field_client_actorID = 'actorID';
		$this->field_client_name = 'name';
		$this->field_client_createdDateTime = 'createdDateTime';
		$this->field_client_abn = 'abn';
		$this->field_client_url = 'url';

		$this->table_traffic_clientclientrep = TABLE_PREFIX.'traffic_clientclientrep';
		$this->field_clientclientrep_clientID = 'clientID';
		$this->field_clientclientrep_clientRepID = 'clientRepID';

		$this->table_traffic_clientrep = TABLE_PREFIX.'traffic_clientrep';
		$this->field_clientrep_clientRepID = 'clientRepID';
		$this->field_clientrep_actorID = 'actorID';

		$this->table_traffic_clientsector = TABLE_PREFIX.'traffic_clientsector';
		$this->field_clientsector_clientID = 'clientID';
		$this->field_clientsector_sectorID = 'sectorID';

		$this->table_traffic_contract = TABLE_PREFIX.'traffic_contract';
		$this->field_contract_contractID = 'contractID';
		$this->field_contract_createdDateTime = 'createdDateTime';
		$this->field_contract_startDate = 'startDate';
		$this->field_contract_endDate = 'endDate';
		$this->field_contract_name = 'name';
		$this->field_contract_contractStatus = 'contractStatus';
		$this->field_contract_stationPresentsStatus = 'stationPresentsStatus';
		$this->field_contract_audioPurchased = 'audioPurchased';
		$this->field_contract_spotsPurchased = 'spotsPurchased';
		$this->field_contract_services = 'services';
		$this->field_contract_notes = 'notes';
		$this->field_contract_price = 'price';
		$this->field_contract_priceGST = 'priceGST';
		$this->field_contract_clientID = 'clientID';
		$this->field_contract_userID = 'userID'; // Deprecated 2010-06-21.

		$this->table_traffic_contractclientrep = TABLE_PREFIX.'traffic_contractclientrep';
		$this->field_contractclientrep_contractID = 'contractID';
		$this->field_contractclientrep_clientRepID = 'clientRepID';

		$this->table_traffic_contractsalesrep = TABLE_PREFIX.'traffic_contractsalesrep';
		$this->field_contractsalesrep_contractID = 'contractID';
		$this->field_contractsalesrep_salesRepID = 'salesRepID';

		$this->table_traffic_feedback = TABLE_PREFIX.'traffic_feedback';
		$this->field_feedback_feedbackID = 'feedbackID';
		$this->field_feedback_name = 'name';
		$this->field_feedback_login = 'login';
		$this->field_feedback_time = 'time';
		$this->field_feedback_message = 'message';

		$this->table_traffic_history = TABLE_PREFIX.'traffic_history';
		$this->field_history_historyID = 'historyID';
		$this->field_history_actorID = 'actorID';
		$this->field_history_timestamp = 'timestamp';
		$this->field_history_id = 'id';
		$this->field_history_type = 'type';
		$this->field_history_action = 'action';
		$this->field_history_details = 'details';

		$this->table_traffic_producer = TABLE_PREFIX.'traffic_producer';
		$this->field_producer_producerID = 'producerID';
		$this->field_producer_actorID = 'actorID';

		$this->table_traffic_producttype = TABLE_PREFIX.'traffic_producttype';
		$this->field_producttype_productTypeID = 'productTypeID';
		$this->field_producttype_name = 'name';
		$this->field_producttype_startDate = 'startDate';
		$this->field_producttype_endDate = 'endDate';

		$this->table_traffic_salesrep = TABLE_PREFIX.'traffic_salesrep';
		$this->field_salesrep_salesRepID = 'salesRepID';
		$this->field_salesrep_actorID = 'actorID';

		$this->table_traffic_sam = TABLE_PREFIX.'traffic_sam';
		$this->field_sam_samID = 'samID';
		$this->field_sam_actorID = 'actorID';

		$this->table_traffic_sector = TABLE_PREFIX.'traffic_sector';
		$this->field_sector_sectorID = 'sectorID';
		$this->field_sector_name = 'name';
		$this->field_sector_startDate = 'startDate';
		$this->field_sector_endDate = 'endDate';

		$this->table_traffic_slot = TABLE_PREFIX.'traffic_slot';
		$this->field_slot_slotID = 'slotID';
		$this->field_slot_startDate = 'startDate';
		$this->field_slot_endDate = 'endDate';
		$this->field_slot_dow = 'dow';
		$this->field_slot_time = 'time';

		$this->table_traffic_spot = TABLE_PREFIX.'traffic_spot';
		$this->field_spot_spotID = 'spotID';
		$this->field_spot_campaignAudioID = 'campaignAudioID'; // Deprecated 2010-06-21.
		$this->field_spot_mediaID = 'mediaID';
		$this->field_spot_dateTime = 'dateTime';
		$this->field_spot_playedDateTime = 'playedDateTime';
		$this->field_spot_priority = 'priority';
		$this->field_spot_inactive = 'inactive';
		$this->field_spot_slotID = 'slotID'; // Deprecated 2010-06-21.

		$this->table_traffic_talent = TABLE_PREFIX.'traffic_talent';
		$this->field_talent_talentID = 'talentID';
		$this->field_talent_actorID = 'actorID';
	}
}
?>