# $Id$

#usage my $store = traffic::Storage->new();
#      print $store->field_campaign_name;
#      print $store->field_actor_actorID;

# /** Extends the core storage class to contain parameters specific to this component. */
package traffic::Storage;

# Specify parent for inheritance.
@ISA = (Retromod::Storage);

# /** Automatically loads core and component storage parameters. */
sub new {
	my $that = shift;
	my $class = ref($that) || $that;

	# Loads up core storage tables and fields.
	my $self = $class->SUPER::new();

	# Define names of the table(s) and fields storing data for this component.

	$self->{table_traffic_campaign} = Retromod::Constant->TABLE_PREFIX."traffic_campaign";
	$self->{field_campaign_campaignID} = "campaignID";
	$self->{field_campaign_name} = "name";
	$self->{field_campaign_createdDateTime} = "createdDateTime";
	$self->{field_campaign_startDate} = "startDate";
	$self->{field_campaign_endDate} = "endDate";
	$self->{field_campaign_audioAllotted} = "audioAllotted";
	$self->{field_campaign_spotsAllotted} = "spotsAllotted";
	$self->{field_campaign_contractID} = "contractID";
	$self->{field_campaign_clientID} = "clientID";
	$self->{field_campaign_userID} = "userID"; # Deprecated 2010-06-21.

	$self->{table_traffic_campaignaudio} = Retromod::Constant->TABLE_PREFIX."traffic_campaignaudio";
	$self->{field_campaignaudio_campaignAudioID} = "campaignAudioID";
	$self->{field_campaignaudio_mediaID} = "mediaID";
	$self->{field_campaignaudio_name} = "name";
	$self->{field_campaignaudio_createdDateTime} = "createdDateTime";
	$self->{field_campaignaudio_description} = "description";
	$self->{field_campaignaudio_filename} = "filename";
	$self->{field_campaignaudio_mimetype} = "mimetype";
	$self->{field_campaignaudio_duration} = "duration";
	$self->{field_campaignaudio_productionStatus} = "productionStatus";
	$self->{field_campaignaudio_data} = "data";
	$self->{field_campaignaudio_talentGender} = "talentGender";
	$self->{field_campaignaudio_startDate} = "startDate";
	$self->{field_campaignaudio_endDate} = "endDate";
	$self->{field_campaignaudio_deadlineDate} = "deadlineDate";
	$self->{field_campaignaudio_campaignID} = "campaignID";
	$self->{field_campaignaudio_contractID} = "contractID";
	$self->{field_campaignaudio_clientID} = "clientID";
	$self->{field_campaignaudio_userID} = "userID"; # Deprecated 2010-06-21.
	$self->{field_campaignaudio_producerID} = "producerID";

	$self->{table_traffic_campaignaudioproducttype} = Retromod::Constant->TABLE_PREFIX."traffic_campaignaudioproducttype";
	$self->{field_campaignaudioproducttype_campaignAudioID} = "campaignAudioID";
	$self->{field_campaignaudioproducttype_campaignID} = "campaignID";
	$self->{field_campaignaudioproducttype_contractID} = "contractID";
	$self->{field_campaignaudioproducttype_clientID} = "clientID";
	$self->{field_campaignaudioproducttype_productTypeID} = "productTypeID";

	$self->{table_traffic_campaignaudiotalent} = Retromod::Constant->TABLE_PREFIX."traffic_campaignaudiotalent";
	$self->{field_campaignaudiotalent_campaignAudioID} = "campaignAudioID";
	$self->{field_campaignaudiotalent_talentID} = "talentID";

	$self->{table_traffic_campaignmaterial} = Retromod::Constant->TABLE_PREFIX."traffic_campaignmaterial";
	$self->{field_campaignmaterial_campaignMaterialID} = "campaignMaterialID";
	$self->{field_campaignmaterial_mediaID} = "mediaID";
	$self->{field_campaignmaterial_name} = "name";
	$self->{field_campaignmaterial_description} = "description";
	$self->{field_campaignmaterial_filename} = "filename";
	$self->{field_campaignmaterial_mimetype} = "mimetype";
	$self->{field_campaignmaterial_campaignID} = "campaignID";
	$self->{field_campaignmaterial_contractID} = "contractID";
	$self->{field_campaignmaterial_clientID} = "clientID";

	$self->{table_traffic_campaignpromotion} = Retromod::Constant->TABLE_PREFIX."traffic_campaignpromotion";
	$self->{field_campaignpromotion_campaignPromotionID} = "campaignPromotionID";
	$self->{field_campaignpromotion_mediaID} = "mediaID";
	$self->{field_campaignpromotion_name} = "name";
	$self->{field_campaignpromotion_description} = "description";
	$self->{field_campaignpromotion_filename} = "filename";
	$self->{field_campaignpromotion_mimetype} = "mimetype";
	$self->{field_campaignpromotion_campaignID} = "campaignID";
	$self->{field_campaignpromotion_contractID} = "contractID";
	$self->{field_campaignpromotion_clientID} = "clientID";

	$self->{table_traffic_campaignassign} = Retromod::Constant->TABLE_PREFIX."traffic_campaignassign";
	$self->{field_campaignassign_campaignID} = "campaignID";
	$self->{field_campaignassign_id} = "id";
	$self->{field_campaignassign_type} = "type";

	$self->{table_traffic_client} = Retromod::Constant->TABLE_PREFIX."traffic_client";
	$self->{field_client_clientID} = "clientID";
	$self->{field_client_actorID} = "actorID";
	$self->{field_client_name} = "name";
	$self->{field_client_createdDateTime} = "createdDateTime";
	$self->{field_client_abn} = "abn";
	$self->{field_client_url} = "url";

	$self->{table_traffic_clientclientrep} = Retromod::Constant->TABLE_PREFIX."traffic_clientclientrep";
	$self->{field_clientclientrep_clientID} = "clientID";
	$self->{field_clientclientrep_clientRepID} = "clientRepID";

	$self->{table_traffic_clientrep} = Retromod::Constant->TABLE_PREFIX."traffic_clientrep";
	$self->{field_clientrep_clientRepID} = "clientRepID";
	$self->{field_clientrep_actorID} = "actorID";

	$self->{table_traffic_clientsector} = Retromod::Constant->TABLE_PREFIX."traffic_clientsector";
	$self->{field_clientsector_clientID} = "clientID";
	$self->{field_clientsector_sectorID} = "sectorID";

	$self->{table_traffic_contract} = Retromod::Constant->TABLE_PREFIX."traffic_contract";
	$self->{field_contract_contractID} = "contractID";
	$self->{field_contract_createdDateTime} = "createdDateTime";
	$self->{field_contract_startDate} = "startDate";
	$self->{field_contract_endDate} = "endDate";
	$self->{field_contract_name} = "name";
	$self->{field_contract_contractStatus} = "contractStatus";
	$self->{field_contract_stationPresentsStatus} = "stationPresentsStatus";
	$self->{field_contract_audioPurchased} = "audioPurchased";
	$self->{field_contract_spotsPurchased} = "spotsPurchased";
	$self->{field_contract_services} = "services";
	$self->{field_contract_notes} = "notes";
	$self->{field_contract_price} = "price";
	$self->{field_contract_priceGST} = "priceGST";
	$self->{field_contract_clientID} = "clientID";
	$self->{field_contract_userID} = "userID"; # Deprecated 2010-06-21.

	$self->{table_traffic_contractclientrep} = Retromod::Constant->TABLE_PREFIX."traffic_contractclientrep";
	$self->{field_contractclientrep_contractID} = "contractID";
	$self->{field_contractclientrep_clientRepID} = "clientRepID";

	$self->{table_traffic_contractsalesrep} = Retromod::Constant->TABLE_PREFIX."traffic_contractsalesrep";
	$self->{field_contractsalesrep_contractID} = "contractID";
	$self->{field_contractsalesrep_salesRepID} = "salesRepID";

	$self->{table_traffic_feedback} = Retromod::Constant->TABLE_PREFIX."traffic_feedback";
	$self->{field_feedback_feedbackID} = "feedbackID";
	$self->{field_feedback_name} = "name";
	$self->{field_feedback_login} = "login";
	$self->{field_feedback_time} = "time";
	$self->{field_feedback_message} = "message";

	$self->{table_traffic_history} = Retromod::Constant->TABLE_PREFIX."traffic_history";
	$self->{field_history_historyID} = "historyID";
	$self->{field_history_actorID} = "actorID";
	$self->{field_history_timestamp} = "timestamp";
	$self->{field_history_id} = "id";
	$self->{field_history_type} = "type";
	$self->{field_history_action} = "action";
	$self->{field_history_details} = "details";

	$self->{table_traffic_producer} = Retromod::Constant->TABLE_PREFIX."traffic_producer";
	$self->{field_producer_producerID} = "producerID";
	$self->{field_producer_actorID} = "actorID";

	$self->{table_traffic_producttype} = Retromod::Constant->TABLE_PREFIX."traffic_producttype";
	$self->{field_producttype_productTypeID} = "productTypeID";
	$self->{field_producttype_name} = "name";
	$self->{field_producttype_startDate} = "startDate";
	$self->{field_producttype_endDate} = "endDate";

	$self->{table_traffic_salesrep} = Retromod::Constant->TABLE_PREFIX."traffic_salesrep";
	$self->{field_salesrep_salesRepID} = "salesRepID";
	$self->{field_salesrep_actorID} = "actorID";

	$self->{table_traffic_sam} = Retromod::Constant->TABLE_PREFIX."traffic_sam";
	$self->{field_sam_samID} = "samID";
	$self->{field_sam_actorID} = "actorID";

	$self->{table_traffic_sector} = Retromod::Constant->TABLE_PREFIX."traffic_sector";
	$self->{field_sector_sectorID} = "sectorID";
	$self->{field_sector_name} = "name";
	$self->{field_sector_startDate} = "startDate";
	$self->{field_sector_endDate} = "endDate";

	$self->{table_traffic_slot} = Retromod::Constant->TABLE_PREFIX."traffic_slot";
	$self->{field_slot_slotID} = "slotID";
	$self->{field_slot_startDate} = "startDate";
	$self->{field_slot_endDate} = "endDate";
	$self->{field_slot_dow} = "dow";
	$self->{field_slot_time} = "time";

	$self->{table_traffic_spot} = Retromod::Constant->TABLE_PREFIX."traffic_spot";
	$self->{field_spot_spotID} = "spotID";
	$self->{field_spot_campaignAudioID} = "campaignAudioID"; # Deprecated 2010-06-21.
	$self->{field_spot_mediaID} = "mediaID";
	$self->{field_spot_dateTime} = "dateTime";
	$self->{field_spot_playedDateTime} = "playedDateTime";
	$self->{field_spot_priority} = "priority";
	$self->{field_spot_inactive} = "inactive";
	$self->{field_spot_slotID} = "slotID"; # Deprecated 2010-06-21.

	$self->{table_traffic_talent} = Retromod::Constant->TABLE_PREFIX."traffic_talent";
	$self->{field_talent_talentID} = "talentID";
	$self->{field_talent_actorID} = "actorID";

	bless ($self, $class);
	return $self;
}

1;