// $Id$

var currentrow = currentcolumn = -1;

/**
* Increments/decrements the spot counter.
*/
function countticks_handler(state) {
    var tickcountbox = document.getElementById("tickcounter");
	var change = parseInt(state);
    var num = parseInt(document.getElementById("tickcounter").value);
	var new_num = num + change;
    tickcountbox.value = new_num;
}

/**
* Decrements/increments the total counter.
*/
function totalticks_handler() {
	var totalcountbox = document.getElementById("totalcounter");
	var ticks = parseInt(document.getElementById("tickcounter").value);
	var allotted = parseInt(document.getElementById("totalspotsallotted").value);
	var total = allotted - ticks;
    totalcountbox.value = total;
}

/**
* Changes the checkbox value when the containing div is clicked, making it much easier to check the box.
*
* Also triggers changes to the onscreen counters.
*/
function checkbox(obj,row,column) {
 	var checkbox = document.getElementById('traffic_checkbox['+row+']['+column+']').getElementsByTagName('input')[0];

	var count = 0;
    if ( checkbox.type == 'checkbox' ) {
		if ( checkbox && checkbox.disabled == false ) {
			if ( checkbox.checked ) {
				checkbox.checked = false;
				count--;
			} else if ( !checkbox.checked ) {
				checkbox.checked = true;
				count++;
			}
			// Change counters. Don't reverse the order as total depends on count.
			countticks_handler(count);
			totalticks_handler();
		}
	}
    if ( checkbox.type == 'radio' ) {
		if ( checkbox && checkbox.disabled == false ) {
			if ( !checkbox.checked ) {
				checkbox.checked = true;
			}
		}
	}
	return true;
}

/**
* Changes the checkbox value when the checkbox itself is clicked.
*
* This compensates for the restrictions placed on the checkbox by the checkbox() function.
*/
function checkedbox(obj,row,column) {
 	var checkbox = document.getElementById('traffic_checkbox['+row+']['+column+']').getElementsByTagName('input')[0];

	var count = 0;
    if ( checkbox.type == 'checkbox' ) {
		if ( checkbox && checkbox.disabled == false ) {
			if ( checkbox.checked ) {
				count++;
				var state = false;
			} else if ( !checkbox.checked ) {
				count--;
				var state = true;
			}
			checkbox.checked = state;
		}
	}
	return true;
}

// http://www.quirksmode.org/js/findpos.html
// Function to find the position of nested objects
function findPos(obj) {
	var curleft = curtop = 0;
    var width = Number(obj.offsetWidth);
    var height = Number(obj.offsetHeight);
    //alert(curright);
	if (obj.offsetParent) {
    	do {
    			curleft += obj.offsetLeft;
    			curtop += obj.offsetTop;
                //alert(curright);
    	} while (obj = obj.offsetParent);
    }
    var curright = (curleft+width);
    var curbottom = (curtop+height);
	return [curleft,curtop,curright,curbottom];
}

function popoutbox() {
	if (currentrow >= 0 && currentcolumn >= 0) {
		popup = document.getElementById('popup['+currentrow+']['+currentcolumn+']');
		popup.style.visibility = 'hidden';
	}
	return true;
}

function popoutkey(id) {
   // if (currentrow >= 0 && currentcolumn >= 0) {
	popup = document.getElementById('popkey["'+id+'"]');
	popup.style.visibility = 'hidden';
   // }
	return true;
}

function popupbox(obj,row,column) {
	popoutbox();
	currentrow = row;
	currentcolumn = column;

	table = document.getElementById('xytble');
	tableRight = findPos(table)[2];
	tableBottom = findPos(table)[3];

	popupLeft = findPos(obj)[0];
	popupTop = findPos(obj)[1];

	popup = document.getElementById('popup['+row+']['+column+']');
	popup.style.left = popupLeft; popup.style.top = popupTop;

	popup.style.visibility = 'visible';

	popupRight = findPos(obj)[2];
	popupBottom = findPos(obj)[3];
	var width = Number(obj.offsetWidth);
	var height = Number(obj.offsetHeight);
	popupRight += width;
//	popupWidth += height;

//	alert(popupRight+'>'+tableRight+'?');
	if (popupRight > tableRight) {
		popup.style.left = tableRight - (popupRight-popupLeft);
	}

	if (popupBottom > tableBottom) {
		popup.style.top = tableBottom - (popupBottom-popupTop);
	}

	return true;
}

/** Displays the legend/key display dropdowns on rollover. */
function popupkey(obj,id) {
//   popoutkey();
   // currentrow = row;
   // currentcolumn = column;
	table = document.getElementById('keytble');
	tableRight = findPos(table)[2];
	tableBottom = findPos(table)[3];

	popupLeft = findPos(obj)[0];
	popupTop = findPos(obj)[3];

	popup = document.getElementById('popkey["'+id+'"]');
	popup.style.left = popupLeft; popup.style.top = popupTop;

	popup.style.visibility = 'visible';

	popupRight = findPos(obj)[2];
	popupBottom = findPos(obj)[3];
	var width = Number(obj.offsetWidth);
	var height = Number(obj.offsetHeight);
	popupRight += width;
//	popupWidth += height;

//	alert(popupRight+'>'+tableRight+'?');
	if (popupRight > tableRight) {
		popup.style.left = tableRight - (popupRight-popupLeft);
	}

	if (popupBottom > tableBottom) {
		popup.style.top = tableBottom - (popupBottom-popupTop);
	}

	return true;
}

//alert("Loaded Traffic.js");
