// $Id$

function RGBtoHex(R,G,B) {return toHex(R)+toHex(G)+toHex(B)}

function toHex(N) {
 if (N==null) return "00";
 N=parseInt(N); if (N==0 || isNaN(N)) return "00";
 N=Math.max(0,N); N=Math.min(N,255); N=Math.round(N);
 return "0123456789ABCDEF".charAt((N-N%16)/16)
      + "0123456789ABCDEF".charAt(N%16);
}

function ColorToR(string) {
    string+='';//forced to string
    if(string.indexOf('rgb')==0) {
        string=string.replace(/^\s*rgb/i, ' ');
        string=string.replace(/[,\(\)]/g, ' ');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return string[0];
    }
    else if(string.indexOf('#')==0) {
        string=string.replace(/#/g, '');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return parseInt(string[0],16);
    }
}
function ColorToG(string) {
    string+='';//forced to string
    if(string.indexOf('rgb')==0) {
        string=string.replace(/^\s*rgb/i, ' ');
        string=string.replace(/[,\(\)]/g, ' ');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return string[1];
    }
    else if(string.indexOf('#')==0) {
        string=string.replace(/#/g, '');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return parseInt(string[1],16);
    }
}
function ColorToB(string) {
    string+='';//forced to string
    if(string.indexOf('rgb')==0) {
        string=string.replace(/^\s*rgb/i, ' ');
        string=string.replace(/[,\(\)]/g, ' ');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return string[2];
    }
    else if(string.indexOf('#')==0) {
        string=string.replace(/#/g, '');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return parseInt(string[2],16);
    }
}
function cutHex(h) {
    return (h.charAt(0)=="#") ? h.substring(1,7):h;
}

function mouse_event_handler(e) {
    e = e || window.event;
    var cell = e.srcElement || e.target;

    var tname = (cell.nodeType == 1) ? cell.tagName.toLowerCase() : '';

    while(tname != "table" && tname !="td" && tname != "th"){
            cell= cell.parentNode || cell.parentElement;
            tname = cell.tagName.toLowerCase();
    }

    if (tname == "td" || tname == "th") {
        var newClass;

        var cellIdx = _getCellIndex(cell);
        var row = cell.parentNode || cell.parentElement;
        var rowIdx = _getRowIndex(row);

        if (cellIdx == 0 && rowIdx == 0) {
            _clearHighlight();
        }
        if (cellIdx == 0) {
            _setRow();
        }
        else if (rowIdx == 0) {
            _setCol();
        }
        else {
            _setRow();
            _setCol();
        }
    }

    function _getTable() {
        var tbleObj;

        if (mouse_event_handler.previous.table)
            return;
        else {
            tbleObj = row.parentNode || row.parentElement; //tbody
            var tn = tbleObj.tagName.toLowerCase();
            while (tn != "table" && tn != "html") {
                tbleObj = tbleObj.parentNode || tbleObj.parentElement;
                tn = tbleObj.tagName.toLowerCase();
            }
            mouse_event_handler.previous.table = tbleObj;
        }
    }//eof _getTable

    function _clearHighlight() {
        _clearRow();
        _clearCol();

        mouse_event_handler.previous.row = null;
        mouse_event_handler.previous.cellIdx = null;
    }//eof clearHighlight

    function changeBackgroundTint(obj,value) {
        var objs;
        if (!obj) return;
        if (obj.nodeName == 'TR') {
            objs = new Array();
            for each (tdobj in obj.childNodes) {
                if (tdobj.nodeName == 'TD') {
                    for each (childobj in tdobj.childNodes) {
                        if (childobj.nodeName == 'DIV') {
                            objs.push(childobj);
                        }
                    }
                }
            }
        } else {
            objs = obj.childNodes;
        }
        for each (childobj in objs) {
            if (childobj.nodeName == 'DIV') {
                var hasstyle=(childobj.style.backgroundColor)?1:0;
                if(hasstyle){
                    prevColor = childobj.style.backgroundColor;
                } else {
                    prevColor = cascadedstyle(childobj, "backgroundColor", "background-color");
                }
                R = ColorToR(prevColor);
                G = ColorToG(prevColor);
                B = ColorToB(prevColor);
                newR = parseInt(R)+parseInt(value);
                newG = parseInt(G)+parseInt(value);
                newB = parseInt(B)+parseInt(value);
                newColor = "#"+RGBtoHex(newR,newG,newB);
                //alert(prevColor+" ("+R+","+G+","+B+")"+" -> "+newColor+" ("+newR+","+newG+","+newB+")");
                childobj.style.backgroundColor = newColor;
            }
        }
    }

    function _clearRow() {
        if (mouse_event_handler.previous.row) {
            changeBackgroundTint(mouse_event_handler.previous.row,-30);
            changeBackgroundTint(mouse_event_handler.previous.row.cells[0],-30);
        }
    }//eof clearRow

    function _setRow() {
        _clearRow();
        if (tname == 'td' || mouse_event_handler.previous.row != row) {
            changeBackgroundTint(row,30);
            changeBackgroundTint(row.cells[0],30);
            //alert(row.cells[0].style.backgroundColor);
            mouse_event_handler.previous.row = row;
        }
        else {
            mouse_event_handler.previous.row = null;
        }
    }//eof setRow

    function _clearCol() {
        _getTable();
        if (mouse_event_handler.previous.cellIdx != null) {
            var table = mouse_event_handler.previous.table;
            var cell = mouse_event_handler.previous.cellIdx;
            for (var i = 0; i < table.rows.length; i++) {
                changeBackgroundTint(table.rows[i].cells[cell],-30);
            }
        }
    }//eof clearCol

    function _setCol () {
        _clearCol();
        if (tname == 'td' || mouse_event_handler.previous.cellIdx != cellIdx) {
            changeBackgroundTint(mouse_event_handler.previous.table.rows[0].cells[cellIdx],30);
            var trs = mouse_event_handler.previous.table.rows;
            for (var i = 1; i < trs.length; i++) {
                changeBackgroundTint(trs[i].cells[cellIdx],30);
            }
            mouse_event_handler.previous.cellIdx = cellIdx;
        }
        else {
            mouse_event_handler.previous.cellIdx = null;
        }
    }//eof setCol

    function _getCellIndex(cell) {
        var rtrn = cell.cellIndex || 0;

        if (rtrn == 0) {
            do{
                if (cell.nodeType == 1) rtrn++;
                cell = cell.previousSibling;
            } while (cell);
            --rtrn;
        }
        return rtrn;
    }//eof getCellIndex

    function _getRowIndex(row) {
        var rtrn = row.rowIndex || 0;

        if (rtrn == 0) {
            do{
                if (row.nodeType == 1) rtrn++;
                row = row.previousSibling;
            } while (row);
            --rtrn;
        }
        return rtrn;
    }//eof getRowIndex

}//eof mouse_event

mouse_event_handler.previous = {cellIdx: null, row: null, table: null};

addLoadEvent(function () {
          //alert("Started.");
          addEventListener(document.getElementById("xytble"), "mouseover", mouse_event_handler);
       });
