// $Id$

function RGBtoHex(R,G,B) {return toHex(R)+toHex(G)+toHex(B)}

function toHex(N) {
 if (N==null) return "00";
 N=parseInt(N); if (N==0 || isNaN(N)) return "00";
 N=Math.max(0,N); N=Math.min(N,255); N=Math.round(N);
 return "0123456789ABCDEF".charAt((N-N%16)/16)
      + "0123456789ABCDEF".charAt(N%16);
}

function ColorToR(string) {
    string+='';//forced to string
    if(string.indexOf('rgb')==0) {
        string=string.replace(/^\s*rgb/i, ' ');
        string=string.replace(/[,\(\)]/g, ' ');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return string[0];
    }
    else if(string.indexOf('#')==0) {
        string=string.replace(/#/g, '');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return parseInt(string[0],16);
    }
}
function ColorToG(string) {
    string+='';//forced to string
    if(string.indexOf('rgb')==0) {
        string=string.replace(/^\s*rgb/i, ' ');
        string=string.replace(/[,\(\)]/g, ' ');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return string[1];
    }
    else if(string.indexOf('#')==0) {
        string=string.replace(/#/g, '');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return parseInt(string[1],16);
    }
}
function ColorToB(string) {
    string+='';//forced to string
    if(string.indexOf('rgb')==0) {
        string=string.replace(/^\s*rgb/i, ' ');
        string=string.replace(/[,\(\)]/g, ' ');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return string[2];
    }
    else if(string.indexOf('#')==0) {
        string=string.replace(/#/g, '');
        string=string.replace(/\s{2,}/g, ' ');
        string=string.replace(/^[\s\b]+|[\s\b]+$/g, '');
        string=string.split(' ');
        return parseInt(string[2],16);
    }
}
function cutHex(h) {
    return (h.charAt(0)=="#") ? h.substring(1,7):h;
}

function mouse_event_handler(e) {
    e = e || window.event;
    var cell = e.srcElement || e.target;

    var tname = (cell.nodeType == 1) ? cell.tagName.toLowerCase() : '';

    while (tname != "table" && tname !="td" && tname != "th") {
		cell = cell.parentNode || cell.parentElement;
		tname = cell.tagName.toLowerCase();
    }

    if (tname == "td" || tname == "th") {
        var newClass;

        var cellIdx = _getCellIndex(cell);
        var row = cell.parentNode || cell.parentElement;
        var rowIdx = _getRowIndex(row);

		// Calculate the total rows and columns.
		// /** @todo Change the following two lines so that the object table is not hard-coded. */
		var colsn = document.getElementById('xytble').getElementsByTagName('tr')[0].getElementsByTagName('td').length;
		var rowsn = document.getElementById('xytble').rows.length;
		rowsn--;

		// Disable highlighting on the time and date footers.
		if (cell.className == 'traffic_head_box' || cell.className == 'traffic_head_box_we') {
			// Do nothing.
			return;
		}

		// If  Slot groups from the Programs module are displayed, disable highlighting.
		if (cell.className == 'traffic_slot_group') {
			// Do nothing.
			return;
		}

        _getTable();

        _clearHighlight();
        if (cellIdx != 0 && rowIdx != 0) {
            _setHighlight();
        }
    }

    function _getTable() {
        var tbleObj;

        if (mouse_event_handler.previous.table)
            return;
        else {
            tbleObj = row.parentNode || row.parentElement; //tbody
            var tn = tbleObj.tagName.toLowerCase();
            while (tn != "table" && tn != "html") {
                tbleObj = tbleObj.parentNode || tbleObj.parentElement;
                tn = tbleObj.tagName.toLowerCase();
            }
            mouse_event_handler.previous.table = tbleObj;
        }
    }//eof _getTable

    function _clearHighlight() {
        var table = mouse_event_handler.previous.table;
        var row = mouse_event_handler.previous.row;
        var cellIdx = mouse_event_handler.previous.cellIdx;

        mouse_event_handler.previous.row = null;
        mouse_event_handler.previous.cellIdx = null;

        if (row != null) {
            changeBackgroundTint(row.cells[0],30);
            changeBackgroundTint(row.cells[colsn],30);
        }
        if (cellIdx != null) {
            changeBackgroundTint(table.rows[0].cells[cellIdx],30);
            changeBackgroundTint(table.rows[rowsn].cells[cellIdx],30);
		}
        if (row != null && cellIdx != null) {
            changeBackgroundTint(row.cells[cellIdx],30);
        }

    }//eof clearHighlight

    function _setHighlight() {
        var table = mouse_event_handler.previous.table;
        changeBackgroundTint(table.rows[rowIdx].cells[0],-30);
        changeBackgroundTint(table.rows[0].cells[cellIdx],-30);
        changeBackgroundTint(table.rows[rowIdx].cells[cellIdx],-30);

        changeBackgroundTint(table.rows[rowIdx].cells[colsn],-30);
        changeBackgroundTint(table.rows[rowsn].cells[cellIdx],-30);

        mouse_event_handler.previous.row = table.rows[rowIdx];
        mouse_event_handler.previous.cellIdx = cellIdx;
    }//eof setHighlight


    function changeBackgroundTint(obj,value) {
        var objs;
        if (!obj) return;
        objs = new Array();
        if (obj.nodeName == 'TR') {
            for each (tdobj in obj.childNodes) {
                if (tdobj.nodeName == 'TD') {
                    for each (childobj in tdobj.childNodes) {
                        if (childobj.nodeName == 'DIV') {
                            objs.push(childobj);
                        }
                    }
                }
            }
        } else if (obj.nodeName == 'TD') {
            objs.push(obj);
            for each (childobj in obj.childNodes) {
                if (childobj.nodeName == 'DIV') {
                    objs.push(childobj);
                }
            }
        } else if (obj.nodeName == 'DIV') {
            objs.push(obj);
        } else {
            //alert('Expecting a TR, TD, or DIV, but received a '+obj.nodeName);
        }
        //if (objs.length <= 0) { alert('No tds or divs existed inside the '+obj.nodeName+' element.'); }
        var tinted = 0;
        for each (obj in objs) {
            if (obj.nodeName == 'DIV' || obj.nodeName == 'TD') {
                var hasstyle=(obj.style.backgroundColor)?1:0;
                if(hasstyle){
                    prevColor = obj.style.backgroundColor;
                } else {
                    prevColor = cascadedstyle(obj, "backgroundColor", "background-color");
                }
                R = ColorToR(prevColor);
                G = ColorToG(prevColor);
                B = ColorToB(prevColor);
                newR = parseInt(R)+parseInt(value);
                newG = parseInt(G)+parseInt(value);
                newB = parseInt(B)+parseInt(value);
                newColor = "#"+RGBtoHex(newR,newG,newB);
                //alert(prevColor+" ("+R+","+G+","+B+")"+" -> "+newColor+" ("+newR+","+newG+","+newB+")");
                obj.style.backgroundColor = newColor;
                tinted++;
            }
        }
    }

    function _getCellIndex(cell) {
        var rtrn = cell.cellIndex || 0;

        if (rtrn == 0) {
            do{
                if (cell.nodeType == 1) rtrn++;
                cell = cell.previousSibling;
            } while (cell);
            --rtrn;
        }
        return rtrn;
    }//eof getCellIndex

    function _getRowIndex(row) {
        var rtrn = row.rowIndex || 0;

        if (rtrn == 0) {
            do{
                if (row.nodeType == 1) rtrn++;
                row = row.previousSibling;
            } while (row);
            --rtrn;
        }
        return rtrn;
    }//eof getRowIndex

}//eof mouse_event

mouse_event_handler.previous = {cellIdx: null, row: null, table: null};

addLoadEvent(function () {
          //alert("Started.");
          addEventListener(document.getElementById("xytble"), "mouseover", mouse_event_handler);
       });
